/* FileChooserDialog.c generated by valac 0.46.6, the Vala compiler
 * generated from FileChooserDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC <https://elementary.io>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1335 USA.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pantheon-files-widgets.h"
#include <glib/gi18n-lib.h>
#include "pantheon-files-core.h"
#include <gdk/gdk.h>

#define TYPE_CUSTOM_FILE_CHOOSER_DIALOG (custom_file_chooser_dialog_get_type ())
#define CUSTOM_FILE_CHOOSER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialog))
#define CUSTOM_FILE_CHOOSER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialogClass))
#define IS_CUSTOM_FILE_CHOOSER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CUSTOM_FILE_CHOOSER_DIALOG))
#define IS_CUSTOM_FILE_CHOOSER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CUSTOM_FILE_CHOOSER_DIALOG))
#define CUSTOM_FILE_CHOOSER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialogClass))

typedef struct _CustomFileChooserDialog CustomFileChooserDialog;
typedef struct _CustomFileChooserDialogClass CustomFileChooserDialogClass;
typedef struct _CustomFileChooserDialogPrivate CustomFileChooserDialogPrivate;
enum  {
	CUSTOM_FILE_CHOOSER_DIALOG_0_PROPERTY,
	CUSTOM_FILE_CHOOSER_DIALOG_NUM_PROPERTIES
};
static GParamSpec* custom_file_chooser_dialog_properties[CUSTOM_FILE_CHOOSER_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))

struct _CustomFileChooserDialog {
	GObject parent_instance;
	CustomFileChooserDialogPrivate * priv;
};

struct _CustomFileChooserDialogClass {
	GObjectClass parent_class;
};

struct _CustomFileChooserDialogPrivate {
	GtkFileChooserDialog* chooser_dialog;
	GtkWidget* rootwidget;
	GtkBox* container_box;
	GtkButton* gtk_folder_button;
	GQueue* previous_paths;
	GQueue* next_paths;
	gboolean filters_available;
	gchar* current_path;
	gboolean is_previous;
	gboolean is_button_next;
	gboolean is_single_click;
	gboolean can_activate;
};

struct _Block1Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GSettings* chooser_settings;
	GtkButton* button_back;
	GtkButton* button_forward;
	MarlinViewChromeBasicLocationBar* location_bar;
};

struct _Block2Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkWidget* root;
};

struct _Block3Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkWidget* rootwidget;
	GtkWidget* w0;
};

struct _Block4Data {
	int _ref_count_;
	Block3Data * _data3_;
	GtkWidget* w1;
};

struct _Block5Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkWidget* w2;
};

struct _Block6Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkTreeView* tv;
};

struct _Block7Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	gchar* current_filter_name;
	GtkComboBoxText* combo_box;
	gint index;
};

static gint CustomFileChooserDialog_private_offset;
static gpointer custom_file_chooser_dialog_parent_class = NULL;

GType custom_file_chooser_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CustomFileChooserDialog, g_object_unref)
static void _g_free0_ (gpointer var);
static inline void _g_queue_free__g_free0_ (GQueue* self);
#define CUSTOM_FILE_CHOOSER_DIALOG_BUTTON_RESPONSE -6
CustomFileChooserDialog* custom_file_chooser_dialog_new (GtkFileChooserDialog* dialog);
CustomFileChooserDialog* custom_file_chooser_dialog_construct (GType object_type,
                                                               GtkFileChooserDialog* dialog);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void custom_file_chooser_dialog_assign_container_box (CustomFileChooserDialog* self);
static void custom_file_chooser_dialog_remove_gtk_widgets (CustomFileChooserDialog* self);
static void custom_file_chooser_dialog_setup_filter_box (CustomFileChooserDialog* self);
static void __lambda24_ (CustomFileChooserDialog* self);
static void ___lambda24__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda25_ (CustomFileChooserDialog* self);
static void ___lambda25__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda26_ (Block1Data* _data1_);
static void ___lambda26__gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender,
                                                           gpointer self);
static void __lambda27_ (Block1Data* _data1_);
static void ___lambda27__gtk_widget_unrealize (GtkWidget* _sender,
                                        gpointer self);
static void __lambda28_ (CustomFileChooserDialog* self,
                  const gchar* uri);
static void ___lambda28__marlin_view_chrome_locatable_path_change_request (MarlinViewChromeLocatable* _sender,
                                                                    const gchar* path,
                                                                    MarlinOpenFlag flag,
                                                                    gpointer self);
static void __lambda5_ (CustomFileChooserDialog* self,
                 GtkWidget* root);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda6_ (Block2Data* _data2_,
                 GtkWidget* w0);
static void custom_file_chooser_dialog_transform_rootwidget_container (CustomFileChooserDialog* self,
                                                                GtkWidget* rootwidget,
                                                                GtkWidget* w0);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda7_ (Block3Data* _data3_,
                 GtkWidget* w1);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda8_ (Block4Data* _data4_,
                  GtkWidget* grid);
static void ____lambda8__gfunc (gconstpointer data,
                         gpointer self);
static void custom_file_chooser_dialog_transform_w1_container (CustomFileChooserDialog* self,
                                                        GtkWidget* w1);
static void ______lambda20_ (Block4Data* _data4_,
                      GtkWidget* w5);
static void _______lambda20__gfunc (gconstpointer data,
                             gpointer self);
static void ___lambda7__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda9_ (CustomFileChooserDialog* self,
                 GtkWidget* paned);
static void __lambda10_ (CustomFileChooserDialog* self,
                  GtkWidget* w2);
static void custom_file_chooser_dialog_transform_w2_container (CustomFileChooserDialog* self,
                                                        GtkWidget* w2);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda9__gfunc (gconstpointer data,
                        gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda11_ (Block5Data* _data5_,
                  GtkWidget* w3);
static void ___lambda12_ (CustomFileChooserDialog* self,
                   GtkWidget* w4);
static void __lambda13_ (CustomFileChooserDialog* self,
                  GtkWidget* w5);
static void __lambda14_ (CustomFileChooserDialog* self,
                  GtkWidget* w6);
static void ___lambda15_ (CustomFileChooserDialog* self,
                   GtkWidget* w7);
static void ____lambda15__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda14__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda13__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda12__gfunc (gconstpointer data,
                          gpointer self);
static GtkTreeView* custom_file_chooser_dialog_find_tree_view (CustomFileChooserDialog* self,
                                                        GtkWidget* browser_box);
static gboolean custom_file_chooser_dialog_on_tv_button_press_event (CustomFileChooserDialog* self,
                                                              GtkWidget* w,
                                                              GdkEventButton* event);
static gboolean _custom_file_chooser_dialog_on_tv_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                             GdkEventButton* event,
                                                                                             gpointer self);
static gboolean custom_file_chooser_dialog_on_tv_button_release_event (CustomFileChooserDialog* self,
                                                                GdkEventButton* event);
static gboolean _custom_file_chooser_dialog_on_tv_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                 GdkEventButton* event,
                                                                                                 gpointer self);
static void ___lambda11__gfunc (gconstpointer data,
                         gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda16_ (Block6Data* _data6_,
                  GtkWidget* w);
static void ___lambda17_ (Block6Data* _data6_,
                   GtkWidget* w);
static void ___lambda18_ (Block6Data* _data6_,
                   GtkWidget* w);
static void ___lambda19_ (Block6Data* _data6_,
                   GtkWidget* w);
static void ____lambda19__gfunc (gconstpointer data,
                          gpointer self);
static void ____lambda18__gfunc (gconstpointer data,
                          gpointer self);
static void ____lambda17__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda4_ (CustomFileChooserDialog* self,
                 GtkWidget* child);
static void ___lambda4__gfunc (gconstpointer data,
                        gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda21_ (Block7Data* _data7_);
static void __lambda22_ (Block7Data* _data7_,
                  GtkFileFilter* filter);
static void ___lambda22__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                          gpointer self);
static void ___lambda23_ (Block7Data* _data7_,
                   GtkFileFilter* filter);
static void ____lambda23__gfunc (gconstpointer data,
                          gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static void custom_file_chooser_dialog_finalize (GObject * obj);

static const gchar* CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[4] = {"widget", "browse_widgets_box", "browse_files_box", "browse_header_revealer"};
static const gchar* CUSTOM_FILE_CHOOSER_DIALOG_GTK_FILTERCHOOSER_PATH[2] = {"extra_and_filters", "filter_combo_hbox"};
static const gchar* CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[3] = {"browse_files_stack", "browse_files_swin", "browse_files_tree_view"};

static inline gpointer
custom_file_chooser_dialog_get_instance_private (CustomFileChooserDialog* self)
{
	return G_STRUCT_MEMBER_P (self, CustomFileChooserDialog_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_queue_free__g_free0_ (GQueue* self)
{
	g_queue_free_full (self, (GDestroyNotify) _g_free0_);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->location_bar);
		_g_object_unref0 (_data1_->button_forward);
		_g_object_unref0 (_data1_->button_back);
		_g_object_unref0 (_data1_->chooser_settings);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda24_ (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GQueue* _tmp1_;
	gpointer _tmp2_;
	gchar* _tmp3_;
	self->priv->is_previous = TRUE;
	_tmp0_ = self->priv->chooser_dialog;
	_tmp1_ = self->priv->previous_paths;
	_tmp2_ = g_queue_pop_head (_tmp1_);
	_tmp3_ = (gchar*) _tmp2_;
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
}

static void
___lambda24__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda24_ ((CustomFileChooserDialog*) self);
}

static void
__lambda25_ (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GQueue* _tmp1_;
	gpointer _tmp2_;
	gchar* _tmp3_;
	self->priv->is_button_next = TRUE;
	_tmp0_ = self->priv->chooser_dialog;
	_tmp1_ = self->priv->next_paths;
	_tmp2_ = g_queue_pop_head (_tmp1_);
	_tmp3_ = (gchar*) _tmp2_;
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
}

static void
___lambda25__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda25_ ((CustomFileChooserDialog*) self);
}

static void
__lambda26_ (Block1Data* _data1_)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* previous_path = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	GtkFileChooserDialog* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	GtkButton* _tmp23_;
	GQueue* _tmp24_;
	GtkButton* _tmp25_;
	GQueue* _tmp26_;
	MarlinViewChromeBasicLocationBar* _tmp27_;
	const gchar* _tmp28_;
	self = _data1_->self;
	_tmp1_ = self->priv->current_path;
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		const gchar* _tmp2_;
		_tmp2_ = g_get_home_dir ();
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_strdup (_tmp0_);
	previous_path = _tmp3_;
	_tmp5_ = self->priv->chooser_dialog;
	_tmp6_ = gtk_file_chooser_get_current_folder_uri ((GtkFileChooser*) _tmp5_);
	_tmp4_ = _tmp6_;
	if (_tmp4_ == NULL) {
		const gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp7_ = g_get_home_dir ();
		_tmp8_ = g_strdup (_tmp7_);
		_g_free0 (_tmp4_);
		_tmp4_ = _tmp8_;
	}
	_tmp9_ = _tmp4_;
	_tmp4_ = NULL;
	_g_free0 (self->priv->current_path);
	self->priv->current_path = _tmp9_;
	_tmp11_ = previous_path;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp12_ = previous_path;
		_tmp13_ = self->priv->current_path;
		_tmp10_ = g_strcmp0 (_tmp12_, _tmp13_) == 0;
	}
	if (_tmp10_) {
		MarlinViewChromeBasicLocationBar* _tmp14_;
		const gchar* _tmp15_;
		_tmp14_ = _data1_->location_bar;
		_tmp15_ = self->priv->current_path;
		marlin_view_chrome_basic_location_bar_set_display_path (_tmp14_, _tmp15_);
		_g_free0 (_tmp4_);
		_g_free0 (previous_path);
		return;
	}
	if (self->priv->is_previous) {
		GQueue* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp16_ = self->priv->next_paths;
		_tmp17_ = previous_path;
		_tmp18_ = g_strdup (_tmp17_);
		g_queue_push_head (_tmp16_, _tmp18_);
		self->priv->is_previous = FALSE;
	} else {
		GQueue* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp19_ = self->priv->previous_paths;
		_tmp20_ = previous_path;
		_tmp21_ = g_strdup (_tmp20_);
		g_queue_push_head (_tmp19_, _tmp21_);
		if (!self->priv->is_button_next) {
			GQueue* _tmp22_;
			_tmp22_ = self->priv->next_paths;
			g_queue_clear (_tmp22_);
		} else {
			self->priv->is_button_next = FALSE;
		}
	}
	_tmp23_ = _data1_->button_back;
	_tmp24_ = self->priv->previous_paths;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, !g_queue_is_empty (_tmp24_));
	_tmp25_ = _data1_->button_forward;
	_tmp26_ = self->priv->next_paths;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, !g_queue_is_empty (_tmp26_));
	_tmp27_ = _data1_->location_bar;
	_tmp28_ = self->priv->current_path;
	marlin_view_chrome_basic_location_bar_set_display_path (_tmp27_, _tmp28_);
	_g_free0 (_tmp4_);
	_g_free0 (previous_path);
}

static void
___lambda26__gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender,
                                                      gpointer self)
{
	__lambda26_ (self);
}

static void
__lambda27_ (Block1Data* _data1_)
{
	CustomFileChooserDialog* self;
	gchar* _tmp0_ = NULL;
	MarlinViewChromeBasicLocationBar* _tmp1_;
	gchar* _tmp2_;
	gchar* last_path = NULL;
	gchar* _tmp5_;
	GSettings* _tmp6_;
	self = _data1_->self;
	_tmp1_ = _data1_->location_bar;
	_tmp2_ = marlin_view_chrome_locatable_get_display_path ((MarlinViewChromeLocatable*) _tmp1_);
	_tmp0_ = _tmp2_;
	if (_tmp0_ == NULL) {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = g_get_home_dir ();
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = g_strdup (_tmp0_);
	last_path = _tmp5_;
	_tmp6_ = _data1_->chooser_settings;
	g_settings_set_string (_tmp6_, "last-folder-uri", last_path);
	_g_free0 (last_path);
	_g_free0 (_tmp0_);
}

static void
___lambda27__gtk_widget_unrealize (GtkWidget* _sender,
                                   gpointer self)
{
	__lambda27_ (self);
}

static void
__lambda28_ (CustomFileChooserDialog* self,
             const gchar* uri)
{
	GtkFileChooserDialog* _tmp1_;
	g_return_if_fail (uri != NULL);
	if (uri != NULL) {
		GtkFileChooserDialog* _tmp0_;
		_tmp0_ = self->priv->chooser_dialog;
		gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp0_, uri);
	}
	_tmp1_ = self->priv->chooser_dialog;
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp1_, FALSE);
}

static void
___lambda28__marlin_view_chrome_locatable_path_change_request (MarlinViewChromeLocatable* _sender,
                                                               const gchar* path,
                                                               MarlinOpenFlag flag,
                                                               gpointer self)
{
	__lambda28_ ((CustomFileChooserDialog*) self, path);
}

CustomFileChooserDialog*
custom_file_chooser_dialog_construct (GType object_type,
                                      GtkFileChooserDialog* dialog)
{
	CustomFileChooserDialog * self = NULL;
	Block1Data* _data1_;
	GQueue* _tmp0_;
	GQueue* _tmp1_;
	GtkFileChooserDialog* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	GSettings* settings = NULL;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GtkHeaderBar* header_bar = NULL;
	GtkHeaderBar* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	MarlinViewChromeBasicLocationBar* _tmp15_;
	MarlinViewChromeBasicLocationBar* _tmp16_;
	GtkHeaderBar* _tmp17_;
	GtkButton* _tmp18_;
	GtkHeaderBar* _tmp19_;
	GtkButton* _tmp20_;
	GtkHeaderBar* _tmp21_;
	MarlinViewChromeBasicLocationBar* _tmp22_;
	gboolean _tmp23_ = FALSE;
	GtkButton* _tmp24_;
	GtkFileChooserDialog* _tmp34_;
	GtkHeaderBar* _tmp35_;
	GtkFileChooserDialog* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkFileChooserDialog* _tmp39_;
	GtkFileChooserDialog* _tmp40_;
	MarlinViewChromeBasicLocationBar* _tmp41_;
	gchar* last_folder = NULL;
	GSettings* _tmp42_;
	gchar* _tmp43_;
	const gchar* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gboolean _tmp54_;
	GtkFileChooserDialog* _tmp57_;
	const gchar* _tmp58_;
	g_return_val_if_fail (dialog != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	self = (CustomFileChooserDialog*) g_object_new (object_type, NULL);
	_data1_->self = g_object_ref (self);
	_tmp0_ = g_queue_new ();
	(self->priv->previous_paths == NULL) ? NULL : (self->priv->previous_paths = (_g_queue_free__g_free0_ (self->priv->previous_paths), NULL));
	self->priv->previous_paths = _tmp0_;
	_tmp1_ = g_queue_new ();
	(self->priv->next_paths == NULL) ? NULL : (self->priv->next_paths = (_g_queue_free__g_free0_ (self->priv->next_paths), NULL));
	self->priv->next_paths = _tmp1_;
	self->priv->chooser_dialog = dialog;
	_tmp2_ = self->priv->chooser_dialog;
	gtk_widget_set_can_focus ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = self->priv->chooser_dialog;
	gtk_window_set_deletable ((GtkWindow*) _tmp3_, FALSE);
	_tmp4_ = self->priv->chooser_dialog;
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp4_, TRUE);
	_tmp5_ = g_settings_new ("io.elementary.files.preferences");
	settings = _tmp5_;
	_tmp6_ = settings;
	self->priv->is_single_click = g_settings_get_boolean (_tmp6_, "single-click");
	_tmp7_ = g_settings_new ("io.elementary.files.file-chooser");
	_data1_->chooser_settings = _tmp7_;
	custom_file_chooser_dialog_assign_container_box (self);
	custom_file_chooser_dialog_remove_gtk_widgets (self);
	custom_file_chooser_dialog_setup_filter_box (self);
	_tmp8_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp8_);
	header_bar = _tmp8_;
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp9_);
	_data1_->button_back = _tmp9_;
	_tmp10_ = _data1_->button_back;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _ ("Previous"));
	_tmp11_ = _data1_->button_back;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp12_);
	_data1_->button_forward = _tmp12_;
	_tmp13_ = _data1_->button_forward;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Next"));
	_tmp14_ = _data1_->button_forward;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
	_tmp15_ = marlin_view_chrome_basic_location_bar_new (NULL);
	g_object_ref_sink (_tmp15_);
	_data1_->location_bar = _tmp15_;
	_tmp16_ = _data1_->location_bar;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
	_tmp17_ = header_bar;
	_tmp18_ = _data1_->button_back;
	gtk_header_bar_pack_start (_tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = header_bar;
	_tmp20_ = _data1_->button_forward;
	gtk_header_bar_pack_start (_tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = header_bar;
	_tmp22_ = _data1_->location_bar;
	gtk_header_bar_pack_start (_tmp21_, (GtkWidget*) _tmp22_);
	_tmp24_ = self->priv->gtk_folder_button;
	if (_tmp24_ != NULL) {
		GtkFileChooserDialog* _tmp25_;
		_tmp25_ = self->priv->chooser_dialog;
		_tmp23_ = gtk_file_chooser_get_action ((GtkFileChooser*) _tmp25_) != GTK_FILE_CHOOSER_ACTION_OPEN;
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		GtkButton* _tmp26_;
		GtkImage* _tmp27_;
		GtkImage* _tmp28_;
		GtkButton* _tmp29_;
		GtkContainer* _tmp30_;
		GtkButton* _tmp31_;
		GtkHeaderBar* _tmp32_;
		GtkButton* _tmp33_;
		_tmp26_ = self->priv->gtk_folder_button;
		_tmp27_ = (GtkImage*) gtk_image_new_from_icon_name ("folder-new", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
		g_object_ref_sink (_tmp27_);
		_tmp28_ = _tmp27_;
		gtk_button_set_image (_tmp26_, (GtkWidget*) _tmp28_);
		_g_object_unref0 (_tmp28_);
		_tmp29_ = self->priv->gtk_folder_button;
		_tmp30_ = gtk_widget_get_parent ((GtkWidget*) _tmp29_);
		_tmp31_ = self->priv->gtk_folder_button;
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_container_get_type (), GtkContainer), (GtkWidget*) _tmp31_);
		_tmp32_ = header_bar;
		_tmp33_ = self->priv->gtk_folder_button;
		gtk_header_bar_pack_end (_tmp32_, (GtkWidget*) _tmp33_);
	}
	_tmp34_ = self->priv->chooser_dialog;
	_tmp35_ = header_bar;
	gtk_window_set_titlebar ((GtkWindow*) _tmp34_, (GtkWidget*) _tmp35_);
	_tmp36_ = self->priv->chooser_dialog;
	gtk_widget_show_all ((GtkWidget*) _tmp36_);
	_tmp37_ = _data1_->button_back;
	g_signal_connect_object (_tmp37_, "clicked", (GCallback) ___lambda24__gtk_button_clicked, self, 0);
	_tmp38_ = _data1_->button_forward;
	g_signal_connect_object (_tmp38_, "clicked", (GCallback) ___lambda25__gtk_button_clicked, self, 0);
	_tmp39_ = self->priv->chooser_dialog;
	g_signal_connect_data ((GtkFileChooser*) _tmp39_, "current-folder-changed", (GCallback) ___lambda26__gtk_file_chooser_current_folder_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp40_ = self->priv->chooser_dialog;
	g_signal_connect_data ((GtkWidget*) _tmp40_, "unrealize", (GCallback) ___lambda27__gtk_widget_unrealize, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp41_ = _data1_->location_bar;
	g_signal_connect_object ((MarlinViewChromeLocatable*) _tmp41_, "path-change-request", (GCallback) ___lambda28__marlin_view_chrome_locatable_path_change_request, self, 0);
	_tmp42_ = _data1_->chooser_settings;
	_tmp43_ = g_settings_get_string (_tmp42_, "last-folder-uri");
	last_folder = _tmp43_;
	_tmp44_ = last_folder;
	_tmp45_ = strlen (_tmp44_);
	_tmp46_ = _tmp45_;
	if (_tmp46_ < 1) {
		const gchar* _tmp47_;
		gchar* _tmp48_;
		_tmp47_ = g_get_home_dir ();
		_tmp48_ = g_strdup (_tmp47_);
		_g_free0 (last_folder);
		last_folder = _tmp48_;
	}
	_tmp49_ = last_folder;
	_tmp50_ = pf_file_utils_sanitize_path (_tmp49_, NULL, TRUE);
	_g_free0 (last_folder);
	last_folder = _tmp50_;
	_tmp51_ = last_folder;
	_tmp52_ = g_uri_parse_scheme (_tmp51_);
	_tmp53_ = _tmp52_;
	_tmp54_ = _tmp53_ == NULL;
	_g_free0 (_tmp53_);
	if (_tmp54_) {
		const gchar* _tmp55_;
		gchar* _tmp56_;
		_tmp55_ = last_folder;
		_tmp56_ = g_strconcat ("file://", _tmp55_, NULL);
		_g_free0 (last_folder);
		last_folder = _tmp56_;
	}
	_tmp57_ = self->priv->chooser_dialog;
	_tmp58_ = last_folder;
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp57_, _tmp58_);
	_g_free0 (last_folder);
	_g_object_unref0 (header_bar);
	_g_object_unref0 (settings);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}

CustomFileChooserDialog*
custom_file_chooser_dialog_new (GtkFileChooserDialog* dialog)
{
	return custom_file_chooser_dialog_construct (TYPE_CUSTOM_FILE_CHOOSER_DIALOG, dialog);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->root);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda6_ (Block2Data* _data2_,
            GtkWidget* w0)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data2_->self;
	g_return_if_fail (w0 != NULL);
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w0);
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[0];
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		GtkContainer* chooserwidget = NULL;
		GtkContainer* _tmp2_;
		GtkContainer* _tmp3_;
		GtkBox* root_box = NULL;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		GtkSeparator* _tmp6_;
		GtkSeparator* _tmp7_;
		GtkBox* _tmp8_;
		GtkContainer* _tmp9_;
		GtkFileChooserDialog* _tmp10_;
		GtkWidget* _tmp11_;
		GtkBox* _tmp15_;
		GtkContainer* _tmp16_;
		GtkWidget* _tmp17_;
		GtkWidget* _tmp18_;
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (w0, gtk_container_get_type ()) ? ((GtkContainer*) w0) : NULL);
		chooserwidget = _tmp2_;
		_tmp3_ = chooserwidget;
		gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data2_->root, gtk_container_get_type ()) ? ((GtkContainer*) _data2_->root) : NULL, w0);
		_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
		g_object_ref_sink (_tmp4_);
		root_box = _tmp4_;
		_tmp5_ = root_box;
		_tmp6_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
		g_object_ref_sink (_tmp6_);
		_tmp7_ = _tmp6_;
		gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp7_);
		_g_object_unref0 (_tmp7_);
		_tmp8_ = root_box;
		_tmp9_ = chooserwidget;
		gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
		_tmp10_ = self->priv->chooser_dialog;
		_tmp11_ = gtk_file_chooser_get_extra_widget ((GtkFileChooser*) _tmp10_);
		if (_tmp11_ == NULL) {
			GtkBox* _tmp12_;
			GtkSeparator* _tmp13_;
			GtkSeparator* _tmp14_;
			_tmp12_ = root_box;
			_tmp13_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
			g_object_ref_sink (_tmp13_);
			_tmp14_ = _tmp13_;
			gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp14_);
			_g_object_unref0 (_tmp14_);
		}
		_tmp15_ = root_box;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_TYPE (_data2_->root, gtk_container_get_type ()) ? ((GtkContainer*) _data2_->root) : NULL, (GtkWidget*) _tmp15_);
		_tmp16_ = chooserwidget;
		self->priv->rootwidget = (GtkWidget*) _tmp16_;
		self->priv->rootwidget = w0;
		_tmp17_ = self->priv->rootwidget;
		gtk_widget_set_can_focus (_tmp17_, TRUE);
		_tmp18_ = self->priv->rootwidget;
		custom_file_chooser_dialog_transform_rootwidget_container (self, _tmp18_, w0);
		_g_object_unref0 (root_box);
		_g_object_unref0 (chooserwidget);
	}
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda6_ (self, (GtkWidget*) data);
}

static void
__lambda5_ (CustomFileChooserDialog* self,
            GtkWidget* root)
{
	Block2Data* _data2_;
	GtkWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (root != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (root);
	_g_object_unref0 (_data2_->root);
	_data2_->root = _tmp0_;
	_tmp1_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data2_->root, gtk_container_get_type ()) ? ((GtkContainer*) _data2_->root) : NULL);
	_tmp2_ = _tmp1_;
	g_list_foreach (_tmp2_, ___lambda6__gfunc, _data2_);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda5_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
custom_file_chooser_dialog_remove_gtk_widgets (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->chooser_dialog;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_list_foreach (_tmp2_, ___lambda5__gfunc, self);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->rootwidget);
		_g_object_unref0 (_data3_->w0);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data4_->_data3_->self;
		_g_object_unref0 (_data4_->w1);
		block3_data_unref (_data4_->_data3_);
		_data4_->_data3_ = NULL;
		g_slice_free (Block4Data, _data4_);
	}
}

static void
___lambda8_ (Block4Data* _data4_,
             GtkWidget* grid)
{
	Block3Data* _data3_;
	CustomFileChooserDialog* self;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	_data3_ = _data4_->_data3_;
	self = _data3_->self;
	g_return_if_fail (grid != NULL);
	g_object_ref ((GObject*) grid);
	g_object_set (grid, "margin", 0, NULL);
	gtk_widget_set_valign (grid, GTK_ALIGN_CENTER);
	gtk_container_set_border_width (G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_container_get_type (), GtkContainer), (guint) 0);
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL, grid);
	_tmp0_ = self->priv->container_box;
	gtk_box_pack_start (_tmp0_, grid, TRUE, TRUE, (guint) 0);
	_tmp1_ = self->priv->container_box;
	gtk_button_box_set_child_secondary (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_box_get_type (), GtkButtonBox), grid, TRUE);
	g_object_unref ((GObject*) grid);
}

static void
____lambda8__gfunc (gconstpointer data,
                    gpointer self)
{
	___lambda8_ (self, (GtkWidget*) data);
}

static void
______lambda20_ (Block4Data* _data4_,
                 GtkWidget* w5)
{
	Block3Data* _data3_;
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	_data3_ = _data4_->_data3_;
	self = _data3_->self;
	g_return_if_fail (w5 != NULL);
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w5);
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_FILTERCHOOSER_PATH[1];
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL, w5);
	}
}

static void
_______lambda20__gfunc (gconstpointer data,
                        gpointer self)
{
	______lambda20_ (self, (GtkWidget*) data);
}

static void
__lambda7_ (Block3Data* _data3_,
            GtkWidget* w1)
{
	CustomFileChooserDialog* self;
	Block4Data* _data4_;
	GtkWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	self = _data3_->self;
	g_return_if_fail (w1 != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->_data3_ = block3_data_ref (_data3_);
	_tmp0_ = _g_object_ref0 (w1);
	_g_object_unref0 (_data4_->w1);
	_data4_->w1 = _tmp0_;
	_tmp2_ = gtk_widget_get_name (_data4_->w1);
	_tmp3_ = _tmp2_;
	if (g_strcmp0 (_tmp3_, "GtkBox") == 0) {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = gtk_buildable_get_name ((GtkBuildable*) _data4_->w1);
		_tmp5_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[1];
		_tmp1_ = g_strcmp0 (_tmp4_, _tmp5_) != 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GList* _tmp6_;
		GList* _tmp7_;
		GtkBox* _tmp8_;
		g_object_ref ((GObject*) _data4_->w1);
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data3_->rootwidget, gtk_container_get_type ()) ? ((GtkContainer*) _data3_->rootwidget) : NULL, _data4_->w1);
		_tmp6_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL);
		_tmp7_ = _tmp6_;
		g_list_foreach (_tmp7_, ____lambda8__gfunc, _data4_);
		(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
		g_object_unref ((GObject*) _data4_->w1);
		_tmp8_ = self->priv->container_box;
		gtk_widget_show_all ((GtkWidget*) _tmp8_);
	} else {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = gtk_buildable_get_name ((GtkBuildable*) _data4_->w1);
		_tmp10_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[1];
		if (g_strcmp0 (_tmp9_, _tmp10_) == 0) {
			custom_file_chooser_dialog_transform_w1_container (self, _data4_->w1);
		} else {
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = gtk_buildable_get_name ((GtkBuildable*) _data4_->w1);
			_tmp12_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_FILTERCHOOSER_PATH[0];
			if (g_strcmp0 (_tmp11_, _tmp12_) == 0) {
				GtkFileChooserDialog* _tmp13_;
				GtkWidget* _tmp14_;
				_tmp13_ = self->priv->chooser_dialog;
				_tmp14_ = gtk_file_chooser_get_extra_widget ((GtkFileChooser*) _tmp13_);
				if (_tmp14_ == NULL) {
					gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data3_->w0, gtk_container_get_type ()) ? ((GtkContainer*) _data3_->w0) : NULL, _data4_->w1);
				} else {
					GList* _tmp15_;
					GList* _tmp16_;
					_tmp15_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL);
					_tmp16_ = _tmp15_;
					g_list_foreach (_tmp16_, _______lambda20__gfunc, _data4_);
					(_tmp16_ == NULL) ? NULL : (_tmp16_ = (g_list_free (_tmp16_), NULL));
				}
			}
		}
	}
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static void
___lambda7__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda7_ (self, (GtkWidget*) data);
}

static void
custom_file_chooser_dialog_transform_rootwidget_container (CustomFileChooserDialog* self,
                                                           GtkWidget* rootwidget,
                                                           GtkWidget* w0)
{
	Block3Data* _data3_;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (rootwidget != NULL);
	g_return_if_fail (w0 != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (rootwidget);
	_g_object_unref0 (_data3_->rootwidget);
	_data3_->rootwidget = _tmp0_;
	_tmp1_ = _g_object_ref0 (w0);
	_g_object_unref0 (_data3_->w0);
	_data3_->w0 = _tmp1_;
	_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data3_->rootwidget, gtk_container_get_type ()) ? ((GtkContainer*) _data3_->rootwidget) : NULL);
	_tmp3_ = _tmp2_;
	g_list_foreach (_tmp3_, ___lambda7__gfunc, _data3_);
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static void
__lambda10_ (CustomFileChooserDialog* self,
             GtkWidget* w2)
{
	g_return_if_fail (w2 != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (w2, gtk_places_sidebar_get_type ())) {
		GtkPlacesSidebar* sidebar = NULL;
		GtkPlacesSidebar* _tmp0_;
		GtkPlacesSidebar* _tmp1_;
		GtkPlacesSidebar* _tmp2_;
		GtkPlacesSidebar* _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w2, gtk_places_sidebar_get_type (), GtkPlacesSidebar));
		sidebar = _tmp0_;
		_tmp1_ = sidebar;
		gtk_places_sidebar_set_show_desktop (_tmp1_, FALSE);
		_tmp2_ = sidebar;
		gtk_places_sidebar_set_show_enter_location (_tmp2_, FALSE);
		_tmp3_ = sidebar;
		gtk_places_sidebar_set_show_recent (_tmp3_, TRUE);
		_g_object_unref0 (sidebar);
	} else {
		custom_file_chooser_dialog_transform_w2_container (self, w2);
	}
}

static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda10_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
__lambda9_ (CustomFileChooserDialog* self,
            GtkWidget* paned)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (paned != NULL);
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (paned, gtk_container_get_type ()) ? ((GtkContainer*) paned) : NULL);
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda10__gfunc, self);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
}

static void
___lambda9__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda9_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
custom_file_chooser_dialog_transform_w1_container (CustomFileChooserDialog* self,
                                                   GtkWidget* w1)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w1 != NULL);
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w1, gtk_container_get_type ()) ? ((GtkContainer*) w1) : NULL);
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda9__gfunc, self);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->w2);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
___lambda15_ (CustomFileChooserDialog* self,
              GtkWidget* w7)
{
	g_return_if_fail (w7 != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (w7, gtk_button_get_type ())) {
		self->priv->gtk_folder_button = G_TYPE_CHECK_INSTANCE_TYPE (w7, gtk_button_get_type ()) ? ((GtkButton*) w7) : NULL;
	}
}

static void
____lambda15__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda15_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
__lambda14_ (CustomFileChooserDialog* self,
             GtkWidget* w6)
{
	g_return_if_fail (w6 != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (w6, gtk_box_get_type ())) {
		GList* _tmp0_;
		GList* _tmp1_;
		_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w6, gtk_container_get_type ()) ? ((GtkContainer*) w6) : NULL);
		_tmp1_ = _tmp0_;
		g_list_foreach (_tmp1_, ____lambda15__gfunc, self);
		(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
	}
}

static void
___lambda14__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda14_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
__lambda13_ (CustomFileChooserDialog* self,
             GtkWidget* w5)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (w5 != NULL);
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w5, gtk_container_get_type ()) ? ((GtkContainer*) w5) : NULL);
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda14__gfunc, self);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
}

static void
___lambda13__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda13_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
___lambda12_ (CustomFileChooserDialog* self,
              GtkWidget* w4)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (w4 != NULL);
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w4, gtk_container_get_type ()) ? ((GtkContainer*) w4) : NULL);
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda13__gfunc, self);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
}

static void
____lambda12__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda12_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static gboolean
_custom_file_chooser_dialog_on_tv_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self)
{
	gboolean result;
	result = custom_file_chooser_dialog_on_tv_button_press_event ((CustomFileChooserDialog*) self, _sender, event);
	return result;
}

static gboolean
_custom_file_chooser_dialog_on_tv_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                        GdkEventButton* event,
                                                                                        gpointer self)
{
	gboolean result;
	result = custom_file_chooser_dialog_on_tv_button_release_event ((CustomFileChooserDialog*) self, event);
	return result;
}

static void
__lambda11_ (Block5Data* _data5_,
             GtkWidget* w3)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data5_->self;
	g_return_if_fail (w3 != NULL);
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w3);
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[3];
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		GList* _tmp2_;
		GList* _tmp3_;
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w3, gtk_container_get_type ()) ? ((GtkContainer*) w3) : NULL);
		_tmp3_ = _tmp2_;
		g_list_foreach (_tmp3_, ____lambda12__gfunc, self);
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data5_->w2, gtk_container_get_type ()) ? ((GtkContainer*) _data5_->w2) : NULL, w3);
	} else {
		const gchar* _tmp4_;
		_tmp4_ = gtk_buildable_get_name ((GtkBuildable*) w3);
		if (g_strcmp0 (_tmp4_, "list_and_preview_box") == 0) {
			GtkTreeView* tv = NULL;
			GtkTreeView* _tmp5_;
			GtkTreeView* _tmp6_;
			_tmp5_ = custom_file_chooser_dialog_find_tree_view (self, w3);
			tv = _tmp5_;
			_tmp6_ = tv;
			if (_tmp6_ != NULL) {
				GtkTreeView* _tmp7_;
				_tmp7_ = tv;
				gtk_tree_view_set_activate_on_single_click (_tmp7_, self->priv->is_single_click);
				if (self->priv->is_single_click) {
					GtkTreeView* _tmp8_;
					GtkTreeView* _tmp9_;
					GtkTreeView* _tmp10_;
					_tmp8_ = tv;
					gtk_widget_add_events ((GtkWidget*) _tmp8_, (gint) (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK));
					_tmp9_ = tv;
					g_signal_connect_object ((GtkWidget*) _tmp9_, "button-press-event", (GCallback) _custom_file_chooser_dialog_on_tv_button_press_event_gtk_widget_button_press_event, self, 0);
					_tmp10_ = tv;
					g_signal_connect_object ((GtkWidget*) _tmp10_, "button-release-event", (GCallback) _custom_file_chooser_dialog_on_tv_button_release_event_gtk_widget_button_release_event, self, 0);
				}
			}
			_g_object_unref0 (tv);
		}
	}
}

static void
___lambda11__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda11_ (self, (GtkWidget*) data);
}

static void
custom_file_chooser_dialog_transform_w2_container (CustomFileChooserDialog* self,
                                                   GtkWidget* w2)
{
	Block5Data* _data5_;
	GtkWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w2 != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (w2);
	_g_object_unref0 (_data5_->w2);
	_data5_->w2 = _tmp0_;
	_tmp1_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data5_->w2, gtk_container_get_type ()) ? ((GtkContainer*) _data5_->w2) : NULL);
	_tmp2_ = _tmp1_;
	g_list_foreach (_tmp2_, ___lambda11__gfunc, _data5_);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->tv);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
___lambda19_ (Block6Data* _data6_,
              GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data6_->self;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w);
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[2];
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		GtkTreeView* _tmp2_;
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_tree_view_get_type (), GtkTreeView));
		_g_object_unref0 (_data6_->tv);
		_data6_->tv = _tmp2_;
	}
}

static void
____lambda19__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda19_ (self, (GtkWidget*) data);
}

static void
___lambda18_ (Block6Data* _data6_,
              GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data6_->self;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w);
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[1];
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		GList* _tmp2_;
		GList* _tmp3_;
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_container_get_type (), GtkContainer));
		_tmp3_ = _tmp2_;
		g_list_foreach (_tmp3_, ____lambda19__gfunc, _data6_);
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
	}
}

static void
____lambda18__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda18_ (self, (GtkWidget*) data);
}

static void
___lambda17_ (Block6Data* _data6_,
              GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data6_->self;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_widget_get_name (w);
	_tmp1_ = _tmp0_;
	if (g_strcmp0 (_tmp1_, "GtkBox") == 0) {
		GList* _tmp2_;
		GList* _tmp3_;
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_container_get_type (), GtkContainer));
		_tmp3_ = _tmp2_;
		g_list_foreach (_tmp3_, ____lambda18__gfunc, _data6_);
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
	}
}

static void
____lambda17__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda17_ (self, (GtkWidget*) data);
}

static void
__lambda16_ (Block6Data* _data6_,
             GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data6_->self;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w);
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[0];
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		GList* _tmp2_;
		GList* _tmp3_;
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_container_get_type (), GtkContainer));
		_tmp3_ = _tmp2_;
		g_list_foreach (_tmp3_, ____lambda17__gfunc, _data6_);
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
	}
}

static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda16_ (self, (GtkWidget*) data);
}

static GtkTreeView*
custom_file_chooser_dialog_find_tree_view (CustomFileChooserDialog* self,
                                           GtkWidget* browser_box)
{
	Block6Data* _data6_;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkTreeView* _tmp2_;
	GtkTreeView* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (browser_box != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_data6_->tv = NULL;
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (browser_box, gtk_container_get_type (), GtkContainer));
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda16__gfunc, _data6_);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
	_tmp2_ = _g_object_ref0 (_data6_->tv);
	result = _tmp2_;
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}

static void
__lambda4_ (CustomFileChooserDialog* self,
            GtkWidget* child)
{
	g_return_if_fail (child != NULL);
	gtk_widget_set_valign (child, GTK_ALIGN_CENTER);
}

static void
___lambda4__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda4_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
}

static void
custom_file_chooser_dialog_assign_container_box (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GtkWidget* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->chooser_dialog;
	_tmp1_ = gtk_dialog_get_action_area ((GtkDialog*) _tmp0_);
	self->priv->container_box = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_box_get_type ()) ? ((GtkBox*) _tmp1_) : NULL;
	_tmp2_ = self->priv->container_box;
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	_tmp3_ = self->priv->container_box;
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
	_tmp5_ = _tmp4_;
	g_list_foreach (_tmp5_, ___lambda4__gfunc, self);
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		CustomFileChooserDialog* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->combo_box);
		_g_free0 (_data7_->current_filter_name);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda22_ (Block7Data* _data7_,
             GtkFileFilter* filter)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	GtkComboBoxText* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	self = _data7_->self;
	g_return_if_fail (filter != NULL);
	_tmp0_ = gtk_file_filter_get_name (filter);
	_tmp1_ = _data7_->combo_box;
	_tmp2_ = gtk_combo_box_text_get_active_text (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strcmp0 (_tmp0_, _tmp3_) == 0;
	_g_free0 (_tmp3_);
	if (_tmp4_) {
		GtkFileChooserDialog* _tmp5_;
		_tmp5_ = self->priv->chooser_dialog;
		gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp5_, filter);
	}
}

static void
___lambda22__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda22_ (self, (GtkFileFilter*) data);
}

static void
___lambda21_ (Block7Data* _data7_)
{
	CustomFileChooserDialog* self;
	GtkFileChooserDialog* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
	self = _data7_->self;
	_tmp0_ = self->priv->chooser_dialog;
	_tmp1_ = gtk_file_chooser_list_filters ((GtkFileChooser*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_slist_foreach (_tmp2_, ___lambda22__gfunc, _data7_);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_slist_free (_tmp2_), NULL));
}

static void
____lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                     gpointer self)
{
	___lambda21_ (self);
}

static void
___lambda23_ (Block7Data* _data7_,
              GtkFileFilter* filter)
{
	CustomFileChooserDialog* self;
	gchar* name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GtkComboBoxText* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp7_;
	self = _data7_->self;
	g_return_if_fail (filter != NULL);
	_tmp0_ = gtk_file_filter_get_name (filter);
	_tmp1_ = g_strdup (_tmp0_);
	name = _tmp1_;
	_tmp2_ = _data7_->combo_box;
	_tmp3_ = name;
	gtk_combo_box_text_append_text (_tmp2_, _tmp3_);
	_tmp4_ = name;
	_tmp5_ = _data7_->current_filter_name;
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
		GtkComboBoxText* _tmp6_;
		_tmp6_ = _data7_->combo_box;
		gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, _data7_->index);
	}
	_tmp7_ = _data7_->index;
	_data7_->index = _tmp7_ + 1;
	_g_free0 (name);
}

static void
____lambda23__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda23_ (self, (GtkFileFilter*) data);
}

static void
custom_file_chooser_dialog_setup_filter_box (CustomFileChooserDialog* self)
{
	GSList* filters = NULL;
	GtkFileChooserDialog* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->chooser_dialog;
	_tmp1_ = gtk_file_chooser_list_filters ((GtkFileChooser*) _tmp0_);
	filters = _tmp1_;
	_tmp2_ = filters;
	if (g_slist_length (_tmp2_) > ((guint) 0)) {
		Block7Data* _data7_;
		GtkFileFilter* current_filter = NULL;
		GtkFileChooserDialog* _tmp3_;
		GtkFileFilter* _tmp4_;
		GtkFileFilter* _tmp5_;
		GtkFileFilter* _tmp6_;
		GtkComboBoxText* _tmp10_;
		GtkComboBoxText* _tmp11_;
		GSList* _tmp12_;
		GtkGrid* grid = NULL;
		GtkGrid* _tmp13_;
		GtkGrid* _tmp14_;
		GtkGrid* _tmp15_;
		GtkComboBoxText* _tmp16_;
		GtkBox* _tmp17_;
		GtkGrid* _tmp18_;
		GtkBox* _tmp19_;
		GtkGrid* _tmp20_;
		_data7_ = g_slice_new0 (Block7Data);
		_data7_->_ref_count_ = 1;
		_data7_->self = g_object_ref (self);
		_data7_->current_filter_name = NULL;
		_tmp3_ = self->priv->chooser_dialog;
		_tmp4_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp3_);
		_tmp5_ = _g_object_ref0 (_tmp4_);
		current_filter = _tmp5_;
		_tmp6_ = current_filter;
		if (_tmp6_ != NULL) {
			GtkFileFilter* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp7_ = current_filter;
			_tmp8_ = gtk_file_filter_get_name (_tmp7_);
			_tmp9_ = g_strdup (_tmp8_);
			_g_free0 (_data7_->current_filter_name);
			_data7_->current_filter_name = _tmp9_;
		}
		self->priv->filters_available = TRUE;
		_tmp10_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
		g_object_ref_sink (_tmp10_);
		_data7_->combo_box = _tmp10_;
		_tmp11_ = _data7_->combo_box;
		g_signal_connect_data ((GtkComboBox*) _tmp11_, "changed", (GCallback) ____lambda21__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
		_data7_->index = 0;
		_tmp12_ = filters;
		g_slist_foreach (_tmp12_, ____lambda23__gfunc, _data7_);
		_tmp13_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp13_);
		grid = _tmp13_;
		_tmp14_ = grid;
		gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
		_tmp15_ = grid;
		_tmp16_ = _data7_->combo_box;
		gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
		_tmp17_ = self->priv->container_box;
		_tmp18_ = grid;
		gtk_box_pack_end (_tmp17_, (GtkWidget*) _tmp18_, TRUE, TRUE, (guint) 0);
		_tmp19_ = self->priv->container_box;
		_tmp20_ = grid;
		gtk_button_box_set_child_secondary (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_button_box_get_type (), GtkButtonBox), (GtkWidget*) _tmp20_, TRUE);
		_g_object_unref0 (grid);
		_g_object_unref0 (current_filter);
		block7_data_unref (_data7_);
		_data7_ = NULL;
	}
	(filters == NULL) ? NULL : (filters = (g_slist_free (filters), NULL));
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
	g_boxed_free (gtk_tree_iter_get_type (), self);
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
}

static gboolean
custom_file_chooser_dialog_on_tv_button_press_event (CustomFileChooserDialog* self,
                                                     GtkWidget* w,
                                                     GdkEventButton* event)
{
	GdkEventType _tmp0_;
	GtkTreeView* tv = NULL;
	GtkTreeView* _tmp1_;
	GtkTreePath* path = NULL;
	gint cell_x = 0;
	gint cell_y = 0;
	GtkTreeView* _tmp2_;
	GtkTreePath* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GtkTreePath* _tmp6_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (w != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	self->priv->can_activate = FALSE;
	_tmp0_ = event->type;
	if (_tmp0_ == GDK_2BUTTON_PRESS) {
		self->priv->can_activate = TRUE;
		result = FALSE;
		return result;
	}
	if (w == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_tree_view_get_type (), GtkTreeView));
	tv = _tmp1_;
	path = NULL;
	_tmp2_ = tv;
	gtk_tree_view_get_path_at_pos (_tmp2_, (gint) event->x, (gint) event->y, &_tmp3_, NULL, &_tmp4_, &_tmp5_);
	__vala_GtkTreePath_free0 (path);
	path = _tmp3_;
	cell_x = _tmp4_;
	cell_y = _tmp5_;
	_tmp6_ = path;
	if (_tmp6_ != NULL) {
		GtkTreeModel* model = NULL;
		GtkTreeView* _tmp7_;
		GtkTreeModel* _tmp8_;
		GtkTreeModel* _tmp9_;
		GtkTreeIter* iter = NULL;
		GtkTreeModel* _tmp10_;
		GtkTreePath* _tmp11_;
		GtkTreeIter _tmp12_ = {0};
		gboolean _tmp13_;
		GtkTreeIter _tmp14_;
		GtkTreeIter* _tmp15_;
		_tmp7_ = tv;
		_tmp8_ = gtk_tree_view_get_model (_tmp7_);
		_tmp9_ = _g_object_ref0 (_tmp8_);
		model = _tmp9_;
		iter = NULL;
		_tmp10_ = model;
		_tmp11_ = path;
		_tmp13_ = gtk_tree_model_get_iter (_tmp10_, &_tmp12_, _tmp11_);
		__vala_GtkTreeIter_free0 (iter);
		_tmp14_ = _tmp12_;
		_tmp15_ = __vala_GtkTreeIter_copy0 (&_tmp14_);
		iter = _tmp15_;
		if (_tmp13_) {
			gboolean is_folder = FALSE;
			GtkTreeModel* _tmp16_;
			GtkTreeIter* _tmp17_;
			GtkTreeIter _tmp18_;
			gboolean _tmp19_ = FALSE;
			_tmp16_ = model;
			_tmp17_ = iter;
			_tmp18_ = *_tmp17_;
			gtk_tree_model_get (_tmp16_, &_tmp18_, 5, &_tmp19_, -1);
			is_folder = _tmp19_;
			if (is_folder) {
				self->priv->can_activate = TRUE;
			}
		}
		__vala_GtkTreeIter_free0 (iter);
		_g_object_unref0 (model);
	}
	result = FALSE;
	__vala_GtkTreePath_free0 (path);
	_g_object_unref0 (tv);
	return result;
}

static gboolean
custom_file_chooser_dialog_on_tv_button_release_event (CustomFileChooserDialog* self,
                                                       GdkEventButton* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	result = !self->priv->can_activate;
	return result;
}

static void
custom_file_chooser_dialog_class_init (CustomFileChooserDialogClass * klass,
                                       gpointer klass_data)
{
	custom_file_chooser_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CustomFileChooserDialog_private_offset);
	G_OBJECT_CLASS (klass)->finalize = custom_file_chooser_dialog_finalize;
}

static void
custom_file_chooser_dialog_instance_init (CustomFileChooserDialog * self,
                                          gpointer klass)
{
	self->priv = custom_file_chooser_dialog_get_instance_private (self);
	self->priv->gtk_folder_button = NULL;
	self->priv->filters_available = FALSE;
	self->priv->current_path = NULL;
	self->priv->is_previous = FALSE;
	self->priv->is_button_next = FALSE;
	self->priv->is_single_click = TRUE;
	self->priv->can_activate = TRUE;
}

static void
custom_file_chooser_dialog_finalize (GObject * obj)
{
	CustomFileChooserDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialog);
	(self->priv->previous_paths == NULL) ? NULL : (self->priv->previous_paths = (_g_queue_free__g_free0_ (self->priv->previous_paths), NULL));
	(self->priv->next_paths == NULL) ? NULL : (self->priv->next_paths = (_g_queue_free__g_free0_ (self->priv->next_paths), NULL));
	_g_free0 (self->priv->current_path);
	G_OBJECT_CLASS (custom_file_chooser_dialog_parent_class)->finalize (obj);
}

/*** The Gtk.FileChooserWidget widget names and paths can be found in "gtkfilechooserwidget.ui"
 *   in the Gtk+3 source code package.  Changes to that file could break this code.
***/
GType
custom_file_chooser_dialog_get_type (void)
{
	static volatile gsize custom_file_chooser_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&custom_file_chooser_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CustomFileChooserDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) custom_file_chooser_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CustomFileChooserDialog), 0, (GInstanceInitFunc) custom_file_chooser_dialog_instance_init, NULL };
		GType custom_file_chooser_dialog_type_id;
		custom_file_chooser_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "CustomFileChooserDialog", &g_define_type_info, 0);
		CustomFileChooserDialog_private_offset = g_type_add_instance_private (custom_file_chooser_dialog_type_id, sizeof (CustomFileChooserDialogPrivate));
		g_once_init_leave (&custom_file_chooser_dialog_type_id__volatile, custom_file_chooser_dialog_type_id);
	}
	return custom_file_chooser_dialog_type_id__volatile;
}

