/* FileChanges.c generated by valac 0.46.6, the Vala compiler
 * generated from FileChanges.vala, do not modify */

/* Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

typedef enum  {
	MARLIN_FILE_CHANGES_KIND_INITIAL,
	MARLIN_FILE_CHANGES_KIND_ADDED,
	MARLIN_FILE_CHANGES_KIND_CHANGED,
	MARLIN_FILE_CHANGES_KIND_REMOVED,
	MARLIN_FILE_CHANGES_KIND_MOVED
} MarlinFileChangesKind;

#define MARLIN_FILE_CHANGES_TYPE_KIND (marlin_file_changes_kind_get_type ())
typedef struct _MarlinFileChangesChange MarlinFileChangesChange;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _marlin_file_changes_change_free0(var) ((var == NULL) ? NULL : (var = (marlin_file_changes_change_free (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _MarlinFileChangesChange {
	MarlinFileChangesKind kind;
	GFile* from;
	GFile* to;
};

extern GQueue* marlin_file_changes_queue;
GQueue* marlin_file_changes_queue = NULL;
extern GMutex marlin_file_changes_queue_mutex;
GMutex marlin_file_changes_queue_mutex = {0};

#define MARLIN_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK 20
GType marlin_file_changes_kind_get_type (void) G_GNUC_CONST;
void marlin_file_changes_change_free (MarlinFileChangesChange * self);
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinFileChangesChange, marlin_file_changes_change_free)
static void marlin_file_changes_change_instance_init (MarlinFileChangesChange * self);
MarlinFileChangesChange* marlin_file_changes_change_new (void);
GQueue* marlin_file_changes_get_queue (void);
static void _marlin_file_changes_change_free0_ (gpointer var);
static inline void _g_queue_free__marlin_file_changes_change_free0_ (GQueue* self);
void marlin_file_changes_queue_add_common (MarlinFileChangesChange* new_item);
void marlin_file_changes_queue_file_added (GFile* location);
void marlin_file_changes_queue_file_changed (GFile* location);
void marlin_file_changes_queue_file_removed (GFile* location);
void marlin_file_changes_queue_file_moved (GFile* from,
                                           GFile* to);
void marlin_file_changes_consume_changes (gboolean consume_all);
void gof_directory_async_notify_files_removed (GList* files);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void gof_directory_async_notify_files_moved (GList* files);
static void _g_array_unref0_ (gpointer var);
static inline void _g_list_free__g_array_unref0_ (GList* self);
void gof_directory_async_notify_files_added (GList* files);
void gof_directory_async_notify_files_changed (GList* files);
static void _vala_GFile_free_function_content_of (gpointer data);

GType
marlin_file_changes_kind_get_type (void)
{
	static volatile gsize marlin_file_changes_kind_type_id__volatile = 0;
	if (g_once_init_enter (&marlin_file_changes_kind_type_id__volatile)) {
		static const GEnumValue values[] = {{MARLIN_FILE_CHANGES_KIND_INITIAL, "MARLIN_FILE_CHANGES_KIND_INITIAL", "initial"}, {MARLIN_FILE_CHANGES_KIND_ADDED, "MARLIN_FILE_CHANGES_KIND_ADDED", "added"}, {MARLIN_FILE_CHANGES_KIND_CHANGED, "MARLIN_FILE_CHANGES_KIND_CHANGED", "changed"}, {MARLIN_FILE_CHANGES_KIND_REMOVED, "MARLIN_FILE_CHANGES_KIND_REMOVED", "removed"}, {MARLIN_FILE_CHANGES_KIND_MOVED, "MARLIN_FILE_CHANGES_KIND_MOVED", "moved"}, {0, NULL, NULL}};
		GType marlin_file_changes_kind_type_id;
		marlin_file_changes_kind_type_id = g_enum_register_static ("MarlinFileChangesKind", values);
		g_once_init_leave (&marlin_file_changes_kind_type_id__volatile, marlin_file_changes_kind_type_id);
	}
	return marlin_file_changes_kind_type_id__volatile;
}

MarlinFileChangesChange*
marlin_file_changes_change_new (void)
{
	MarlinFileChangesChange* self;
	self = g_slice_new0 (MarlinFileChangesChange);
	marlin_file_changes_change_instance_init (self);
	return self;
}

static void
marlin_file_changes_change_instance_init (MarlinFileChangesChange * self)
{
}

void
marlin_file_changes_change_free (MarlinFileChangesChange * self)
{
	_g_object_unref0 (self->from);
	_g_object_unref0 (self->to);
	g_slice_free (MarlinFileChangesChange, self);
}

static void
_marlin_file_changes_change_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (marlin_file_changes_change_free (var), NULL));
}

static inline void
_g_queue_free__marlin_file_changes_change_free0_ (GQueue* self)
{
	g_queue_free_full (self, (GDestroyNotify) _marlin_file_changes_change_free0_);
}

GQueue*
marlin_file_changes_get_queue (void)
{
	GQueue* _tmp0_;
	GQueue* _tmp2_;
	GQueue* result = NULL;
	g_mutex_lock (&marlin_file_changes_queue_mutex);
	_tmp0_ = marlin_file_changes_queue;
	if (_tmp0_ == NULL) {
		GQueue* _tmp1_;
		_tmp1_ = g_queue_new ();
		(marlin_file_changes_queue == NULL) ? NULL : (marlin_file_changes_queue = (_g_queue_free__marlin_file_changes_change_free0_ (marlin_file_changes_queue), NULL));
		marlin_file_changes_queue = _tmp1_;
	}
	g_mutex_unlock (&marlin_file_changes_queue_mutex);
	_tmp2_ = marlin_file_changes_queue;
	result = _tmp2_;
	return result;
}

void
marlin_file_changes_queue_add_common (MarlinFileChangesChange* new_item)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	g_return_if_fail (new_item != NULL);
	_tmp0_ = marlin_file_changes_get_queue ();
	queue = _tmp0_;
	g_mutex_lock (&marlin_file_changes_queue_mutex);
	_tmp1_ = new_item;
	new_item = NULL;
	g_queue_push_head (queue, _tmp1_);
	g_mutex_unlock (&marlin_file_changes_queue_mutex);
	_marlin_file_changes_change_free0 (new_item);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
marlin_file_changes_queue_file_added (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
	g_return_if_fail (location != NULL);
	_tmp0_ = marlin_file_changes_change_new ();
	new_item = _tmp0_;
	_tmp1_ = new_item;
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_ADDED;
	_tmp2_ = new_item;
	_tmp3_ = _g_object_ref0 (location);
	_g_object_unref0 (_tmp2_->from);
	_tmp2_->from = _tmp3_;
	_tmp4_ = new_item;
	new_item = NULL;
	marlin_file_changes_queue_add_common (_tmp4_);
	_marlin_file_changes_change_free0 (new_item);
}

void
marlin_file_changes_queue_file_changed (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
	g_return_if_fail (location != NULL);
	_tmp0_ = marlin_file_changes_change_new ();
	new_item = _tmp0_;
	_tmp1_ = new_item;
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_CHANGED;
	_tmp2_ = new_item;
	_tmp3_ = _g_object_ref0 (location);
	_g_object_unref0 (_tmp2_->from);
	_tmp2_->from = _tmp3_;
	_tmp4_ = new_item;
	new_item = NULL;
	marlin_file_changes_queue_add_common (_tmp4_);
	_marlin_file_changes_change_free0 (new_item);
}

void
marlin_file_changes_queue_file_removed (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
	g_return_if_fail (location != NULL);
	_tmp0_ = marlin_file_changes_change_new ();
	new_item = _tmp0_;
	_tmp1_ = new_item;
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_REMOVED;
	_tmp2_ = new_item;
	_tmp3_ = _g_object_ref0 (location);
	_g_object_unref0 (_tmp2_->from);
	_tmp2_->from = _tmp3_;
	_tmp4_ = new_item;
	new_item = NULL;
	marlin_file_changes_queue_add_common (_tmp4_);
	_marlin_file_changes_change_free0 (new_item);
}

void
marlin_file_changes_queue_file_moved (GFile* from,
                                      GFile* to)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
	GFile* _tmp5_;
	MarlinFileChangesChange* _tmp6_;
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	_tmp0_ = marlin_file_changes_change_new ();
	new_item = _tmp0_;
	_tmp1_ = new_item;
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_MOVED;
	_tmp2_ = new_item;
	_tmp3_ = _g_object_ref0 (from);
	_g_object_unref0 (_tmp2_->from);
	_tmp2_->from = _tmp3_;
	_tmp4_ = new_item;
	_tmp5_ = _g_object_ref0 (to);
	_g_object_unref0 (_tmp4_->to);
	_tmp4_->to = _tmp5_;
	_tmp6_ = new_item;
	new_item = NULL;
	marlin_file_changes_queue_add_common (_tmp6_);
	_marlin_file_changes_change_free0 (new_item);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
_g_array_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_array_unref (var), NULL));
}

static inline void
_g_list_free__g_array_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_array_unref0_);
}

static void
_vala_GFile_free_function_content_of (gpointer data)
{
	GFile* self;
	self = *((GFile**) data);
	_g_object_unref0_ (self);
}

static gpointer
_g_array_ref0 (gpointer self)
{
	return self ? g_array_ref (self) : NULL;
}

void
marlin_file_changes_consume_changes (gboolean consume_all)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	guint chunk_count = 0U;
	gboolean flush_needed = FALSE;
	GList* additions = NULL;
	GList* changes = NULL;
	GList* deletions = NULL;
	GList* moves = NULL;
	_tmp0_ = marlin_file_changes_get_queue ();
	queue = _tmp0_;
	additions = NULL;
	changes = NULL;
	deletions = NULL;
	moves = NULL;
	{
		gboolean _tmp1_ = FALSE;
		chunk_count = (guint) 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			MarlinFileChangesChange* change = NULL;
			GQueue* _tmp3_;
			gpointer _tmp4_;
			MarlinFileChangesChange* _tmp5_;
			MarlinFileChangesChange* _tmp31_;
			MarlinFileChangesChange* _tmp32_;
			MarlinFileChangesKind _tmp33_;
			if (!_tmp1_) {
				guint _tmp2_;
				_tmp2_ = chunk_count;
				chunk_count = _tmp2_ + 1;
			}
			_tmp1_ = FALSE;
			g_mutex_lock (&marlin_file_changes_queue_mutex);
			_tmp3_ = queue;
			_tmp4_ = g_queue_pop_tail (_tmp3_);
			change = (MarlinFileChangesChange*) _tmp4_;
			g_mutex_unlock (&marlin_file_changes_queue_mutex);
			_tmp5_ = change;
			if (_tmp5_ == NULL) {
				flush_needed = TRUE;
			} else {
				gboolean _tmp6_ = FALSE;
				GList* _tmp7_;
				gboolean _tmp10_ = FALSE;
				GList* _tmp11_;
				gboolean _tmp14_ = FALSE;
				GList* _tmp15_;
				gboolean _tmp18_ = FALSE;
				GList* _tmp19_;
				gboolean _tmp22_ = FALSE;
				_tmp7_ = additions;
				if (_tmp7_ != NULL) {
					MarlinFileChangesChange* _tmp8_;
					MarlinFileChangesKind _tmp9_;
					_tmp8_ = change;
					_tmp9_ = _tmp8_->kind;
					_tmp6_ = _tmp9_ != MARLIN_FILE_CHANGES_KIND_ADDED;
				} else {
					_tmp6_ = FALSE;
				}
				flush_needed = _tmp6_;
				_tmp11_ = changes;
				if (_tmp11_ != NULL) {
					MarlinFileChangesChange* _tmp12_;
					MarlinFileChangesKind _tmp13_;
					_tmp12_ = change;
					_tmp13_ = _tmp12_->kind;
					_tmp10_ = _tmp13_ != MARLIN_FILE_CHANGES_KIND_CHANGED;
				} else {
					_tmp10_ = FALSE;
				}
				flush_needed |= _tmp10_;
				_tmp15_ = moves;
				if (_tmp15_ != NULL) {
					MarlinFileChangesChange* _tmp16_;
					MarlinFileChangesKind _tmp17_;
					_tmp16_ = change;
					_tmp17_ = _tmp16_->kind;
					_tmp14_ = _tmp17_ != MARLIN_FILE_CHANGES_KIND_MOVED;
				} else {
					_tmp14_ = FALSE;
				}
				flush_needed |= _tmp14_;
				_tmp19_ = deletions;
				if (_tmp19_ != NULL) {
					MarlinFileChangesChange* _tmp20_;
					MarlinFileChangesKind _tmp21_;
					_tmp20_ = change;
					_tmp21_ = _tmp20_->kind;
					_tmp18_ = _tmp21_ != MARLIN_FILE_CHANGES_KIND_REMOVED;
				} else {
					_tmp18_ = FALSE;
				}
				flush_needed |= _tmp18_;
				if (!consume_all) {
					_tmp22_ = chunk_count >= ((guint) MARLIN_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK);
				} else {
					_tmp22_ = FALSE;
				}
				flush_needed |= _tmp22_;
			}
			if (flush_needed) {
				GList* _tmp23_;
				GList* _tmp25_;
				GList* _tmp27_;
				GList* _tmp29_;
				_tmp23_ = deletions;
				if (_tmp23_ != NULL) {
					GList* _tmp24_;
					deletions = g_list_reverse (deletions);
					_tmp24_ = deletions;
					gof_directory_async_notify_files_removed (_tmp24_);
					(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
					deletions = NULL;
				}
				_tmp25_ = moves;
				if (_tmp25_ != NULL) {
					GList* _tmp26_;
					moves = g_list_reverse (moves);
					_tmp26_ = moves;
					gof_directory_async_notify_files_moved (_tmp26_);
					(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
					moves = NULL;
				}
				_tmp27_ = additions;
				if (_tmp27_ != NULL) {
					GList* _tmp28_;
					additions = g_list_reverse (additions);
					_tmp28_ = additions;
					gof_directory_async_notify_files_added (_tmp28_);
					(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
					additions = NULL;
				}
				_tmp29_ = changes;
				if (_tmp29_ != NULL) {
					GList* _tmp30_;
					changes = g_list_reverse (changes);
					_tmp30_ = changes;
					gof_directory_async_notify_files_changed (_tmp30_);
					(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
					changes = NULL;
				}
			}
			_tmp31_ = change;
			if (_tmp31_ == NULL) {
				_marlin_file_changes_change_free0 (change);
				(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
				(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
				(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
				(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
				return;
			}
			_tmp32_ = change;
			_tmp33_ = _tmp32_->kind;
			switch (_tmp33_) {
				case MARLIN_FILE_CHANGES_KIND_ADDED:
				{
					GList* _tmp34_;
					MarlinFileChangesChange* _tmp35_;
					GFile* _tmp36_;
					GFile* _tmp37_;
					_tmp34_ = additions;
					if (_tmp34_ == NULL) {
						(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
						additions = NULL;
					}
					_tmp35_ = change;
					_tmp36_ = _tmp35_->from;
					_tmp37_ = _g_object_ref0 (_tmp36_);
					additions = g_list_prepend (additions, _tmp37_);
					break;
				}
				case MARLIN_FILE_CHANGES_KIND_CHANGED:
				{
					GList* _tmp38_;
					MarlinFileChangesChange* _tmp39_;
					GFile* _tmp40_;
					GFile* _tmp41_;
					_tmp38_ = changes;
					if (_tmp38_ == NULL) {
						(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
						changes = NULL;
					}
					_tmp39_ = change;
					_tmp40_ = _tmp39_->from;
					_tmp41_ = _g_object_ref0 (_tmp40_);
					changes = g_list_prepend (changes, _tmp41_);
					break;
				}
				case MARLIN_FILE_CHANGES_KIND_REMOVED:
				{
					GList* _tmp42_;
					MarlinFileChangesChange* _tmp43_;
					GFile* _tmp44_;
					GFile* _tmp45_;
					_tmp42_ = deletions;
					if (_tmp42_ == NULL) {
						(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
						deletions = NULL;
					}
					_tmp43_ = change;
					_tmp44_ = _tmp43_->from;
					_tmp45_ = _g_object_ref0 (_tmp44_);
					deletions = g_list_prepend (deletions, _tmp45_);
					break;
				}
				case MARLIN_FILE_CHANGES_KIND_MOVED:
				{
					GList* _tmp46_;
					GArray* pair = NULL;
					GArray* _tmp47_;
					GArray* _tmp48_;
					MarlinFileChangesChange* _tmp49_;
					GFile* _tmp50_;
					GFile* _tmp51_;
					GArray* _tmp52_;
					MarlinFileChangesChange* _tmp53_;
					GFile* _tmp54_;
					GFile* _tmp55_;
					GArray* _tmp56_;
					GArray* _tmp57_;
					_tmp46_ = moves;
					if (_tmp46_ == NULL) {
						(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
						moves = NULL;
					}
					_tmp47_ = g_array_sized_new (FALSE, FALSE, sizeof (GFile*), (guint) 2);
					g_array_set_clear_func (_tmp47_, (GDestroyNotify) _vala_GFile_free_function_content_of);
					pair = _tmp47_;
					_tmp48_ = pair;
					_tmp49_ = change;
					_tmp50_ = _tmp49_->from;
					_tmp51_ = _g_object_ref0 (_tmp50_);
					g_array_append_val (_tmp48_, _tmp51_);
					_tmp52_ = pair;
					_tmp53_ = change;
					_tmp54_ = _tmp53_->to;
					_tmp55_ = _g_object_ref0 (_tmp54_);
					g_array_append_val (_tmp52_, _tmp55_);
					_tmp56_ = pair;
					_tmp57_ = _g_array_ref0 (_tmp56_);
					moves = g_list_prepend (moves, _tmp57_);
					_g_array_unref0 (pair);
					break;
				}
				default:
				{
					g_assert_not_reached ();
				}
			}
			_marlin_file_changes_change_free0 (change);
		}
	}
	(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
	(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
	(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
	(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
}

