/* AbstractDirectoryView.c generated by valac 0.46.6, the Vala compiler
 * generated from AbstractDirectoryView.vala, do not modify */

/*
* Copyright 2015-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Jeremy Wootten <jeremy@elementaryos.org>
*/
/* Implementations of AbstractDirectoryView are
     * IconView
     * ListView
     * ColumnView
*/
/*** Private methods */
/** Signal Handlers */
/** Menu actions */
/** HELPER AND CONVENIENCE FUNCTIONS */
/** Keyboard event handling **/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <cairo.h>
#include "pantheon-files-core.h"
#include <stdlib.h>
#include <string.h>
#include "fm-list-model.h"
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include "marlin-global-preferences.h"
#include <gee.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include "marlin-file-operations.h"
#include "pantheon-files-widgets.h"
#include "config.h"
#include <pango/pango.h>
#include <unistd.h>
#include <sys/types.h>

#define FM_TYPE_ABSTRACT_DIRECTORY_VIEW (fm_abstract_directory_view_get_type ())
#define FM_ABSTRACT_DIRECTORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FM_TYPE_ABSTRACT_DIRECTORY_VIEW, FMAbstractDirectoryView))
#define FM_ABSTRACT_DIRECTORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FM_TYPE_ABSTRACT_DIRECTORY_VIEW, FMAbstractDirectoryViewClass))
#define FM_IS_ABSTRACT_DIRECTORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FM_TYPE_ABSTRACT_DIRECTORY_VIEW))
#define FM_IS_ABSTRACT_DIRECTORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FM_TYPE_ABSTRACT_DIRECTORY_VIEW))
#define FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FM_TYPE_ABSTRACT_DIRECTORY_VIEW, FMAbstractDirectoryViewClass))

typedef struct _FMAbstractDirectoryView FMAbstractDirectoryView;
typedef struct _FMAbstractDirectoryViewClass FMAbstractDirectoryViewClass;
typedef struct _FMAbstractDirectoryViewPrivate FMAbstractDirectoryViewPrivate;

#define MARLIN_TYPE_TEXT_RENDERER (marlin_text_renderer_get_type ())
#define MARLIN_TEXT_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_TYPE_TEXT_RENDERER, MarlinTextRenderer))
#define MARLIN_TEXT_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_TYPE_TEXT_RENDERER, MarlinTextRendererClass))
#define MARLIN_IS_TEXT_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_TYPE_TEXT_RENDERER))
#define MARLIN_IS_TEXT_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_TYPE_TEXT_RENDERER))
#define MARLIN_TEXT_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_TYPE_TEXT_RENDERER, MarlinTextRendererClass))

typedef struct _MarlinTextRenderer MarlinTextRenderer;
typedef struct _MarlinTextRendererClass MarlinTextRendererClass;

#define MARLIN_TYPE_ICON_RENDERER (marlin_icon_renderer_get_type ())
#define MARLIN_ICON_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_TYPE_ICON_RENDERER, MarlinIconRenderer))
#define MARLIN_ICON_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_TYPE_ICON_RENDERER, MarlinIconRendererClass))
#define MARLIN_IS_ICON_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_TYPE_ICON_RENDERER))
#define MARLIN_IS_ICON_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_TYPE_ICON_RENDERER))
#define MARLIN_ICON_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_TYPE_ICON_RENDERER, MarlinIconRendererClass))

typedef struct _MarlinIconRenderer MarlinIconRenderer;
typedef struct _MarlinIconRendererClass MarlinIconRendererClass;

#define MARLIN_VIEW_TYPE_SLOT (marlin_view_slot_get_type ())
#define MARLIN_VIEW_SLOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_VIEW_TYPE_SLOT, MarlinViewSlot))
#define MARLIN_VIEW_SLOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_VIEW_TYPE_SLOT, MarlinViewSlotClass))
#define MARLIN_VIEW_IS_SLOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_VIEW_TYPE_SLOT))
#define MARLIN_VIEW_IS_SLOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_VIEW_TYPE_SLOT))
#define MARLIN_VIEW_SLOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_VIEW_TYPE_SLOT, MarlinViewSlotClass))

typedef struct _MarlinViewSlot MarlinViewSlot;
typedef struct _MarlinViewSlotClass MarlinViewSlotClass;

#define MARLIN_VIEW_TYPE_WINDOW (marlin_view_window_get_type ())
#define MARLIN_VIEW_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_VIEW_TYPE_WINDOW, MarlinViewWindow))
#define MARLIN_VIEW_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_VIEW_TYPE_WINDOW, MarlinViewWindowClass))
#define MARLIN_VIEW_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_VIEW_TYPE_WINDOW))
#define MARLIN_VIEW_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_VIEW_TYPE_WINDOW))
#define MARLIN_VIEW_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_VIEW_TYPE_WINDOW, MarlinViewWindowClass))

typedef struct _MarlinViewWindow MarlinViewWindow;
typedef struct _MarlinViewWindowClass MarlinViewWindowClass;

#define MARLIN_TYPE_CLIPBOARD_MANAGER (marlin_clipboard_manager_get_type ())
#define MARLIN_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_TYPE_CLIPBOARD_MANAGER, MarlinClipboardManager))
#define MARLIN_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_TYPE_CLIPBOARD_MANAGER, MarlinClipboardManagerClass))
#define MARLIN_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_TYPE_CLIPBOARD_MANAGER))
#define MARLIN_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_TYPE_CLIPBOARD_MANAGER))
#define MARLIN_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_TYPE_CLIPBOARD_MANAGER, MarlinClipboardManagerClass))

typedef struct _MarlinClipboardManager MarlinClipboardManager;
typedef struct _MarlinClipboardManagerClass MarlinClipboardManagerClass;
enum  {
	FM_ABSTRACT_DIRECTORY_VIEW_0_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_SINGLE_CLICK_MODE_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_HIDE_LOCAL_THUMBNAILS_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_IS_ADMIN_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_NUM_PROPERTIES
};
static GParamSpec* fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_NUM_PROPERTIES];
typedef enum  {
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER,
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER,
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON,
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME,
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH,
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH,
	FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID
} FMAbstractDirectoryViewClickZone;

#define FM_ABSTRACT_DIRECTORY_VIEW_TYPE_CLICK_ZONE (fm_abstract_directory_view_click_zone_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

#define MARLIN_TYPE_APPLICATION (marlin_application_get_type ())
#define MARLIN_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_TYPE_APPLICATION, MarlinApplication))
#define MARLIN_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_TYPE_APPLICATION, MarlinApplicationClass))
#define MARLIN_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_TYPE_APPLICATION))
#define MARLIN_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_TYPE_APPLICATION))
#define MARLIN_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_TYPE_APPLICATION, MarlinApplicationClass))

typedef struct _MarlinApplication MarlinApplication;
typedef struct _MarlinApplicationClass MarlinApplicationClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block31Data Block31Data;
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))

#define MARLIN_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG (marlin_view_abstract_properties_dialog_get_type ())
#define MARLIN_VIEW_ABSTRACT_PROPERTIES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, MarlinViewAbstractPropertiesDialog))
#define MARLIN_VIEW_ABSTRACT_PROPERTIES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, MarlinViewAbstractPropertiesDialogClass))
#define MARLIN_VIEW_IS_ABSTRACT_PROPERTIES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG))
#define MARLIN_VIEW_IS_ABSTRACT_PROPERTIES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG))
#define MARLIN_VIEW_ABSTRACT_PROPERTIES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, MarlinViewAbstractPropertiesDialogClass))

typedef struct _MarlinViewAbstractPropertiesDialog MarlinViewAbstractPropertiesDialog;
typedef struct _MarlinViewAbstractPropertiesDialogClass MarlinViewAbstractPropertiesDialogClass;

#define MARLIN_VIEW_TYPE_PROPERTIES_WINDOW (marlin_view_properties_window_get_type ())
#define MARLIN_VIEW_PROPERTIES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_VIEW_TYPE_PROPERTIES_WINDOW, MarlinViewPropertiesWindow))
#define MARLIN_VIEW_PROPERTIES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_VIEW_TYPE_PROPERTIES_WINDOW, MarlinViewPropertiesWindowClass))
#define MARLIN_VIEW_IS_PROPERTIES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_VIEW_TYPE_PROPERTIES_WINDOW))
#define MARLIN_VIEW_IS_PROPERTIES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_VIEW_TYPE_PROPERTIES_WINDOW))
#define MARLIN_VIEW_PROPERTIES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_VIEW_TYPE_PROPERTIES_WINDOW, MarlinViewPropertiesWindowClass))

typedef struct _MarlinViewPropertiesWindow MarlinViewPropertiesWindow;
typedef struct _MarlinViewPropertiesWindowClass MarlinViewPropertiesWindowClass;
typedef struct _Block32Data Block32Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
typedef struct _Block33Data Block33Data;
#define __vala_GdkEventButton_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventButton_free (var), NULL)))

#define FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM (fm_abstract_directory_view_sort_sub_menu_item_get_type ())
#define FM_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FMAbstractDirectoryViewSortSubMenuItem))
#define FM_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FMAbstractDirectoryViewSortSubMenuItemClass))
#define FM_ABSTRACT_DIRECTORY_VIEW_IS_SORT_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM))
#define FM_ABSTRACT_DIRECTORY_VIEW_IS_SORT_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM))
#define FM_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FMAbstractDirectoryViewSortSubMenuItemClass))

typedef struct _FMAbstractDirectoryViewSortSubMenuItem FMAbstractDirectoryViewSortSubMenuItem;
typedef struct _FMAbstractDirectoryViewSortSubMenuItemClass FMAbstractDirectoryViewSortSubMenuItemClass;

#define FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM (fm_abstract_directory_view_new_sub_menu_item_get_type ())
#define FM_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FMAbstractDirectoryViewNewSubMenuItem))
#define FM_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FMAbstractDirectoryViewNewSubMenuItemClass))
#define FM_ABSTRACT_DIRECTORY_VIEW_IS_NEW_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM))
#define FM_ABSTRACT_DIRECTORY_VIEW_IS_NEW_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM))
#define FM_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FMAbstractDirectoryViewNewSubMenuItemClass))

typedef struct _FMAbstractDirectoryViewNewSubMenuItem FMAbstractDirectoryViewNewSubMenuItem;
typedef struct _FMAbstractDirectoryViewNewSubMenuItemClass FMAbstractDirectoryViewNewSubMenuItemClass;
typedef struct _Block34Data Block34Data;
typedef struct _Block35Data Block35Data;

#define MARLIN_TYPE_ABSTRACT_EDITABLE_LABEL (marlin_abstract_editable_label_get_type ())
#define MARLIN_ABSTRACT_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_TYPE_ABSTRACT_EDITABLE_LABEL, MarlinAbstractEditableLabel))
#define MARLIN_ABSTRACT_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_TYPE_ABSTRACT_EDITABLE_LABEL, MarlinAbstractEditableLabelClass))
#define MARLIN_IS_ABSTRACT_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_TYPE_ABSTRACT_EDITABLE_LABEL))
#define MARLIN_IS_ABSTRACT_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_TYPE_ABSTRACT_EDITABLE_LABEL))
#define MARLIN_ABSTRACT_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_TYPE_ABSTRACT_EDITABLE_LABEL, MarlinAbstractEditableLabelClass))

typedef struct _MarlinAbstractEditableLabel MarlinAbstractEditableLabel;
typedef struct _MarlinAbstractEditableLabelClass MarlinAbstractEditableLabelClass;
typedef struct _FmAbstractDirectoryViewSetFileDisplayNameData FmAbstractDirectoryViewSetFileDisplayNameData;
typedef struct _Block36Data Block36Data;
typedef struct _Block37Data Block37Data;
typedef struct _Block38Data Block38Data;
#define __vala_GtkTreeRowReference_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL)))
typedef struct _MarlinIconRendererPrivate MarlinIconRendererPrivate;
typedef struct _FMAbstractDirectoryViewSortSubMenuItemPrivate FMAbstractDirectoryViewSortSubMenuItemPrivate;
enum  {
	FM_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_0_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* fm_abstract_directory_view_sort_sub_menu_item_properties[FM_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_NUM_PROPERTIES];
typedef struct _FMAbstractDirectoryViewNewSubMenuItemPrivate FMAbstractDirectoryViewNewSubMenuItemPrivate;
enum  {
	FM_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_0_PROPERTY,
	FM_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* fm_abstract_directory_view_new_sub_menu_item_properties[FM_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_NUM_PROPERTIES];
enum  {
	FM_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL,
	FM_ABSTRACT_DIRECTORY_VIEW_ITEM_HOVERED_SIGNAL,
	FM_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL,
	FM_ABSTRACT_DIRECTORY_VIEW_NUM_SIGNALS
};
static guint fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FMAbstractDirectoryView {
	GtkScrolledWindow parent_instance;
	FMAbstractDirectoryViewPrivate * priv;
	MarlinZoomLevel minimum_zoom;
	MarlinZoomLevel maximum_zoom;
	gboolean large_thumbnails;
	gboolean dnd_disabled;
	MarlinTextRenderer* name_renderer;
	gchar* original_name;
	gchar* proposed_name;
	gboolean activate_on_blank;
	gboolean right_margin_unselects_all;
	gboolean should_activate;
	gboolean should_scroll;
	gboolean should_deselect;
	GtkTreePath* click_path;
	guint click_zone;
	guint previous_click_zone;
	GList* selected_files;
	gboolean is_writable;
	gboolean is_loading;
	gboolean helpers_shown;
	FMListModel* model;
	MarlinIconRenderer* icon_renderer;
	MarlinViewSlot* slot;
	MarlinViewWindow* window;
	GtkRecentManager* recent;
};

struct _FMAbstractDirectoryViewClass {
	GtkScrolledWindowClass parent_class;
	void (*set_up_name_renderer) (FMAbstractDirectoryView* self);
	void (*on_row_deleted) (FMAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*on_view_key_press_event) (FMAbstractDirectoryView* self, GdkEventKey* event);
	gboolean (*on_scroll_event) (FMAbstractDirectoryView* self, GdkEventScroll* event);
	gboolean (*on_view_draw) (FMAbstractDirectoryView* self, cairo_t* cr);
	gboolean (*handle_primary_button_click) (FMAbstractDirectoryView* self, GdkEventButton* event, GtkTreePath* path);
	gboolean (*handle_secondary_button_click) (FMAbstractDirectoryView* self, GdkEventButton* event);
	gboolean (*on_view_button_press_event) (FMAbstractDirectoryView* self, GdkEventButton* event);
	gboolean (*on_view_button_release_event) (FMAbstractDirectoryView* self, GdkEventButton* event);
	void (*change_zoom_level) (FMAbstractDirectoryView* self);
	gboolean (*expand_collapse) (FMAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*handle_default_button_click) (FMAbstractDirectoryView* self, GdkEventButton* event);
	gboolean (*get_next_visible_iter) (FMAbstractDirectoryView* self, GtkTreeIter* iter, gboolean recurse);
	void (*cancel) (FMAbstractDirectoryView* self);
	void (*highlight_path) (FMAbstractDirectoryView* self, GtkTreePath* path);
	GtkTreePath* (*up) (FMAbstractDirectoryView* self, GtkTreePath* path);
	GtkTreePath* (*down) (FMAbstractDirectoryView* self, GtkTreePath* path);
	GList* (*get_selected_paths) (FMAbstractDirectoryView* self);
	GtkTreePath* (*get_path_at_pos) (FMAbstractDirectoryView* self, gint x, gint win);
	GtkTreePath* (*get_path_at_cursor) (FMAbstractDirectoryView* self);
	void (*tree_select_all) (FMAbstractDirectoryView* self);
	void (*tree_unselect_all) (FMAbstractDirectoryView* self);
	void (*tree_unselect_others) (FMAbstractDirectoryView* self);
	void (*select_path) (FMAbstractDirectoryView* self, GtkTreePath* path, gboolean cursor_follows);
	void (*unselect_path) (FMAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*path_is_selected) (FMAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*get_visible_range) (FMAbstractDirectoryView* self, GtkTreePath* * start_path, GtkTreePath* * end_path);
	void (*set_cursor) (FMAbstractDirectoryView* self, GtkTreePath* path, gboolean start_editing, gboolean select, gboolean scroll_to_top);
	gboolean (*move_cursor) (FMAbstractDirectoryView* self, guint keyval, gboolean only_shift_pressed, gboolean control_pressed);
	gboolean (*will_handle_button_press) (FMAbstractDirectoryView* self, gboolean no_mods, gboolean only_control_pressed, gboolean only_shift_pressed);
	gboolean (*handle_multi_select) (FMAbstractDirectoryView* self, GtkTreePath* path);
	GtkWidget* (*create_view) (FMAbstractDirectoryView* self);
	MarlinZoomLevel (*get_set_up_zoom_level) (FMAbstractDirectoryView* self);
	MarlinZoomLevel (*get_normal_zoom_level) (FMAbstractDirectoryView* self);
	gboolean (*view_has_focus) (FMAbstractDirectoryView* self);
	guint (*get_selected_files_from_model) (FMAbstractDirectoryView* self, GList* * selected_files);
	guint (*get_event_position_info) (FMAbstractDirectoryView* self, GdkEventButton* event, GtkTreePath* * path, gboolean rubberband);
	void (*scroll_to_cell) (FMAbstractDirectoryView* self, GtkTreePath* path, gboolean scroll_to_top);
	void (*set_cursor_on_cell) (FMAbstractDirectoryView* self, GtkTreePath* path, GtkCellRenderer* renderer, gboolean start_editing, gboolean scroll_to_top);
	void (*freeze_tree) (FMAbstractDirectoryView* self);
	void (*thaw_tree) (FMAbstractDirectoryView* self);
	void (*freeze_child_notify) (FMAbstractDirectoryView* self);
	void (*thaw_child_notify) (FMAbstractDirectoryView* self);
	void (*connect_tree_signals) (FMAbstractDirectoryView* self);
	void (*disconnect_tree_signals) (FMAbstractDirectoryView* self);
};

struct _FMAbstractDirectoryViewPrivate {
	GSimpleActionGroup* common_actions;
	GSimpleActionGroup* selection_actions;
	GSimpleActionGroup* background_actions;
	MarlinZoomLevel _zoom_level;
	gint drag_x;
	gint drag_y;
	gint drag_button;
	guint drag_timer_id;
	GList* source_drag_file_list;
	GdkAtom current_target_type;
	guint drag_scroll_timer_id;
	guint drag_enter_timer_id;
	gboolean destination_data_ready;
	gboolean drop_occurred;
	GOFFile* drop_target_file;
	GList* destination_drop_file_list;
	GdkDragAction current_suggested_action;
	GdkDragAction current_actions;
	gboolean _drop_highlight;
	void* drag_data;
	gint thumbnail_request;
	guint thumbnail_source_id;
	guint freeze_source_id;
	MarlinThumbnailer* thumbnailer;
	guint add_remove_file_timeout_id;
	gboolean signal_free_space_change;
	gdouble total_delta_y;
	GtkTreePath* deleted_path;
	gboolean _single_click_mode;
	GdkCursor* editable_cursor;
	GdkCursor* activatable_cursor;
	GdkCursor* selectable_cursor;
	GList* open_with_apps;
	gboolean selected_files_invalid;
	GAppInfo* default_app;
	GtkTreePath* hover_path;
	gboolean _renaming;
	gboolean _is_frozen;
	gboolean _in_recent;
	gboolean _tree_frozen;
	gboolean in_trash;
	gboolean in_network_root;
	gboolean _show_remote_thumbnails;
	gboolean _hide_local_thumbnails;
	gboolean all_selected;
	GtkWidget* view;
	MarlinClipboardManager* clipboard;
	gulong select_source_handler;
	guint draw_timeout_id;
};

struct _Block25Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	gboolean select;
};

struct _Block26Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GeeLinkedList* files_to_select_list;
	GFile* focus_after_select;
};

struct _Block27Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GdkScreen* screen;
	MarlinOpenFlag flag;
};

struct _Block28Data {
	int _ref_count_;
	Block27Data * _data27_;
	GOFFile* file;
};

struct _Block29Data {
	int _ref_count_;
	Block27Data * _data27_;
	GList* files_to_open;
};

struct _Block30Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	gboolean only_folders;
};

struct _Block31Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GList* locations;
};

struct _Block32Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GFile* target;
};

struct _Block33Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GdkEvent* event;
};

struct _Block34Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GdkDragContext* context;
};

struct _Block35Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GList* action_files;
};

struct _FmAbstractDirectoryViewSetFileDisplayNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FMAbstractDirectoryView* self;
	GFile* old_location;
	gchar* new_name;
	GCancellable* cancellable;
	GFile* result;
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* e;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

struct _Block36Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GdkEventButton* event;
};

struct _Block37Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GtkTreePath* path;
	guint count;
	gboolean ok_next_time;
	GtkTreePath* start_path;
};

struct _Block38Data {
	int _ref_count_;
	FMAbstractDirectoryView* self;
	GOFDirectoryAsync* dir;
};

struct _MarlinIconRenderer {
	GtkCellRenderer parent_instance;
	MarlinIconRendererPrivate * priv;
	GdkRectangle hover_helper_rect;
	GdkRectangle hover_rect;
};

struct _MarlinIconRendererClass {
	GtkCellRendererClass parent_class;
};

struct _FMAbstractDirectoryViewSortSubMenuItem {
	GtkMenuItem parent_instance;
	FMAbstractDirectoryViewSortSubMenuItemPrivate * priv;
};

struct _FMAbstractDirectoryViewSortSubMenuItemClass {
	GtkMenuItemClass parent_class;
};

struct _FMAbstractDirectoryViewNewSubMenuItem {
	GtkMenuItem parent_instance;
	FMAbstractDirectoryViewNewSubMenuItemPrivate * priv;
};

struct _FMAbstractDirectoryViewNewSubMenuItemClass {
	GtkMenuItemClass parent_class;
};

static gint FMAbstractDirectoryView_private_offset;
static gpointer fm_abstract_directory_view_parent_class = NULL;
static GList* fm_abstract_directory_view_templates;
static GList* fm_abstract_directory_view_templates = NULL;
extern MarlinDndHandler* fm_abstract_directory_view_dnd_handler;
MarlinDndHandler* fm_abstract_directory_view_dnd_handler = NULL;
static gpointer fm_abstract_directory_view_sort_sub_menu_item_parent_class = NULL;
static gpointer fm_abstract_directory_view_new_sub_menu_item_parent_class = NULL;

GType fm_abstract_directory_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FMAbstractDirectoryView, g_object_unref)
GType marlin_text_renderer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinTextRenderer, g_object_unref)
GType marlin_icon_renderer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinIconRenderer, g_object_unref)
GType marlin_view_slot_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinViewSlot, g_object_unref)
GType marlin_view_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinViewWindow, g_object_unref)
GType marlin_clipboard_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinClipboardManager, g_object_unref)
GType fm_abstract_directory_view_click_zone_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
#define FM_ABSTRACT_DIRECTORY_VIEW_MAX_TEMPLATES 32
#define FM_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
static void fm_abstract_directory_view_on_selection_action_open_executable (FMAbstractDirectoryView* self,
                                                                     GSimpleAction* action,
                                                                     GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self);
static void fm_abstract_directory_view_on_selection_action_open_with_app (FMAbstractDirectoryView* self,
                                                                   GSimpleAction* action,
                                                                   GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                     GVariant* parameter,
                                                                                                     gpointer self);
static void fm_abstract_directory_view_on_selection_action_open_with_default (FMAbstractDirectoryView* self,
                                                                       GSimpleAction* action,
                                                                       GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                         GVariant* parameter,
                                                                                                         gpointer self);
static void fm_abstract_directory_view_on_selection_action_open_with_other_app (FMAbstractDirectoryView* self);
static void _fm_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void fm_abstract_directory_view_on_selection_action_rename (FMAbstractDirectoryView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
static void fm_abstract_directory_view_on_selection_action_view_in_location (FMAbstractDirectoryView* self,
                                                                      GSimpleAction* action,
                                                                      GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                        GVariant* parameter,
                                                                                                        gpointer self);
static void fm_abstract_directory_view_on_selection_action_forget (FMAbstractDirectoryView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
static void fm_abstract_directory_view_on_selection_action_cut (FMAbstractDirectoryView* self,
                                                         GSimpleAction* action,
                                                         GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                           GVariant* parameter,
                                                                                           gpointer self);
static void fm_abstract_directory_view_on_selection_action_trash (FMAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self);
static void fm_abstract_directory_view_on_selection_action_delete (FMAbstractDirectoryView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
static void fm_abstract_directory_view_on_selection_action_restore (FMAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _fm_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void fm_abstract_directory_view_on_background_action_new (FMAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param);
static void _fm_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self);
static void fm_abstract_directory_view_on_background_action_create_from (FMAbstractDirectoryView* self,
                                                                  GSimpleAction* action,
                                                                  GVariant* param);
static void _fm_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                    GVariant* parameter,
                                                                                                    gpointer self);
static void fm_abstract_directory_view_on_background_action_sort_by_changed (FMAbstractDirectoryView* self,
                                                                      GSimpleAction* action,
                                                                      GVariant* val);
static void _fm_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                        GVariant* parameter,
                                                                                                        gpointer self);
static void fm_abstract_directory_view_on_background_action_reverse_changed (FMAbstractDirectoryView* self,
                                                                      GSimpleAction* action,
                                                                      GVariant* val);
static void _fm_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                        GVariant* parameter,
                                                                                                        gpointer self);
static void fm_abstract_directory_view_on_background_action_folders_first_changed (FMAbstractDirectoryView* self,
                                                                            GSimpleAction* action,
                                                                            GVariant* val);
static void _fm_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                              GVariant* parameter,
                                                                                                              gpointer self);
static void fm_abstract_directory_view_change_state_show_hidden (FMAbstractDirectoryView* self,
                                                          GSimpleAction* action);
static void _fm_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                GVariant* value,
                                                                                                gpointer self);
static void fm_abstract_directory_view_change_state_show_remote_thumbnails (FMAbstractDirectoryView* self,
                                                                     GSimpleAction* action);
static void _fm_abstract_directory_view_change_state_show_remote_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                           GVariant* value,
                                                                                                           gpointer self);
static void fm_abstract_directory_view_change_state_hide_local_thumbnails (FMAbstractDirectoryView* self,
                                                                    GSimpleAction* action);
static void _fm_abstract_directory_view_change_state_hide_local_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                          GVariant* value,
                                                                                                          gpointer self);
static void fm_abstract_directory_view_on_common_action_copy (FMAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param);
static void _fm_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self);
static void fm_abstract_directory_view_on_common_action_paste_into (FMAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _fm_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void fm_abstract_directory_view_on_common_action_open_in (FMAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param);
static void _fm_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self);
static void fm_abstract_directory_view_on_common_action_bookmark (FMAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param);
static void _fm_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self);
static void fm_abstract_directory_view_on_common_action_properties (FMAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _fm_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void fm_abstract_directory_view_on_common_action_copy_link (FMAbstractDirectoryView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _fm_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
FMAbstractDirectoryView* fm_abstract_directory_view_construct (GType object_type,
                                                               MarlinViewSlot* _slot);
MarlinViewWindow* marlin_view_slot_get_window (MarlinViewSlot* self);
GType marlin_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinApplication, g_object_unref)
MarlinClipboardManager* marlin_application_get_clipboard_manager (MarlinApplication* self);
GtkRecentManager* marlin_application_get_recent_manager (MarlinApplication* self);
MarlinIconRenderer* marlin_icon_renderer_new (void);
MarlinIconRenderer* marlin_icon_renderer_construct (GType object_type);
static void __lambda84_ (FMAbstractDirectoryView* self,
                  guint req);
static void fm_abstract_directory_view_draw_when_idle (FMAbstractDirectoryView* self);
static void ___lambda84__marlin_thumbnailer_finished (MarlinThumbnailer* _sender,
                                               guint request,
                                               gpointer self);
static void fm_abstract_directory_view_set_up__menu_actions (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_set_up_directory_view (FMAbstractDirectoryView* self);
GtkWidget* fm_abstract_directory_view_create_view (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_connect_drag_drop_signals (FMAbstractDirectoryView* self,
                                                           GtkWidget* widget);
gboolean fm_abstract_directory_view_on_motion_notify_event (FMAbstractDirectoryView* self,
                                                            GdkEventMotion* event);
static gboolean _fm_abstract_directory_view_on_motion_notify_event_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                            GdkEventMotion* event,
                                                                                            gpointer self);
gboolean fm_abstract_directory_view_on_leave_notify_event (FMAbstractDirectoryView* self,
                                                           GdkEventCrossing* event);
static gboolean _fm_abstract_directory_view_on_leave_notify_event_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                                          GdkEventCrossing* event,
                                                                                          gpointer self);
gboolean fm_abstract_directory_view_on_view_key_press_event (FMAbstractDirectoryView* self,
                                                             GdkEventKey* event);
static gboolean _fm_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                         GdkEventKey* event,
                                                                                         gpointer self);
gboolean fm_abstract_directory_view_on_view_button_press_event (FMAbstractDirectoryView* self,
                                                                GdkEventButton* event);
static gboolean _fm_abstract_directory_view_on_view_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                               GdkEventButton* event,
                                                                                               gpointer self);
gboolean fm_abstract_directory_view_on_view_button_release_event (FMAbstractDirectoryView* self,
                                                                  GdkEventButton* event);
static gboolean _fm_abstract_directory_view_on_view_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                   GdkEventButton* event,
                                                                                                   gpointer self);
gboolean fm_abstract_directory_view_on_view_draw (FMAbstractDirectoryView* self,
                                                  cairo_t* cr);
static gboolean _fm_abstract_directory_view_on_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                   cairo_t* cr,
                                                                   gpointer self);
void fm_abstract_directory_view_freeze_tree (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_set_up_zoom_level (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_connect_directory_handlers (FMAbstractDirectoryView* self,
                                                            GOFDirectoryAsync* dir);
void fm_abstract_directory_view_set_up_name_renderer (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_set_up_name_renderer (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_on_name_edited (FMAbstractDirectoryView* self,
                                                const gchar* path_string,
                                                const gchar* new_name);
static void _fm_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited (GtkCellRendererText* _sender,
                                                                               const gchar* path,
                                                                               const gchar* new_text,
                                                                               gpointer self);
void fm_abstract_directory_view_on_name_editing_canceled (FMAbstractDirectoryView* self);
static void _fm_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                              gpointer self);
void fm_abstract_directory_view_on_name_editing_started (FMAbstractDirectoryView* self,
                                                         GtkCellEditable* editable,
                                                         const gchar* path_string);
static void _fm_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                            GtkCellEditable* editable,
                                                                                            const gchar* path,
                                                                                            gpointer self);
static gboolean fm_abstract_directory_view_on_popup_menu (FMAbstractDirectoryView* self);
static gboolean _fm_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                          gpointer self);
static void __lambda85_ (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_on_clipboard_changed (FMAbstractDirectoryView* self);
static void _fm_abstract_directory_view_on_clipboard_changed_marlin_clipboard_manager_changed (MarlinClipboardManager* _sender,
                                                                                        gpointer self);
static void ___lambda85__gtk_widget_unrealize (GtkWidget* _sender,
                                        gpointer self);
static void __lambda86_ (FMAbstractDirectoryView* self);
static void ___lambda86__gtk_widget_realize (GtkWidget* _sender,
                                      gpointer self);
gboolean fm_abstract_directory_view_on_scroll_event (FMAbstractDirectoryView* self,
                                                     GdkEventScroll* event);
static gboolean _fm_abstract_directory_view_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                              GdkEventScroll* event,
                                                                              gpointer self);
static void __lambda87_ (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_schedule_thumbnail_timeout (FMAbstractDirectoryView* self);
static void ___lambda87__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
static void fm_abstract_directory_view_on_show_hidden_files_changed (FMAbstractDirectoryView* self,
                                                              GObject* prefs,
                                                              GParamSpec* pspec);
static void _fm_abstract_directory_view_on_show_hidden_files_changed_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self);
static void fm_abstract_directory_view_on_show_remote_thumbnails_changed (FMAbstractDirectoryView* self,
                                                                   GObject* prefs,
                                                                   GParamSpec* pspec);
static void _fm_abstract_directory_view_on_show_remote_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                    GParamSpec* pspec,
                                                                                    gpointer self);
static void fm_abstract_directory_view_on_hide_local_thumbnails_changed (FMAbstractDirectoryView* self,
                                                                  GObject* prefs,
                                                                  GParamSpec* pspec);
static void _fm_abstract_directory_view_on_hide_local_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                   GParamSpec* pspec,
                                                                                   gpointer self);
static void fm_abstract_directory_view_on_sort_directories_first_changed (FMAbstractDirectoryView* self,
                                                                   GObject* prefs,
                                                                   GParamSpec* pspec);
static void _fm_abstract_directory_view_on_sort_directories_first_changed_g_object_notify (GObject* _sender,
                                                                                    GParamSpec* pspec,
                                                                                    gpointer self);
void fm_abstract_directory_view_on_row_deleted (FMAbstractDirectoryView* self,
                                                GtkTreePath* path);
static void _fm_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                                                            GtkTreePath* path,
                                                                            gpointer self);
void fm_abstract_directory_view_on_sort_column_changed (FMAbstractDirectoryView* self);
static void _fm_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                               gpointer self);
static void fm_abstract_directory_view_action_set_state (FMAbstractDirectoryView* self,
                                                  GSimpleActionGroup* action_group,
                                                  const gchar* name,
                                                  GVariant* val);
static GVariant* _variant_new3 (gboolean value);
static GVariant* _variant_new4 (gboolean value);
static GVariant* _variant_new5 (gboolean value);
void fm_abstract_directory_view_zoom_in (FMAbstractDirectoryView* self);
MarlinZoomLevel fm_abstract_directory_view_get_zoom_level (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_set_zoom_level (FMAbstractDirectoryView* self,
                                                MarlinZoomLevel value);
void fm_abstract_directory_view_zoom_out (FMAbstractDirectoryView* self);
MarlinZoomLevel fm_abstract_directory_view_get_set_up_zoom_level (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_zoom_normal (FMAbstractDirectoryView* self);
MarlinZoomLevel fm_abstract_directory_view_get_normal_zoom_level (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_focus_first_for_empty_selection (FMAbstractDirectoryView* self,
                                                                 gboolean select);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static gboolean ___lambda80_ (Block25Data* _data25_);
gboolean fm_abstract_directory_view_get_tree_frozen (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_set_cursor (FMAbstractDirectoryView* self,
                                            GtkTreePath* path,
                                            gboolean start_editing,
                                            gboolean select,
                                            gboolean scroll_to_top);
static gboolean ____lambda80__gsource_func (gpointer self);
void fm_abstract_directory_view_select_glib_files_when_thawed (FMAbstractDirectoryView* self,
                                                               GList* location_list,
                                                               GFile* focus_location);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static void __lambda78_ (Block26Data* _data26_,
                  GFile* loc);
static void ___lambda78__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda79_ (Block26Data* _data26_);
static void fm_abstract_directory_view_select_files_and_update_if_thawed (FMAbstractDirectoryView* self,
                                                                   GeeLinkedList* files_to_select,
                                                                   GFile* focus_file);
static void ____lambda79__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
void fm_abstract_directory_view_disconnect_tree_signals (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_unselect_all (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_select_path (FMAbstractDirectoryView* self,
                                             GtkTreePath* path,
                                             gboolean cursor_follows);
void fm_abstract_directory_view_connect_tree_signals (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_on_view_selection_changed (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_update_selected_files_and_menu (FMAbstractDirectoryView* self);
GList* fm_abstract_directory_view_get_open_with_apps (FMAbstractDirectoryView* self);
GAppInfo* fm_abstract_directory_view_get_default_app (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_grab_focus (FMAbstractDirectoryView* self);
gboolean marlin_view_slot_get_is_active (MarlinViewSlot* self);
void fm_abstract_directory_view_set_active_slot (FMAbstractDirectoryView* self,
                                                 gboolean scroll);
GList* fm_abstract_directory_view_get_selected_files (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_load_location (FMAbstractDirectoryView* self,
                                               GFile* location);
void fm_abstract_directory_view_load_root_location (FMAbstractDirectoryView* self,
                                                    GFile* location);
void fm_abstract_directory_view_activate_selected_items (FMAbstractDirectoryView* self,
                                                         MarlinOpenFlag flag,
                                                         GList* selection);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
gboolean fm_abstract_directory_view_get_is_frozen (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_activate_file (FMAbstractDirectoryView* self,
                                               GOFFile* _file,
                                               GdkScreen* screen,
                                               MarlinOpenFlag flag,
                                               gboolean only_one_file);
static gboolean fm_abstract_directory_view_app_is_this_app (FMAbstractDirectoryView* self,
                                                     GAppInfo* ai);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static gboolean _______lambda46_ (Block28Data* _data28_);
static gboolean ________lambda46__gsource_func (gpointer self);
static gboolean _______lambda47_ (Block28Data* _data28_);
static void fm_abstract_directory_view_open_file (FMAbstractDirectoryView* self,
                                           GOFFile* file,
                                           GdkScreen* screen,
                                           GAppInfo* app_info);
static gboolean ________lambda47__gsource_func (gpointer self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static gboolean _____lambda48_ (Block29Data* _data29_);
static void fm_abstract_directory_view_open_files_with (FMAbstractDirectoryView* self,
                                                 GAppInfo* app,
                                                 GList* files);
static gboolean ______lambda48__gsource_func (gpointer self);
void fm_abstract_directory_view_select_gof_file (FMAbstractDirectoryView* self,
                                                 GOFFile* file);
void fm_abstract_directory_view_select_and_scroll_to_gof_file (FMAbstractDirectoryView* self,
                                                               GOFFile* file);
void fm_abstract_directory_view_add_gof_file_to_selection (FMAbstractDirectoryView* self,
                                                           GOFFile* file);
static void fm_abstract_directory_view_on_directory_file_added (FMAbstractDirectoryView* self,
                                                         GOFDirectoryAsync* dir,
                                                         GOFFile* file);
static void _fm_abstract_directory_view_on_directory_file_added_gof_directory_async_file_added (GOFDirectoryAsync* _sender,
                                                                                         GOFFile* file,
                                                                                         gpointer self);
static void fm_abstract_directory_view_on_directory_file_changed (FMAbstractDirectoryView* self,
                                                           GOFDirectoryAsync* dir,
                                                           GOFFile* file);
static void _fm_abstract_directory_view_on_directory_file_changed_gof_directory_async_file_changed (GOFDirectoryAsync* _sender,
                                                                                             GOFFile* file,
                                                                                             gpointer self);
static void fm_abstract_directory_view_on_directory_file_deleted (FMAbstractDirectoryView* self,
                                                           GOFDirectoryAsync* dir,
                                                           GOFFile* file);
static void _fm_abstract_directory_view_on_directory_file_deleted_gof_directory_async_file_deleted (GOFDirectoryAsync* _sender,
                                                                                             GOFFile* file,
                                                                                             gpointer self);
static void fm_abstract_directory_view_on_directory_file_icon_changed (FMAbstractDirectoryView* self,
                                                                GOFDirectoryAsync* dir,
                                                                GOFFile* file);
static void _fm_abstract_directory_view_on_directory_file_icon_changed_gof_directory_async_icon_changed (GOFDirectoryAsync* _sender,
                                                                                                  GOFFile* file,
                                                                                                  gpointer self);
void fm_abstract_directory_view_connect_directory_loading_handlers (FMAbstractDirectoryView* self,
                                                                    GOFDirectoryAsync* dir);
static void fm_abstract_directory_view_on_directory_file_loaded (FMAbstractDirectoryView* self,
                                                          GOFDirectoryAsync* dir,
                                                          GOFFile* file);
static void _fm_abstract_directory_view_on_directory_file_loaded_gof_directory_async_file_loaded (GOFDirectoryAsync* _sender,
                                                                                           GOFFile* file,
                                                                                           gpointer self);
static void fm_abstract_directory_view_on_directory_done_loading (FMAbstractDirectoryView* self,
                                                           GOFDirectoryAsync* dir);
static void _fm_abstract_directory_view_on_directory_done_loading_gof_directory_async_done_loading (GOFDirectoryAsync* _sender,
                                                                                             gpointer self);
void fm_abstract_directory_view_disconnect_directory_loading_handlers (FMAbstractDirectoryView* self,
                                                                       GOFDirectoryAsync* dir);
void fm_abstract_directory_view_disconnect_directory_handlers (FMAbstractDirectoryView* self,
                                                               GOFDirectoryAsync* dir);
void fm_abstract_directory_view_change_directory (FMAbstractDirectoryView* self,
                                                  GOFDirectoryAsync* old_dir,
                                                  GOFDirectoryAsync* new_dir);
void fm_abstract_directory_view_cancel (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_clear (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_prepare_reload (FMAbstractDirectoryView* self,
                                                GOFDirectoryAsync* dir);
void fm_abstract_directory_view_block_model (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_unblock_model (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_on_drag_drop (FMAbstractDirectoryView* self,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  guint timestamp);
static gboolean _fm_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop (GtkWidget* _sender,
                                                                        GdkDragContext* context,
                                                                        gint x,
                                                                        gint y,
                                                                        guint time_,
                                                                        gpointer self);
static void fm_abstract_directory_view_on_drag_data_received (FMAbstractDirectoryView* self,
                                                       GdkDragContext* context,
                                                       gint x,
                                                       gint y,
                                                       GtkSelectionData* selection_data,
                                                       guint info,
                                                       guint timestamp);
static void _fm_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                      GdkDragContext* context,
                                                                                      gint x,
                                                                                      gint y,
                                                                                      GtkSelectionData* selection_data,
                                                                                      guint info,
                                                                                      guint time_,
                                                                                      gpointer self);
static void fm_abstract_directory_view_on_drag_leave (FMAbstractDirectoryView* self,
                                               GdkDragContext* context,
                                               guint timestamp);
static void _fm_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                                      GdkDragContext* context,
                                                                      guint time_,
                                                                      gpointer self);
static gboolean fm_abstract_directory_view_on_drag_motion (FMAbstractDirectoryView* self,
                                                    GdkDragContext* context,
                                                    gint x,
                                                    gint y,
                                                    guint timestamp);
static gboolean _fm_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                            GdkDragContext* context,
                                                                            gint x,
                                                                            gint y,
                                                                            guint time_,
                                                                            gpointer self);
static void fm_abstract_directory_view_on_drag_begin (FMAbstractDirectoryView* self,
                                               GdkDragContext* context);
static void _fm_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                      GdkDragContext* context,
                                                                      gpointer self);
static void fm_abstract_directory_view_on_drag_data_get (FMAbstractDirectoryView* self,
                                                  GdkDragContext* context,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint timestamp);
static void _fm_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                            GdkDragContext* context,
                                                                            GtkSelectionData* selection_data,
                                                                            guint info,
                                                                            guint time_,
                                                                            gpointer self);
static void fm_abstract_directory_view_on_drag_data_delete (FMAbstractDirectoryView* self,
                                                     GdkDragContext* context);
static void _fm_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete (GtkWidget* _sender,
                                                                                  GdkDragContext* context,
                                                                                  gpointer self);
static void fm_abstract_directory_view_on_drag_end (FMAbstractDirectoryView* self,
                                             GdkDragContext* context);
static void _fm_abstract_directory_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  gpointer self);
void fm_abstract_directory_view_cancel_drag_timer (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_disconnect_drag_timeout_motion_and_release_events (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_cancel_timeout (FMAbstractDirectoryView* self,
                                                guint* id);
void fm_abstract_directory_view_cancel_thumbnailing (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_selection_only_contains_folders (FMAbstractDirectoryView* self,
                                                                     GList* list);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void __lambda36_ (Block30Data* _data30_,
                  GOFFile* file);
static void ___lambda36__gfunc (gconstpointer data,
                         gpointer self);
gboolean fm_abstract_directory_view_handle_scroll_event (FMAbstractDirectoryView* self,
                                                         GdkEventScroll* event);
GList* fm_abstract_directory_view_get_selected_files_for_transfer (FMAbstractDirectoryView* self,
                                                                   GList* selection);
gboolean fm_abstract_directory_view_get_in_recent (FMAbstractDirectoryView* self);
GAppInfo* marlin_mime_actions_get_default_application_for_file (GOFFile* file);
static gboolean fm_abstract_directory_view_can_open_file (FMAbstractDirectoryView* self,
                                                   GOFFile* file,
                                                   gboolean show_error_dialog);
void marlin_mime_actions_open_glib_file_request (GFile* file_to_open,
                                                 GtkWidget* parent,
                                                 GAppInfo* app);
static void fm_abstract_directory_view_trash_or_delete_files (FMAbstractDirectoryView* self,
                                                       GList* file_list,
                                                       gboolean delete_if_already_in_trash,
                                                       gboolean delete_immediately);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void ___lambda41_ (Block31Data* _data31_,
                   GOFFile* file);
static void ____lambda41__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda42_ (Block31Data* _data31_,
                   GOFFile* file);
static void ____lambda42__gfunc (gconstpointer data,
                          gpointer self);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static void ___lambda43_ (FMAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
void fm_abstract_directory_view_after_trash_or_delete (FMAbstractDirectoryView* self);
static void ____lambda43__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void fm_abstract_directory_view_add_file (FMAbstractDirectoryView* self,
                                          GOFFile* file,
                                          GOFDirectoryAsync* dir,
                                          gboolean select);
static void fm_abstract_directory_view_handle_free_space_change (FMAbstractDirectoryView* self);
static gboolean ___lambda63_ (FMAbstractDirectoryView* self);
static gboolean ____lambda63__gsource_func (gpointer self);
static void fm_abstract_directory_view_new_empty_file (FMAbstractDirectoryView* self,
                                                const gchar* parent_uri);
static void __lambda81_ (FMAbstractDirectoryView* self,
                  GObject* obj,
                  GAsyncResult* res);
void fm_abstract_directory_view_create_file_done (GFile* new_file,
                                                  FMAbstractDirectoryView* self);
static void ___lambda81__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void fm_abstract_directory_view_new_empty_folder (FMAbstractDirectoryView* self);
static void __lambda49_ (FMAbstractDirectoryView* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda49__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void fm_abstract_directory_view_after_new_file_added (FMAbstractDirectoryView* self,
                                                      GOFFile* file);
static void _fm_abstract_directory_view_after_new_file_added_gof_directory_async_file_added (GOFDirectoryAsync* _sender,
                                                                                      GOFFile* file,
                                                                                      gpointer self);
void fm_abstract_directory_view_rename_file (FMAbstractDirectoryView* self,
                                             GOFFile* file_to_rename);
gboolean fm_abstract_directory_view_get_renaming (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_start_renaming_file (FMAbstractDirectoryView* self,
                                                     GOFFile* file);
static void fm_abstract_directory_view_unblock_directory_monitor (FMAbstractDirectoryView* self);
static gboolean __lambda44_ (FMAbstractDirectoryView* self);
static gboolean ___lambda44__gsource_func (gpointer self);
static gboolean __lambda45_ (FMAbstractDirectoryView* self);
static gboolean ___lambda45__gsource_func (gpointer self);
static void fm_abstract_directory_view_trash_or_delete_selected_files (FMAbstractDirectoryView* self,
                                                                gboolean delete_immediately);
static void fm_abstract_directory_view_view_selected_file (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_forget_selected_file (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_rename_selected_file (FMAbstractDirectoryView* self);
void marlin_clipboard_manager_cut_files (MarlinClipboardManager* self,
                                         GList* files);
gboolean fm_abstract_directory_view_get_is_admin (FMAbstractDirectoryView* self);
static GList* fm_abstract_directory_view_get_files_for_action (FMAbstractDirectoryView* self);
void marlin_view_window_bookmark_uri (MarlinViewWindow* self,
                                      const gchar* uri,
                                      const gchar* name);
void marlin_view_window_change_state_show_hidden (MarlinViewWindow* self,
                                                  GSimpleAction* action);
void marlin_view_window_change_state_show_remote_thumbnails (MarlinViewWindow* self,
                                                             GSimpleAction* action);
void marlin_view_window_change_state_hide_local_thumbnails (MarlinViewWindow* self,
                                                            GSimpleAction* action);
static void fm_abstract_directory_view_create_from_template (FMAbstractDirectoryView* self,
                                                      GFile* template);
static void fm_abstract_directory_view_set_sort (FMAbstractDirectoryView* self,
                                          const gchar* col_name,
                                          gboolean reverse);
MarlinViewPropertiesWindow* marlin_view_properties_window_new (GList* _files,
                                                               FMAbstractDirectoryView* _view,
                                                               GtkWindow* parent);
MarlinViewPropertiesWindow* marlin_view_properties_window_construct (GType object_type,
                                                                     GList* _files,
                                                                     FMAbstractDirectoryView* _view,
                                                                     GtkWindow* parent);
GType marlin_view_abstract_properties_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinViewAbstractPropertiesDialog, g_object_unref)
GType marlin_view_properties_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinViewPropertiesWindow, g_object_unref)
void marlin_clipboard_manager_copy_link_files (MarlinClipboardManager* self,
                                               GList* files);
void marlin_clipboard_manager_copy_files (MarlinClipboardManager* self,
                                          GList* files);
gboolean marlin_clipboard_manager_get_can_paste (MarlinClipboardManager* self);
gboolean marlin_clipboard_manager_get_files_linked (MarlinClipboardManager* self);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
gboolean marlin_clipboard_manager_has_file (MarlinClipboardManager* self,
                                            GOFFile* file);
void marlin_clipboard_manager_paste_files (MarlinClipboardManager* self,
                                           GFile* target_file,
                                           GtkWidget* widget,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void marlin_clipboard_manager_paste_files_finish (MarlinClipboardManager* self,
                                                  GAsyncResult* _res_);
static void ___lambda83_ (Block32Data* _data32_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda83__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void fm_abstract_directory_view_remove_marlin_icon_info_cache (FMAbstractDirectoryView* self,
                                                               GOFFile* file);
gboolean fm_abstract_directory_view_get_hide_local_thumbnails (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_get_show_remote_thumbnails (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_set_in_recent (FMAbstractDirectoryView* self,
                                               gboolean value);
void fm_abstract_directory_view_thaw_tree (FMAbstractDirectoryView* self);
gint fm_abstract_directory_view_get_column_id_from_string (FMAbstractDirectoryView* self,
                                                           const gchar* col_name);
static void fm_abstract_directory_view_on_zoom_level_changed (FMAbstractDirectoryView* self,
                                                       MarlinZoomLevel zoom);
gint fm_abstract_directory_view_get_icon_size (FMAbstractDirectoryView* self);
void marlin_view_slot_refresh_files (MarlinViewSlot* self);
void fm_abstract_directory_view_change_zoom_level (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_directory_hidden_changed (FMAbstractDirectoryView* self,
                                                          GOFDirectoryAsync* dir,
                                                          gboolean show);
static GVariant* _variant_new6 (gboolean value);
void fm_abstract_directory_view_set_show_remote_thumbnails (FMAbstractDirectoryView* self,
                                                            gboolean value);
static GVariant* _variant_new7 (gboolean value);
void fm_abstract_directory_view_set_hide_local_thumbnails (FMAbstractDirectoryView* self,
                                                           gboolean value);
static GVariant* _variant_new8 (gboolean value);
void fm_abstract_directory_view_show_context_menu (FMAbstractDirectoryView* self,
                                                   GdkEvent* event);
static void _vala_GdkEvent_free (GdkEvent* self);
static gboolean fm_abstract_directory_view_on_drag_timeout_button_release (FMAbstractDirectoryView* self,
                                                                    GdkEventButton* event);
static gboolean fm_abstract_directory_view_on_drag_timeout_motion_notify (FMAbstractDirectoryView* self,
                                                                   GdkEventMotion* event);
static GtkWidget* fm_abstract_directory_view_get_real_view (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_on_row_deleted (FMAbstractDirectoryView* self,
                                                     GtkTreePath* path);
static void fm_abstract_directory_view_check_destination_actions_and_target_file (FMAbstractDirectoryView* self,
                                                                           GdkDragContext* context,
                                                                           gint x,
                                                                           gint y,
                                                                           guint timestamp);
static void fm_abstract_directory_view_get_drag_data (FMAbstractDirectoryView* self,
                                               GdkDragContext* context,
                                               gint x,
                                               gint y,
                                               guint timestamp);
static void fm_abstract_directory_view_start_drag_scroll_timer (FMAbstractDirectoryView* self,
                                                         GdkDragContext* context);
static GOFFile* fm_abstract_directory_view_get_drop_target_file (FMAbstractDirectoryView* self,
                                                          gint win_x,
                                                          gint win_y);
static void fm_abstract_directory_view_clear_destination_drag_data (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_get_drop_highlight (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_set_drop_highlight (FMAbstractDirectoryView* self,
                                                    gboolean value);
void fm_abstract_directory_view_highlight_path (FMAbstractDirectoryView* self,
                                                GtkTreePath* path);
GtkTreePath* fm_abstract_directory_view_get_path_at_pos (FMAbstractDirectoryView* self,
                                                         gint x,
                                                         gint win);
static void fm_abstract_directory_view_highlight_drop_file (FMAbstractDirectoryView* self,
                                                     GOFFile* drop_file,
                                                     GdkDragAction action,
                                                     GtkTreePath* path);
static gboolean fm_abstract_directory_view_is_valid_drop_folder (FMAbstractDirectoryView* self,
                                                          GOFFile* file);
static gboolean _____lambda89_ (FMAbstractDirectoryView* self);
static gboolean ______lambda89__gsource_func (gpointer self);
void fm_abstract_directory_view_start_drag_timer (FMAbstractDirectoryView* self,
                                                  GdkEvent* event);
static GdkEvent* _vala_GdkEvent_copy (GdkEvent* self);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static void fm_abstract_directory_view_connect_drag_timeout_motion_and_release_events (FMAbstractDirectoryView* self);
static GdkEventButton* _vala_GdkEventButton_copy (GdkEventButton* self);
static gboolean __lambda91_ (Block33Data* _data33_);
static gboolean ___lambda91__gsource_func (gpointer self);
static void _vala_GdkEventButton_free (GdkEventButton* self);
static void fm_abstract_directory_view_update_menu_actions (FMAbstractDirectoryView* self);
static GVariant* _variant_new9 (const gchar* value);
static GVariant* _variant_new10 (const gchar* value);
GList* marlin_mime_actions_get_applications_for_files (GList* files);
static void fm_abstract_directory_view_filter_default_app_from_open_with_apps (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_filter_this_app_from_open_with_apps (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_valid_selection_for_restore (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_valid_selection_for_edit (FMAbstractDirectoryView* self);
gboolean marlin_view_window_can_bookmark_uri (MarlinViewWindow* self,
                                              const gchar* uri);
gboolean marlin_clipboard_manager_has_cutted_file (MarlinClipboardManager* self,
                                                   GOFFile* file);
static FMAbstractDirectoryViewSortSubMenuItem* fm_abstract_directory_view_sort_sub_menu_item_new (void);
static FMAbstractDirectoryViewSortSubMenuItem* fm_abstract_directory_view_sort_sub_menu_item_construct (GType object_type);
static GType fm_abstract_directory_view_sort_sub_menu_item_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FMAbstractDirectoryViewSortSubMenuItem, g_object_unref)
static FMAbstractDirectoryViewNewSubMenuItem* fm_abstract_directory_view_new_sub_menu_item_new (void);
static FMAbstractDirectoryViewNewSubMenuItem* fm_abstract_directory_view_new_sub_menu_item_construct (GType object_type);
static GType fm_abstract_directory_view_new_sub_menu_item_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FMAbstractDirectoryViewNewSubMenuItem, g_object_unref)
static void fm_abstract_directory_view_action_set_enabled (FMAbstractDirectoryView* self,
                                                    GSimpleActionGroup* action_group,
                                                    const gchar* name,
                                                    gboolean enabled);
static void fm_abstract_directory_view_update_default_app (FMAbstractDirectoryView* self,
                                                    GList* selection);
static void fm_abstract_directory_view_update_menu_actions_sort (FMAbstractDirectoryView* self);
GAppInfo* marlin_mime_actions_get_default_application_for_files (GList* files);
static void fm_abstract_directory_view_load_templates_from_folder (GFile* template_folder);
static gint ___lambda38_ (GFile* a,
                   GFile* b);
static gint ____lambda38__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void ___lambda39_ (GFile* folder);
static void ____lambda39__gfunc (gconstpointer data,
                          gpointer self);
static void __lambda82_ (FMAbstractDirectoryView* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda82__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
void marlin_mime_actions_open_multiple_gof_files_request (GList* gofs_to_open,
                                                          GtkWidget* parent,
                                                          GAppInfo* app);
void fm_abstract_directory_view_freeze_child_notify (FMAbstractDirectoryView* self);
static gboolean __lambda51_ (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_thaw_child_notify (FMAbstractDirectoryView* self);
static gboolean ___lambda51__gsource_func (gpointer self);
gint marlin_view_slot_get_displayed_files_count (MarlinViewSlot* self);
static gboolean __lambda52_ (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_get_visible_range (FMAbstractDirectoryView* self,
                                                       GtkTreePath* * start_path,
                                                       GtkTreePath* * end_path);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
gboolean fm_abstract_directory_view_get_next_visible_iter (FMAbstractDirectoryView* self,
                                                           GtkTreeIter* iter,
                                                           gboolean recurse);
static gboolean ___lambda52__gsource_func (gpointer self);
static gboolean __lambda53_ (FMAbstractDirectoryView* self);
static gboolean ___lambda53__gsource_func (gpointer self);
static gboolean _fm_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                     GdkEventButton* event,
                                                                                                     gpointer self);
static gboolean _fm_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                                   GdkEventMotion* event,
                                                                                                   gpointer self);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static gboolean __lambda90_ (Block34Data* _data34_);
static void fm_abstract_directory_view_scroll_if_near_edge (FMAbstractDirectoryView* self,
                                                     gint pos,
                                                     gint dim,
                                                     gint threshold,
                                                     GtkAdjustment* adj);
static gboolean ___lambda90__gsource_func (gpointer self);
static Block35Data* block35_data_ref (Block35Data* _data35_);
static void block35_data_unref (void * _userdata_);
static void ____lambda35_ (Block35Data* _data35_,
                    GOFFile* file);
static void _____lambda35__gfunc (gconstpointer data,
                           gpointer self);
void fm_abstract_directory_view_on_view_items_activated (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_match_keycode (FMAbstractDirectoryView* self,
                                                   guint keyval,
                                                   guint code,
                                                   gint level);
static gboolean fm_abstract_directory_view_real_on_view_key_press_event (FMAbstractDirectoryView* self,
                                                                  GdkEventKey* event);
static void fm_abstract_directory_view_cancel_hover (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_view_has_focus (FMAbstractDirectoryView* self);
GtkTreePath* fm_abstract_directory_view_get_path_at_cursor (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_path_is_selected (FMAbstractDirectoryView* self,
                                                      GtkTreePath* path);
void fm_abstract_directory_view_unselect_path (FMAbstractDirectoryView* self,
                                               GtkTreePath* path);
void fm_abstract_directory_view_select_all (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_invert_selection (FMAbstractDirectoryView* self);
gboolean fm_abstract_directory_view_move_cursor (FMAbstractDirectoryView* self,
                                                 guint keyval,
                                                 gboolean only_shift_pressed,
                                                 gboolean control_pressed);
gboolean fm_abstract_directory_view_handle_multi_select (FMAbstractDirectoryView* self,
                                                         GtkTreePath* path);
static gboolean __lambda50_ (FMAbstractDirectoryView* self);
static gboolean ___lambda50__gsource_func (gpointer self);
guint fm_abstract_directory_view_get_event_position_info (FMAbstractDirectoryView* self,
                                                          GdkEventButton* event,
                                                          GtkTreePath* * path,
                                                          gboolean rubberband);
gboolean fm_abstract_directory_view_get_single_click_mode (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_real_on_scroll_event (FMAbstractDirectoryView* self,
                                                          GdkEventScroll* event);
void fm_abstract_directory_view_set_renaming (FMAbstractDirectoryView* self,
                                              gboolean value);
GType marlin_abstract_editable_label_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MarlinAbstractEditableLabel, g_object_unref)
gchar* marlin_abstract_editable_label_get_chars (MarlinAbstractEditableLabel* self,
                                                 gint start_pos,
                                                 gint end_pos);
void marlin_abstract_editable_label_select_region (MarlinAbstractEditableLabel* self,
                                                   gint start_pos,
                                                   gint end_pos);
void fm_abstract_directory_view_set_is_frozen (FMAbstractDirectoryView* self,
                                               gboolean value);
void fm_abstract_directory_view_set_file_display_name (FMAbstractDirectoryView* self,
                                                       GFile* old_location,
                                                       const gchar* new_name,
                                                       GCancellable* cancellable,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
GFile* fm_abstract_directory_view_set_file_display_name_finish (FMAbstractDirectoryView* self,
                                                                GAsyncResult* _res_,
                                                                GError** error);
static void ____lambda55_ (FMAbstractDirectoryView* self,
                    GObject* obj,
                    GAsyncResult* res);
static void _____lambda55__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void fm_abstract_directory_view_set_file_display_name_data_free (gpointer _data);
static gboolean fm_abstract_directory_view_set_file_display_name_co (FmAbstractDirectoryViewSetFileDisplayNameData* _data_);
static void fm_abstract_directory_view_after_renamed_file_added (FMAbstractDirectoryView* self,
                                                          GOFFile* new_file);
static void _fm_abstract_directory_view_after_renamed_file_added_gof_directory_async_file_added (GOFDirectoryAsync* _sender,
                                                                                          GOFFile* file,
                                                                                          gpointer self);
static void fm_abstract_directory_view_set_file_display_name_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static gboolean fm_abstract_directory_view_real_on_view_draw (FMAbstractDirectoryView* self,
                                                       cairo_t* cr);
gchar* marlin_view_slot_get_empty_message (MarlinViewSlot* self);
static PangoRectangle* _pango_rectangle_dup (PangoRectangle* self);
gboolean fm_abstract_directory_view_handle_primary_button_click (FMAbstractDirectoryView* self,
                                                                 GdkEventButton* event,
                                                                 GtkTreePath* path);
static gboolean fm_abstract_directory_view_real_handle_primary_button_click (FMAbstractDirectoryView* self,
                                                                      GdkEventButton* event,
                                                                      GtkTreePath* path);
gboolean fm_abstract_directory_view_handle_secondary_button_click (FMAbstractDirectoryView* self,
                                                                   GdkEventButton* event);
static gboolean fm_abstract_directory_view_real_handle_secondary_button_click (FMAbstractDirectoryView* self,
                                                                        GdkEventButton* event);
void fm_abstract_directory_view_block_drag_and_drop (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_unblock_drag_and_drop (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_real_on_view_button_press_event (FMAbstractDirectoryView* self,
                                                                     GdkEventButton* event);
void marlin_text_renderer_end_editing (MarlinTextRenderer* self,
                                       gboolean cancel);
gboolean fm_abstract_directory_view_will_handle_button_press (FMAbstractDirectoryView* self,
                                                              gboolean no_mods,
                                                              gboolean only_control_pressed,
                                                              gboolean only_shift_pressed);
gboolean fm_abstract_directory_view_expand_collapse (FMAbstractDirectoryView* self,
                                                     GtkTreePath* path);
gboolean fm_abstract_directory_view_handle_default_button_click (FMAbstractDirectoryView* self,
                                                                 GdkEventButton* event);
static gboolean fm_abstract_directory_view_real_on_view_button_release_event (FMAbstractDirectoryView* self,
                                                                       GdkEventButton* event);
static Block36Data* block36_data_ref (Block36Data* _data36_);
static void block36_data_unref (void * _userdata_);
static gboolean ____lambda60_ (Block36Data* _data36_);
static gboolean _____lambda60__gsource_func (gpointer self);
static gboolean _____lambda61_ (FMAbstractDirectoryView* self);
static gboolean ______lambda61__gsource_func (gpointer self);
static void fm_abstract_directory_view_real_change_zoom_level (FMAbstractDirectoryView* self);
static Block37Data* block37_data_ref (Block37Data* _data37_);
static void block37_data_unref (void * _userdata_);
void fm_abstract_directory_view_set_cursor_on_cell (FMAbstractDirectoryView* self,
                                                    GtkTreePath* path,
                                                    GtkCellRenderer* renderer,
                                                    gboolean start_editing,
                                                    gboolean scroll_to_top);
static gboolean __lambda40_ (Block37Data* _data37_);
static gboolean ___lambda40__gsource_func (gpointer self);
gchar* fm_abstract_directory_view_get_string_from_column_id (FMAbstractDirectoryView* self,
                                                             gint id);
static Block38Data* block38_data_ref (Block38Data* _data38_);
static void block38_data_unref (void * _userdata_);
static void ___lambda88_ (Block38Data* _data38_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda88__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
guint fm_abstract_directory_view_get_selected_files_from_model (FMAbstractDirectoryView* self,
                                                                GList* * selected_files);
static gboolean fm_abstract_directory_view_real_expand_collapse (FMAbstractDirectoryView* self,
                                                          GtkTreePath* path);
static gboolean fm_abstract_directory_view_real_handle_default_button_click (FMAbstractDirectoryView* self,
                                                                      GdkEventButton* event);
static gboolean fm_abstract_directory_view_real_get_next_visible_iter (FMAbstractDirectoryView* self,
                                                                GtkTreeIter* iter,
                                                                gboolean recurse);
static void fm_abstract_directory_view_real_cancel (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_close (FMAbstractDirectoryView* self);
GList* fm_abstract_directory_view_get_selected_paths (FMAbstractDirectoryView* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static GtkTreeRowReference* _vala_GtkTreeRowReference_copy (GtkTreeRowReference* self);
static void _vala_GtkTreeRowReference_free (GtkTreeRowReference* self);
static void __vala_GtkTreeRowReference_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreeRowReference_free0_ (GList* self);
void fm_abstract_directory_view_tree_select_all (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_tree_unselect_all (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_unselect_others (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_tree_unselect_others (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_highlight_path (FMAbstractDirectoryView* self,
                                                     GtkTreePath* path);
GtkTreePath* fm_abstract_directory_view_up (FMAbstractDirectoryView* self,
                                            GtkTreePath* path);
static GtkTreePath* fm_abstract_directory_view_real_up (FMAbstractDirectoryView* self,
                                                 GtkTreePath* path);
GtkTreePath* fm_abstract_directory_view_down (FMAbstractDirectoryView* self,
                                              GtkTreePath* path);
static GtkTreePath* fm_abstract_directory_view_real_down (FMAbstractDirectoryView* self,
                                                   GtkTreePath* path);
static GList* fm_abstract_directory_view_real_get_selected_paths (FMAbstractDirectoryView* self);
static GtkTreePath* fm_abstract_directory_view_real_get_path_at_pos (FMAbstractDirectoryView* self,
                                                              gint x,
                                                              gint win);
static GtkTreePath* fm_abstract_directory_view_real_get_path_at_cursor (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_tree_select_all (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_tree_unselect_all (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_tree_unselect_others (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_select_path (FMAbstractDirectoryView* self,
                                                  GtkTreePath* path,
                                                  gboolean cursor_follows);
static void fm_abstract_directory_view_real_unselect_path (FMAbstractDirectoryView* self,
                                                    GtkTreePath* path);
static gboolean fm_abstract_directory_view_real_path_is_selected (FMAbstractDirectoryView* self,
                                                           GtkTreePath* path);
static gboolean fm_abstract_directory_view_real_get_visible_range (FMAbstractDirectoryView* self,
                                                            GtkTreePath* * start_path,
                                                            GtkTreePath* * end_path);
static void fm_abstract_directory_view_real_set_cursor (FMAbstractDirectoryView* self,
                                                 GtkTreePath* path,
                                                 gboolean start_editing,
                                                 gboolean select,
                                                 gboolean scroll_to_top);
static gboolean fm_abstract_directory_view_real_move_cursor (FMAbstractDirectoryView* self,
                                                      guint keyval,
                                                      gboolean only_shift_pressed,
                                                      gboolean control_pressed);
static gboolean fm_abstract_directory_view_real_will_handle_button_press (FMAbstractDirectoryView* self,
                                                                   gboolean no_mods,
                                                                   gboolean only_control_pressed,
                                                                   gboolean only_shift_pressed);
gboolean fm_abstract_directory_view_is_on_icon (FMAbstractDirectoryView* self,
                                                gint x,
                                                gint y,
                                                gboolean* on_helper);
static gboolean fm_abstract_directory_view_real_handle_multi_select (FMAbstractDirectoryView* self,
                                                              GtkTreePath* path);
static GtkWidget* fm_abstract_directory_view_real_create_view (FMAbstractDirectoryView* self);
static MarlinZoomLevel fm_abstract_directory_view_real_get_set_up_zoom_level (FMAbstractDirectoryView* self);
static MarlinZoomLevel fm_abstract_directory_view_real_get_normal_zoom_level (FMAbstractDirectoryView* self);
static gboolean fm_abstract_directory_view_real_view_has_focus (FMAbstractDirectoryView* self);
static guint fm_abstract_directory_view_real_get_selected_files_from_model (FMAbstractDirectoryView* self,
                                                                     GList* * selected_files);
static guint fm_abstract_directory_view_real_get_event_position_info (FMAbstractDirectoryView* self,
                                                               GdkEventButton* event,
                                                               GtkTreePath* * path,
                                                               gboolean rubberband);
void fm_abstract_directory_view_scroll_to_cell (FMAbstractDirectoryView* self,
                                                GtkTreePath* path,
                                                gboolean scroll_to_top);
static void fm_abstract_directory_view_real_scroll_to_cell (FMAbstractDirectoryView* self,
                                                     GtkTreePath* path,
                                                     gboolean scroll_to_top);
static void fm_abstract_directory_view_real_set_cursor_on_cell (FMAbstractDirectoryView* self,
                                                         GtkTreePath* path,
                                                         GtkCellRenderer* renderer,
                                                         gboolean start_editing,
                                                         gboolean scroll_to_top);
static void fm_abstract_directory_view_real_freeze_tree (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_thaw_tree (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_freeze_child_notify (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_thaw_child_notify (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_connect_tree_signals (FMAbstractDirectoryView* self);
static void fm_abstract_directory_view_real_disconnect_tree_signals (FMAbstractDirectoryView* self);
void fm_abstract_directory_view_set_single_click_mode (FMAbstractDirectoryView* self,
                                                       gboolean value);
void fm_abstract_directory_view_set_tree_frozen (FMAbstractDirectoryView* self,
                                                 gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static GObject * fm_abstract_directory_view_sort_sub_menu_item_constructor (GType type,
                                                                     guint n_construct_properties,
                                                                     GObjectConstructParam * construct_properties);
static GVariant* _variant_new11 (const gchar* value);
static GVariant* _variant_new12 (const gchar* value);
static GVariant* _variant_new13 (const gchar* value);
static GVariant* _variant_new14 (const gchar* value);
static GObject * fm_abstract_directory_view_new_sub_menu_item_constructor (GType type,
                                                                    guint n_construct_properties,
                                                                    GObjectConstructParam * construct_properties);
static GVariant* _variant_new15 (const gchar* value);
static GVariant* _variant_new16 (const gchar* value);
static void fm_abstract_directory_view_finalize (GObject * obj);
static void _vala_fm_abstract_directory_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_fm_abstract_directory_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GtkTargetEntry FM_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS[2] = {{"text/plain", (guint) GTK_TARGET_SAME_APP, (guint) MARLIN_TARGET_TYPE_STRING}, {"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) MARLIN_TARGET_TYPE_TEXT_URI_LIST}};
static const GtkTargetEntry FM_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS[4] = {{"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) MARLIN_TARGET_TYPE_TEXT_URI_LIST}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) MARLIN_TARGET_TYPE_TEXT_URI_LIST}, {"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) MARLIN_TARGET_TYPE_XDND_DIRECT_SAVE0}, {"_NETSCAPE_URL", (guint) GTK_TARGET_OTHER_APP, (guint) MARLIN_TARGET_TYPE_NETSCAPE_URL}};
static const GActionEntry FM_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES[11] = {{"open", _fm_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback}, {"open-with-app", _fm_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback, "u"}, {"open-with-default", _fm_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback}, {"open-with-other-app", _fm_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback}, {"rename", _fm_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback}, {"view-in-location", _fm_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback}, {"forget", _fm_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback}, {"cut", _fm_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback}, {"trash", _fm_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback}, {"delete", _fm_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback}, {"restore", _fm_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback}};
static const GActionEntry FM_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES[8] = {{"new", _fm_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback, "s"}, {"create-from", _fm_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback, "s"}, {"sort-by", _fm_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback, "s", "'name'"}, {"reverse", _fm_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback, NULL, "false"}, {"folders-first", _fm_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback, NULL, "true"}, {"show-hidden", NULL, NULL, "false", _fm_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback}, {"show-remote-thumbnails", NULL, NULL, "false", _fm_abstract_directory_view_change_state_show_remote_thumbnails_gsimple_action_change_state_callback}, {"hide-local-thumbnails", NULL, NULL, "false", _fm_abstract_directory_view_change_state_hide_local_thumbnails_gsimple_action_change_state_callback}};
static const GActionEntry FM_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES[6] = {{"copy", _fm_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback}, {"paste-into", _fm_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback}, {"open-in", _fm_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback, "s"}, {"bookmark", _fm_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback}, {"properties", _fm_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback}, {"copy-link", _fm_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback}};

static inline gpointer
fm_abstract_directory_view_get_instance_private (FMAbstractDirectoryView* self)
{
	return G_STRUCT_MEMBER_P (self, FMAbstractDirectoryView_private_offset);
}

GType
fm_abstract_directory_view_click_zone_get_type (void)
{
	static volatile gsize fm_abstract_directory_view_click_zone_type_id__volatile = 0;
	if (g_once_init_enter (&fm_abstract_directory_view_click_zone_type_id__volatile)) {
		static const GEnumValue values[] = {{FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER", "expander"}, {FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER", "helper"}, {FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON", "icon"}, {FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME", "name"}, {FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH", "blank-path"}, {FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH", "blank-no-path"}, {FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID, "FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID", "invalid"}, {0, NULL, NULL}};
		GType fm_abstract_directory_view_click_zone_type_id;
		fm_abstract_directory_view_click_zone_type_id = g_enum_register_static ("FMAbstractDirectoryViewClickZone", values);
		g_once_init_leave (&fm_abstract_directory_view_click_zone_type_id__volatile, fm_abstract_directory_view_click_zone_type_id);
	}
	return fm_abstract_directory_view_click_zone_type_id__volatile;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
_fm_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self)
{
	fm_abstract_directory_view_on_selection_action_open_executable ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                GVariant* parameter,
                                                                                                gpointer self)
{
	fm_abstract_directory_view_on_selection_action_open_with_app ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                    GVariant* parameter,
                                                                                                    gpointer self)
{
	fm_abstract_directory_view_on_selection_action_open_with_default ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
	fm_abstract_directory_view_on_selection_action_open_with_other_app ((FMAbstractDirectoryView*) self);
}

static void
_fm_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
	fm_abstract_directory_view_on_selection_action_rename ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                   GVariant* parameter,
                                                                                                   gpointer self)
{
	fm_abstract_directory_view_on_selection_action_view_in_location ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
	fm_abstract_directory_view_on_selection_action_forget ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self)
{
	fm_abstract_directory_view_on_selection_action_cut ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self)
{
	fm_abstract_directory_view_on_selection_action_trash ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
	fm_abstract_directory_view_on_selection_action_delete ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
	fm_abstract_directory_view_on_selection_action_restore ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self)
{
	fm_abstract_directory_view_on_background_action_new ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self)
{
	fm_abstract_directory_view_on_background_action_create_from ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                   GVariant* parameter,
                                                                                                   gpointer self)
{
	fm_abstract_directory_view_on_background_action_sort_by_changed ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                   GVariant* parameter,
                                                                                                   gpointer self)
{
	fm_abstract_directory_view_on_background_action_reverse_changed ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                         GVariant* parameter,
                                                                                                         gpointer self)
{
	fm_abstract_directory_view_on_background_action_folders_first_changed ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                           GVariant* value,
                                                                                           gpointer self)
{
	fm_abstract_directory_view_change_state_show_hidden ((FMAbstractDirectoryView*) self, action);
}

static void
_fm_abstract_directory_view_change_state_show_remote_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                      GVariant* value,
                                                                                                      gpointer self)
{
	fm_abstract_directory_view_change_state_show_remote_thumbnails ((FMAbstractDirectoryView*) self, action);
}

static void
_fm_abstract_directory_view_change_state_hide_local_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                     GVariant* value,
                                                                                                     gpointer self)
{
	fm_abstract_directory_view_change_state_hide_local_thumbnails ((FMAbstractDirectoryView*) self, action);
}

static void
_fm_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self)
{
	fm_abstract_directory_view_on_common_action_copy ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
	fm_abstract_directory_view_on_common_action_paste_into ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self)
{
	fm_abstract_directory_view_on_common_action_open_in ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self)
{
	fm_abstract_directory_view_on_common_action_bookmark ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
	fm_abstract_directory_view_on_common_action_properties ((FMAbstractDirectoryView*) self, action, parameter);
}

static void
_fm_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
	fm_abstract_directory_view_on_common_action_copy_link ((FMAbstractDirectoryView*) self, action, parameter);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda84_ (FMAbstractDirectoryView* self,
             guint req)
{
	if (req == ((guint) self->priv->thumbnail_request)) {
		self->priv->thumbnail_request = -1;
	}
	fm_abstract_directory_view_draw_when_idle (self);
}

static void
___lambda84__marlin_thumbnailer_finished (MarlinThumbnailer* _sender,
                                          guint request,
                                          gpointer self)
{
	__lambda84_ ((FMAbstractDirectoryView*) self, request);
}

static gboolean
_fm_abstract_directory_view_on_motion_notify_event_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                   GdkEventMotion* event,
                                                                                   gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_motion_notify_event ((FMAbstractDirectoryView*) self, event);
	return result;
}

static gboolean
_fm_abstract_directory_view_on_leave_notify_event_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                                 GdkEventCrossing* event,
                                                                                 gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_leave_notify_event ((FMAbstractDirectoryView*) self, event);
	return result;
}

static gboolean
_fm_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_view_key_press_event ((FMAbstractDirectoryView*) self, event);
	return result;
}

static gboolean
_fm_abstract_directory_view_on_view_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                      GdkEventButton* event,
                                                                                      gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_view_button_press_event ((FMAbstractDirectoryView*) self, event);
	return result;
}

static gboolean
_fm_abstract_directory_view_on_view_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                          GdkEventButton* event,
                                                                                          gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_view_button_release_event ((FMAbstractDirectoryView*) self, event);
	return result;
}

static gboolean
_fm_abstract_directory_view_on_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                          cairo_t* cr,
                                                          gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_view_draw ((FMAbstractDirectoryView*) self, cr);
	return result;
}

FMAbstractDirectoryView*
fm_abstract_directory_view_construct (GType object_type,
                                      MarlinViewSlot* _slot)
{
	FMAbstractDirectoryView * self = NULL;
	MarlinViewWindow* _tmp0_;
	MarlinViewWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkCursor* _tmp7_;
	MarlinApplication* app = NULL;
	GApplication* _tmp8_;
	MarlinApplication* _tmp9_;
	MarlinApplication* _tmp10_;
	MarlinClipboardManager* _tmp11_;
	MarlinApplication* _tmp12_;
	GtkRecentManager* _tmp13_;
	MarlinIconRenderer* _tmp14_;
	MarlinThumbnailer* _tmp15_;
	MarlinThumbnailer* _tmp16_;
	GObject* _tmp17_;
	GObject* _tmp18_;
	FMListModel* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* _tmp24_;
	MarlinViewSlot* _tmp34_;
	GOFDirectoryAsync* _tmp35_;
	GOFDirectoryAsync* _tmp36_;
	g_return_val_if_fail (_slot != NULL, NULL);
	self = (FMAbstractDirectoryView*) g_object_new (object_type, NULL);
	self->slot = _slot;
	_tmp0_ = marlin_view_slot_get_window (_slot);
	_tmp1_ = _tmp0_;
	self->window = _tmp1_;
	_tmp2_ = gdk_display_get_default ();
	_tmp3_ = gdk_cursor_new_from_name (_tmp2_, "text");
	_g_object_unref0 (self->priv->editable_cursor);
	self->priv->editable_cursor = _tmp3_;
	_tmp4_ = gdk_display_get_default ();
	_tmp5_ = gdk_cursor_new_from_name (_tmp4_, "pointer");
	_g_object_unref0 (self->priv->activatable_cursor);
	self->priv->activatable_cursor = _tmp5_;
	_tmp6_ = gdk_display_get_default ();
	_tmp7_ = gdk_cursor_new_from_name (_tmp6_, "default");
	_g_object_unref0 (self->priv->selectable_cursor);
	self->priv->selectable_cursor = _tmp7_;
	_tmp8_ = g_application_get_default ();
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, MARLIN_TYPE_APPLICATION, MarlinApplication));
	app = _tmp9_;
	_tmp10_ = app;
	_tmp11_ = marlin_application_get_clipboard_manager (_tmp10_);
	self->priv->clipboard = _tmp11_;
	_tmp12_ = app;
	_tmp13_ = marlin_application_get_recent_manager (_tmp12_);
	self->recent = _tmp13_;
	_tmp14_ = marlin_icon_renderer_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->icon_renderer);
	self->icon_renderer = _tmp14_;
	_tmp15_ = marlin_thumbnailer_get ();
	_g_object_unref0 (self->priv->thumbnailer);
	self->priv->thumbnailer = _tmp15_;
	_tmp16_ = self->priv->thumbnailer;
	g_signal_connect_object (_tmp16_, "finished", (GCallback) ___lambda84__marlin_thumbnailer_finished, self, 0);
	_tmp17_ = g_object_new (fm_list_model_get_type (), NULL, NULL);
	_tmp18_ = G_IS_INITIALLY_UNOWNED (_tmp17_) ? g_object_ref_sink (_tmp17_) : _tmp17_;
	_tmp19_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, FM_TYPE_LIST_MODEL) ? ((FMListModel*) _tmp18_) : NULL;
	if (_tmp19_ == NULL) {
		_g_object_unref0 (_tmp18_);
	}
	_g_object_unref0 (self->model);
	self->model = _tmp19_;
	_tmp20_ = settings;
	g_settings_bind (_tmp20_, "single-click", (GObject*) self, "single_click_mode", G_SETTINGS_BIND_GET);
	_tmp21_ = settings;
	g_settings_bind (_tmp21_, "show-remote-thumbnails", (GObject*) self, "show_remote_thumbnails", G_SETTINGS_BIND_GET);
	_tmp22_ = settings;
	g_settings_bind (_tmp22_, "hide-local-thumbnails", (GObject*) self, "hide_local_thumbnails", G_SETTINGS_BIND_GET);
	fm_abstract_directory_view_set_up__menu_actions (self);
	fm_abstract_directory_view_set_up_directory_view (self);
	_tmp23_ = fm_abstract_directory_view_create_view (self);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp23_;
	_tmp24_ = self->priv->view;
	if (_tmp24_ != NULL) {
		GtkWidget* _tmp25_;
		GtkWidget* _tmp26_;
		GtkWidget* _tmp27_;
		GtkWidget* _tmp28_;
		GtkWidget* _tmp29_;
		GtkWidget* _tmp30_;
		GtkWidget* _tmp31_;
		GtkWidget* _tmp32_;
		GtkWidget* _tmp33_;
		_tmp25_ = self->priv->view;
		gtk_container_add ((GtkContainer*) self, _tmp25_);
		gtk_widget_show_all ((GtkWidget*) self);
		_tmp26_ = self->priv->view;
		fm_abstract_directory_view_connect_drag_drop_signals (self, _tmp26_);
		_tmp27_ = self->priv->view;
		gtk_widget_add_events (_tmp27_, (gint) ((GDK_POINTER_MOTION_MASK | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK));
		_tmp28_ = self->priv->view;
		g_signal_connect_object (_tmp28_, "motion-notify-event", (GCallback) _fm_abstract_directory_view_on_motion_notify_event_gtk_widget_motion_notify_event, self, 0);
		_tmp29_ = self->priv->view;
		g_signal_connect_object (_tmp29_, "leave-notify-event", (GCallback) _fm_abstract_directory_view_on_leave_notify_event_gtk_widget_leave_notify_event, self, 0);
		_tmp30_ = self->priv->view;
		g_signal_connect_object (_tmp30_, "key-press-event", (GCallback) _fm_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event, self, 0);
		_tmp31_ = self->priv->view;
		g_signal_connect_object (_tmp31_, "button-press-event", (GCallback) _fm_abstract_directory_view_on_view_button_press_event_gtk_widget_button_press_event, self, 0);
		_tmp32_ = self->priv->view;
		g_signal_connect_object (_tmp32_, "button-release-event", (GCallback) _fm_abstract_directory_view_on_view_button_release_event_gtk_widget_button_release_event, self, 0);
		_tmp33_ = self->priv->view;
		g_signal_connect_object (_tmp33_, "draw", (GCallback) _fm_abstract_directory_view_on_view_draw_gtk_widget_draw, self, 0);
	}
	fm_abstract_directory_view_freeze_tree (self);
	fm_abstract_directory_view_set_up_zoom_level (self);
	_tmp34_ = self->slot;
	_tmp35_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp34_);
	_tmp36_ = _tmp35_;
	fm_abstract_directory_view_connect_directory_handlers (self, _tmp36_);
	_g_object_unref0 (app);
	return self;
}

static void
_fm_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited (GtkCellRendererText* _sender,
                                                                          const gchar* path,
                                                                          const gchar* new_text,
                                                                          gpointer self)
{
	fm_abstract_directory_view_on_name_edited ((FMAbstractDirectoryView*) self, path, new_text);
}

static void
_fm_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                         gpointer self)
{
	fm_abstract_directory_view_on_name_editing_canceled ((FMAbstractDirectoryView*) self);
}

static void
_fm_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                       GtkCellEditable* editable,
                                                                                       const gchar* path,
                                                                                       gpointer self)
{
	fm_abstract_directory_view_on_name_editing_started ((FMAbstractDirectoryView*) self, editable, path);
}

static void
fm_abstract_directory_view_real_set_up_name_renderer (FMAbstractDirectoryView* self)
{
	MarlinTextRenderer* _tmp0_;
	MarlinTextRenderer* _tmp1_;
	MarlinTextRenderer* _tmp2_;
	MarlinTextRenderer* _tmp3_;
	_tmp0_ = self->name_renderer;
	g_object_set ((GtkCellRendererText*) _tmp0_, "editable", FALSE, NULL);
	_tmp1_ = self->name_renderer;
	g_signal_connect_object ((GtkCellRendererText*) _tmp1_, "edited", (GCallback) _fm_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited, self, 0);
	_tmp2_ = self->name_renderer;
	g_signal_connect_object ((GtkCellRenderer*) _tmp2_, "editing-canceled", (GCallback) _fm_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
	_tmp3_ = self->name_renderer;
	g_signal_connect_object ((GtkCellRenderer*) _tmp3_, "editing-started", (GCallback) _fm_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started, self, 0);
}

void
fm_abstract_directory_view_set_up_name_renderer (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->set_up_name_renderer (self);
}

static gboolean
_fm_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                 gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_popup_menu ((FMAbstractDirectoryView*) self);
	return result;
}

static void
_fm_abstract_directory_view_on_clipboard_changed_marlin_clipboard_manager_changed (MarlinClipboardManager* _sender,
                                                                                   gpointer self)
{
	fm_abstract_directory_view_on_clipboard_changed ((FMAbstractDirectoryView*) self);
}

static void
__lambda85_ (FMAbstractDirectoryView* self)
{
	MarlinClipboardManager* _tmp0_;
	guint _tmp1_;
	_tmp0_ = self->priv->clipboard;
	g_signal_parse_name ("changed", MARLIN_TYPE_CLIPBOARD_MANAGER, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_clipboard_changed_marlin_clipboard_manager_changed, self);
}

static void
___lambda85__gtk_widget_unrealize (GtkWidget* _sender,
                                   gpointer self)
{
	__lambda85_ ((FMAbstractDirectoryView*) self);
}

static void
__lambda86_ (FMAbstractDirectoryView* self)
{
	MarlinClipboardManager* _tmp0_;
	_tmp0_ = self->priv->clipboard;
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _fm_abstract_directory_view_on_clipboard_changed_marlin_clipboard_manager_changed, self, 0);
	fm_abstract_directory_view_on_clipboard_changed (self);
}

static void
___lambda86__gtk_widget_realize (GtkWidget* _sender,
                                 gpointer self)
{
	__lambda86_ ((FMAbstractDirectoryView*) self);
}

static gboolean
_fm_abstract_directory_view_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                     GdkEventScroll* event,
                                                                     gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_scroll_event ((FMAbstractDirectoryView*) self, event);
	return result;
}

static void
__lambda87_ (FMAbstractDirectoryView* self)
{
	fm_abstract_directory_view_schedule_thumbnail_timeout (self);
}

static void
___lambda87__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
	__lambda87_ ((FMAbstractDirectoryView*) self);
}

static void
_fm_abstract_directory_view_on_show_hidden_files_changed_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self)
{
	fm_abstract_directory_view_on_show_hidden_files_changed ((FMAbstractDirectoryView*) self, _sender, pspec);
}

static void
_fm_abstract_directory_view_on_show_remote_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self)
{
	fm_abstract_directory_view_on_show_remote_thumbnails_changed ((FMAbstractDirectoryView*) self, _sender, pspec);
}

static void
_fm_abstract_directory_view_on_hide_local_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                              GParamSpec* pspec,
                                                                              gpointer self)
{
	fm_abstract_directory_view_on_hide_local_thumbnails_changed ((FMAbstractDirectoryView*) self, _sender, pspec);
}

static void
_fm_abstract_directory_view_on_sort_directories_first_changed_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self)
{
	fm_abstract_directory_view_on_sort_directories_first_changed ((FMAbstractDirectoryView*) self, _sender, pspec);
}

static void
_fm_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                                                       GtkTreePath* path,
                                                                       gpointer self)
{
	fm_abstract_directory_view_on_row_deleted ((FMAbstractDirectoryView*) self, path);
}

static void
_fm_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                          gpointer self)
{
	fm_abstract_directory_view_on_sort_column_changed ((FMAbstractDirectoryView*) self);
}

static void
fm_abstract_directory_view_set_up_directory_view (FMAbstractDirectoryView* self)
{
	GtkAdjustment* _tmp0_;
	GOFPreferences* prefs = NULL;
	GOFPreferences* _tmp1_;
	FMListModel* _tmp2_;
	GOFPreferences* _tmp3_;
	GOFPreferences* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	FMListModel* _tmp7_;
	FMListModel* _tmp8_;
	g_return_if_fail (self != NULL);
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type ((GtkScrolledWindow*) self, GTK_SHADOW_NONE);
	g_signal_connect_object ((GtkWidget*) self, "popup-menu", (GCallback) _fm_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "unrealize", (GCallback) ___lambda85__gtk_widget_unrealize, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) ___lambda86__gtk_widget_realize, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) _fm_abstract_directory_view_on_scroll_event_gtk_widget_scroll_event, self, 0);
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
	g_signal_connect_object (_tmp0_, "value-changed", (GCallback) ___lambda87__gtk_adjustment_value_changed, self, G_CONNECT_AFTER);
	_tmp1_ = gof_preferences_get_default ();
	prefs = _tmp1_;
	g_signal_connect_object ((GObject*) prefs, "notify::show-hidden-files", (GCallback) _fm_abstract_directory_view_on_show_hidden_files_changed_g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) prefs, "notify::show-remote-thumbnails", (GCallback) _fm_abstract_directory_view_on_show_remote_thumbnails_changed_g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) prefs, "notify::hide-local-thumbnails", (GCallback) _fm_abstract_directory_view_on_hide_local_thumbnails_changed_g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) prefs, "notify::sort-directories-first", (GCallback) _fm_abstract_directory_view_on_sort_directories_first_changed_g_object_notify, self, 0);
	_tmp2_ = self->model;
	_tmp3_ = gof_preferences_get_default ();
	_tmp4_ = _tmp3_;
	_tmp5_ = gof_preferences_get_sort_directories_first (_tmp4_);
	_tmp6_ = _tmp5_;
	fm_list_model_set_should_sort_directories_first (_tmp2_, _tmp6_);
	_g_object_unref0 (_tmp4_);
	_tmp7_ = self->model;
	g_signal_connect_object ((GtkTreeModel*) _tmp7_, "row-deleted", (GCallback) _fm_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self, 0);
	_tmp8_ = self->model;
	g_signal_connect_object ((GtkTreeSortable*) _tmp8_, "sort-column-changed", (GCallback) _fm_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed, self, 0);
	_g_object_unref0 (prefs);
}

static GVariant*
_variant_new3 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new4 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new5 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
fm_abstract_directory_view_set_up__menu_actions (FMAbstractDirectoryView* self)
{
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GSimpleActionGroup* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleActionGroup* _tmp7_;
	GSimpleActionGroup* _tmp8_;
	GSimpleActionGroup* _tmp9_;
	GSettings* _tmp10_;
	GVariant* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	GSettings* _tmp13_;
	GVariant* _tmp14_;
	GSimpleActionGroup* _tmp15_;
	GSettings* _tmp16_;
	GVariant* _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_simple_action_group_new ();
	_g_object_unref0 (self->priv->selection_actions);
	self->priv->selection_actions = _tmp0_;
	_tmp1_ = self->priv->selection_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, FM_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES, (gint) G_N_ELEMENTS (FM_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES), self);
	_tmp2_ = self->priv->selection_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, "selection", (GActionGroup*) _tmp2_);
	_tmp3_ = g_simple_action_group_new ();
	_g_object_unref0 (self->priv->background_actions);
	self->priv->background_actions = _tmp3_;
	_tmp4_ = self->priv->background_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp4_, FM_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES, (gint) G_N_ELEMENTS (FM_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES), self);
	_tmp5_ = self->priv->background_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, "background", (GActionGroup*) _tmp5_);
	_tmp6_ = g_simple_action_group_new ();
	_g_object_unref0 (self->priv->common_actions);
	self->priv->common_actions = _tmp6_;
	_tmp7_ = self->priv->common_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp7_, FM_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES, (gint) G_N_ELEMENTS (FM_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES), self);
	_tmp8_ = self->priv->common_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, "common", (GActionGroup*) _tmp8_);
	_tmp9_ = self->priv->background_actions;
	_tmp10_ = settings;
	_tmp11_ = _variant_new3 (g_settings_get_boolean (_tmp10_, "show-hiddenfiles"));
	fm_abstract_directory_view_action_set_state (self, _tmp9_, "show-hidden", _tmp11_);
	_g_variant_unref0 (_tmp11_);
	_tmp12_ = self->priv->background_actions;
	_tmp13_ = settings;
	_tmp14_ = _variant_new4 (g_settings_get_boolean (_tmp13_, "show-remote-thumbnails"));
	fm_abstract_directory_view_action_set_state (self, _tmp12_, "show-remote-thumbnails", _tmp14_);
	_g_variant_unref0 (_tmp14_);
	_tmp15_ = self->priv->background_actions;
	_tmp16_ = settings;
	_tmp17_ = _variant_new5 (g_settings_get_boolean (_tmp16_, "hide-local-thumbnails"));
	fm_abstract_directory_view_action_set_state (self, _tmp15_, "hide-local-thumbnails", _tmp17_);
	_g_variant_unref0 (_tmp17_);
}

void
fm_abstract_directory_view_zoom_in (FMAbstractDirectoryView* self)
{
	MarlinZoomLevel _tmp0_;
	MarlinZoomLevel _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_zoom_level (self);
	_tmp1_ = _tmp0_;
	fm_abstract_directory_view_set_zoom_level (self, _tmp1_ + 1);
}

void
fm_abstract_directory_view_zoom_out (FMAbstractDirectoryView* self)
{
	MarlinZoomLevel _tmp0_;
	MarlinZoomLevel _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_zoom_level (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ > 0) {
		MarlinZoomLevel _tmp2_;
		MarlinZoomLevel _tmp3_;
		_tmp2_ = fm_abstract_directory_view_get_zoom_level (self);
		_tmp3_ = _tmp2_;
		fm_abstract_directory_view_set_zoom_level (self, _tmp3_ - 1);
	}
}

static void
fm_abstract_directory_view_set_up_zoom_level (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_set_zoom_level (self, fm_abstract_directory_view_get_set_up_zoom_level (self));
}

void
fm_abstract_directory_view_zoom_normal (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_set_zoom_level (self, fm_abstract_directory_view_get_normal_zoom_level (self));
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
	g_atomic_int_inc (&_data25_->_ref_count_);
	return _data25_;
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data25_->self;
		_g_object_unref0 (self);
		g_slice_free (Block25Data, _data25_);
	}
}

static gboolean
___lambda80_ (Block25Data* _data25_)
{
	FMAbstractDirectoryView* self;
	gboolean _tmp0_;
	gboolean result = FALSE;
	self = _data25_->self;
	_tmp0_ = self->priv->_tree_frozen;
	if (!_tmp0_) {
		GtkTreePath* _tmp1_;
		GtkTreePath* _tmp2_;
		_tmp1_ = gtk_tree_path_new_from_indices (0, -1);
		_tmp2_ = _tmp1_;
		fm_abstract_directory_view_set_cursor (self, _tmp2_, FALSE, _data25_->select, TRUE);
		__vala_GtkTreePath_free0 (_tmp2_);
		result = G_SOURCE_REMOVE;
		return result;
	} else {
		result = G_SOURCE_CONTINUE;
		return result;
	}
}

static gboolean
____lambda80__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda80_ (self);
	return result;
}

void
fm_abstract_directory_view_focus_first_for_empty_selection (FMAbstractDirectoryView* self,
                                                            gboolean select)
{
	Block25Data* _data25_;
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	_data25_ = g_slice_new0 (Block25Data);
	_data25_->_ref_count_ = 1;
	_data25_->self = g_object_ref (self);
	_data25_->select = select;
	_tmp0_ = self->selected_files;
	if (_tmp0_ == NULL) {
		g_idle_add_full (G_PRIORITY_LOW, ____lambda80__gsource_func, block25_data_ref (_data25_), block25_data_unref);
	}
	block25_data_unref (_data25_);
	_data25_ = NULL;
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
	g_atomic_int_inc (&_data26_->_ref_count_);
	return _data26_;
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data26_->self;
		_g_object_unref0 (_data26_->focus_after_select);
		_g_object_unref0 (_data26_->files_to_select_list);
		_g_object_unref0 (self);
		g_slice_free (Block26Data, _data26_);
	}
}

static void
__lambda78_ (Block26Data* _data26_,
             GFile* loc)
{
	FMAbstractDirectoryView* self;
	GeeLinkedList* _tmp0_;
	GOFFile* _tmp1_;
	GOFFile* _tmp2_;
	self = _data26_->self;
	g_return_if_fail (loc != NULL);
	_tmp0_ = _data26_->files_to_select_list;
	_tmp1_ = gof_file_get (loc);
	_tmp2_ = _tmp1_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
___lambda78__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda78_ (self, (GFile*) data);
}

static void
___lambda79_ (Block26Data* _data26_)
{
	FMAbstractDirectoryView* self;
	GeeLinkedList* _tmp0_;
	GFile* _tmp1_;
	self = _data26_->self;
	_tmp0_ = _data26_->files_to_select_list;
	_tmp1_ = _data26_->focus_after_select;
	fm_abstract_directory_view_select_files_and_update_if_thawed (self, _tmp0_, _tmp1_);
}

static void
____lambda79__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda79_ (self);
}

void
fm_abstract_directory_view_select_glib_files_when_thawed (FMAbstractDirectoryView* self,
                                                          GList* location_list,
                                                          GFile* focus_location)
{
	Block26Data* _data26_;
	GeeLinkedList* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_data26_ = g_slice_new0 (Block26Data);
	_data26_->_ref_count_ = 1;
	_data26_->self = g_object_ref (self);
	_tmp0_ = gee_linked_list_new (GOF_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data26_->files_to_select_list = _tmp0_;
	g_list_foreach (location_list, ___lambda78__gfunc, _data26_);
	if (focus_location != NULL) {
		GFile* _tmp2_;
		_tmp2_ = g_file_dup (focus_location);
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp2_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	_tmp3_ = _g_object_ref0 (_tmp1_);
	_data26_->focus_after_select = _tmp3_;
	_tmp4_ = self->priv->_tree_frozen;
	if (_tmp4_) {
		gulong _tmp5_;
		_tmp5_ = g_signal_connect_data ((GObject*) self, "notify::tree-frozen", (GCallback) ____lambda79__g_object_notify, block26_data_ref (_data26_), (GClosureNotify) block26_data_unref, 0);
		self->priv->select_source_handler = _tmp5_;
	} else {
		GeeLinkedList* _tmp6_;
		GFile* _tmp7_;
		_tmp6_ = _data26_->files_to_select_list;
		_tmp7_ = _data26_->focus_after_select;
		fm_abstract_directory_view_select_files_and_update_if_thawed (self, _tmp6_, _tmp7_);
	}
	_g_object_unref0 (_tmp1_);
	block26_data_unref (_data26_);
	_data26_ = NULL;
}

static void
fm_abstract_directory_view_select_files_and_update_if_thawed (FMAbstractDirectoryView* self,
                                                              GeeLinkedList* files_to_select,
                                                              GFile* focus_file)
{
	gboolean _tmp0_;
	GtkTreeIter iter = {0};
	guint count = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (files_to_select != NULL);
	_tmp0_ = self->priv->_tree_frozen;
	if (_tmp0_) {
		return;
	}
	if (self->priv->select_source_handler > ((gulong) 0)) {
		g_signal_handler_disconnect ((GObject*) self, self->priv->select_source_handler);
		self->priv->select_source_handler = (gulong) 0;
	}
	fm_abstract_directory_view_disconnect_tree_signals (self);
	fm_abstract_directory_view_unselect_all (self);
	count = (guint) 0;
	{
		GeeLinkedList* _f_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _f_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _f_index = 0;
		_tmp1_ = _g_object_ref0 (files_to_select);
		_f_list = _tmp1_;
		_tmp2_ = _f_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_f_size = _tmp4_;
		_f_index = -1;
		while (TRUE) {
			GOFFile* f = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			FMListModel* _tmp7_;
			GOFFile* _tmp8_;
			GtkTreeIter _tmp9_ = {0};
			gboolean _tmp10_;
			_f_index = _f_index + 1;
			if (!(_f_index < _f_size)) {
				break;
			}
			_tmp5_ = _f_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _f_index);
			f = (GOFFile*) _tmp6_;
			_tmp7_ = self->model;
			_tmp8_ = f;
			_tmp10_ = fm_list_model_get_first_iter_for_file (_tmp7_, _tmp8_, &_tmp9_);
			iter = _tmp9_;
			if (_tmp10_) {
				guint _tmp11_;
				GtkTreePath* path = NULL;
				FMListModel* _tmp12_;
				GtkTreeIter _tmp13_;
				GtkTreePath* _tmp14_;
				gboolean _tmp15_ = FALSE;
				GtkTreePath* _tmp18_;
				_tmp11_ = count;
				count = _tmp11_ + 1;
				_tmp12_ = self->model;
				_tmp13_ = iter;
				_tmp14_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp12_, &_tmp13_);
				path = _tmp14_;
				if (focus_file != NULL) {
					GOFFile* _tmp16_;
					GFile* _tmp17_;
					_tmp16_ = f;
					_tmp17_ = _tmp16_->location;
					_tmp15_ = g_file_equal (focus_file, _tmp17_);
				} else {
					_tmp15_ = FALSE;
				}
				_tmp18_ = path;
				fm_abstract_directory_view_select_path (self, _tmp18_, _tmp15_);
				__vala_GtkTreePath_free0 (path);
			}
			_g_object_unref0 (f);
		}
		_g_object_unref0 (_f_list);
	}
	if (count == ((guint) 0)) {
		fm_abstract_directory_view_focus_first_for_empty_selection (self, FALSE);
	}
	fm_abstract_directory_view_connect_tree_signals (self);
	fm_abstract_directory_view_on_view_selection_changed (self);
	fm_abstract_directory_view_update_selected_files_and_menu (self);
}

GList*
fm_abstract_directory_view_get_open_with_apps (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->open_with_apps;
	result = _tmp0_;
	return result;
}

GAppInfo*
fm_abstract_directory_view_get_default_app (FMAbstractDirectoryView* self)
{
	GAppInfo* _tmp0_;
	GAppInfo* _tmp1_;
	GAppInfo* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->default_app;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

void
fm_abstract_directory_view_grab_focus (FMAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->view;
	if (gtk_widget_get_realized (_tmp0_)) {
		MarlinViewSlot* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkWidget* _tmp4_;
		_tmp1_ = self->slot;
		_tmp2_ = marlin_view_slot_get_is_active (_tmp1_);
		_tmp3_ = _tmp2_;
		if (!_tmp3_) {
			fm_abstract_directory_view_set_active_slot (self, TRUE);
		}
		_tmp4_ = self->priv->view;
		gtk_widget_grab_focus (_tmp4_);
	}
}

GList*
fm_abstract_directory_view_get_selected_files (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	fm_abstract_directory_view_update_selected_files_and_menu (self);
	_tmp0_ = self->selected_files;
	result = _tmp0_;
	return result;
}

/*** Protected Methods */
void
fm_abstract_directory_view_set_active_slot (FMAbstractDirectoryView* self,
                                            gboolean scroll)
{
	MarlinViewSlot* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->slot;
	g_signal_emit_by_name ((GOFAbstractSlot*) _tmp0_, "active", scroll, TRUE);
}

void
fm_abstract_directory_view_load_location (FMAbstractDirectoryView* self,
                                          GFile* location)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (location != NULL);
	g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, location, MARLIN_OPEN_FLAG_DEFAULT, FALSE);
}

void
fm_abstract_directory_view_load_root_location (FMAbstractDirectoryView* self,
                                               GFile* location)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (location != NULL);
	g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, location, MARLIN_OPEN_FLAG_DEFAULT, TRUE);
}

/** Operations on selections */
static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
	g_atomic_int_inc (&_data27_->_ref_count_);
	return _data27_;
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data27_->self;
		_g_object_unref0 (self);
		g_slice_free (Block27Data, _data27_);
	}
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
	g_atomic_int_inc (&_data28_->_ref_count_);
	return _data28_;
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data28_->_data27_->self;
		_g_object_unref0 (_data28_->file);
		block27_data_unref (_data28_->_data27_);
		_data28_->_data27_ = NULL;
		g_slice_free (Block28Data, _data28_);
	}
}

static gboolean
_______lambda46_ (Block28Data* _data28_)
{
	Block27Data* _data27_;
	FMAbstractDirectoryView* self;
	GOFFile* _tmp0_;
	GdkScreen* _tmp1_;
	gboolean result = FALSE;
	_data27_ = _data28_->_data27_;
	self = _data27_->self;
	_tmp0_ = _data28_->file;
	_tmp1_ = _data27_->screen;
	fm_abstract_directory_view_activate_file (self, _tmp0_, _tmp1_, _data27_->flag, FALSE);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
________lambda46__gsource_func (gpointer self)
{
	gboolean result;
	result = _______lambda46_ (self);
	return result;
}

static gboolean
_______lambda47_ (Block28Data* _data28_)
{
	Block27Data* _data27_;
	FMAbstractDirectoryView* self;
	GOFFile* _tmp0_;
	GdkScreen* _tmp1_;
	gboolean result = FALSE;
	_data27_ = _data28_->_data27_;
	self = _data27_->self;
	_tmp0_ = _data28_->file;
	_tmp1_ = _data27_->screen;
	fm_abstract_directory_view_open_file (self, _tmp0_, _tmp1_, NULL);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
________lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = _______lambda47_ (self);
	return result;
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
	g_atomic_int_inc (&_data29_->_ref_count_);
	return _data29_;
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data29_->_data27_->self;
		(_data29_->files_to_open == NULL) ? NULL : (_data29_->files_to_open = (_g_list_free__g_object_unref0_ (_data29_->files_to_open), NULL));
		block27_data_unref (_data29_->_data27_);
		_data29_->_data27_ = NULL;
		g_slice_free (Block29Data, _data29_);
	}
}

static gboolean
_____lambda48_ (Block29Data* _data29_)
{
	Block27Data* _data27_;
	FMAbstractDirectoryView* self;
	GAppInfo* _tmp0_;
	GList* _tmp1_;
	gboolean result = FALSE;
	_data27_ = _data29_->_data27_;
	self = _data27_->self;
	_tmp0_ = self->priv->default_app;
	_tmp1_ = _data29_->files_to_open;
	fm_abstract_directory_view_open_files_with (self, _tmp0_, _tmp1_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
______lambda48__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda48_ (self);
	return result;
}

void
fm_abstract_directory_view_activate_selected_items (FMAbstractDirectoryView* self,
                                                    MarlinOpenFlag flag,
                                                    GList* selection)
{
	Block27Data* _data27_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GdkScreen* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	g_return_if_fail (self != NULL);
	_data27_ = g_slice_new0 (Block27Data);
	_data27_->_ref_count_ = 1;
	_data27_->self = g_object_ref (self);
	_data27_->flag = flag;
	_tmp1_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = selection == NULL;
	}
	if (_tmp0_) {
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return;
	}
	_tmp3_ = gtk_widget_get_screen ((GtkWidget*) self);
	_data27_->screen = _tmp3_;
	_tmp4_ = g_list_first (selection);
	_tmp5_ = _tmp4_->next;
	if (_tmp5_ == NULL) {
		gconstpointer _tmp6_;
		GdkScreen* _tmp7_;
		_tmp6_ = selection->data;
		_tmp7_ = _data27_->screen;
		fm_abstract_directory_view_activate_file (self, (GOFFile*) _tmp6_, _tmp7_, _data27_->flag, TRUE);
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return;
	}
	if (!self->priv->in_trash) {
		gboolean _tmp8_ = FALSE;
		gconstpointer _tmp9_;
		_tmp9_ = g_list_nth_data (selection, (guint) 11);
		if (((GOFFile*) _tmp9_) == NULL) {
			gboolean _tmp10_ = FALSE;
			GAppInfo* _tmp11_;
			_tmp11_ = self->priv->default_app;
			if (_tmp11_ == NULL) {
				_tmp10_ = TRUE;
			} else {
				GAppInfo* _tmp12_;
				_tmp12_ = self->priv->default_app;
				_tmp10_ = fm_abstract_directory_view_app_is_this_app (self, _tmp12_);
			}
			_tmp8_ = _tmp10_;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			{
				GList* file_collection = NULL;
				GList* file_it = NULL;
				file_collection = selection;
				for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
					GOFFile* _tmp13_;
					GOFFile* file = NULL;
					_tmp13_ = _g_object_ref0 ((GOFFile*) file_it->data);
					file = _tmp13_;
					{
						Block28Data* _data28_;
						GOFFile* _tmp14_;
						_data28_ = g_slice_new0 (Block28Data);
						_data28_->_ref_count_ = 1;
						_data28_->_data27_ = block27_data_ref (_data27_);
						_data28_->file = file;
						_tmp14_ = _data28_->file;
						if (gof_file_is_folder (_tmp14_)) {
							if (_data27_->flag == MARLIN_OPEN_FLAG_DEFAULT) {
								_data27_->flag = MARLIN_OPEN_FLAG_NEW_TAB;
							}
							g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ________lambda46__gsource_func, block28_data_ref (_data28_), block28_data_unref);
						} else {
							g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ________lambda47__gsource_func, block28_data_ref (_data28_), block28_data_unref);
						}
						block28_data_unref (_data28_);
						_data28_ = NULL;
					}
				}
			}
		} else {
			GAppInfo* _tmp15_;
			_tmp15_ = self->priv->default_app;
			if (_tmp15_ != NULL) {
				Block29Data* _data29_;
				GList* _tmp16_;
				_data29_ = g_slice_new0 (Block29Data);
				_data29_->_ref_count_ = 1;
				_data29_->_data27_ = block27_data_ref (_data27_);
				_tmp16_ = g_list_copy_deep (selection, (GCopyFunc) g_object_ref, NULL);
				_data29_->files_to_open = _tmp16_;
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda48__gsource_func, block29_data_ref (_data29_), block29_data_unref);
				block29_data_unref (_data29_);
				_data29_ = NULL;
			}
		}
	} else {
		g_warning ("AbstractDirectoryView.vala:585: Cannot open files in trash");
	}
	block27_data_unref (_data27_);
	_data27_ = NULL;
}

void
fm_abstract_directory_view_select_gof_file (FMAbstractDirectoryView* self,
                                            GOFFile* file)
{
	GtkTreeIter iter = {0};
	FMListModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreePath* path = NULL;
	FMListModel* _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	memset (&iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->model;
	_tmp2_ = fm_list_model_get_first_iter_for_file (_tmp0_, file, &_tmp1_);
	iter = _tmp1_;
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = self->model;
	_tmp4_ = iter;
	_tmp5_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp3_, &_tmp4_);
	path = _tmp5_;
	_tmp6_ = path;
	fm_abstract_directory_view_set_cursor (self, _tmp6_, FALSE, TRUE, FALSE);
	__vala_GtkTreePath_free0 (path);
}

void
fm_abstract_directory_view_select_and_scroll_to_gof_file (FMAbstractDirectoryView* self,
                                                          GOFFile* file)
{
	GtkTreeIter iter = {0};
	FMListModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreePath* path = NULL;
	FMListModel* _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	memset (&iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->model;
	_tmp2_ = fm_list_model_get_first_iter_for_file (_tmp0_, file, &_tmp1_);
	iter = _tmp1_;
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = self->model;
	_tmp4_ = iter;
	_tmp5_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp3_, &_tmp4_);
	path = _tmp5_;
	_tmp6_ = path;
	fm_abstract_directory_view_set_cursor (self, _tmp6_, FALSE, TRUE, TRUE);
	__vala_GtkTreePath_free0 (path);
}

void
fm_abstract_directory_view_add_gof_file_to_selection (FMAbstractDirectoryView* self,
                                                      GOFFile* file)
{
	GtkTreeIter iter = {0};
	FMListModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreePath* path = NULL;
	FMListModel* _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	memset (&iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->model;
	_tmp2_ = fm_list_model_get_first_iter_for_file (_tmp0_, file, &_tmp1_);
	iter = _tmp1_;
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = self->model;
	_tmp4_ = iter;
	_tmp5_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp3_, &_tmp4_);
	path = _tmp5_;
	_tmp6_ = path;
	fm_abstract_directory_view_select_path (self, _tmp6_, FALSE);
	__vala_GtkTreePath_free0 (path);
}

/** Directory signal handlers. */
static void
_fm_abstract_directory_view_on_directory_file_added_gof_directory_async_file_added (GOFDirectoryAsync* _sender,
                                                                                    GOFFile* file,
                                                                                    gpointer self)
{
	fm_abstract_directory_view_on_directory_file_added ((FMAbstractDirectoryView*) self, _sender, file);
}

static void
_fm_abstract_directory_view_on_directory_file_changed_gof_directory_async_file_changed (GOFDirectoryAsync* _sender,
                                                                                        GOFFile* file,
                                                                                        gpointer self)
{
	fm_abstract_directory_view_on_directory_file_changed ((FMAbstractDirectoryView*) self, _sender, file);
}

static void
_fm_abstract_directory_view_on_directory_file_deleted_gof_directory_async_file_deleted (GOFDirectoryAsync* _sender,
                                                                                        GOFFile* file,
                                                                                        gpointer self)
{
	fm_abstract_directory_view_on_directory_file_deleted ((FMAbstractDirectoryView*) self, _sender, file);
}

static void
_fm_abstract_directory_view_on_directory_file_icon_changed_gof_directory_async_icon_changed (GOFDirectoryAsync* _sender,
                                                                                             GOFFile* file,
                                                                                             gpointer self)
{
	fm_abstract_directory_view_on_directory_file_icon_changed ((FMAbstractDirectoryView*) self, _sender, file);
}

void
fm_abstract_directory_view_connect_directory_handlers (FMAbstractDirectoryView* self,
                                                       GOFDirectoryAsync* dir)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	_vala_assert (dir != NULL, "dir != null");
	g_signal_connect_object (dir, "file-added", (GCallback) _fm_abstract_directory_view_on_directory_file_added_gof_directory_async_file_added, self, 0);
	g_signal_connect_object (dir, "file-changed", (GCallback) _fm_abstract_directory_view_on_directory_file_changed_gof_directory_async_file_changed, self, 0);
	g_signal_connect_object (dir, "file-deleted", (GCallback) _fm_abstract_directory_view_on_directory_file_deleted_gof_directory_async_file_deleted, self, 0);
	g_signal_connect_object (dir, "icon-changed", (GCallback) _fm_abstract_directory_view_on_directory_file_icon_changed_gof_directory_async_icon_changed, self, 0);
	fm_abstract_directory_view_connect_directory_loading_handlers (self, dir);
}

static void
_fm_abstract_directory_view_on_directory_file_loaded_gof_directory_async_file_loaded (GOFDirectoryAsync* _sender,
                                                                                      GOFFile* file,
                                                                                      gpointer self)
{
	fm_abstract_directory_view_on_directory_file_loaded ((FMAbstractDirectoryView*) self, _sender, file);
}

static void
_fm_abstract_directory_view_on_directory_done_loading_gof_directory_async_done_loading (GOFDirectoryAsync* _sender,
                                                                                        gpointer self)
{
	fm_abstract_directory_view_on_directory_done_loading ((FMAbstractDirectoryView*) self, _sender);
}

void
fm_abstract_directory_view_connect_directory_loading_handlers (FMAbstractDirectoryView* self,
                                                               GOFDirectoryAsync* dir)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_signal_connect_object (dir, "file-loaded", (GCallback) _fm_abstract_directory_view_on_directory_file_loaded_gof_directory_async_file_loaded, self, 0);
	g_signal_connect_object (dir, "done-loading", (GCallback) _fm_abstract_directory_view_on_directory_done_loading_gof_directory_async_done_loading, self, 0);
}

void
fm_abstract_directory_view_disconnect_directory_loading_handlers (FMAbstractDirectoryView* self,
                                                                  GOFDirectoryAsync* dir)
{
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_signal_parse_name ("file-loaded", GOF_DIRECTORY_TYPE_ASYNC, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_file_loaded_gof_directory_async_file_loaded, self);
	g_signal_parse_name ("done-loading", GOF_DIRECTORY_TYPE_ASYNC, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_done_loading_gof_directory_async_done_loading, self);
}

void
fm_abstract_directory_view_disconnect_directory_handlers (FMAbstractDirectoryView* self,
                                                          GOFDirectoryAsync* dir)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	if (gof_directory_async_is_loading (dir)) {
		fm_abstract_directory_view_disconnect_directory_loading_handlers (self, dir);
	}
	g_signal_parse_name ("file-added", GOF_DIRECTORY_TYPE_ASYNC, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_file_added_gof_directory_async_file_added, self);
	g_signal_parse_name ("file-changed", GOF_DIRECTORY_TYPE_ASYNC, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_file_changed_gof_directory_async_file_changed, self);
	g_signal_parse_name ("file-deleted", GOF_DIRECTORY_TYPE_ASYNC, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_file_deleted_gof_directory_async_file_deleted, self);
	g_signal_parse_name ("icon-changed", GOF_DIRECTORY_TYPE_ASYNC, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_file_icon_changed_gof_directory_async_icon_changed, self);
	g_signal_parse_name ("done-loading", GOF_DIRECTORY_TYPE_ASYNC, &_tmp4_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_directory_done_loading_gof_directory_async_done_loading, self);
}

void
fm_abstract_directory_view_change_directory (FMAbstractDirectoryView* self,
                                             GOFDirectoryAsync* old_dir,
                                             GOFDirectoryAsync* new_dir)
{
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (old_dir != NULL);
	g_return_if_fail (new_dir != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = style_context;
	if (gtk_style_context_has_class (_tmp2_, GRANITE_STYLE_CLASS_H2_LABEL)) {
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
		_tmp3_ = style_context;
		gtk_style_context_remove_class (_tmp3_, GRANITE_STYLE_CLASS_H2_LABEL);
		_tmp4_ = style_context;
		gtk_style_context_remove_class (_tmp4_, GTK_STYLE_CLASS_VIEW);
	}
	fm_abstract_directory_view_cancel (self);
	fm_abstract_directory_view_clear (self);
	fm_abstract_directory_view_disconnect_directory_handlers (self, old_dir);
	fm_abstract_directory_view_connect_directory_handlers (self, new_dir);
	_g_object_unref0 (style_context);
}

void
fm_abstract_directory_view_prepare_reload (FMAbstractDirectoryView* self,
                                           GOFDirectoryAsync* dir)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	fm_abstract_directory_view_cancel (self);
	fm_abstract_directory_view_clear (self);
	fm_abstract_directory_view_connect_directory_loading_handlers (self, dir);
}

static void
fm_abstract_directory_view_clear (FMAbstractDirectoryView* self)
{
	FMListModel* _tmp0_;
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_freeze_tree (self);
	fm_abstract_directory_view_block_model (self);
	_tmp0_ = self->model;
	fm_list_model_clear (_tmp0_);
	self->priv->all_selected = FALSE;
	fm_abstract_directory_view_unblock_model (self);
}

static gboolean
_fm_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               gint x,
                                                               gint y,
                                                               guint time_,
                                                               gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_drag_drop ((FMAbstractDirectoryView*) self, context, x, y, time_);
	return result;
}

static void
_fm_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                 GdkDragContext* context,
                                                                                 gint x,
                                                                                 gint y,
                                                                                 GtkSelectionData* selection_data,
                                                                                 guint info,
                                                                                 guint time_,
                                                                                 gpointer self)
{
	fm_abstract_directory_view_on_drag_data_received ((FMAbstractDirectoryView*) self, context, x, y, selection_data, info, time_);
}

static void
_fm_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 guint time_,
                                                                 gpointer self)
{
	fm_abstract_directory_view_on_drag_leave ((FMAbstractDirectoryView*) self, context, time_);
}

static gboolean
_fm_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   gint x,
                                                                   gint y,
                                                                   guint time_,
                                                                   gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_drag_motion ((FMAbstractDirectoryView*) self, context, x, y, time_);
	return result;
}

static void
_fm_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 gpointer self)
{
	fm_abstract_directory_view_on_drag_begin ((FMAbstractDirectoryView*) self, context);
}

static void
_fm_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkSelectionData* selection_data,
                                                                       guint info,
                                                                       guint time_,
                                                                       gpointer self)
{
	fm_abstract_directory_view_on_drag_data_get ((FMAbstractDirectoryView*) self, context, selection_data, info, time_);
}

static void
_fm_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete (GtkWidget* _sender,
                                                                             GdkDragContext* context,
                                                                             gpointer self)
{
	fm_abstract_directory_view_on_drag_data_delete ((FMAbstractDirectoryView*) self, context);
}

static void
_fm_abstract_directory_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self)
{
	fm_abstract_directory_view_on_drag_end ((FMAbstractDirectoryView*) self, context);
}

void
fm_abstract_directory_view_connect_drag_drop_signals (FMAbstractDirectoryView* self,
                                                      GtkWidget* widget)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	gtk_drag_dest_set (widget, GTK_DEST_DEFAULT_MOTION, FM_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS, (gint) G_N_ELEMENTS (FM_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS), GDK_ACTION_ASK | FM_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS);
	g_signal_connect_object (widget, "drag-drop", (GCallback) _fm_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop, self, 0);
	g_signal_connect_object (widget, "drag-data-received", (GCallback) _fm_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received, self, 0);
	g_signal_connect_object (widget, "drag-leave", (GCallback) _fm_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave, self, 0);
	g_signal_connect_object (widget, "drag-motion", (GCallback) _fm_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion, self, 0);
	gtk_drag_source_set (widget, GDK_BUTTON1_MASK, FM_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS, (gint) G_N_ELEMENTS (FM_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS), FM_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS);
	g_signal_connect_object (widget, "drag-begin", (GCallback) _fm_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object (widget, "drag-data-get", (GCallback) _fm_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
	g_signal_connect_object (widget, "drag-data-delete", (GCallback) _fm_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete, self, 0);
	g_signal_connect_object (widget, "drag-end", (GCallback) _fm_abstract_directory_view_on_drag_end_gtk_widget_drag_end, self, 0);
}

void
fm_abstract_directory_view_cancel_drag_timer (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_disconnect_drag_timeout_motion_and_release_events (self);
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->drag_timer_id);
}

void
fm_abstract_directory_view_cancel_thumbnailing (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->thumbnail_request >= 0) {
		MarlinThumbnailer* _tmp0_;
		_tmp0_ = self->priv->thumbnailer;
		marlin_thumbnailer_dequeue (_tmp0_, self->priv->thumbnail_request);
		self->priv->thumbnail_request = -1;
	}
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->thumbnail_source_id);
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data30_->self;
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}

static void
__lambda36_ (Block30Data* _data30_,
             GOFFile* file)
{
	FMAbstractDirectoryView* self;
	gboolean _tmp0_ = FALSE;
	self = _data30_->self;
	g_return_if_fail (file != NULL);
	if (gof_file_is_folder (file)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = gof_file_is_root_network_folder (file);
	}
	if (!_tmp0_) {
		_data30_->only_folders = FALSE;
	}
}

static void
___lambda36__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda36_ (self, (GOFFile*) data);
}

gboolean
fm_abstract_directory_view_selection_only_contains_folders (FMAbstractDirectoryView* self,
                                                            GList* list)
{
	Block30Data* _data30_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_data30_ = g_slice_new0 (Block30Data);
	_data30_->_ref_count_ = 1;
	_data30_->self = g_object_ref (self);
	_data30_->only_folders = TRUE;
	g_list_foreach (list, ___lambda36__gfunc, _data30_);
	result = _data30_->only_folders;
	block30_data_unref (_data30_);
	_data30_ = NULL;
	return result;
}

/** Handle scroll events */
gboolean
fm_abstract_directory_view_handle_scroll_event (FMAbstractDirectoryView* self,
                                                GdkEventScroll* event)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GdkModifierType _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		result = TRUE;
		return result;
	}
	_tmp2_ = event->state;
	if ((_tmp2_ & GDK_CONTROL_MASK) > 0) {
		GdkScrollDirection _tmp3_;
		_tmp3_ = event->direction;
		switch (_tmp3_) {
			case GDK_SCROLL_UP:
			{
				fm_abstract_directory_view_zoom_in (self);
				result = TRUE;
				return result;
			}
			case GDK_SCROLL_DOWN:
			{
				fm_abstract_directory_view_zoom_out (self);
				result = TRUE;
				return result;
			}
			case GDK_SCROLL_SMOOTH:
			{
				gdouble delta_x = 0.0;
				gdouble delta_y = 0.0;
				gdouble _tmp4_ = 0.0;
				gdouble _tmp5_ = 0.0;
				gdk_event_get_scroll_deltas ((GdkEvent*) event, &_tmp4_, &_tmp5_);
				delta_x = _tmp4_;
				delta_y = _tmp5_;
				self->priv->total_delta_y = self->priv->total_delta_y + delta_y;
				if (self->priv->total_delta_y >= 0.5) {
					self->priv->total_delta_y = (gdouble) 0;
					fm_abstract_directory_view_zoom_out (self);
				} else {
					if (self->priv->total_delta_y <= (-0.5)) {
						self->priv->total_delta_y = (gdouble) 0;
						fm_abstract_directory_view_zoom_in (self);
					}
				}
				result = TRUE;
				return result;
			}
			default:
			{
				break;
			}
		}
	}
	result = FALSE;
	return result;
}

GList*
fm_abstract_directory_view_get_selected_files_for_transfer (FMAbstractDirectoryView* self,
                                                            GList* selection)
{
	GList* _tmp0_;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_list_copy_deep (selection, (GCopyFunc) g_object_ref, NULL);
	result = _tmp0_;
	return result;
}

/** File operations */
static void
fm_abstract_directory_view_activate_file (FMAbstractDirectoryView* self,
                                          GOFFile* _file,
                                          GdkScreen* screen,
                                          MarlinOpenFlag flag,
                                          gboolean only_one_file)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GOFFile* file = NULL;
	GOFFile* _tmp2_;
	gboolean _tmp3_;
	GOFFile* _tmp8_;
	GAppInfo* _tmp9_;
	GFile* location = NULL;
	GOFFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_file != NULL);
	_tmp0_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp2_ = _g_object_ref0 (_file);
	file = _tmp2_;
	_tmp3_ = self->priv->_in_recent;
	if (_tmp3_) {
		GOFFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GOFFile* _tmp7_;
		_tmp4_ = file;
		_tmp5_ = gof_file_get_display_target_uri (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = gof_file_get_by_uri (_tmp6_);
		_g_object_unref0 (file);
		file = _tmp7_;
		_g_free0 (_tmp6_);
	}
	_tmp8_ = file;
	_tmp9_ = marlin_mime_actions_get_default_application_for_file (_tmp8_);
	_g_object_unref0 (self->priv->default_app);
	self->priv->default_app = _tmp9_;
	_tmp10_ = file;
	_tmp11_ = gof_file_get_target_location (_tmp10_);
	_tmp12_ = _g_object_ref0 (_tmp11_);
	location = _tmp12_;
	if (screen == NULL) {
		GdkScreen* _tmp13_;
		_tmp13_ = gtk_widget_get_screen ((GtkWidget*) self);
		screen = _tmp13_;
	}
	if (flag != MARLIN_OPEN_FLAG_APP) {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		GOFFile* _tmp17_;
		_tmp17_ = file;
		if (gof_file_is_folder (_tmp17_)) {
			_tmp16_ = TRUE;
		} else {
			GOFFile* _tmp18_;
			const gchar* _tmp19_;
			_tmp18_ = file;
			_tmp19_ = gof_file_get_ftype (_tmp18_);
			_tmp16_ = g_strcmp0 (_tmp19_, "inode/directory") == 0;
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			GOFFile* _tmp20_;
			_tmp20_ = file;
			_tmp15_ = gof_file_is_root_network_folder (_tmp20_);
		}
		_tmp14_ = _tmp15_;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		switch (flag) {
			case MARLIN_OPEN_FLAG_NEW_TAB:
			case MARLIN_OPEN_FLAG_NEW_WINDOW:
			{
				GFile* _tmp21_;
				_tmp21_ = location;
				g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, _tmp21_, flag, TRUE);
				break;
			}
			default:
			{
				if (only_one_file) {
					GFile* _tmp22_;
					_tmp22_ = location;
					fm_abstract_directory_view_load_location (self, _tmp22_);
				}
				break;
			}
		}
	} else {
		if (!self->priv->in_trash) {
			if (only_one_file) {
				GOFFile* _tmp23_;
				_tmp23_ = file;
				if (gof_file_is_executable (_tmp23_)) {
					gchar* content_type = NULL;
					GOFFile* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					_tmp24_ = file;
					_tmp25_ = gof_file_get_ftype (_tmp24_);
					_tmp26_ = g_strdup (_tmp25_);
					content_type = _tmp26_;
					_tmp27_ = content_type;
					if (g_content_type_is_a (_tmp27_, "text/plain")) {
						GOFFile* _tmp28_;
						GAppInfo* _tmp29_;
						_tmp28_ = file;
						_tmp29_ = self->priv->default_app;
						fm_abstract_directory_view_open_file (self, _tmp28_, screen, _tmp29_);
					} else {
						{
							GOFFile* _tmp30_;
							_tmp30_ = file;
							gof_file_execute (_tmp30_, NULL, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch25_g_error;
							}
						}
						goto __finally25;
						__catch25_g_error:
						{
							GError* e = NULL;
							GError* _tmp31_;
							const gchar* _tmp32_;
							MarlinViewWindow* _tmp33_;
							GraniteMessageDialog* _tmp34_;
							GraniteMessageDialog* _tmp35_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp31_ = e;
							_tmp32_ = _tmp31_->message;
							_tmp33_ = self->window;
							_tmp34_ = pf_dialogs_show_warning_dialog (_ ("Cannot execute this file"), _tmp32_, (GtkWindow*) _tmp33_);
							_tmp35_ = _tmp34_;
							_g_object_unref0 (_tmp35_);
							_g_error_free0 (e);
						}
						__finally25:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_free0 (content_type);
							_g_object_unref0 (location);
							_g_object_unref0 (file);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_g_free0 (content_type);
				} else {
					GOFFile* _tmp36_;
					GAppInfo* _tmp37_;
					_tmp36_ = file;
					_tmp37_ = self->priv->default_app;
					fm_abstract_directory_view_open_file (self, _tmp36_, screen, _tmp37_);
				}
			}
		} else {
			g_warning ("AbstractDirectoryView.vala:828: Cannot open file in trash");
		}
	}
	_g_object_unref0 (location);
	_g_object_unref0 (file);
}

static void
fm_abstract_directory_view_open_file (FMAbstractDirectoryView* self,
                                      GOFFile* file,
                                      GdkScreen* screen,
                                      GAppInfo* app_info)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	if (fm_abstract_directory_view_can_open_file (self, file, TRUE)) {
		GFile* _tmp0_;
		_tmp0_ = file->location;
		marlin_mime_actions_open_glib_file_request (_tmp0_, (GtkWidget*) self, app_info);
	}
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
fm_abstract_directory_view_can_open_file (FMAbstractDirectoryView* self,
                                          GOFFile* file,
                                          gboolean show_error_dialog)
{
	gchar* err_msg1 = NULL;
	gchar* _tmp0_;
	gchar* err_msg2 = NULL;
	gchar* _tmp1_;
	gchar* content_type = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp11_;
	gboolean success = FALSE;
	const gchar* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gboolean _tmp42_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	_tmp0_ = g_strdup (_ ("Cannot open this file"));
	err_msg1 = _tmp0_;
	_tmp1_ = g_strdup ("");
	err_msg2 = _tmp1_;
	_tmp2_ = gof_file_get_ftype (file);
	_tmp3_ = g_strdup (_tmp2_);
	content_type = _tmp3_;
	_tmp4_ = content_type;
	if (_tmp4_ == NULL) {
		gboolean result_uncertain = FALSE;
		const gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		result_uncertain = TRUE;
		_tmp5_ = file->basename;
		_tmp7_ = g_content_type_guess (_tmp5_, NULL, (gsize) 0, &_tmp6_);
		result_uncertain = _tmp6_;
		_g_free0 (content_type);
		content_type = _tmp7_;
		_tmp8_ = content_type;
		_tmp9_ = bool_to_string (result_uncertain);
		_tmp10_ = _tmp9_;
		g_debug ("AbstractDirectoryView.vala:848: Guessed content type to be %s from nam" \
"e - result_uncertain %s", _tmp8_, _tmp10_);
		_g_free0 (_tmp10_);
	}
	_tmp11_ = content_type;
	if (_tmp11_ == NULL) {
		gchar* _tmp12_;
		_tmp12_ = g_strdup (_ ("Cannot identify file type to open"));
		_g_free0 (err_msg2);
		err_msg2 = _tmp12_;
	} else {
		MarlinViewSlot* _tmp13_;
		GOFDirectoryAsync* _tmp14_;
		GOFDirectoryAsync* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
		_tmp13_ = self->slot;
		_tmp14_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = gof_directory_async_get_can_open_files (_tmp15_);
		_tmp17_ = _tmp16_;
		if (!_tmp17_) {
			MarlinViewSlot* _tmp18_;
			GOFDirectoryAsync* _tmp19_;
			GOFDirectoryAsync* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			_tmp18_ = self->slot;
			_tmp19_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = gof_directory_async_get_scheme (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = g_strdup_printf ("Cannot open files with this protocol (%s)", _tmp22_);
			_g_free0 (err_msg2);
			err_msg2 = _tmp23_;
		} else {
			gboolean _tmp24_ = FALSE;
			MarlinViewSlot* _tmp25_;
			GOFDirectoryAsync* _tmp26_;
			GOFDirectoryAsync* _tmp27_;
			gboolean _tmp28_;
			gboolean _tmp29_;
			_tmp25_ = self->slot;
			_tmp26_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = gof_directory_async_get_can_stream_files (_tmp27_);
			_tmp29_ = _tmp28_;
			if (!_tmp29_) {
				gboolean _tmp30_ = FALSE;
				const gchar* _tmp31_;
				_tmp31_ = content_type;
				if (string_contains (_tmp31_, "video")) {
					_tmp30_ = TRUE;
				} else {
					const gchar* _tmp32_;
					_tmp32_ = content_type;
					_tmp30_ = string_contains (_tmp32_, "audio");
				}
				_tmp24_ = _tmp30_;
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				MarlinViewSlot* _tmp33_;
				GOFDirectoryAsync* _tmp34_;
				GOFDirectoryAsync* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				_tmp33_ = self->slot;
				_tmp34_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp33_);
				_tmp35_ = _tmp34_;
				_tmp36_ = gof_directory_async_get_scheme (_tmp35_);
				_tmp37_ = _tmp36_;
				_tmp38_ = g_strdup_printf ("Cannot stream from this protocol (%s)", _tmp37_);
				_g_free0 (err_msg2);
				err_msg2 = _tmp38_;
			}
		}
	}
	_tmp39_ = err_msg2;
	_tmp40_ = strlen (_tmp39_);
	_tmp41_ = _tmp40_;
	success = _tmp41_ < 1;
	if (!success) {
		_tmp42_ = show_error_dialog;
	} else {
		_tmp42_ = FALSE;
	}
	if (_tmp42_) {
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		MarlinViewWindow* _tmp45_;
		GraniteMessageDialog* _tmp46_;
		GraniteMessageDialog* _tmp47_;
		_tmp43_ = err_msg1;
		_tmp44_ = err_msg2;
		_tmp45_ = self->window;
		_tmp46_ = pf_dialogs_show_warning_dialog (_tmp43_, _tmp44_, (GtkWindow*) _tmp45_);
		_tmp47_ = _tmp46_;
		_g_object_unref0 (_tmp47_);
	}
	result = success;
	_g_free0 (content_type);
	_g_free0 (err_msg2);
	_g_free0 (err_msg1);
	return result;
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
	g_atomic_int_inc (&_data31_->_ref_count_);
	return _data31_;
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data31_->self;
		(_data31_->locations == NULL) ? NULL : (_data31_->locations = (_g_list_free__g_object_unref0_ (_data31_->locations), NULL));
		_g_object_unref0 (self);
		g_slice_free (Block31Data, _data31_);
	}
}

static void
___lambda41_ (Block31Data* _data31_,
              GOFFile* file)
{
	FMAbstractDirectoryView* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	self = _data31_->self;
	g_return_if_fail (file != NULL);
	_tmp0_ = gof_file_get_display_target_uri (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_new_for_uri (_tmp1_);
	_data31_->locations = g_list_prepend (_data31_->locations, _tmp2_);
	_g_free0 (_tmp1_);
}

static void
____lambda41__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda41_ (self, (GOFFile*) data);
}

static void
___lambda42_ (Block31Data* _data31_,
              GOFFile* file)
{
	FMAbstractDirectoryView* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	self = _data31_->self;
	g_return_if_fail (file != NULL);
	_tmp0_ = file->location;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_data31_->locations = g_list_prepend (_data31_->locations, _tmp1_);
}

static void
____lambda42__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda42_ (self, (GOFFile*) data);
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
	g_boxed_free (gtk_tree_iter_get_type (), self);
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
}

static void
___lambda43_ (FMAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		marlin_file_operations_delete_finish (res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch26_g_error;
		}
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_debug ("AbstractDirectoryView.vala:903: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally26:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	fm_abstract_directory_view_after_trash_or_delete (self);
}

static void
____lambda43__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda43_ ((FMAbstractDirectoryView*) self, source_object, res);
	g_object_unref (self);
}

static void
fm_abstract_directory_view_trash_or_delete_files (FMAbstractDirectoryView* self,
                                                  GList* file_list,
                                                  gboolean delete_if_already_in_trash,
                                                  gboolean delete_immediately)
{
	Block31Data* _data31_;
	gboolean _tmp0_;
	GtkTreeIter* iter = NULL;
	FMListModel* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	GtkTreeIter _tmp5_;
	GtkTreeIter* _tmp6_;
	FMListModel* _tmp7_;
	GtkTreeIter* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkTreePath* _tmp10_;
	GList* _tmp11_;
	gboolean _tmp17_;
	g_return_if_fail (self != NULL);
	_data31_ = g_slice_new0 (Block31Data);
	_data31_->_ref_count_ = 1;
	_data31_->self = g_object_ref (self);
	_data31_->locations = NULL;
	_tmp0_ = self->priv->_in_recent;
	if (_tmp0_) {
		g_list_foreach (file_list, ____lambda41__gfunc, _data31_);
	} else {
		g_list_foreach (file_list, ____lambda42__gfunc, _data31_);
	}
	iter = NULL;
	_tmp1_ = self->model;
	_tmp2_ = g_list_first (file_list);
	_tmp3_ = _tmp2_->data;
	fm_list_model_get_first_iter_for_file (_tmp1_, (GOFFile*) _tmp3_, &_tmp4_);
	__vala_GtkTreeIter_free0 (iter);
	_tmp5_ = _tmp4_;
	_tmp6_ = __vala_GtkTreeIter_copy0 (&_tmp5_);
	iter = _tmp6_;
	_tmp7_ = self->model;
	_tmp8_ = iter;
	_tmp9_ = *_tmp8_;
	_tmp10_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp7_, &_tmp9_);
	__vala_GtkTreePath_free0 (self->priv->deleted_path);
	self->priv->deleted_path = _tmp10_;
	_tmp11_ = _data31_->locations;
	if (_tmp11_ != NULL) {
		MarlinViewSlot* _tmp12_;
		GOFDirectoryAsync* _tmp13_;
		GOFDirectoryAsync* _tmp14_;
		GList* _tmp15_;
		MarlinViewWindow* _tmp16_;
		_data31_->locations = g_list_reverse (_data31_->locations);
		_tmp12_ = self->slot;
		_tmp13_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp12_);
		_tmp14_ = _tmp13_;
		gof_directory_async_block_monitor (_tmp14_);
		_tmp15_ = _data31_->locations;
		_tmp16_ = self->window;
		marlin_file_operations_delete (_tmp15_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp16_) : NULL, !delete_immediately, NULL, ____lambda43__gasync_ready_callback, g_object_ref (self));
	}
	_tmp17_ = self->priv->_in_recent;
	if (_tmp17_) {
		MarlinViewSlot* _tmp18_;
		_tmp18_ = self->slot;
		gof_abstract_slot_reload ((GOFAbstractSlot*) _tmp18_, FALSE);
	}
	__vala_GtkTreeIter_free0 (iter);
	block31_data_unref (_data31_);
	_data31_ = NULL;
}

static void
fm_abstract_directory_view_add_file (FMAbstractDirectoryView* self,
                                     GOFFile* file,
                                     GOFDirectoryAsync* dir,
                                     gboolean select)
{
	FMListModel* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (dir != NULL);
	_tmp0_ = self->model;
	fm_list_model_add_file (_tmp0_, file, dir);
	if (select) {
		fm_abstract_directory_view_add_gof_file_to_selection (self, file);
	}
}

static gboolean
___lambda63_ (FMAbstractDirectoryView* self)
{
	gboolean result = FALSE;
	if (self->priv->signal_free_space_change) {
		MarlinViewWindow* _tmp0_;
		self->priv->add_remove_file_timeout_id = (guint) 0;
		_tmp0_ = self->window;
		g_signal_emit_by_name (_tmp0_, "free-space-change");
		result = G_SOURCE_REMOVE;
		return result;
	} else {
		self->priv->signal_free_space_change = TRUE;
		result = G_SOURCE_CONTINUE;
		return result;
	}
}

static gboolean
____lambda63__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda63_ ((FMAbstractDirectoryView*) self);
	return result;
}

static void
fm_abstract_directory_view_handle_free_space_change (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->add_remove_file_timeout_id == ((guint) 0)) {
		self->priv->signal_free_space_change = FALSE;
		self->priv->add_remove_file_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ____lambda63__gsource_func, g_object_ref (self), g_object_unref);
	} else {
		self->priv->signal_free_space_change = FALSE;
	}
}

static void
__lambda81_ (FMAbstractDirectoryView* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		_tmp0_ = marlin_file_operations_new_file_finish (res, &_inner_error0_);
		file = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch27_g_error;
		}
		fm_abstract_directory_view_create_file_done (file, self);
		_g_object_unref0 (file);
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_critical ("AbstractDirectoryView.vala:964: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally27:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda81__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda81_ ((FMAbstractDirectoryView*) self, source_object, res);
	g_object_unref (self);
}

static void
fm_abstract_directory_view_new_empty_file (FMAbstractDirectoryView* self,
                                           const gchar* parent_uri)
{
	MarlinViewSlot* _tmp6_;
	GOFDirectoryAsync* _tmp7_;
	GOFDirectoryAsync* _tmp8_;
	g_return_if_fail (self != NULL);
	if (parent_uri == NULL) {
		MarlinViewSlot* _tmp0_;
		GOFDirectoryAsync* _tmp1_;
		GOFDirectoryAsync* _tmp2_;
		GOFFile* _tmp3_;
		GOFFile* _tmp4_;
		const gchar* _tmp5_;
		_tmp0_ = self->slot;
		_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = gof_directory_async_get_file (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_->uri;
		parent_uri = _tmp5_;
	}
	_tmp6_ = self->slot;
	_tmp7_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp6_);
	_tmp8_ = _tmp7_;
	gof_directory_async_block_monitor (_tmp8_);
	marlin_file_operations_new_file (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL, NULL, parent_uri, NULL, NULL, 0, NULL, ___lambda81__gasync_ready_callback, g_object_ref (self));
}

static void
__lambda49_ (FMAbstractDirectoryView* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		_tmp0_ = marlin_file_operations_new_folder_finish (res, &_inner_error0_);
		file = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch28_g_error;
		}
		fm_abstract_directory_view_create_file_done (file, self);
		_g_object_unref0 (file);
	}
	goto __finally28;
	__catch28_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_critical ("AbstractDirectoryView.vala:978: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally28:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda49__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda49_ ((FMAbstractDirectoryView*) self, source_object, res);
	g_object_unref (self);
}

static void
fm_abstract_directory_view_new_empty_folder (FMAbstractDirectoryView* self)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	MarlinViewSlot* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	gof_directory_async_block_monitor (_tmp2_);
	_tmp3_ = self->slot;
	_tmp4_ = gof_abstract_slot_get_location ((GOFAbstractSlot*) _tmp3_);
	_tmp5_ = _tmp4_;
	marlin_file_operations_new_folder (NULL, NULL, _tmp5_, NULL, ___lambda49__gasync_ready_callback, g_object_ref (self));
}

static void
_fm_abstract_directory_view_after_new_file_added_gof_directory_async_file_added (GOFDirectoryAsync* _sender,
                                                                                 GOFFile* file,
                                                                                 gpointer self)
{
	fm_abstract_directory_view_after_new_file_added ((FMAbstractDirectoryView*) self, file);
}

static void
fm_abstract_directory_view_after_new_file_added (FMAbstractDirectoryView* self,
                                                 GOFFile* file)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_parse_name ("file-added", GOF_DIRECTORY_TYPE_ASYNC, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _fm_abstract_directory_view_after_new_file_added_gof_directory_async_file_added, self);
	if (file != NULL) {
		fm_abstract_directory_view_rename_file (self, file);
	}
}

void
fm_abstract_directory_view_rename_file (FMAbstractDirectoryView* self,
                                        GOFFile* file_to_rename)
{
	gboolean _tmp0_;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_to_rename != NULL);
	_tmp0_ = self->priv->_renaming;
	if (_tmp0_) {
		const gchar* _tmp1_;
		_tmp1_ = file_to_rename->basename;
		g_warning ("AbstractDirectoryView.vala:992: already renaming %s", _tmp1_);
		return;
	}
	if (self->is_writable) {
		_tmp2_ = TRUE;
	} else {
		MarlinViewSlot* _tmp3_;
		GOFDirectoryAsync* _tmp4_;
		GOFDirectoryAsync* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp3_ = self->slot;
		_tmp4_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = gof_directory_async_get_is_local (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp2_ = !_tmp7_;
	}
	if (_tmp2_) {
		fm_abstract_directory_view_start_renaming_file (self, file_to_rename);
	} else {
		g_warning ("AbstractDirectoryView.vala:1000: You do not have permission to rename " \
"this file");
	}
}

/** File operation callbacks */
void
fm_abstract_directory_view_create_file_done (GFile* new_file,
                                             FMAbstractDirectoryView* self)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	g_return_if_fail (self != NULL);
	if (new_file == NULL) {
		return;
	}
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_connect_object (_tmp2_, "file-added", (GCallback) _fm_abstract_directory_view_after_new_file_added_gof_directory_async_file_added, self, G_CONNECT_AFTER);
	fm_abstract_directory_view_unblock_directory_monitor (self);
}

static gboolean
__lambda44_ (FMAbstractDirectoryView* self)
{
	GtkTreePath* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->deleted_path;
	fm_abstract_directory_view_set_cursor (self, _tmp0_, FALSE, FALSE, FALSE);
	fm_abstract_directory_view_unblock_directory_monitor (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda44__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda44_ ((FMAbstractDirectoryView*) self);
	return result;
}

void
fm_abstract_directory_view_after_trash_or_delete (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda44__gsource_func, g_object_ref (self), g_object_unref);
}

static gboolean
__lambda45_ (FMAbstractDirectoryView* self)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	gboolean result = FALSE;
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	gof_directory_async_unblock_monitor (_tmp2_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((FMAbstractDirectoryView*) self);
	return result;
}

static void
fm_abstract_directory_view_unblock_directory_monitor (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	g_idle_add_full (G_PRIORITY_LOW, ___lambda45__gsource_func, g_object_ref (self), g_object_unref);
}

static void
fm_abstract_directory_view_trash_or_delete_selected_files (FMAbstractDirectoryView* self,
                                                           gboolean delete_immediately)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_selected_files (self);
	_tmp1_ = fm_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
	selection = _tmp1_;
	_tmp2_ = selection;
	if (_tmp2_ != NULL) {
		GList* _tmp3_;
		_tmp3_ = selection;
		fm_abstract_directory_view_trash_or_delete_files (self, _tmp3_, TRUE, delete_immediately);
	}
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
}

/** Selection actions */
static void
fm_abstract_directory_view_on_selection_action_view_in_location (FMAbstractDirectoryView* self,
                                                                 GSimpleAction* action,
                                                                 GVariant* param)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	fm_abstract_directory_view_view_selected_file (self);
}

static void
fm_abstract_directory_view_view_selected_file (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->selected_files;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->selected_files;
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = _tmp1_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			GOFFile* _tmp2_;
			GOFFile* file = NULL;
			_tmp2_ = _g_object_ref0 ((GOFFile*) file_it->data);
			file = _tmp2_;
			{
				GFile* loc = NULL;
				GOFFile* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				_tmp3_ = file;
				_tmp4_ = gof_file_get_display_target_uri (_tmp3_);
				_tmp5_ = _tmp4_;
				_tmp6_ = g_file_new_for_uri (_tmp5_);
				_tmp7_ = _tmp6_;
				_g_free0 (_tmp5_);
				loc = _tmp7_;
				_tmp8_ = loc;
				g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, _tmp8_, MARLIN_OPEN_FLAG_NEW_TAB, TRUE);
				_g_object_unref0 (loc);
				_g_object_unref0 (file);
			}
		}
	}
}

static void
fm_abstract_directory_view_on_selection_action_forget (FMAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	fm_abstract_directory_view_forget_selected_file (self);
}

static void
fm_abstract_directory_view_forget_selected_file (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->selected_files;
	if (_tmp0_ == NULL) {
		return;
	}
	{
		GList* _tmp1_;
		_tmp1_ = self->selected_files;
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
			file_collection = _tmp1_;
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
				GOFFile* _tmp2_;
				GOFFile* file = NULL;
				_tmp2_ = _g_object_ref0 ((GOFFile*) file_it->data);
				file = _tmp2_;
				{
					GtkRecentManager* _tmp3_;
					GOFFile* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					_tmp3_ = self->recent;
					_tmp4_ = file;
					_tmp5_ = gof_file_get_display_target_uri (_tmp4_);
					_tmp6_ = _tmp5_;
					gtk_recent_manager_remove_item (_tmp3_, _tmp6_, &_inner_error0_);
					_g_free0 (_tmp6_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (file);
						goto __catch29_g_error;
					}
					_g_object_unref0 (file);
				}
			}
		}
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		g_critical ("AbstractDirectoryView.vala:1080: %s", _tmp8_);
		_g_error_free0 (err);
	}
	__finally29:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
fm_abstract_directory_view_on_selection_action_rename (FMAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	fm_abstract_directory_view_rename_selected_file (self);
}

static void
fm_abstract_directory_view_rename_selected_file (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->selected_files;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->selected_files;
	_tmp2_ = _tmp1_->next;
	if (_tmp2_ != NULL) {
		g_warning ("AbstractDirectoryView.vala:1094: Cannot rename multiple files (yet) - " \
"renaming first only");
	}
	_tmp3_ = self->selected_files;
	_tmp4_ = g_list_first (_tmp3_);
	_tmp5_ = _tmp4_->data;
	fm_abstract_directory_view_rename_file (self, (GOFFile*) _tmp5_);
}

static void
fm_abstract_directory_view_on_selection_action_cut (FMAbstractDirectoryView* self,
                                                    GSimpleAction* action,
                                                    GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MarlinClipboardManager* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_selected_files (self);
	_tmp1_ = fm_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
	selection = _tmp1_;
	_tmp2_ = self->priv->clipboard;
	marlin_clipboard_manager_cut_files (_tmp2_, selection);
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
}

static void
fm_abstract_directory_view_on_selection_action_trash (FMAbstractDirectoryView* self,
                                                      GSimpleAction* action,
                                                      GVariant* param)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_is_admin (self);
	_tmp1_ = _tmp0_;
	fm_abstract_directory_view_trash_or_delete_selected_files (self, _tmp1_);
}

static void
fm_abstract_directory_view_on_selection_action_delete (FMAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	fm_abstract_directory_view_trash_or_delete_selected_files (self, TRUE);
}

static void
fm_abstract_directory_view_on_selection_action_restore (FMAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MarlinViewWindow* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_selected_files (self);
	_tmp1_ = fm_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
	selection = _tmp1_;
	_tmp2_ = self->window;
	pf_file_utils_restore_files_from_trash (selection, (GtkWidget*) _tmp2_);
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
}

static void
fm_abstract_directory_view_on_selection_action_open_executable (FMAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GOFFile* file = NULL;
	gconstpointer _tmp1_;
	GOFFile* _tmp2_;
	GOFFile* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_files_for_action (self);
	selection = _tmp0_;
	_tmp1_ = selection->data;
	_tmp2_ = (GOFFile*) _tmp1_;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GOF_TYPE_FILE) ? ((GOFFile*) _tmp2_) : NULL);
	file = _tmp3_;
	{
		gof_file_execute (file, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch30_g_error;
		}
	}
	goto __finally30;
	__catch30_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		MarlinViewWindow* _tmp6_;
		GraniteMessageDialog* _tmp7_;
		GraniteMessageDialog* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		_tmp6_ = self->window;
		_tmp7_ = pf_dialogs_show_warning_dialog (_ ("Cannot execute this file"), _tmp5_, (GtkWindow*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp8_);
		_g_error_free0 (e);
	}
	__finally30:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file);
		(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (file);
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
}

static void
fm_abstract_directory_view_on_selection_action_open_with_default (FMAbstractDirectoryView* self,
                                                                  GSimpleAction* action,
                                                                  GVariant* param)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_files_for_action (self);
	_tmp1_ = _tmp0_;
	fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_APP, _tmp1_);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
}

static void
fm_abstract_directory_view_on_selection_action_open_with_app (FMAbstractDirectoryView* self,
                                                              GSimpleAction* action,
                                                              GVariant* param)
{
	GList* _tmp0_;
	gconstpointer _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->open_with_apps;
	_tmp1_ = g_list_nth_data (_tmp0_, (guint) g_variant_get_uint32 (param));
	_tmp2_ = fm_abstract_directory_view_get_files_for_action (self);
	_tmp3_ = _tmp2_;
	fm_abstract_directory_view_open_files_with (self, (GAppInfo*) _tmp1_, _tmp3_);
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (_g_list_free__g_object_unref0_ (_tmp3_), NULL));
}

static void
fm_abstract_directory_view_on_selection_action_open_with_other_app (FMAbstractDirectoryView* self)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GOFFile* file = NULL;
	gconstpointer _tmp1_;
	GOFFile* _tmp2_;
	GOFFile* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_files_for_action (self);
	selection = _tmp0_;
	_tmp1_ = selection->data;
	_tmp2_ = (GOFFile*) _tmp1_;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GOF_TYPE_FILE) ? ((GOFFile*) _tmp2_) : NULL);
	file = _tmp3_;
	fm_abstract_directory_view_open_file (self, file, NULL, NULL);
	_g_object_unref0 (file);
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
}

static void
fm_abstract_directory_view_on_common_action_bookmark (FMAbstractDirectoryView* self,
                                                      GSimpleAction* action,
                                                      GVariant* param)
{
	GFile* location = NULL;
	GList* _tmp0_;
	MarlinViewWindow* _tmp12_;
	GFile* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->selected_files;
	if (_tmp0_ != NULL) {
		GList* _tmp1_;
		gconstpointer _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		_tmp1_ = self->selected_files;
		_tmp2_ = _tmp1_->data;
		_tmp3_ = gof_file_get_target_location ((GOFFile*) _tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (location);
		location = _tmp4_;
	} else {
		MarlinViewSlot* _tmp5_;
		GOFDirectoryAsync* _tmp6_;
		GOFDirectoryAsync* _tmp7_;
		GOFFile* _tmp8_;
		GOFFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		_tmp5_ = self->slot;
		_tmp6_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = gof_directory_async_get_file (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = gof_file_get_target_location (_tmp9_);
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_g_object_unref0 (location);
		location = _tmp11_;
	}
	_tmp12_ = self->window;
	_tmp13_ = location;
	_tmp14_ = g_file_get_uri (_tmp13_);
	_tmp15_ = _tmp14_;
	marlin_view_window_bookmark_uri (_tmp12_, _tmp15_, NULL);
	_g_free0 (_tmp15_);
	_g_object_unref0 (location);
}

/** Background actions */
static void
fm_abstract_directory_view_change_state_show_hidden (FMAbstractDirectoryView* self,
                                                     GSimpleAction* action)
{
	MarlinViewWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->window;
	marlin_view_window_change_state_show_hidden (_tmp0_, action);
}

static void
fm_abstract_directory_view_change_state_show_remote_thumbnails (FMAbstractDirectoryView* self,
                                                                GSimpleAction* action)
{
	MarlinViewWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->window;
	marlin_view_window_change_state_show_remote_thumbnails (_tmp0_, action);
}

static void
fm_abstract_directory_view_change_state_hide_local_thumbnails (FMAbstractDirectoryView* self,
                                                               GSimpleAction* action)
{
	MarlinViewWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->window;
	marlin_view_window_change_state_hide_local_thumbnails (_tmp0_, action);
}

static void
fm_abstract_directory_view_on_background_action_new (FMAbstractDirectoryView* self,
                                                     GSimpleAction* action,
                                                     GVariant* param)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = g_variant_get_string (param, NULL);
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("FOLDER")))) {
		switch (0) {
			default:
			{
				fm_abstract_directory_view_new_empty_folder (self);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("FILE")))) {
		switch (0) {
			default:
			{
				fm_abstract_directory_view_new_empty_file (self, NULL);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}

static void
fm_abstract_directory_view_on_background_action_create_from (FMAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param)
{
	gint index = 0;
	const gchar* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = g_variant_get_string (param, NULL);
	index = atoi (_tmp0_);
	_tmp1_ = fm_abstract_directory_view_templates;
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) index);
	fm_abstract_directory_view_create_from_template (self, (GFile*) _tmp2_);
}

static void
fm_abstract_directory_view_on_background_action_sort_by_changed (FMAbstractDirectoryView* self,
                                                                 GSimpleAction* action,
                                                                 GVariant* val)
{
	gchar* sort = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = g_variant_get_string (val, NULL);
	_tmp1_ = g_strdup (_tmp0_);
	sort = _tmp1_;
	fm_abstract_directory_view_set_sort (self, sort, FALSE);
	_g_free0 (sort);
}

static void
fm_abstract_directory_view_on_background_action_reverse_changed (FMAbstractDirectoryView* self,
                                                                 GSimpleAction* action,
                                                                 GVariant* val)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	fm_abstract_directory_view_set_sort (self, NULL, TRUE);
}

static void
fm_abstract_directory_view_on_background_action_folders_first_changed (FMAbstractDirectoryView* self,
                                                                       GSimpleAction* action,
                                                                       GVariant* val)
{
	GOFPreferences* prefs = NULL;
	GOFPreferences* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = gof_preferences_get_default ();
	prefs = _tmp0_;
	_tmp1_ = gof_preferences_get_sort_directories_first (prefs);
	_tmp2_ = _tmp1_;
	gof_preferences_set_sort_directories_first (prefs, !_tmp2_);
	_g_object_unref0 (prefs);
}

static void
fm_abstract_directory_view_set_sort (FMAbstractDirectoryView* self,
                                     const gchar* col_name,
                                     gboolean reverse)
{
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	FMListModel* _tmp0_;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->model;
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp0_, &_tmp1_, &_tmp2_);
	sort_column_id = _tmp1_;
	sort_order = _tmp2_;
	if (_tmp3_) {
		FMListModel* _tmp5_;
		GtkSortType _tmp6_;
		if (col_name != NULL) {
			sort_column_id = (gint) fm_list_model_column_id_from_string (col_name);
		}
		if (reverse) {
			GtkSortType _tmp4_;
			_tmp4_ = sort_order;
			if (_tmp4_ == GTK_SORT_ASCENDING) {
				sort_order = GTK_SORT_DESCENDING;
			} else {
				sort_order = GTK_SORT_ASCENDING;
			}
		}
		_tmp5_ = self->model;
		_tmp6_ = sort_order;
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp5_, sort_column_id, _tmp6_);
	}
}

/** Common actions */
static void
fm_abstract_directory_view_on_common_action_open_in (FMAbstractDirectoryView* self,
                                                     GSimpleAction* action,
                                                     GVariant* param)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_g_object_unref0 (self->priv->default_app);
	self->priv->default_app = NULL;
	_tmp0_ = g_variant_get_string (param, NULL);
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("TAB")))) {
		switch (0) {
			default:
			{
				GList* _tmp4_;
				GList* _tmp5_;
				_tmp4_ = fm_abstract_directory_view_get_files_for_action (self);
				_tmp5_ = _tmp4_;
				fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_NEW_TAB, _tmp5_);
				(_tmp5_ == NULL) ? NULL : (_tmp5_ = (_g_list_free__g_object_unref0_ (_tmp5_), NULL));
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("WINDOW")))) {
		switch (0) {
			default:
			{
				GList* _tmp6_;
				GList* _tmp7_;
				_tmp6_ = fm_abstract_directory_view_get_files_for_action (self);
				_tmp7_ = _tmp6_;
				fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_NEW_WINDOW, _tmp7_);
				(_tmp7_ == NULL) ? NULL : (_tmp7_ = (_g_list_free__g_object_unref0_ (_tmp7_), NULL));
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}

static void
fm_abstract_directory_view_on_common_action_properties (FMAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	GList* _tmp0_;
	GList* _tmp1_;
	MarlinViewWindow* _tmp2_;
	MarlinViewPropertiesWindow* _tmp3_;
	MarlinViewPropertiesWindow* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_files_for_action (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->window;
	_tmp3_ = marlin_view_properties_window_new (_tmp1_, self, (GtkWindow*) _tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp4_);
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
}

static void
fm_abstract_directory_view_on_common_action_copy_link (FMAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	MarlinClipboardManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->clipboard;
	_tmp1_ = fm_abstract_directory_view_get_files_for_action (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = fm_abstract_directory_view_get_selected_files_for_transfer (self, _tmp2_);
	_tmp4_ = _tmp3_;
	marlin_clipboard_manager_copy_link_files (_tmp0_, _tmp4_);
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
}

static void
fm_abstract_directory_view_on_common_action_copy (FMAbstractDirectoryView* self,
                                                  GSimpleAction* action,
                                                  GVariant* param)
{
	MarlinClipboardManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->clipboard;
	_tmp1_ = fm_abstract_directory_view_get_files_for_action (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = fm_abstract_directory_view_get_selected_files_for_transfer (self, _tmp2_);
	_tmp4_ = _tmp3_;
	marlin_clipboard_manager_copy_files (_tmp0_, _tmp4_);
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
	g_atomic_int_inc (&_data32_->_ref_count_);
	return _data32_;
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data32_->self;
		_g_object_unref0 (_data32_->target);
		_g_object_unref0 (self);
		g_slice_free (Block32Data, _data32_);
	}
}

static void
___lambda83_ (Block32Data* _data32_,
              GObject* obj,
              GAsyncResult* res)
{
	FMAbstractDirectoryView* self;
	MarlinClipboardManager* _tmp0_;
	GFile* _tmp1_;
	self = _data32_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = self->priv->clipboard;
	marlin_clipboard_manager_paste_files_finish (_tmp0_, res);
	_tmp1_ = _data32_->target;
	if (g_file_has_uri_scheme (_tmp1_, "trash")) {
		fm_abstract_directory_view_after_trash_or_delete (self);
	}
}

static void
____lambda83__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda83_ (self, source_object, res);
	block32_data_unref (self);
}

static void
fm_abstract_directory_view_on_common_action_paste_into (FMAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	GOFFile* file = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	GOFFile* _tmp3_;
	GOFFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GOFFile* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = fm_abstract_directory_view_get_files_for_action (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
	_tmp3_ = _g_object_ref0 ((GOFFile*) _tmp2_);
	_tmp4_ = _tmp3_;
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
	file = _tmp4_;
	_tmp7_ = file;
	if (_tmp7_ != NULL) {
		MarlinClipboardManager* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp8_ = self->priv->clipboard;
		_tmp9_ = marlin_clipboard_manager_get_can_paste (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp6_ = _tmp10_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gboolean _tmp11_ = FALSE;
		MarlinClipboardManager* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp12_ = self->priv->clipboard;
		_tmp13_ = marlin_clipboard_manager_get_files_linked (_tmp12_);
		_tmp14_ = _tmp13_;
		if (_tmp14_) {
			_tmp11_ = self->priv->in_trash;
		} else {
			_tmp11_ = FALSE;
		}
		_tmp5_ = !_tmp11_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		Block32Data* _data32_;
		gboolean _tmp15_ = FALSE;
		GOFFile* _tmp16_;
		MarlinClipboardManager* _tmp26_;
		GFile* _tmp27_;
		_data32_ = g_slice_new0 (Block32Data);
		_data32_->_ref_count_ = 1;
		_data32_->self = g_object_ref (self);
		_tmp16_ = file;
		if (gof_file_is_folder (_tmp16_)) {
			MarlinClipboardManager* _tmp17_;
			GOFFile* _tmp18_;
			_tmp17_ = self->priv->clipboard;
			_tmp18_ = file;
			_tmp15_ = !marlin_clipboard_manager_has_file (_tmp17_, _tmp18_);
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			GOFFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			_tmp19_ = file;
			_tmp20_ = gof_file_get_target_location (_tmp19_);
			_tmp21_ = _g_object_ref0 (_tmp20_);
			_g_object_unref0 (_data32_->target);
			_data32_->target = _tmp21_;
		} else {
			MarlinViewSlot* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			_tmp22_ = self->slot;
			_tmp23_ = gof_abstract_slot_get_location ((GOFAbstractSlot*) _tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = _g_object_ref0 (_tmp24_);
			_g_object_unref0 (_data32_->target);
			_data32_->target = _tmp25_;
		}
		_tmp26_ = self->priv->clipboard;
		_tmp27_ = _data32_->target;
		marlin_clipboard_manager_paste_files (_tmp26_, _tmp27_, G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL, ____lambda83__gasync_ready_callback, block32_data_ref (_data32_));
		block32_data_unref (_data32_);
		_data32_ = NULL;
	}
	_g_object_unref0 (file);
}

static void
fm_abstract_directory_view_on_directory_file_added (FMAbstractDirectoryView* self,
                                                    GOFDirectoryAsync* dir,
                                                    GOFFile* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	if (file != NULL) {
		fm_abstract_directory_view_add_file (self, file, dir, TRUE);
		fm_abstract_directory_view_handle_free_space_change (self);
	} else {
		g_critical ("AbstractDirectoryView.vala:1283: Null file added");
	}
}

static void
fm_abstract_directory_view_on_directory_file_loaded (FMAbstractDirectoryView* self,
                                                     GOFDirectoryAsync* dir,
                                                     GOFFile* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_return_if_fail (file != NULL);
	fm_abstract_directory_view_add_file (self, file, dir, FALSE);
}

static void
fm_abstract_directory_view_on_directory_file_changed (FMAbstractDirectoryView* self,
                                                      GOFDirectoryAsync* dir,
                                                      GOFFile* file)
{
	GFile* _tmp0_;
	GOFFile* _tmp1_;
	GOFFile* _tmp2_;
	GFile* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = file->location;
	_tmp1_ = gof_directory_async_get_file (dir);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_->location;
	if (g_file_equal (_tmp0_, _tmp3_)) {
		MarlinViewSlot* _tmp4_;
		GOFDirectoryAsync* _tmp5_;
		GOFDirectoryAsync* _tmp6_;
		GOFFile* _tmp7_;
		GOFFile* _tmp8_;
		_tmp4_ = self->slot;
		_tmp5_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = gof_directory_async_get_file (_tmp6_);
		_tmp8_ = _tmp7_;
		self->is_writable = gof_file_is_writable (_tmp8_);
	} else {
		FMListModel* _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		MarlinViewSlot* _tmp12_;
		GOFDirectoryAsync* _tmp13_;
		GOFDirectoryAsync* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		fm_abstract_directory_view_remove_marlin_icon_info_cache (self, file);
		_tmp9_ = self->model;
		fm_list_model_file_changed (_tmp9_, file, dir);
		_tmp12_ = self->slot;
		_tmp13_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = gof_directory_async_get_is_local (_tmp14_);
		_tmp16_ = _tmp15_;
		if (_tmp16_) {
			gboolean _tmp17_;
			_tmp17_ = self->priv->_hide_local_thumbnails;
			_tmp11_ = !_tmp17_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			_tmp10_ = TRUE;
		} else {
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
			_tmp19_ = self->priv->_show_remote_thumbnails;
			if (_tmp19_) {
				MarlinViewSlot* _tmp20_;
				GOFDirectoryAsync* _tmp21_;
				GOFDirectoryAsync* _tmp22_;
				gboolean _tmp23_;
				gboolean _tmp24_;
				_tmp20_ = self->slot;
				_tmp21_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = gof_directory_async_get_can_open_files (_tmp22_);
				_tmp24_ = _tmp23_;
				_tmp18_ = _tmp24_;
			} else {
				_tmp18_ = FALSE;
			}
			_tmp10_ = _tmp18_;
		}
		if (_tmp10_) {
			MarlinThumbnailer* _tmp25_;
			MarlinPluginManager* _tmp26_;
			_tmp25_ = self->priv->thumbnailer;
			marlin_thumbnailer_queue_file (_tmp25_, file, NULL, self->large_thumbnails);
			_tmp26_ = plugins;
			if (_tmp26_ != NULL) {
				MarlinPluginManager* _tmp27_;
				_tmp27_ = plugins;
				marlin_plugin_manager_update_file_info (_tmp27_, file);
			}
		}
	}
	fm_abstract_directory_view_draw_when_idle (self);
}

static void
fm_abstract_directory_view_on_directory_file_icon_changed (FMAbstractDirectoryView* self,
                                                           GOFDirectoryAsync* dir,
                                                           GOFFile* file)
{
	FMListModel* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = self->model;
	fm_list_model_file_changed (_tmp0_, file, dir);
	fm_abstract_directory_view_draw_when_idle (self);
}

static void
fm_abstract_directory_view_on_directory_file_deleted (FMAbstractDirectoryView* self,
                                                      GOFDirectoryAsync* dir,
                                                      GOFFile* file)
{
	FMListModel* _tmp0_;
	const gchar* _tmp1_;
	MarlinPluginManager* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_return_if_fail (file != NULL);
	file->exists = FALSE;
	_tmp0_ = self->model;
	fm_list_model_remove_file (_tmp0_, file, dir);
	fm_abstract_directory_view_remove_marlin_icon_info_cache (self, file);
	_tmp1_ = gof_file_get_thumbnail_path (file);
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		_tmp2_ = file->uri;
		pf_file_utils_remove_thumbnail_paths_for_uri (_tmp2_);
	}
	_tmp3_ = plugins;
	if (_tmp3_ != NULL) {
		MarlinPluginManager* _tmp4_;
		_tmp4_ = plugins;
		marlin_plugin_manager_update_file_info (_tmp4_, file);
	}
	if (gof_file_is_folder (file)) {
		GOFDirectoryAsync* file_dir = NULL;
		GFile* _tmp5_;
		GOFDirectoryAsync* _tmp6_;
		GOFDirectoryAsync* _tmp7_;
		_tmp5_ = file->location;
		_tmp6_ = gof_directory_async_cache_lookup (_tmp5_);
		file_dir = _tmp6_;
		_tmp7_ = file_dir;
		if (_tmp7_ != NULL) {
			GOFDirectoryAsync* _tmp8_;
			MarlinViewSlot* _tmp9_;
			GOFDirectoryAsync* _tmp10_;
			_tmp8_ = file_dir;
			gof_directory_async_purge_dir_from_cache (_tmp8_);
			_tmp9_ = self->slot;
			_tmp10_ = file_dir;
			g_signal_emit_by_name (_tmp9_, "folder-deleted", file, _tmp10_);
		}
		_g_object_unref0 (file_dir);
	}
	fm_abstract_directory_view_handle_free_space_change (self);
}

static void
fm_abstract_directory_view_on_directory_done_loading (FMAbstractDirectoryView* self,
                                                      GOFDirectoryAsync* dir)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	MarlinViewSlot* _tmp5_;
	GOFDirectoryAsync* _tmp6_;
	GOFDirectoryAsync* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	MarlinViewSlot* _tmp10_;
	GOFDirectoryAsync* _tmp11_;
	GOFDirectoryAsync* _tmp12_;
	GOFFile* _tmp13_;
	GOFFile* _tmp14_;
	MarlinViewSlot* _tmp15_;
	GOFDirectoryAsync* _tmp16_;
	GOFDirectoryAsync* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	fm_abstract_directory_view_disconnect_directory_loading_handlers (self, dir);
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gof_directory_async_get_is_trash (_tmp2_);
	_tmp4_ = _tmp3_;
	self->priv->in_trash = _tmp4_;
	_tmp5_ = self->slot;
	_tmp6_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = gof_directory_async_get_is_recent (_tmp7_);
	_tmp9_ = _tmp8_;
	fm_abstract_directory_view_set_in_recent (self, _tmp9_);
	_tmp10_ = self->slot;
	_tmp11_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = gof_directory_async_get_file (_tmp12_);
	_tmp14_ = _tmp13_;
	self->priv->in_network_root = gof_file_is_root_network_folder (_tmp14_);
	fm_abstract_directory_view_thaw_tree (self);
	_tmp15_ = self->slot;
	_tmp16_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = gof_directory_async_get_can_load (_tmp17_);
	_tmp19_ = _tmp18_;
	if (_tmp19_) {
		MarlinViewSlot* _tmp20_;
		GOFDirectoryAsync* _tmp21_;
		GOFDirectoryAsync* _tmp22_;
		GOFFile* _tmp23_;
		GOFFile* _tmp24_;
		gboolean _tmp25_;
		_tmp20_ = self->slot;
		_tmp21_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = gof_directory_async_get_file (_tmp22_);
		_tmp24_ = _tmp23_;
		self->is_writable = gof_file_is_writable (_tmp24_);
		_tmp25_ = self->priv->_in_recent;
		if (_tmp25_) {
			FMListModel* _tmp26_;
			_tmp26_ = self->model;
			gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp26_, fm_abstract_directory_view_get_column_id_from_string (self, "modified"), GTK_SORT_DESCENDING);
		} else {
			MarlinViewSlot* _tmp27_;
			GOFDirectoryAsync* _tmp28_;
			GOFDirectoryAsync* _tmp29_;
			GOFFile* _tmp30_;
			GOFFile* _tmp31_;
			GFileInfo* _tmp32_;
			_tmp27_ = self->slot;
			_tmp28_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = gof_directory_async_get_file (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = _tmp31_->info;
			if (_tmp32_ != NULL) {
				FMListModel* _tmp33_;
				MarlinViewSlot* _tmp34_;
				GOFDirectoryAsync* _tmp35_;
				GOFDirectoryAsync* _tmp36_;
				GOFFile* _tmp37_;
				GOFFile* _tmp38_;
				MarlinViewSlot* _tmp39_;
				GOFDirectoryAsync* _tmp40_;
				GOFDirectoryAsync* _tmp41_;
				GOFFile* _tmp42_;
				GOFFile* _tmp43_;
				GtkSortType _tmp44_;
				_tmp33_ = self->model;
				_tmp34_ = self->slot;
				_tmp35_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp34_);
				_tmp36_ = _tmp35_;
				_tmp37_ = gof_directory_async_get_file (_tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = self->slot;
				_tmp40_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp39_);
				_tmp41_ = _tmp40_;
				_tmp42_ = gof_directory_async_get_file (_tmp41_);
				_tmp43_ = _tmp42_;
				_tmp44_ = _tmp43_->sort_order;
				gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp33_, _tmp38_->sort_column_id, _tmp44_);
			}
		}
	} else {
		self->is_writable = FALSE;
	}
	fm_abstract_directory_view_schedule_thumbnail_timeout (self);
}

/** Handle zoom level change */
static void
fm_abstract_directory_view_on_zoom_level_changed (FMAbstractDirectoryView* self,
                                                  MarlinZoomLevel zoom)
{
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	FMListModel* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GValue _tmp9_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_icon_size (self);
	_tmp1_ = _tmp0_;
	size = _tmp1_ * gtk_widget_get_scale_factor ((GtkWidget*) self);
	if (!self->large_thumbnails) {
		_tmp3_ = size > 128;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		if (self->large_thumbnails) {
			_tmp4_ = size <= 128;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp2_ = _tmp4_;
	}
	if (_tmp2_) {
		MarlinViewSlot* _tmp5_;
		self->large_thumbnails = size > 128;
		_tmp5_ = self->slot;
		marlin_view_slot_refresh_files (_tmp5_);
		fm_abstract_directory_view_schedule_thumbnail_timeout (self);
	}
	_tmp6_ = self->model;
	_tmp7_ = fm_abstract_directory_view_get_icon_size (self);
	_tmp8_ = _tmp7_;
	g_value_init (&_tmp9_, G_TYPE_INT);
	g_value_set_int (&_tmp9_, _tmp8_);
	g_object_set_property ((GObject*) _tmp6_, "size", &_tmp9_);
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
	fm_abstract_directory_view_change_zoom_level (self);
}

/** Handle Preference changes */
static GVariant*
_variant_new6 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
fm_abstract_directory_view_on_show_hidden_files_changed (FMAbstractDirectoryView* self,
                                                         GObject* prefs,
                                                         GParamSpec* pspec)
{
	gboolean show = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	MarlinViewSlot* _tmp3_;
	GOFDirectoryAsync* _tmp4_;
	GOFDirectoryAsync* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GVariant* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prefs != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = gof_preferences_get_show_hidden_files (G_TYPE_CHECK_INSTANCE_TYPE (prefs, GOF_TYPE_PREFERENCES) ? ((GOFPreferences*) prefs) : NULL);
	_tmp1_ = _tmp0_;
	show = _tmp1_;
	fm_abstract_directory_view_cancel (self);
	fm_abstract_directory_view_unselect_all (self);
	if (!show) {
		FMListModel* _tmp2_;
		fm_abstract_directory_view_block_model (self);
		_tmp2_ = self->model;
		fm_list_model_clear (_tmp2_);
	}
	_tmp3_ = self->slot;
	_tmp4_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp3_);
	_tmp5_ = _tmp4_;
	fm_abstract_directory_view_directory_hidden_changed (self, _tmp5_, show);
	if (!show) {
		fm_abstract_directory_view_unblock_model (self);
	}
	_tmp6_ = self->priv->background_actions;
	_tmp7_ = _variant_new6 (show);
	fm_abstract_directory_view_action_set_state (self, _tmp6_, "show-hidden", _tmp7_);
	_g_variant_unref0 (_tmp7_);
}

static GVariant*
_variant_new7 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
fm_abstract_directory_view_on_show_remote_thumbnails_changed (FMAbstractDirectoryView* self,
                                                              GObject* prefs,
                                                              GParamSpec* pspec)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSimpleActionGroup* _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	MarlinViewSlot* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prefs != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = gof_preferences_get_show_remote_thumbnails (G_TYPE_CHECK_INSTANCE_TYPE (prefs, GOF_TYPE_PREFERENCES) ? ((GOFPreferences*) prefs) : NULL);
	_tmp1_ = _tmp0_;
	fm_abstract_directory_view_set_show_remote_thumbnails (self, _tmp1_);
	_tmp2_ = self->priv->background_actions;
	_tmp3_ = self->priv->_show_remote_thumbnails;
	_tmp4_ = _variant_new7 (_tmp3_);
	fm_abstract_directory_view_action_set_state (self, _tmp2_, "show-remote-thumbnails", _tmp4_);
	_g_variant_unref0 (_tmp4_);
	_tmp5_ = self->slot;
	gof_abstract_slot_reload ((GOFAbstractSlot*) _tmp5_, FALSE);
}

static GVariant*
_variant_new8 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
fm_abstract_directory_view_on_hide_local_thumbnails_changed (FMAbstractDirectoryView* self,
                                                             GObject* prefs,
                                                             GParamSpec* pspec)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSimpleActionGroup* _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	MarlinViewSlot* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prefs != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = gof_preferences_get_hide_local_thumbnails (G_TYPE_CHECK_INSTANCE_TYPE (prefs, GOF_TYPE_PREFERENCES) ? ((GOFPreferences*) prefs) : NULL);
	_tmp1_ = _tmp0_;
	fm_abstract_directory_view_set_hide_local_thumbnails (self, _tmp1_);
	_tmp2_ = self->priv->background_actions;
	_tmp3_ = self->priv->_hide_local_thumbnails;
	_tmp4_ = _variant_new8 (_tmp3_);
	fm_abstract_directory_view_action_set_state (self, _tmp2_, "hide-local-thumbnails", _tmp4_);
	_g_variant_unref0 (_tmp4_);
	_tmp5_ = self->slot;
	gof_abstract_slot_reload ((GOFAbstractSlot*) _tmp5_, FALSE);
}

static void
fm_abstract_directory_view_on_sort_directories_first_changed (FMAbstractDirectoryView* self,
                                                              GObject* prefs,
                                                              GParamSpec* pspec)
{
	gboolean sort_directories_first = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FMListModel* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prefs != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = gof_preferences_get_sort_directories_first (G_TYPE_CHECK_INSTANCE_TYPE (prefs, GOF_TYPE_PREFERENCES) ? ((GOFPreferences*) prefs) : NULL);
	_tmp1_ = _tmp0_;
	sort_directories_first = _tmp1_;
	_tmp2_ = self->model;
	fm_list_model_set_should_sort_directories_first (_tmp2_, sort_directories_first);
}

static void
fm_abstract_directory_view_directory_hidden_changed (FMAbstractDirectoryView* self,
                                                     GOFDirectoryAsync* dir,
                                                     gboolean show)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	g_signal_connect_object (dir, "file-loaded", (GCallback) _fm_abstract_directory_view_on_directory_file_loaded_gof_directory_async_file_loaded, self, 0);
	gof_directory_async_load_hiddens (dir);
}

/** Handle popup menu events */
static void
_vala_GdkEvent_free (GdkEvent* self)
{
	g_boxed_free (gdk_event_get_type (), self);
}

static gboolean
fm_abstract_directory_view_on_popup_menu (FMAbstractDirectoryView* self)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_get_current_event ();
	event = _tmp0_;
	fm_abstract_directory_view_show_context_menu (self, event);
	result = TRUE;
	__vala_GdkEvent_free0 (event);
	return result;
}

/** Handle Button events */
static gboolean
fm_abstract_directory_view_on_drag_timeout_button_release (FMAbstractDirectoryView* self,
                                                           GdkEventButton* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	fm_abstract_directory_view_cancel_drag_timer (self);
	result = TRUE;
	return result;
}

/** Handle Motion events */
static gboolean
fm_abstract_directory_view_on_drag_timeout_motion_notify (FMAbstractDirectoryView* self,
                                                          GdkEventMotion* event)
{
	GdkDragContext* context = NULL;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	gint x = 0;
	gint y = 0;
	GtkWidget* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = fm_abstract_directory_view_get_real_view (self);
	widget = _tmp0_;
	x = (gint) event->x;
	y = (gint) event->y;
	_tmp1_ = widget;
	if (gtk_drag_check_threshold (_tmp1_, self->priv->drag_x, self->priv->drag_y, x, y)) {
		GtkTargetList* target_list = NULL;
		GtkTargetList* _tmp2_;
		GdkDragAction actions = 0U;
		GtkWidget* _tmp4_;
		GtkTargetList* _tmp5_;
		GdkDragAction _tmp6_;
		GdkDragContext* _tmp7_;
		GdkDragContext* _tmp8_;
		fm_abstract_directory_view_cancel_drag_timer (self);
		self->should_activate = FALSE;
		_tmp2_ = gtk_target_list_new (FM_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS, G_N_ELEMENTS (FM_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS));
		target_list = _tmp2_;
		actions = FM_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS;
		if (self->priv->drag_button == GDK_BUTTON_SECONDARY) {
			GdkDragAction _tmp3_;
			_tmp3_ = actions;
			actions = _tmp3_ | GDK_ACTION_ASK;
		}
		_tmp4_ = widget;
		_tmp5_ = target_list;
		_tmp6_ = actions;
		_tmp7_ = gtk_drag_begin_with_coordinates (_tmp4_, _tmp5_, _tmp6_, self->priv->drag_button, (GdkEvent*) event, x, y);
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_g_object_unref0 (context);
		context = _tmp8_;
		result = TRUE;
		_gtk_target_list_unref0 (target_list);
		_g_object_unref0 (widget);
		_g_object_unref0 (context);
		return result;
	} else {
		result = FALSE;
		_g_object_unref0 (widget);
		_g_object_unref0 (context);
		return result;
	}
	_g_object_unref0 (widget);
	_g_object_unref0 (context);
}

/** Handle TreeModel events */
static void
fm_abstract_directory_view_real_on_row_deleted (FMAbstractDirectoryView* self,
                                                GtkTreePath* path)
{
	g_return_if_fail (path != NULL);
	fm_abstract_directory_view_unselect_all (self);
}

void
fm_abstract_directory_view_on_row_deleted (FMAbstractDirectoryView* self,
                                           GtkTreePath* path)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->on_row_deleted (self, path);
}

/** Handle clipboard signal */
static void
fm_abstract_directory_view_on_clipboard_changed (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
}

/** DRAG AND DROP SOURCE */
static void
fm_abstract_directory_view_on_drag_begin (FMAbstractDirectoryView* self,
                                          GdkDragContext* context)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	self->should_activate = FALSE;
}

static void
fm_abstract_directory_view_on_drag_data_get (FMAbstractDirectoryView* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint timestamp)
{
	GList* _tmp0_;
	GList* _tmp3_;
	GOFFile* file = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	GOFFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GOFFile* _tmp9_;
	GList* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	_tmp0_ = self->priv->source_drag_file_list;
	if (_tmp0_ == NULL) {
		GList* _tmp1_;
		GList* _tmp2_;
		_tmp1_ = fm_abstract_directory_view_get_selected_files (self);
		_tmp2_ = fm_abstract_directory_view_get_selected_files_for_transfer (self, _tmp1_);
		(self->priv->source_drag_file_list == NULL) ? NULL : (self->priv->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->priv->source_drag_file_list), NULL));
		self->priv->source_drag_file_list = _tmp2_;
	}
	_tmp3_ = self->priv->source_drag_file_list;
	if (_tmp3_ == NULL) {
		return;
	}
	_tmp4_ = self->priv->source_drag_file_list;
	_tmp5_ = g_list_first (_tmp4_);
	_tmp6_ = _tmp5_->data;
	_tmp7_ = _g_object_ref0 ((GOFFile*) _tmp6_);
	file = _tmp7_;
	_tmp9_ = file;
	if (_tmp9_ != NULL) {
		GOFFile* _tmp10_;
		GdkPixbuf* _tmp11_;
		_tmp10_ = file;
		_tmp11_ = _tmp10_->pix;
		_tmp8_ = _tmp11_ != NULL;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		GOFFile* _tmp12_;
		GdkPixbuf* _tmp13_;
		_tmp12_ = file;
		_tmp13_ = _tmp12_->pix;
		gtk_drag_set_icon_gicon (context, (GIcon*) _tmp13_, 0, 0);
	} else {
		gtk_drag_set_icon_name (context, "stock-file", 0, 0);
	}
	_tmp14_ = self->priv->source_drag_file_list;
	marlin_dnd_handler_set_selection_data_from_file_list (selection_data, _tmp14_, "");
	_g_object_unref0 (file);
}

static void
fm_abstract_directory_view_on_drag_data_delete (FMAbstractDirectoryView* self,
                                                GdkDragContext* context)
{
	GtkWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = fm_abstract_directory_view_get_real_view (self);
	g_signal_stop_emission_by_name (_tmp0_, "drag-data-delete");
}

static void
fm_abstract_directory_view_on_drag_end (FMAbstractDirectoryView* self,
                                        GdkDragContext* context)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	(self->priv->source_drag_file_list == NULL) ? NULL : (self->priv->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->priv->source_drag_file_list), NULL));
	self->priv->source_drag_file_list = NULL;
}

/** DRAG AND DROP DESTINATION */
static gboolean
fm_abstract_directory_view_on_drag_motion (FMAbstractDirectoryView* self,
                                           GdkDragContext* context,
                                           gint x,
                                           gint y,
                                           guint timestamp)
{
	GdkDragAction _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	if (self->priv->destination_data_ready) {
		fm_abstract_directory_view_check_destination_actions_and_target_file (self, context, x, y, timestamp);
	} else {
		fm_abstract_directory_view_get_drag_data (self, context, x, y, timestamp);
		result = FALSE;
		return result;
	}
	if (self->priv->drag_scroll_timer_id == ((guint) 0)) {
		fm_abstract_directory_view_start_drag_scroll_timer (self, context);
	}
	_tmp0_ = self->priv->current_suggested_action;
	gdk_drag_status (context, _tmp0_, (guint32) timestamp);
	result = TRUE;
	return result;
}

static gboolean
fm_abstract_directory_view_on_drag_drop (FMAbstractDirectoryView* self,
                                         GdkDragContext* context,
                                         gint x,
                                         gint y,
                                         guint timestamp)
{
	GtkTargetList* list = NULL;
	gchar* uri = NULL;
	GdkAtom target = 0U;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkTargetList* _tmp2_;
	GdkAtom _tmp3_;
	GtkWidget* _tmp21_;
	GtkWidget* _tmp22_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	list = NULL;
	uri = NULL;
	self->priv->drop_occurred = TRUE;
	_tmp0_ = fm_abstract_directory_view_get_real_view (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = list;
	_tmp3_ = gtk_drag_dest_find_target (_tmp1_, context, _tmp2_);
	_g_object_unref0 (_tmp1_);
	target = _tmp3_;
	if (target == gdk_atom_intern_static_string ("XdndDirectSave0")) {
		GOFFile* target_file = NULL;
		GOFFile* _tmp4_;
		gchar* filename = NULL;
		MarlinDndHandler* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GOFFile* _tmp8_;
		_tmp4_ = fm_abstract_directory_view_get_drop_target_file (self, x, y);
		target_file = _tmp4_;
		_tmp5_ = fm_abstract_directory_view_dnd_handler;
		_tmp6_ = marlin_dnd_handler_get_source_filename (_tmp5_, context);
		filename = _tmp6_;
		_tmp8_ = target_file;
		if (_tmp8_ != NULL) {
			const gchar* _tmp9_;
			_tmp9_ = filename;
			_tmp7_ = _tmp9_ != NULL;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			GOFFile* _tmp10_;
			GFile* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			MarlinDndHandler* _tmp16_;
			const gchar* _tmp17_;
			_tmp10_ = target_file;
			_tmp11_ = gof_file_get_target_location (_tmp10_);
			_tmp12_ = filename;
			_tmp13_ = g_file_resolve_relative_path (_tmp11_, _tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = g_file_get_uri (_tmp14_);
			_g_free0 (uri);
			uri = _tmp15_;
			_g_object_unref0 (_tmp14_);
			_tmp16_ = fm_abstract_directory_view_dnd_handler;
			_tmp17_ = uri;
			marlin_dnd_handler_set_source_uri (_tmp16_, context, _tmp17_);
		} else {
			MarlinViewWindow* _tmp18_;
			GraniteMessageDialog* _tmp19_;
			GraniteMessageDialog* _tmp20_;
			_tmp18_ = self->window;
			_tmp19_ = pf_dialogs_show_error_dialog (_ ("Cannot drop this file"), _ ("Invalid file name provided"), (GtkWindow*) _tmp18_);
			_tmp20_ = _tmp19_;
			_g_object_unref0 (_tmp20_);
			result = FALSE;
			_g_free0 (filename);
			_g_object_unref0 (target_file);
			_g_free0 (uri);
			_gtk_target_list_unref0 (list);
			return result;
		}
		_g_free0 (filename);
		_g_object_unref0 (target_file);
	}
	_tmp21_ = fm_abstract_directory_view_get_real_view (self);
	_tmp22_ = _tmp21_;
	gtk_drag_get_data (_tmp22_, context, target, (guint32) timestamp);
	_g_object_unref0 (_tmp22_);
	result = TRUE;
	_g_free0 (uri);
	_gtk_target_list_unref0 (list);
	return result;
}

static void
fm_abstract_directory_view_on_drag_data_received (FMAbstractDirectoryView* self,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint timestamp)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	if (info == ((guint) MARLIN_TARGET_TYPE_TEXT_URI_LIST)) {
		GList* _tmp1_;
		_tmp1_ = self->priv->destination_drop_file_list;
		_tmp0_ = _tmp1_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* text = NULL;
		gchar* _tmp2_ = NULL;
		gboolean _tmp3_;
		_tmp3_ = marlin_dnd_handler_selection_data_is_uri_list (selection_data, info, &_tmp2_);
		_g_free0 (text);
		text = _tmp2_;
		if (_tmp3_) {
			const gchar* _tmp4_;
			GList* _tmp5_;
			_tmp4_ = text;
			_tmp5_ = pf_file_utils_files_from_uris (_tmp4_);
			(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
			self->priv->destination_drop_file_list = _tmp5_;
			self->priv->destination_data_ready = TRUE;
		}
		_g_free0 (text);
	}
	if (self->priv->drop_occurred) {
		gboolean success = FALSE;
		success = FALSE;
		self->priv->drop_occurred = FALSE;
		switch (info) {
			case MARLIN_TARGET_TYPE_XDND_DIRECT_SAVE0:
			{
				MarlinDndHandler* _tmp6_;
				GOFFile* _tmp7_;
				_tmp6_ = fm_abstract_directory_view_dnd_handler;
				_tmp7_ = self->priv->drop_target_file;
				success = marlin_dnd_handler_handle_xdnddirectsave (_tmp6_, context, _tmp7_, selection_data);
				break;
			}
			case MARLIN_TARGET_TYPE_NETSCAPE_URL:
			{
				MarlinDndHandler* _tmp8_;
				GOFFile* _tmp9_;
				_tmp8_ = fm_abstract_directory_view_dnd_handler;
				_tmp9_ = self->priv->drop_target_file;
				success = marlin_dnd_handler_handle_netscape_url (_tmp8_, context, _tmp9_, selection_data);
				break;
			}
			case MARLIN_TARGET_TYPE_TEXT_URI_LIST:
			{
				GdkDragAction _tmp10_;
				GList* _tmp11_;
				MarlinDndHandler* _tmp12_;
				GtkWidget* _tmp13_;
				GtkWidget* _tmp14_;
				MarlinViewWindow* _tmp15_;
				GOFFile* _tmp16_;
				GList* _tmp17_;
				GdkDragAction _tmp18_;
				GdkDragAction _tmp19_;
				_tmp10_ = self->priv->current_actions;
				if ((_tmp10_ & FM_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS) == 0) {
					break;
				}
				_tmp11_ = self->selected_files;
				if (_tmp11_ != NULL) {
					fm_abstract_directory_view_unselect_all (self);
				}
				_tmp12_ = fm_abstract_directory_view_dnd_handler;
				_tmp13_ = fm_abstract_directory_view_get_real_view (self);
				_tmp14_ = _tmp13_;
				_tmp15_ = self->window;
				_tmp16_ = self->priv->drop_target_file;
				_tmp17_ = self->priv->destination_drop_file_list;
				_tmp18_ = self->priv->current_actions;
				_tmp19_ = self->priv->current_suggested_action;
				success = marlin_dnd_handler_handle_file_drag_actions (_tmp12_, _tmp14_, (GtkApplicationWindow*) _tmp15_, context, _tmp16_, _tmp17_, _tmp18_, _tmp19_, (guint32) timestamp);
				_g_object_unref0 (_tmp14_);
				break;
			}
			default:
			{
				break;
			}
		}
		gtk_drag_finish (context, success, FALSE, (guint32) timestamp);
		fm_abstract_directory_view_clear_destination_drag_data (self);
	}
}

static void
fm_abstract_directory_view_on_drag_leave (FMAbstractDirectoryView* self,
                                          GdkDragContext* context,
                                          guint timestamp)
{
	MarlinIconRenderer* _tmp0_;
	GValue _tmp1_ = {0};
	GValue _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->icon_renderer;
	g_value_init (&_tmp1_, G_TYPE_OBJECT);
	_tmp2_ = _tmp1_;
	g_object_set_property ((GObject*) _tmp0_, "drop-file", &_tmp2_);
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->drag_enter_timer_id);
	_tmp3_ = fm_abstract_directory_view_get_drop_highlight (self);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		fm_abstract_directory_view_set_drop_highlight (self, FALSE);
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	fm_abstract_directory_view_highlight_path (self, NULL);
	fm_abstract_directory_view_clear_destination_drag_data (self);
}

/** DnD destination helpers */
static void
fm_abstract_directory_view_clear_destination_drag_data (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	self->priv->destination_data_ready = FALSE;
	self->priv->current_target_type = GDK_NONE;
	(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
	self->priv->destination_drop_file_list = NULL;
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
}

static GOFFile*
fm_abstract_directory_view_get_drop_target_file (FMAbstractDirectoryView* self,
                                                 gint win_x,
                                                 gint win_y)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GOFFile* file = NULL;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp15_;
	GOFFile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = fm_abstract_directory_view_get_path_at_pos (self, win_x, win_y);
	path = _tmp0_;
	file = NULL;
	_tmp1_ = path;
	if (_tmp1_ != NULL) {
		FMListModel* _tmp2_;
		GtkTreePath* _tmp3_;
		GOFFile* _tmp4_;
		GOFFile* _tmp5_;
		_tmp2_ = self->model;
		_tmp3_ = path;
		_tmp4_ = fm_list_model_file_for_path (_tmp2_, _tmp3_);
		_g_object_unref0 (file);
		file = _tmp4_;
		_tmp5_ = file;
		if (_tmp5_ == NULL) {
			GtkTreePath* folder_path = NULL;
			GtkTreePath* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
			FMListModel* _tmp9_;
			GtkTreePath* _tmp10_;
			GOFFile* _tmp11_;
			_tmp6_ = path;
			_tmp7_ = gtk_tree_path_copy (_tmp6_);
			folder_path = _tmp7_;
			_tmp8_ = folder_path;
			gtk_tree_path_up (_tmp8_);
			_tmp9_ = self->model;
			_tmp10_ = folder_path;
			_tmp11_ = fm_list_model_file_for_path (_tmp9_, _tmp10_);
			_g_object_unref0 (file);
			file = _tmp11_;
			__vala_GtkTreePath_free0 (folder_path);
		} else {
			gboolean _tmp12_ = FALSE;
			GOFFile* _tmp13_;
			_tmp13_ = file;
			if (!gof_file_is_folder (_tmp13_)) {
				GOFFile* _tmp14_;
				_tmp14_ = file;
				_tmp12_ = !gof_file_is_executable (_tmp14_);
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				_g_object_unref0 (file);
				file = NULL;
				__vala_GtkTreePath_free0 (path);
				path = NULL;
			}
		}
	}
	_tmp15_ = path;
	if (_tmp15_ == NULL) {
		MarlinViewSlot* _tmp16_;
		GOFDirectoryAsync* _tmp17_;
		GOFDirectoryAsync* _tmp18_;
		GOFFile* _tmp19_;
		GOFFile* _tmp20_;
		GOFFile* _tmp21_;
		_tmp16_ = self->slot;
		_tmp17_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = gof_directory_async_get_file (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = _g_object_ref0 (_tmp20_);
		_g_object_unref0 (file);
		file = _tmp21_;
	}
	result = file;
	__vala_GtkTreePath_free0 (path);
	return result;
}

static void
fm_abstract_directory_view_get_drag_data (FMAbstractDirectoryView* self,
                                          GdkDragContext* context,
                                          gint x,
                                          gint y,
                                          guint timestamp)
{
	GtkTargetList* list = NULL;
	GdkAtom target = 0U;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkTargetList* _tmp2_;
	GdkAtom _tmp3_;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	list = NULL;
	_tmp0_ = fm_abstract_directory_view_get_real_view (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = list;
	_tmp3_ = gtk_drag_dest_find_target (_tmp1_, context, _tmp2_);
	_g_object_unref0 (_tmp1_);
	target = _tmp3_;
	self->priv->current_target_type = target;
	if (target == gdk_atom_intern_static_string ("XdndDirectSave0")) {
		_tmp4_ = TRUE;
	} else {
		_tmp4_ = target == gdk_atom_intern_static_string ("_NETSCAPE_URL");
	}
	if (_tmp4_) {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		GOFFile* _tmp7_;
		_tmp7_ = self->priv->drop_target_file;
		if (_tmp7_ != NULL) {
			GOFFile* _tmp8_;
			_tmp8_ = self->priv->drop_target_file;
			_tmp6_ = gof_file_is_folder (_tmp8_);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			GOFFile* _tmp9_;
			_tmp9_ = self->priv->drop_target_file;
			_tmp5_ = gof_file_is_writable (_tmp9_);
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			MarlinIconRenderer* _tmp10_;
			GOFFile* _tmp11_;
			GtkTreePath* _tmp12_;
			GtkTreePath* _tmp13_;
			_tmp10_ = self->icon_renderer;
			_tmp11_ = self->priv->drop_target_file;
			g_object_set ((GObject*) _tmp10_, "drop-file", _tmp11_, NULL);
			_tmp12_ = fm_abstract_directory_view_get_path_at_pos (self, x, y);
			_tmp13_ = _tmp12_;
			fm_abstract_directory_view_highlight_path (self, _tmp13_);
			__vala_GtkTreePath_free0 (_tmp13_);
		}
		self->priv->destination_data_ready = TRUE;
	} else {
		gboolean _tmp14_ = FALSE;
		if (target != GDK_NONE) {
			GList* _tmp15_;
			_tmp15_ = self->priv->destination_drop_file_list;
			_tmp14_ = _tmp15_ == NULL;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			GtkWidget* _tmp16_;
			GtkWidget* _tmp17_;
			_tmp16_ = fm_abstract_directory_view_get_real_view (self);
			_tmp17_ = _tmp16_;
			gtk_drag_get_data (_tmp17_, context, target, (guint32) timestamp);
			_g_object_unref0 (_tmp17_);
		}
	}
	_gtk_target_list_unref0 (list);
}

static gboolean
_____lambda89_ (FMAbstractDirectoryView* self)
{
	GOFFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->drop_target_file;
	_tmp1_ = gof_file_get_target_location (_tmp0_);
	fm_abstract_directory_view_load_location (self, _tmp1_);
	self->priv->drag_enter_timer_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
______lambda89__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda89_ ((FMAbstractDirectoryView*) self);
	return result;
}

static void
fm_abstract_directory_view_check_destination_actions_and_target_file (FMAbstractDirectoryView* self,
                                                                      GdkDragContext* context,
                                                                      gint x,
                                                                      gint y,
                                                                      guint timestamp)
{
	const gchar* _tmp0_ = NULL;
	GOFFile* _tmp1_;
	gchar* current_uri = NULL;
	gchar* _tmp4_;
	GOFFile* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GOFFile* _tmp7_;
	gchar* uri = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp1_ = self->priv->drop_target_file;
	if (_tmp1_ != NULL) {
		GOFFile* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = self->priv->drop_target_file;
		_tmp3_ = _tmp2_->uri;
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = "";
	}
	_tmp4_ = g_strdup (_tmp0_);
	current_uri = _tmp4_;
	_tmp5_ = fm_abstract_directory_view_get_drop_target_file (self, x, y);
	_g_object_unref0 (self->priv->drop_target_file);
	self->priv->drop_target_file = _tmp5_;
	_tmp7_ = self->priv->drop_target_file;
	if (_tmp7_ != NULL) {
		GOFFile* _tmp8_;
		const gchar* _tmp9_;
		_tmp8_ = self->priv->drop_target_file;
		_tmp9_ = _tmp8_->uri;
		_tmp6_ = _tmp9_;
	} else {
		_tmp6_ = "";
	}
	_tmp10_ = g_strdup (_tmp6_);
	uri = _tmp10_;
	_tmp11_ = uri;
	_tmp12_ = current_uri;
	if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
		GOFFile* _tmp13_;
		fm_abstract_directory_view_cancel_timeout (self, &self->priv->drag_enter_timer_id);
		self->priv->current_actions = GDK_ACTION_DEFAULT;
		self->priv->current_suggested_action = GDK_ACTION_DEFAULT;
		_tmp13_ = self->priv->drop_target_file;
		if (_tmp13_ != NULL) {
			GOFFile* _tmp19_;
			GdkDragAction _tmp20_;
			GtkTreePath* _tmp21_;
			GtkTreePath* _tmp22_;
			gboolean _tmp23_ = FALSE;
			GOFFile* _tmp24_;
			if (self->priv->current_target_type == gdk_atom_intern_static_string ("XdndDirectSave0")) {
				GdkDragAction _tmp14_;
				self->priv->current_suggested_action = GDK_ACTION_COPY;
				_tmp14_ = self->priv->current_suggested_action;
				self->priv->current_actions = _tmp14_;
			} else {
				GOFFile* _tmp15_;
				GList* _tmp16_;
				GdkDragAction _tmp17_ = 0U;
				GdkDragAction _tmp18_;
				_tmp15_ = self->priv->drop_target_file;
				_tmp16_ = self->priv->destination_drop_file_list;
				_tmp18_ = pf_file_utils_file_accepts_drop (_tmp15_, _tmp16_, context, &_tmp17_);
				self->priv->current_suggested_action = _tmp17_;
				self->priv->current_actions = _tmp18_;
			}
			_tmp19_ = self->priv->drop_target_file;
			_tmp20_ = self->priv->current_actions;
			_tmp21_ = fm_abstract_directory_view_get_path_at_pos (self, x, y);
			_tmp22_ = _tmp21_;
			fm_abstract_directory_view_highlight_drop_file (self, _tmp19_, _tmp20_, _tmp22_);
			__vala_GtkTreePath_free0 (_tmp22_);
			_tmp24_ = self->priv->drop_target_file;
			if (gof_file_is_folder (_tmp24_)) {
				GOFFile* _tmp25_;
				_tmp25_ = self->priv->drop_target_file;
				_tmp23_ = fm_abstract_directory_view_is_valid_drop_folder (self, _tmp25_);
			} else {
				_tmp23_ = FALSE;
			}
			if (_tmp23_) {
				self->priv->drag_enter_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 1000, ______lambda89__gsource_func, g_object_ref (self), g_object_unref);
			}
		}
	}
	_g_free0 (uri);
	_g_free0 (current_uri);
}

static gboolean
fm_abstract_directory_view_is_valid_drop_folder (FMAbstractDirectoryView* self,
                                                 GOFFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	MarlinViewSlot* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	_tmp2_ = file->uri;
	_tmp3_ = self->slot;
	_tmp4_ = gof_abstract_slot_get_uri ((GOFAbstractSlot*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (g_strcmp0 (_tmp2_, _tmp5_) != 0) {
		GList* _tmp6_;
		_tmp6_ = self->priv->source_drag_file_list;
		_tmp1_ = _tmp6_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GList* _tmp7_;
		_tmp7_ = self->priv->source_drag_file_list;
		_tmp0_ = g_list_index (_tmp7_, file) < 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static void
fm_abstract_directory_view_highlight_drop_file (FMAbstractDirectoryView* self,
                                                GOFFile* drop_file,
                                                GdkDragAction action,
                                                GtkTreePath* path)
{
	gboolean can_drop = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GOFFile* _tmp2_ = NULL;
	MarlinIconRenderer* _tmp3_;
	GValue _tmp4_ = {0};
	GtkTreePath* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (drop_file != NULL);
	can_drop = action > GDK_ACTION_DEFAULT;
	_tmp0_ = fm_abstract_directory_view_get_drop_highlight (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != can_drop) {
		fm_abstract_directory_view_set_drop_highlight (self, can_drop);
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	if (can_drop) {
		_tmp2_ = drop_file;
	} else {
		_tmp2_ = NULL;
	}
	drop_file = _tmp2_;
	_tmp3_ = self->icon_renderer;
	g_value_init (&_tmp4_, GOF_TYPE_FILE);
	g_value_set_object (&_tmp4_, drop_file);
	g_object_set_property ((GObject*) _tmp3_, "drop-file", &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
	if (can_drop) {
		_tmp5_ = path;
	} else {
		_tmp5_ = NULL;
	}
	fm_abstract_directory_view_highlight_path (self, _tmp5_);
}

/** MENU FUNCTIONS */
static GdkEvent*
_vala_GdkEvent_copy (GdkEvent* self)
{
	return g_boxed_copy (gdk_event_get_type (), self);
}

static gpointer
__vala_GdkEvent_copy0 (gpointer self)
{
	return self ? _vala_GdkEvent_copy (self) : NULL;
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
	g_atomic_int_inc (&_data33_->_ref_count_);
	return _data33_;
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data33_->self;
		__vala_GdkEvent_free0 (_data33_->event);
		_g_object_unref0 (self);
		g_slice_free (Block33Data, _data33_);
	}
}

static GdkEventButton*
_vala_GdkEventButton_copy (GdkEventButton* self)
{
	return g_boxed_copy (gdk_event_get_type (), self);
}

static gpointer
__vala_GdkEventButton_copy0 (gpointer self)
{
	return self ? _vala_GdkEventButton_copy (self) : NULL;
}

static gboolean
__lambda91_ (Block33Data* _data33_)
{
	FMAbstractDirectoryView* self;
	gboolean result = FALSE;
	self = _data33_->self;
	fm_abstract_directory_view_on_drag_timeout_button_release (self, (GdkEventButton*) _data33_->event);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda91__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda91_ (self);
	return result;
}

static void
_vala_GdkEventButton_free (GdkEventButton* self)
{
	g_boxed_free (gdk_event_get_type (), self);
}

void
fm_abstract_directory_view_start_drag_timer (FMAbstractDirectoryView* self,
                                             GdkEvent* event)
{
	Block33Data* _data33_;
	GdkEvent* _tmp0_;
	GdkEventButton* button_event = NULL;
	GdkEventButton* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	_data33_ = g_slice_new0 (Block33Data);
	_data33_->_ref_count_ = 1;
	_data33_->self = g_object_ref (self);
	_tmp0_ = __vala_GdkEvent_copy0 (event);
	__vala_GdkEvent_free0 (_data33_->event);
	_data33_->event = _tmp0_;
	fm_abstract_directory_view_connect_drag_timeout_motion_and_release_events (self);
	_tmp1_ = __vala_GdkEventButton_copy0 ((GdkEventButton*) _data33_->event);
	button_event = _tmp1_;
	self->priv->drag_button = (gint) button_event->button;
	self->priv->drag_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 300, ___lambda91__gsource_func, block33_data_ref (_data33_), block33_data_unref);
	__vala_GdkEventButton_free0 (button_event);
	block33_data_unref (_data33_);
	_data33_ = NULL;
}

static GVariant*
_variant_new9 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new10 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

void
fm_abstract_directory_view_show_context_menu (FMAbstractDirectoryView* self,
                                              GdkEvent* event)
{
	GtkMenu* menu = NULL;
	GtkMenu* _tmp0_;
	GList* selection = NULL;
	GList* _tmp1_;
	GOFFile* selected_file = NULL;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	GOFFile* _tmp4_;
	GtkMenu* open_submenu = NULL;
	GtkMenu* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	GOFFile* _tmp27_;
	GtkMenuItem* open_submenu_item = NULL;
	GtkMenuItem* _tmp110_;
	GtkMenu* _tmp111_;
	GList* _tmp112_;
	GList* _tmp113_;
	gboolean _tmp114_;
	GtkMenuItem* paste_menuitem = NULL;
	GtkMenuItem* _tmp124_;
	GtkMenuItem* _tmp125_;
	GtkMenuItem* bookmark_menuitem = NULL;
	GtkMenuItem* _tmp126_;
	GtkMenuItem* _tmp127_;
	GraniteAccelLabel* _tmp128_;
	GraniteAccelLabel* _tmp129_;
	GtkMenuItem* _tmp130_;
	GtkMenuItem* properties_menuitem = NULL;
	GtkMenuItem* _tmp131_;
	GtkMenuItem* _tmp132_;
	GraniteAccelLabel* _tmp133_;
	GraniteAccelLabel* _tmp134_;
	GtkMenuItem* _tmp135_;
	GList* _tmp136_;
	GtkMenu* _tmp361_;
	GtkMenu* _tmp362_;
	MarlinViewSlot* _tmp363_;
	GOFDirectoryAsync* _tmp364_;
	GOFDirectoryAsync* _tmp365_;
	GtkMenu* _tmp368_;
	GtkMenu* _tmp369_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	fm_abstract_directory_view_cancel_drag_timer (self);
	fm_abstract_directory_view_update_menu_actions (self);
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp0_);
	menu = _tmp0_;
	_tmp1_ = fm_abstract_directory_view_get_files_for_action (self);
	selection = _tmp1_;
	_tmp2_ = selection;
	_tmp3_ = _tmp2_->data;
	_tmp4_ = _g_object_ref0 ((GOFFile*) _tmp3_);
	selected_file = _tmp4_;
	_tmp5_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp5_);
	open_submenu = _tmp5_;
	_tmp6_ = self->priv->common_actions;
	if (g_action_group_get_action_enabled ((GActionGroup*) _tmp6_, "open-in")) {
		GtkMenuItem* new_tab_menuitem = NULL;
		GtkMenuItem* _tmp7_;
		GtkMenuItem* _tmp8_;
		GraniteAccelLabel* _tmp9_;
		GraniteAccelLabel* _tmp10_;
		GtkMenuItem* _tmp11_;
		GtkMenuItem* _tmp12_;
		GVariant* _tmp13_;
		GtkMenuItem* new_window_menuitem = NULL;
		GtkMenuItem* _tmp14_;
		GtkMenuItem* _tmp15_;
		GtkMenuItem* _tmp16_;
		GVariant* _tmp17_;
		GtkMenu* _tmp18_;
		GtkMenuItem* _tmp19_;
		GtkMenu* _tmp20_;
		GtkMenuItem* _tmp21_;
		GtkMenu* _tmp22_;
		GtkSeparatorMenuItem* _tmp23_;
		GtkSeparatorMenuItem* _tmp24_;
		_tmp7_ = (GtkMenuItem*) gtk_menu_item_new ();
		g_object_ref_sink (_tmp7_);
		new_tab_menuitem = _tmp7_;
		_tmp8_ = new_tab_menuitem;
		_tmp9_ = granite_accel_label_new (_ ("New Tab"), "<Shift>Return");
		g_object_ref_sink (_tmp9_);
		_tmp10_ = _tmp9_;
		gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp10_);
		_g_object_unref0 (_tmp10_);
		_tmp11_ = new_tab_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp11_, "common.open-in");
		_tmp12_ = new_tab_menuitem;
		_tmp13_ = _variant_new9 ("TAB");
		g_object_set ((GtkActionable*) _tmp12_, "action-target", _tmp13_, NULL);
		_g_variant_unref0 (_tmp13_);
		_tmp14_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Window"));
		g_object_ref_sink (_tmp14_);
		new_window_menuitem = _tmp14_;
		_tmp15_ = new_window_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp15_, "common.open-in");
		_tmp16_ = new_window_menuitem;
		_tmp17_ = _variant_new10 ("WINDOW");
		g_object_set ((GtkActionable*) _tmp16_, "action-target", _tmp17_, NULL);
		_g_variant_unref0 (_tmp17_);
		_tmp18_ = open_submenu;
		_tmp19_ = new_tab_menuitem;
		gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
		_tmp20_ = open_submenu;
		_tmp21_ = new_window_menuitem;
		gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
		_tmp22_ = open_submenu;
		_tmp23_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		g_object_ref_sink (_tmp23_);
		_tmp24_ = _tmp23_;
		gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp24_);
		_g_object_unref0 (_tmp24_);
		_g_object_unref0 (new_window_menuitem);
		_g_object_unref0 (new_tab_menuitem);
	}
	_tmp27_ = selected_file;
	if (!gof_file_is_mountable (_tmp27_)) {
		GOFFile* _tmp28_;
		_tmp28_ = selected_file;
		_tmp26_ = !gof_file_is_root_network_folder (_tmp28_);
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		GOFFile* _tmp29_;
		_tmp29_ = selected_file;
		_tmp25_ = fm_abstract_directory_view_can_open_file (self, _tmp29_, FALSE);
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		gboolean _tmp30_ = FALSE;
		GOFFile* _tmp31_;
		GList* _tmp52_;
		GList* _tmp53_;
		GOFFile* _tmp54_;
		gboolean _tmp55_ = FALSE;
		GList* _tmp56_;
		gboolean _tmp101_ = FALSE;
		GList* _tmp102_;
		_tmp31_ = selected_file;
		if (!gof_file_is_folder (_tmp31_)) {
			GOFFile* _tmp32_;
			_tmp32_ = selected_file;
			_tmp30_ = gof_file_is_executable (_tmp32_);
		} else {
			_tmp30_ = FALSE;
		}
		if (_tmp30_) {
			GtkMenuItem* run_menuitem = NULL;
			GtkMenuItem* _tmp33_;
			GtkMenuItem* _tmp34_;
			GtkMenu* _tmp35_;
			GtkMenuItem* _tmp36_;
			_tmp33_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Run"));
			g_object_ref_sink (_tmp33_);
			run_menuitem = _tmp33_;
			_tmp34_ = run_menuitem;
			gtk_actionable_set_action_name ((GtkActionable*) _tmp34_, "selection.open");
			_tmp35_ = menu;
			_tmp36_ = run_menuitem;
			gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
			_g_object_unref0 (run_menuitem);
		} else {
			gboolean _tmp37_ = FALSE;
			GAppInfo* _tmp38_;
			_tmp38_ = self->priv->default_app;
			if (_tmp38_ != NULL) {
				GAppInfo* _tmp39_;
				const gchar* _tmp40_;
				_tmp39_ = self->priv->default_app;
				_tmp40_ = g_app_info_get_id (_tmp39_);
				_tmp37_ = g_strcmp0 (_tmp40_, MARLIN_APP_ID ".desktop") != 0;
			} else {
				_tmp37_ = FALSE;
			}
			if (_tmp37_) {
				GtkMenuItem* open_menuitem = NULL;
				GtkMenuItem* _tmp41_;
				GtkMenuItem* _tmp42_;
				GAppInfo* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				GraniteAccelLabel* _tmp47_;
				GraniteAccelLabel* _tmp48_;
				GtkMenuItem* _tmp49_;
				GtkMenu* _tmp50_;
				GtkMenuItem* _tmp51_;
				_tmp41_ = (GtkMenuItem*) gtk_menu_item_new ();
				g_object_ref_sink (_tmp41_);
				open_menuitem = _tmp41_;
				_tmp42_ = open_menuitem;
				_tmp43_ = self->priv->default_app;
				_tmp44_ = g_app_info_get_display_name (_tmp43_);
				_tmp45_ = g_strdup_printf (_ ("Open in %s"), _tmp44_);
				_tmp46_ = _tmp45_;
				_tmp47_ = granite_accel_label_new (_tmp46_, "Return");
				g_object_ref_sink (_tmp47_);
				_tmp48_ = _tmp47_;
				gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp48_);
				_g_object_unref0 (_tmp48_);
				_g_free0 (_tmp46_);
				_tmp49_ = open_menuitem;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp49_, "selection.open-with-default");
				_tmp50_ = menu;
				_tmp51_ = open_menuitem;
				gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
				_g_object_unref0 (open_menuitem);
			}
		}
		_tmp52_ = selection;
		_tmp53_ = marlin_mime_actions_get_applications_for_files (_tmp52_);
		(self->priv->open_with_apps == NULL) ? NULL : (self->priv->open_with_apps = (_g_list_free__g_object_unref0_ (self->priv->open_with_apps), NULL));
		self->priv->open_with_apps = _tmp53_;
		_tmp54_ = selected_file;
		if (gof_file_is_executable (_tmp54_) == FALSE) {
			fm_abstract_directory_view_filter_default_app_from_open_with_apps (self);
		}
		fm_abstract_directory_view_filter_this_app_from_open_with_apps (self);
		_tmp56_ = self->priv->open_with_apps;
		if (_tmp56_ != NULL) {
			GList* _tmp57_;
			gconstpointer _tmp58_;
			_tmp57_ = self->priv->open_with_apps;
			_tmp58_ = _tmp57_->data;
			_tmp55_ = ((GAppInfo*) _tmp58_) != NULL;
		} else {
			_tmp55_ = FALSE;
		}
		if (_tmp55_) {
			const gchar* last_label = NULL;
			const gchar* last_exec = NULL;
			guint count = 0U;
			GList* _tmp59_;
			last_label = "";
			last_exec = "";
			count = (guint) 0;
			_tmp59_ = self->priv->open_with_apps;
			{
				GList* app_info_collection = NULL;
				GList* app_info_it = NULL;
				app_info_collection = _tmp59_;
				for (app_info_it = app_info_collection; app_info_it != NULL; app_info_it = app_info_it->next) {
					GAppInfo* app_info = NULL;
					app_info = (GAppInfo*) app_info_it->data;
					{
						const gchar* label = NULL;
						GAppInfo* _tmp60_;
						const gchar* _tmp61_;
						const gchar* exec = NULL;
						GAppInfo* _tmp62_;
						const gchar* _tmp63_;
						gchar** _tmp64_;
						gchar** _tmp65_;
						gchar** _tmp66_;
						gint _tmp66__length1;
						const gchar* _tmp67_;
						const gchar* _tmp68_;
						gboolean _tmp69_ = FALSE;
						const gchar* _tmp70_;
						const gchar* _tmp71_;
						const gchar* _tmp95_;
						const gchar* _tmp96_;
						guint _tmp97_;
						_tmp60_ = app_info;
						_tmp61_ = g_app_info_get_display_name (_tmp60_);
						label = _tmp61_;
						_tmp62_ = app_info;
						_tmp63_ = g_app_info_get_executable (_tmp62_);
						_tmp65_ = _tmp64_ = g_strsplit (_tmp63_, " ", 0);
						_tmp66_ = _tmp65_;
						_tmp66__length1 = _vala_array_length (_tmp64_);
						_tmp67_ = _tmp66_[0];
						_tmp68_ = _tmp67_;
						_tmp66_ = (_vala_array_free (_tmp66_, _tmp66__length1, (GDestroyNotify) g_free), NULL);
						exec = _tmp68_;
						_tmp70_ = label;
						_tmp71_ = last_label;
						if (g_strcmp0 (_tmp70_, _tmp71_) != 0) {
							_tmp69_ = TRUE;
						} else {
							const gchar* _tmp72_;
							const gchar* _tmp73_;
							_tmp72_ = exec;
							_tmp73_ = last_exec;
							_tmp69_ = g_strcmp0 (_tmp72_, _tmp73_) != 0;
						}
						if (_tmp69_) {
							GtkImage* app_image = NULL;
							GAppInfo* _tmp74_;
							GIcon* _tmp75_;
							GtkImage* _tmp76_;
							GtkImage* _tmp77_;
							GtkGrid* label_grid = NULL;
							GtkGrid* _tmp78_;
							GtkGrid* _tmp79_;
							GtkImage* _tmp80_;
							GtkGrid* _tmp81_;
							const gchar* _tmp82_;
							GtkLabel* _tmp83_;
							GtkLabel* _tmp84_;
							GtkMenuItem* menuitem = NULL;
							GtkMenuItem* _tmp85_;
							GtkMenuItem* _tmp86_;
							GtkGrid* _tmp87_;
							GtkMenuItem* _tmp88_;
							GVariant* _tmp89_;
							GVariant* _tmp90_;
							gchar* _tmp91_;
							gchar* _tmp92_;
							GtkMenu* _tmp93_;
							GtkMenuItem* _tmp94_;
							_tmp74_ = app_info;
							_tmp75_ = g_app_info_get_icon (_tmp74_);
							_tmp76_ = (GtkImage*) gtk_image_new_from_gicon (_tmp75_, (GtkIconSize) GTK_ICON_SIZE_MENU);
							g_object_ref_sink (_tmp76_);
							app_image = _tmp76_;
							_tmp77_ = app_image;
							gtk_image_set_pixel_size (_tmp77_, 16);
							_tmp78_ = (GtkGrid*) gtk_grid_new ();
							g_object_ref_sink (_tmp78_);
							label_grid = _tmp78_;
							_tmp79_ = label_grid;
							_tmp80_ = app_image;
							gtk_container_add ((GtkContainer*) _tmp79_, (GtkWidget*) _tmp80_);
							_tmp81_ = label_grid;
							_tmp82_ = label;
							_tmp83_ = (GtkLabel*) gtk_label_new (_tmp82_);
							g_object_ref_sink (_tmp83_);
							_tmp84_ = _tmp83_;
							gtk_container_add ((GtkContainer*) _tmp81_, (GtkWidget*) _tmp84_);
							_g_object_unref0 (_tmp84_);
							_tmp85_ = (GtkMenuItem*) gtk_menu_item_new ();
							g_object_ref_sink (_tmp85_);
							menuitem = _tmp85_;
							_tmp86_ = menuitem;
							_tmp87_ = label_grid;
							gtk_container_add ((GtkContainer*) _tmp86_, (GtkWidget*) _tmp87_);
							_tmp88_ = menuitem;
							_tmp89_ = g_variant_new_uint32 ((guint32) count);
							g_variant_ref_sink (_tmp89_);
							_tmp90_ = _tmp89_;
							_tmp91_ = g_action_print_detailed_name ("selection.open-with-app", _tmp90_);
							_tmp92_ = _tmp91_;
							gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp88_, _tmp92_);
							_g_free0 (_tmp92_);
							_g_variant_unref0 (_tmp90_);
							_tmp93_ = open_submenu;
							_tmp94_ = menuitem;
							gtk_container_add ((GtkContainer*) _tmp93_, (GtkWidget*) _tmp94_);
							_g_object_unref0 (menuitem);
							_g_object_unref0 (label_grid);
							_g_object_unref0 (app_image);
						}
						_tmp95_ = label;
						last_label = _tmp95_;
						_tmp96_ = exec;
						last_exec = _tmp96_;
						_tmp97_ = count;
						count = _tmp97_ + 1;
					}
				}
			}
			if (count > ((guint) 0)) {
				GtkMenu* _tmp98_;
				GtkSeparatorMenuItem* _tmp99_;
				GtkSeparatorMenuItem* _tmp100_;
				_tmp98_ = open_submenu;
				_tmp99_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp99_);
				_tmp100_ = _tmp99_;
				gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp100_);
				_g_object_unref0 (_tmp100_);
			}
		}
		_tmp102_ = selection;
		if (_tmp102_ != NULL) {
			GList* _tmp103_;
			GList* _tmp104_;
			GList* _tmp105_;
			_tmp103_ = selection;
			_tmp104_ = g_list_first (_tmp103_);
			_tmp105_ = _tmp104_->next;
			_tmp101_ = _tmp105_ == NULL;
		} else {
			_tmp101_ = FALSE;
		}
		if (_tmp101_) {
			GtkMenuItem* other_apps_menuitem = NULL;
			GtkMenuItem* _tmp106_;
			GtkMenuItem* _tmp107_;
			GtkMenu* _tmp108_;
			GtkMenuItem* _tmp109_;
			_tmp106_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Other Application…"));
			g_object_ref_sink (_tmp106_);
			other_apps_menuitem = _tmp106_;
			_tmp107_ = other_apps_menuitem;
			gtk_actionable_set_action_name ((GtkActionable*) _tmp107_, "selection.open-with-other-app");
			_tmp108_ = open_submenu;
			_tmp109_ = other_apps_menuitem;
			gtk_container_add ((GtkContainer*) _tmp108_, (GtkWidget*) _tmp109_);
			_g_object_unref0 (other_apps_menuitem);
		}
	}
	_tmp110_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp110_);
	open_submenu_item = _tmp110_;
	_tmp111_ = open_submenu;
	_tmp112_ = gtk_container_get_children ((GtkContainer*) _tmp111_);
	_tmp113_ = _tmp112_;
	_tmp114_ = g_list_length (_tmp113_) > ((guint) 0);
	(_tmp113_ == NULL) ? NULL : (_tmp113_ = (g_list_free (_tmp113_), NULL));
	if (_tmp114_) {
		GtkMenuItem* _tmp115_;
		GtkMenu* _tmp116_;
		gboolean _tmp117_ = FALSE;
		GOFFile* _tmp118_;
		GtkMenu* _tmp122_;
		GtkMenuItem* _tmp123_;
		_tmp115_ = open_submenu_item;
		_tmp116_ = open_submenu;
		gtk_menu_item_set_submenu (_tmp115_, _tmp116_);
		_tmp118_ = selected_file;
		if (gof_file_is_folder (_tmp118_)) {
			_tmp117_ = TRUE;
		} else {
			GOFFile* _tmp119_;
			_tmp119_ = selected_file;
			_tmp117_ = gof_file_is_root_network_folder (_tmp119_);
		}
		if (_tmp117_) {
			GtkMenuItem* _tmp120_;
			_tmp120_ = open_submenu_item;
			gtk_menu_item_set_label (_tmp120_, _ ("Open in"));
		} else {
			GtkMenuItem* _tmp121_;
			_tmp121_ = open_submenu_item;
			gtk_menu_item_set_label (_tmp121_, _ ("Open with"));
		}
		_tmp122_ = menu;
		_tmp123_ = open_submenu_item;
		gtk_container_add ((GtkContainer*) _tmp122_, (GtkWidget*) _tmp123_);
	}
	_tmp124_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Paste"));
	g_object_ref_sink (_tmp124_);
	paste_menuitem = _tmp124_;
	_tmp125_ = paste_menuitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp125_, "common.paste-into");
	_tmp126_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp126_);
	bookmark_menuitem = _tmp126_;
	_tmp127_ = bookmark_menuitem;
	_tmp128_ = granite_accel_label_new (_ ("Bookmark"), "<Ctrl>d");
	g_object_ref_sink (_tmp128_);
	_tmp129_ = _tmp128_;
	gtk_container_add ((GtkContainer*) _tmp127_, (GtkWidget*) _tmp129_);
	_g_object_unref0 (_tmp129_);
	_tmp130_ = bookmark_menuitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp130_, "common.bookmark");
	_tmp131_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp131_);
	properties_menuitem = _tmp131_;
	_tmp132_ = properties_menuitem;
	_tmp133_ = granite_accel_label_new (_ ("Properties"), "<Alt>Return");
	g_object_ref_sink (_tmp133_);
	_tmp134_ = _tmp133_;
	gtk_container_add ((GtkContainer*) _tmp132_, (GtkWidget*) _tmp134_);
	_g_object_unref0 (_tmp134_);
	_tmp135_ = properties_menuitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp135_, "common.properties");
	_tmp136_ = fm_abstract_directory_view_get_selected_files (self);
	if (_tmp136_ != NULL) {
		GtkMenuItem* cut_menuitem = NULL;
		GtkMenuItem* _tmp137_;
		GtkMenuItem* _tmp138_;
		GraniteAccelLabel* _tmp139_;
		GraniteAccelLabel* _tmp140_;
		GtkMenuItem* _tmp141_;
		GtkMenuItem* copy_menuitem = NULL;
		GtkMenuItem* _tmp142_;
		GtkMenuItem* _tmp143_;
		GraniteAccelLabel* _tmp144_;
		GraniteAccelLabel* _tmp145_;
		GtkMenuItem* _tmp146_;
		GtkMenuItem* trash_menuitem = NULL;
		GtkMenuItem* _tmp147_;
		GtkMenuItem* _tmp148_;
		GraniteAccelLabel* _tmp149_;
		GraniteAccelLabel* _tmp150_;
		GtkMenuItem* _tmp151_;
		GtkMenuItem* delete_menuitem = NULL;
		GtkMenuItem* _tmp152_;
		GtkMenuItem* _tmp153_;
		gboolean _tmp154_ = FALSE;
		_tmp137_ = (GtkMenuItem*) gtk_menu_item_new ();
		g_object_ref_sink (_tmp137_);
		cut_menuitem = _tmp137_;
		_tmp138_ = cut_menuitem;
		_tmp139_ = granite_accel_label_new (_ ("Cut"), "<Ctrl>x");
		g_object_ref_sink (_tmp139_);
		_tmp140_ = _tmp139_;
		gtk_container_add ((GtkContainer*) _tmp138_, (GtkWidget*) _tmp140_);
		_g_object_unref0 (_tmp140_);
		_tmp141_ = cut_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp141_, "selection.cut");
		_tmp142_ = (GtkMenuItem*) gtk_menu_item_new ();
		g_object_ref_sink (_tmp142_);
		copy_menuitem = _tmp142_;
		_tmp143_ = copy_menuitem;
		_tmp144_ = granite_accel_label_new (_ ("Copy"), "<Ctrl>c");
		g_object_ref_sink (_tmp144_);
		_tmp145_ = _tmp144_;
		gtk_container_add ((GtkContainer*) _tmp143_, (GtkWidget*) _tmp145_);
		_g_object_unref0 (_tmp145_);
		_tmp146_ = copy_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp146_, "common.copy");
		_tmp147_ = (GtkMenuItem*) gtk_menu_item_new ();
		g_object_ref_sink (_tmp147_);
		trash_menuitem = _tmp147_;
		_tmp148_ = trash_menuitem;
		_tmp149_ = granite_accel_label_new (_ ("Move to Trash"), "Delete");
		g_object_ref_sink (_tmp149_);
		_tmp150_ = _tmp149_;
		gtk_container_add ((GtkContainer*) _tmp148_, (GtkWidget*) _tmp150_);
		_g_object_unref0 (_tmp150_);
		_tmp151_ = trash_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp151_, "selection.trash");
		_tmp152_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Delete permanently"));
		g_object_ref_sink (_tmp152_);
		delete_menuitem = _tmp152_;
		_tmp153_ = delete_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp153_, "selection.delete");
		if (self->priv->in_trash) {
			_tmp154_ = fm_abstract_directory_view_valid_selection_for_restore (self);
		} else {
			_tmp154_ = FALSE;
		}
		if (_tmp154_) {
			GtkMenuItem* restore_menuitem = NULL;
			GtkMenuItem* _tmp155_;
			GtkMenuItem* _tmp156_;
			GtkMenu* _tmp157_;
			GtkSeparatorMenuItem* _tmp158_;
			GtkSeparatorMenuItem* _tmp159_;
			GtkMenu* _tmp160_;
			GtkMenuItem* _tmp161_;
			GtkMenu* _tmp162_;
			GtkMenuItem* _tmp163_;
			GtkMenu* _tmp164_;
			GtkSeparatorMenuItem* _tmp165_;
			GtkSeparatorMenuItem* _tmp166_;
			GtkMenu* _tmp167_;
			GtkMenuItem* _tmp168_;
			GtkMenu* _tmp169_;
			GtkSeparatorMenuItem* _tmp170_;
			GtkSeparatorMenuItem* _tmp171_;
			GtkMenu* _tmp172_;
			GtkMenuItem* _tmp173_;
			_tmp155_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restore from Trash"));
			g_object_ref_sink (_tmp155_);
			restore_menuitem = _tmp155_;
			_tmp156_ = restore_menuitem;
			gtk_actionable_set_action_name ((GtkActionable*) _tmp156_, "selection.restore");
			_tmp157_ = menu;
			_tmp158_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp158_);
			_tmp159_ = _tmp158_;
			gtk_container_add ((GtkContainer*) _tmp157_, (GtkWidget*) _tmp159_);
			_g_object_unref0 (_tmp159_);
			_tmp160_ = menu;
			_tmp161_ = restore_menuitem;
			gtk_container_add ((GtkContainer*) _tmp160_, (GtkWidget*) _tmp161_);
			_tmp162_ = menu;
			_tmp163_ = delete_menuitem;
			gtk_container_add ((GtkContainer*) _tmp162_, (GtkWidget*) _tmp163_);
			_tmp164_ = menu;
			_tmp165_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp165_);
			_tmp166_ = _tmp165_;
			gtk_container_add ((GtkContainer*) _tmp164_, (GtkWidget*) _tmp166_);
			_g_object_unref0 (_tmp166_);
			_tmp167_ = menu;
			_tmp168_ = cut_menuitem;
			gtk_container_add ((GtkContainer*) _tmp167_, (GtkWidget*) _tmp168_);
			_tmp169_ = menu;
			_tmp170_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp170_);
			_tmp171_ = _tmp170_;
			gtk_container_add ((GtkContainer*) _tmp169_, (GtkWidget*) _tmp171_);
			_g_object_unref0 (_tmp171_);
			_tmp172_ = menu;
			_tmp173_ = properties_menuitem;
			gtk_container_add ((GtkContainer*) _tmp172_, (GtkWidget*) _tmp173_);
			_g_object_unref0 (restore_menuitem);
		} else {
			gboolean _tmp174_;
			_tmp174_ = self->priv->_in_recent;
			if (_tmp174_) {
				GtkMenuItem* open_parent_menuitem = NULL;
				GtkMenuItem* _tmp175_;
				GtkMenuItem* _tmp176_;
				GtkMenuItem* forget_menuitem = NULL;
				GtkMenuItem* _tmp177_;
				GtkMenuItem* _tmp178_;
				GtkMenu* _tmp179_;
				GtkMenuItem* _tmp180_;
				GtkMenu* _tmp181_;
				GtkSeparatorMenuItem* _tmp182_;
				GtkSeparatorMenuItem* _tmp183_;
				GtkMenu* _tmp184_;
				GtkMenuItem* _tmp185_;
				GtkMenu* _tmp186_;
				GtkMenuItem* _tmp187_;
				GtkMenu* _tmp188_;
				GtkMenuItem* _tmp189_;
				GtkMenu* _tmp190_;
				GtkSeparatorMenuItem* _tmp191_;
				GtkSeparatorMenuItem* _tmp192_;
				GtkMenu* _tmp193_;
				GtkMenuItem* _tmp194_;
				_tmp175_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Open Parent Folder"));
				g_object_ref_sink (_tmp175_);
				open_parent_menuitem = _tmp175_;
				_tmp176_ = open_parent_menuitem;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp176_, "selection.view-in-location");
				_tmp177_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove from History"));
				g_object_ref_sink (_tmp177_);
				forget_menuitem = _tmp177_;
				_tmp178_ = forget_menuitem;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp178_, "selection.forget");
				_tmp179_ = menu;
				_tmp180_ = open_parent_menuitem;
				gtk_container_add ((GtkContainer*) _tmp179_, (GtkWidget*) _tmp180_);
				_tmp181_ = menu;
				_tmp182_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp182_);
				_tmp183_ = _tmp182_;
				gtk_container_add ((GtkContainer*) _tmp181_, (GtkWidget*) _tmp183_);
				_g_object_unref0 (_tmp183_);
				_tmp184_ = menu;
				_tmp185_ = forget_menuitem;
				gtk_container_add ((GtkContainer*) _tmp184_, (GtkWidget*) _tmp185_);
				_tmp186_ = menu;
				_tmp187_ = copy_menuitem;
				gtk_container_add ((GtkContainer*) _tmp186_, (GtkWidget*) _tmp187_);
				_tmp188_ = menu;
				_tmp189_ = trash_menuitem;
				gtk_container_add ((GtkContainer*) _tmp188_, (GtkWidget*) _tmp189_);
				_tmp190_ = menu;
				_tmp191_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp191_);
				_tmp192_ = _tmp191_;
				gtk_container_add ((GtkContainer*) _tmp190_, (GtkWidget*) _tmp192_);
				_g_object_unref0 (_tmp192_);
				_tmp193_ = menu;
				_tmp194_ = properties_menuitem;
				gtk_container_add ((GtkContainer*) _tmp193_, (GtkWidget*) _tmp194_);
				_g_object_unref0 (forget_menuitem);
				_g_object_unref0 (open_parent_menuitem);
			} else {
				gboolean _tmp195_ = FALSE;
				gboolean _tmp196_ = FALSE;
				MarlinViewSlot* _tmp197_;
				GOFDirectoryAsync* _tmp198_;
				GOFDirectoryAsync* _tmp199_;
				GOFFile* _tmp200_;
				GOFFile* _tmp201_;
				gboolean _tmp264_ = FALSE;
				GSimpleActionGroup* _tmp265_;
				GtkMenu* _tmp272_;
				GtkSeparatorMenuItem* _tmp273_;
				GtkSeparatorMenuItem* _tmp274_;
				GtkMenu* _tmp275_;
				GtkMenuItem* _tmp276_;
				_tmp197_ = self->slot;
				_tmp198_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp197_);
				_tmp199_ = _tmp198_;
				_tmp200_ = gof_directory_async_get_file (_tmp199_);
				_tmp201_ = _tmp200_;
				if (gof_file_is_smb_server (_tmp201_)) {
					MarlinClipboardManager* _tmp202_;
					_tmp202_ = self->priv->clipboard;
					_tmp196_ = _tmp202_ != NULL;
				} else {
					_tmp196_ = FALSE;
				}
				if (_tmp196_) {
					MarlinClipboardManager* _tmp203_;
					gboolean _tmp204_;
					gboolean _tmp205_;
					_tmp203_ = self->priv->clipboard;
					_tmp204_ = marlin_clipboard_manager_get_can_paste (_tmp203_);
					_tmp205_ = _tmp204_;
					_tmp195_ = _tmp205_;
				} else {
					_tmp195_ = FALSE;
				}
				if (_tmp195_) {
					GtkMenu* _tmp206_;
					GtkMenuItem* _tmp207_;
					_tmp206_ = menu;
					_tmp207_ = paste_menuitem;
					gtk_container_add ((GtkContainer*) _tmp206_, (GtkWidget*) _tmp207_);
				} else {
					if (fm_abstract_directory_view_valid_selection_for_edit (self)) {
						GtkMenuItem* rename_menuitem = NULL;
						GtkMenuItem* _tmp208_;
						GtkMenuItem* _tmp209_;
						GraniteAccelLabel* _tmp210_;
						GraniteAccelLabel* _tmp211_;
						GtkMenuItem* _tmp212_;
						GtkMenuItem* copy_link_menuitem = NULL;
						GtkMenuItem* _tmp213_;
						GtkMenuItem* _tmp214_;
						GraniteAccelLabel* _tmp215_;
						GraniteAccelLabel* _tmp216_;
						GtkMenuItem* _tmp217_;
						GtkMenu* _tmp218_;
						GList* _tmp219_;
						GList* _tmp220_;
						GtkMenuItem* _tmp221_;
						GList* _tmp222_;
						gboolean _tmp223_;
						GtkMenu* _tmp227_;
						GtkMenuItem* _tmp228_;
						GtkMenu* _tmp229_;
						GtkMenuItem* _tmp230_;
						GtkMenu* _tmp231_;
						GtkMenuItem* _tmp232_;
						gboolean _tmp233_ = FALSE;
						gboolean _tmp234_ = FALSE;
						GSimpleActionGroup* _tmp235_;
						GtkMenu* _tmp247_;
						GtkSeparatorMenuItem* _tmp248_;
						GtkSeparatorMenuItem* _tmp249_;
						gboolean _tmp250_ = FALSE;
						MarlinViewSlot* _tmp251_;
						GOFDirectoryAsync* _tmp252_;
						GOFDirectoryAsync* _tmp253_;
						gboolean _tmp254_;
						gboolean _tmp255_;
						GtkMenu* _tmp262_;
						GtkMenuItem* _tmp263_;
						_tmp208_ = (GtkMenuItem*) gtk_menu_item_new ();
						g_object_ref_sink (_tmp208_);
						rename_menuitem = _tmp208_;
						_tmp209_ = rename_menuitem;
						_tmp210_ = granite_accel_label_new (_ ("Rename…"), "F2");
						g_object_ref_sink (_tmp210_);
						_tmp211_ = _tmp210_;
						gtk_container_add ((GtkContainer*) _tmp209_, (GtkWidget*) _tmp211_);
						_g_object_unref0 (_tmp211_);
						_tmp212_ = rename_menuitem;
						gtk_actionable_set_action_name ((GtkActionable*) _tmp212_, "selection.rename");
						_tmp213_ = (GtkMenuItem*) gtk_menu_item_new ();
						g_object_ref_sink (_tmp213_);
						copy_link_menuitem = _tmp213_;
						_tmp214_ = copy_link_menuitem;
						_tmp215_ = granite_accel_label_new (_ ("Copy as Link"), "<Shift><Ctrl>c");
						g_object_ref_sink (_tmp215_);
						_tmp216_ = _tmp215_;
						gtk_container_add ((GtkContainer*) _tmp214_, (GtkWidget*) _tmp216_);
						_g_object_unref0 (_tmp216_);
						_tmp217_ = copy_link_menuitem;
						gtk_actionable_set_action_name ((GtkActionable*) _tmp217_, "common.copy-link");
						_tmp218_ = menu;
						_tmp219_ = gtk_container_get_children ((GtkContainer*) _tmp218_);
						_tmp220_ = _tmp219_;
						_tmp221_ = open_submenu_item;
						_tmp222_ = g_list_find (_tmp220_, (GtkWidget*) _tmp221_);
						_tmp223_ = _tmp222_ != NULL;
						(_tmp220_ == NULL) ? NULL : (_tmp220_ = (g_list_free (_tmp220_), NULL));
						if (_tmp223_) {
							GtkMenu* _tmp224_;
							GtkSeparatorMenuItem* _tmp225_;
							GtkSeparatorMenuItem* _tmp226_;
							_tmp224_ = menu;
							_tmp225_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
							g_object_ref_sink (_tmp225_);
							_tmp226_ = _tmp225_;
							gtk_container_add ((GtkContainer*) _tmp224_, (GtkWidget*) _tmp226_);
							_g_object_unref0 (_tmp226_);
						}
						_tmp227_ = menu;
						_tmp228_ = cut_menuitem;
						gtk_container_add ((GtkContainer*) _tmp227_, (GtkWidget*) _tmp228_);
						_tmp229_ = menu;
						_tmp230_ = copy_menuitem;
						gtk_container_add ((GtkContainer*) _tmp229_, (GtkWidget*) _tmp230_);
						_tmp231_ = menu;
						_tmp232_ = copy_link_menuitem;
						gtk_container_add ((GtkContainer*) _tmp231_, (GtkWidget*) _tmp232_);
						_tmp235_ = self->priv->common_actions;
						if (g_action_group_get_action_enabled ((GActionGroup*) _tmp235_, "paste-into")) {
							MarlinClipboardManager* _tmp236_;
							_tmp236_ = self->priv->clipboard;
							_tmp234_ = _tmp236_ != NULL;
						} else {
							_tmp234_ = FALSE;
						}
						if (_tmp234_) {
							MarlinClipboardManager* _tmp237_;
							gboolean _tmp238_;
							gboolean _tmp239_;
							_tmp237_ = self->priv->clipboard;
							_tmp238_ = marlin_clipboard_manager_get_can_paste (_tmp237_);
							_tmp239_ = _tmp238_;
							_tmp233_ = _tmp239_;
						} else {
							_tmp233_ = FALSE;
						}
						if (_tmp233_) {
							MarlinClipboardManager* _tmp240_;
							gboolean _tmp241_;
							gboolean _tmp242_;
							GtkMenu* _tmp245_;
							GtkMenuItem* _tmp246_;
							_tmp240_ = self->priv->clipboard;
							_tmp241_ = marlin_clipboard_manager_get_files_linked (_tmp240_);
							_tmp242_ = _tmp241_;
							if (_tmp242_) {
								GtkMenuItem* _tmp243_;
								_tmp243_ = paste_menuitem;
								gtk_menu_item_set_label (_tmp243_, _ ("Paste Link into Folder"));
							} else {
								GtkMenuItem* _tmp244_;
								_tmp244_ = paste_menuitem;
								gtk_menu_item_set_label (_tmp244_, _ ("Paste into Folder"));
							}
							_tmp245_ = menu;
							_tmp246_ = paste_menuitem;
							gtk_container_add ((GtkContainer*) _tmp245_, (GtkWidget*) _tmp246_);
						}
						_tmp247_ = menu;
						_tmp248_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
						g_object_ref_sink (_tmp248_);
						_tmp249_ = _tmp248_;
						gtk_container_add ((GtkContainer*) _tmp247_, (GtkWidget*) _tmp249_);
						_g_object_unref0 (_tmp249_);
						_tmp251_ = self->slot;
						_tmp252_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp251_);
						_tmp253_ = _tmp252_;
						_tmp254_ = gof_directory_async_get_has_trash_dirs (_tmp253_);
						_tmp255_ = _tmp254_;
						if (_tmp255_) {
							gboolean _tmp256_;
							gboolean _tmp257_;
							_tmp256_ = fm_abstract_directory_view_get_is_admin (self);
							_tmp257_ = _tmp256_;
							_tmp250_ = !_tmp257_;
						} else {
							_tmp250_ = FALSE;
						}
						if (_tmp250_) {
							GtkMenu* _tmp258_;
							GtkMenuItem* _tmp259_;
							_tmp258_ = menu;
							_tmp259_ = trash_menuitem;
							gtk_container_add ((GtkContainer*) _tmp258_, (GtkWidget*) _tmp259_);
						} else {
							GtkMenu* _tmp260_;
							GtkMenuItem* _tmp261_;
							_tmp260_ = menu;
							_tmp261_ = delete_menuitem;
							gtk_container_add ((GtkContainer*) _tmp260_, (GtkWidget*) _tmp261_);
						}
						_tmp262_ = menu;
						_tmp263_ = rename_menuitem;
						gtk_container_add ((GtkContainer*) _tmp262_, (GtkWidget*) _tmp263_);
						_g_object_unref0 (copy_link_menuitem);
						_g_object_unref0 (rename_menuitem);
					}
				}
				_tmp265_ = self->priv->common_actions;
				if (g_action_group_get_action_enabled ((GActionGroup*) _tmp265_, "bookmark")) {
					MarlinViewWindow* _tmp266_;
					GList* _tmp267_;
					gconstpointer _tmp268_;
					const gchar* _tmp269_;
					_tmp266_ = self->window;
					_tmp267_ = self->selected_files;
					_tmp268_ = _tmp267_->data;
					_tmp269_ = ((GOFFile*) _tmp268_)->uri;
					_tmp264_ = marlin_view_window_can_bookmark_uri (_tmp266_, _tmp269_);
				} else {
					_tmp264_ = FALSE;
				}
				if (_tmp264_) {
					GtkMenu* _tmp270_;
					GtkMenuItem* _tmp271_;
					_tmp270_ = menu;
					_tmp271_ = bookmark_menuitem;
					gtk_container_add ((GtkContainer*) _tmp270_, (GtkWidget*) _tmp271_);
				}
				_tmp272_ = menu;
				_tmp273_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp273_);
				_tmp274_ = _tmp273_;
				gtk_container_add ((GtkContainer*) _tmp272_, (GtkWidget*) _tmp274_);
				_g_object_unref0 (_tmp274_);
				_tmp275_ = menu;
				_tmp276_ = properties_menuitem;
				gtk_container_add ((GtkContainer*) _tmp275_, (GtkWidget*) _tmp276_);
			}
		}
		_g_object_unref0 (delete_menuitem);
		_g_object_unref0 (trash_menuitem);
		_g_object_unref0 (copy_menuitem);
		_g_object_unref0 (cut_menuitem);
	} else {
		GtkCheckMenuItem* show_hidden_menuitem = NULL;
		GtkCheckMenuItem* _tmp277_;
		GtkCheckMenuItem* _tmp278_;
		GtkCheckMenuItem* show_remote_thumbnails_menuitem = NULL;
		GtkCheckMenuItem* _tmp279_;
		GtkCheckMenuItem* _tmp280_;
		GtkCheckMenuItem* hide_local_thumbnails_menuitem = NULL;
		GtkCheckMenuItem* _tmp281_;
		GtkCheckMenuItem* _tmp282_;
		_tmp277_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Show Hidden Files"));
		g_object_ref_sink (_tmp277_);
		show_hidden_menuitem = _tmp277_;
		_tmp278_ = show_hidden_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp278_, "background.show-hidden");
		_tmp279_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Show Remote Thumbnails"));
		g_object_ref_sink (_tmp279_);
		show_remote_thumbnails_menuitem = _tmp279_;
		_tmp280_ = show_remote_thumbnails_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp280_, "background.show-remote-thumbnails");
		_tmp281_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Hide Thumbnails"));
		g_object_ref_sink (_tmp281_);
		hide_local_thumbnails_menuitem = _tmp281_;
		_tmp282_ = hide_local_thumbnails_menuitem;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp282_, "background.hide-local-thumbnails");
		if (self->priv->in_trash) {
			gboolean _tmp283_ = FALSE;
			MarlinClipboardManager* _tmp284_;
			_tmp284_ = self->priv->clipboard;
			if (_tmp284_ != NULL) {
				MarlinClipboardManager* _tmp285_;
				_tmp285_ = self->priv->clipboard;
				_tmp283_ = marlin_clipboard_manager_has_cutted_file (_tmp285_, NULL);
			} else {
				_tmp283_ = FALSE;
			}
			if (_tmp283_) {
				GtkMenu* _tmp286_;
				GtkMenuItem* _tmp287_;
				_tmp286_ = menu;
				_tmp287_ = paste_menuitem;
				gtk_container_add ((GtkContainer*) _tmp286_, (GtkWidget*) _tmp287_);
			}
		} else {
			gboolean _tmp288_;
			_tmp288_ = self->priv->_in_recent;
			if (_tmp288_) {
				GtkMenu* _tmp289_;
				GtkSeparatorMenuItem* _tmp290_;
				GtkSeparatorMenuItem* _tmp291_;
				GtkMenu* _tmp292_;
				FMAbstractDirectoryViewSortSubMenuItem* _tmp293_;
				FMAbstractDirectoryViewSortSubMenuItem* _tmp294_;
				GtkMenu* _tmp295_;
				GtkSeparatorMenuItem* _tmp296_;
				GtkSeparatorMenuItem* _tmp297_;
				GtkMenu* _tmp298_;
				GtkCheckMenuItem* _tmp299_;
				GtkMenu* _tmp300_;
				GtkCheckMenuItem* _tmp301_;
				_tmp289_ = menu;
				_tmp290_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp290_);
				_tmp291_ = _tmp290_;
				gtk_container_add ((GtkContainer*) _tmp289_, (GtkWidget*) _tmp291_);
				_g_object_unref0 (_tmp291_);
				_tmp292_ = menu;
				_tmp293_ = fm_abstract_directory_view_sort_sub_menu_item_new ();
				g_object_ref_sink (_tmp293_);
				_tmp294_ = _tmp293_;
				gtk_container_add ((GtkContainer*) _tmp292_, (GtkWidget*) _tmp294_);
				_g_object_unref0 (_tmp294_);
				_tmp295_ = menu;
				_tmp296_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp296_);
				_tmp297_ = _tmp296_;
				gtk_container_add ((GtkContainer*) _tmp295_, (GtkWidget*) _tmp297_);
				_g_object_unref0 (_tmp297_);
				_tmp298_ = menu;
				_tmp299_ = show_hidden_menuitem;
				gtk_container_add ((GtkContainer*) _tmp298_, (GtkWidget*) _tmp299_);
				_tmp300_ = menu;
				_tmp301_ = hide_local_thumbnails_menuitem;
				gtk_container_add ((GtkContainer*) _tmp300_, (GtkWidget*) _tmp301_);
			} else {
				gboolean _tmp322_ = FALSE;
				GSimpleActionGroup* _tmp323_;
				GtkMenu* _tmp333_;
				GtkSeparatorMenuItem* _tmp334_;
				GtkSeparatorMenuItem* _tmp335_;
				GtkMenu* _tmp336_;
				GtkCheckMenuItem* _tmp337_;
				MarlinViewSlot* _tmp338_;
				GOFDirectoryAsync* _tmp339_;
				GOFDirectoryAsync* _tmp340_;
				gboolean _tmp341_;
				gboolean _tmp342_;
				if (!self->priv->in_network_root) {
					GtkMenu* _tmp302_;
					GtkSeparatorMenuItem* _tmp303_;
					GtkSeparatorMenuItem* _tmp304_;
					gboolean _tmp305_ = FALSE;
					MarlinClipboardManager* _tmp306_;
					GtkMenu* _tmp319_;
					FMAbstractDirectoryViewSortSubMenuItem* _tmp320_;
					FMAbstractDirectoryViewSortSubMenuItem* _tmp321_;
					_tmp302_ = menu;
					_tmp303_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
					g_object_ref_sink (_tmp303_);
					_tmp304_ = _tmp303_;
					gtk_container_add ((GtkContainer*) _tmp302_, (GtkWidget*) _tmp304_);
					_g_object_unref0 (_tmp304_);
					_tmp306_ = self->priv->clipboard;
					if (_tmp306_ != NULL) {
						MarlinClipboardManager* _tmp307_;
						gboolean _tmp308_;
						gboolean _tmp309_;
						_tmp307_ = self->priv->clipboard;
						_tmp308_ = marlin_clipboard_manager_get_can_paste (_tmp307_);
						_tmp309_ = _tmp308_;
						_tmp305_ = _tmp309_;
					} else {
						_tmp305_ = FALSE;
					}
					if (_tmp305_) {
						MarlinClipboardManager* _tmp310_;
						gboolean _tmp311_;
						gboolean _tmp312_;
						GtkMenu* _tmp314_;
						GtkMenuItem* _tmp315_;
						_tmp310_ = self->priv->clipboard;
						_tmp311_ = marlin_clipboard_manager_get_files_linked (_tmp310_);
						_tmp312_ = _tmp311_;
						if (_tmp312_) {
							GtkMenuItem* _tmp313_;
							_tmp313_ = paste_menuitem;
							gtk_menu_item_set_label (_tmp313_, _ ("Paste Link"));
						}
						_tmp314_ = menu;
						_tmp315_ = paste_menuitem;
						gtk_container_add ((GtkContainer*) _tmp314_, (GtkWidget*) _tmp315_);
					}
					if (self->is_writable) {
						GtkMenu* _tmp316_;
						FMAbstractDirectoryViewNewSubMenuItem* _tmp317_;
						FMAbstractDirectoryViewNewSubMenuItem* _tmp318_;
						_tmp316_ = menu;
						_tmp317_ = fm_abstract_directory_view_new_sub_menu_item_new ();
						g_object_ref_sink (_tmp317_);
						_tmp318_ = _tmp317_;
						gtk_container_add ((GtkContainer*) _tmp316_, (GtkWidget*) _tmp318_);
						_g_object_unref0 (_tmp318_);
					}
					_tmp319_ = menu;
					_tmp320_ = fm_abstract_directory_view_sort_sub_menu_item_new ();
					g_object_ref_sink (_tmp320_);
					_tmp321_ = _tmp320_;
					gtk_container_add ((GtkContainer*) _tmp319_, (GtkWidget*) _tmp321_);
					_g_object_unref0 (_tmp321_);
				}
				_tmp323_ = self->priv->common_actions;
				if (g_action_group_get_action_enabled ((GActionGroup*) _tmp323_, "bookmark")) {
					MarlinViewWindow* _tmp324_;
					MarlinViewSlot* _tmp325_;
					GOFDirectoryAsync* _tmp326_;
					GOFDirectoryAsync* _tmp327_;
					GOFFile* _tmp328_;
					GOFFile* _tmp329_;
					const gchar* _tmp330_;
					_tmp324_ = self->window;
					_tmp325_ = self->slot;
					_tmp326_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp325_);
					_tmp327_ = _tmp326_;
					_tmp328_ = gof_directory_async_get_file (_tmp327_);
					_tmp329_ = _tmp328_;
					_tmp330_ = _tmp329_->uri;
					_tmp322_ = marlin_view_window_can_bookmark_uri (_tmp324_, _tmp330_);
				} else {
					_tmp322_ = FALSE;
				}
				if (_tmp322_) {
					GtkMenu* _tmp331_;
					GtkMenuItem* _tmp332_;
					_tmp331_ = menu;
					_tmp332_ = bookmark_menuitem;
					gtk_container_add ((GtkContainer*) _tmp331_, (GtkWidget*) _tmp332_);
				}
				_tmp333_ = menu;
				_tmp334_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
				g_object_ref_sink (_tmp334_);
				_tmp335_ = _tmp334_;
				gtk_container_add ((GtkContainer*) _tmp333_, (GtkWidget*) _tmp335_);
				_g_object_unref0 (_tmp335_);
				_tmp336_ = menu;
				_tmp337_ = show_hidden_menuitem;
				gtk_container_add ((GtkContainer*) _tmp336_, (GtkWidget*) _tmp337_);
				_tmp338_ = self->slot;
				_tmp339_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp338_);
				_tmp340_ = _tmp339_;
				_tmp341_ = gof_directory_async_get_is_local (_tmp340_);
				_tmp342_ = _tmp341_;
				if (_tmp342_) {
					GtkMenu* _tmp343_;
					GtkCheckMenuItem* _tmp344_;
					_tmp343_ = menu;
					_tmp344_ = hide_local_thumbnails_menuitem;
					gtk_container_add ((GtkContainer*) _tmp343_, (GtkWidget*) _tmp344_);
				} else {
					MarlinViewSlot* _tmp345_;
					GOFDirectoryAsync* _tmp346_;
					GOFDirectoryAsync* _tmp347_;
					gboolean _tmp348_;
					gboolean _tmp349_;
					_tmp345_ = self->slot;
					_tmp346_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp345_);
					_tmp347_ = _tmp346_;
					_tmp348_ = gof_directory_async_get_can_open_files (_tmp347_);
					_tmp349_ = _tmp348_;
					if (_tmp349_) {
						GtkMenu* _tmp350_;
						GtkCheckMenuItem* _tmp351_;
						_tmp350_ = menu;
						_tmp351_ = show_remote_thumbnails_menuitem;
						gtk_container_add ((GtkContainer*) _tmp350_, (GtkWidget*) _tmp351_);
					}
				}
				if (!self->priv->in_network_root) {
					GtkMenu* _tmp352_;
					GtkSeparatorMenuItem* _tmp353_;
					GtkSeparatorMenuItem* _tmp354_;
					GtkMenu* _tmp355_;
					GtkMenuItem* _tmp356_;
					_tmp352_ = menu;
					_tmp353_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
					g_object_ref_sink (_tmp353_);
					_tmp354_ = _tmp353_;
					gtk_container_add ((GtkContainer*) _tmp352_, (GtkWidget*) _tmp354_);
					_g_object_unref0 (_tmp354_);
					_tmp355_ = menu;
					_tmp356_ = properties_menuitem;
					gtk_container_add ((GtkContainer*) _tmp355_, (GtkWidget*) _tmp356_);
				}
			}
		}
		_g_object_unref0 (hide_local_thumbnails_menuitem);
		_g_object_unref0 (show_remote_thumbnails_menuitem);
		_g_object_unref0 (show_hidden_menuitem);
	}
	if (!self->priv->in_trash) {
		MarlinPluginManager* _tmp357_;
		GtkMenu* _tmp358_;
		GList* _tmp359_;
		GList* _tmp360_;
		_tmp357_ = plugins;
		_tmp358_ = menu;
		_tmp359_ = fm_abstract_directory_view_get_files_for_action (self);
		_tmp360_ = _tmp359_;
		marlin_plugin_manager_hook_context_menu (_tmp357_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp358_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp358_) : NULL, _tmp360_);
		(_tmp360_ == NULL) ? NULL : (_tmp360_ = (_g_list_free__g_object_unref0_ (_tmp360_), NULL));
	}
	_tmp361_ = menu;
	gtk_menu_set_screen (_tmp361_, NULL);
	_tmp362_ = menu;
	gtk_menu_attach_to_widget (_tmp362_, (GtkWidget*) self, NULL);
	_tmp363_ = self->slot;
	_tmp364_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp363_);
	_tmp365_ = _tmp364_;
	if (gof_directory_async_is_empty (_tmp365_)) {
		GtkMenu* _tmp366_;
		GtkStyleContext* _tmp367_;
		_tmp366_ = menu;
		_tmp367_ = gtk_widget_get_style_context ((GtkWidget*) _tmp366_);
		gtk_style_context_add_class (_tmp367_, GTK_STYLE_CLASS_CONTEXT_MENU);
	}
	_tmp368_ = menu;
	gtk_widget_show_all ((GtkWidget*) _tmp368_);
	_tmp369_ = menu;
	gtk_menu_popup_at_pointer (_tmp369_, event);
	_g_object_unref0 (properties_menuitem);
	_g_object_unref0 (bookmark_menuitem);
	_g_object_unref0 (paste_menuitem);
	_g_object_unref0 (open_submenu_item);
	_g_object_unref0 (open_submenu);
	_g_object_unref0 (selected_file);
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
	_g_object_unref0 (menu);
}

static gboolean
fm_abstract_directory_view_valid_selection_for_edit (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = fm_abstract_directory_view_get_selected_files (self);
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = _tmp0_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			GOFFile* file = NULL;
			file = (GOFFile*) file_it->data;
			{
				GOFFile* _tmp1_;
				_tmp1_ = file;
				if (gof_file_is_root_network_folder (_tmp1_)) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static gboolean
fm_abstract_directory_view_valid_selection_for_restore (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = fm_abstract_directory_view_get_selected_files (self);
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = _tmp0_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			GOFFile* file = NULL;
			file = (GOFFile*) file_it->data;
			{
				GOFFile* _tmp1_;
				GFile* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gboolean _tmp5_;
				_tmp1_ = file;
				_tmp2_ = _tmp1_->directory;
				_tmp3_ = g_file_get_basename (_tmp2_);
				_tmp4_ = _tmp3_;
				_tmp5_ = !(g_strcmp0 (_tmp4_, "/") == 0);
				_g_free0 (_tmp4_);
				if (_tmp5_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static void
fm_abstract_directory_view_update_menu_actions (FMAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GList* selection = NULL;
	GList* _tmp8_;
	GOFFile* file = NULL;
	gboolean is_selected = FALSE;
	GList* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean more_than_one_selected = FALSE;
	gboolean single_folder = FALSE;
	gboolean only_folders = FALSE;
	GList* _tmp14_;
	gboolean can_rename = FALSE;
	gboolean can_show_properties = FALSE;
	gboolean can_copy = FALSE;
	gboolean can_open = FALSE;
	gboolean can_paste_into = FALSE;
	gboolean can_bookmark = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	GOFFile* _tmp46_;
	GOFFile* _tmp47_;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_;
	GSimpleActionGroup* _tmp50_;
	GSimpleActionGroup* _tmp51_;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_ = FALSE;
	GSimpleActionGroup* _tmp54_;
	GSimpleActionGroup* _tmp55_;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	GSimpleActionGroup* _tmp58_;
	GSimpleActionGroup* _tmp59_;
	GSimpleActionGroup* _tmp60_;
	GSimpleActionGroup* _tmp61_;
	gboolean _tmp62_ = FALSE;
	GSimpleActionGroup* _tmp63_;
	gboolean _tmp64_ = FALSE;
	GSimpleActionGroup* _tmp70_;
	GSimpleActionGroup* _tmp71_;
	GSimpleActionGroup* _tmp72_;
	GSimpleActionGroup* _tmp73_;
	gboolean _tmp74_ = FALSE;
	GSimpleActionGroup* _tmp75_;
	gboolean _tmp76_ = FALSE;
	gboolean _tmp77_ = FALSE;
	GSimpleActionGroup* _tmp79_;
	GSimpleActionGroup* _tmp80_;
	GList* _tmp81_;
	g_return_if_fail (self != NULL);
	_tmp1_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		MarlinViewSlot* _tmp3_;
		GOFDirectoryAsync* _tmp4_;
		GOFDirectoryAsync* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp3_ = self->slot;
		_tmp4_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = gof_directory_async_get_can_load (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp0_ = !_tmp7_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp8_ = fm_abstract_directory_view_get_files_for_action (self);
	selection = _tmp8_;
	_tmp9_ = selection;
	is_selected = _tmp9_ != NULL;
	if (is_selected) {
		GList* _tmp11_;
		GList* _tmp12_;
		GList* _tmp13_;
		_tmp11_ = selection;
		_tmp12_ = g_list_first (_tmp11_);
		_tmp13_ = _tmp12_->next;
		_tmp10_ = _tmp13_ != NULL;
	} else {
		_tmp10_ = FALSE;
	}
	more_than_one_selected = _tmp10_;
	single_folder = FALSE;
	_tmp14_ = selection;
	only_folders = fm_abstract_directory_view_selection_only_contains_folders (self, _tmp14_);
	can_rename = FALSE;
	can_show_properties = FALSE;
	can_copy = FALSE;
	can_open = FALSE;
	can_paste_into = FALSE;
	can_bookmark = FALSE;
	if (is_selected) {
		GList* _tmp15_;
		gconstpointer _tmp16_;
		GOFFile* _tmp17_;
		GOFFile* _tmp18_;
		_tmp15_ = selection;
		_tmp16_ = _tmp15_->data;
		_tmp17_ = _g_object_ref0 ((GOFFile*) _tmp16_);
		_g_object_unref0 (file);
		file = _tmp17_;
		_tmp18_ = file;
		if (_tmp18_ != NULL) {
			gboolean _tmp19_ = FALSE;
			gboolean _tmp21_ = FALSE;
			if (!more_than_one_selected) {
				GOFFile* _tmp20_;
				_tmp20_ = file;
				_tmp19_ = gof_file_is_folder (_tmp20_);
			} else {
				_tmp19_ = FALSE;
			}
			single_folder = _tmp19_;
			can_rename = self->is_writable;
			if (single_folder) {
				GOFFile* _tmp22_;
				_tmp22_ = file;
				_tmp21_ = gof_file_is_writable (_tmp22_);
			} else {
				_tmp21_ = FALSE;
			}
			can_paste_into = _tmp21_;
		} else {
			g_critical ("AbstractDirectoryView.vala:2302: File in selection is null");
		}
	} else {
		MarlinViewSlot* _tmp23_;
		GOFDirectoryAsync* _tmp24_;
		GOFDirectoryAsync* _tmp25_;
		GOFFile* _tmp26_;
		GOFFile* _tmp27_;
		GOFFile* _tmp28_;
		gboolean _tmp29_ = FALSE;
		_tmp23_ = self->slot;
		_tmp24_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = gof_directory_async_get_file (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = _g_object_ref0 (_tmp27_);
		_g_object_unref0 (file);
		file = _tmp28_;
		if (!more_than_one_selected) {
			GOFFile* _tmp30_;
			_tmp30_ = file;
			_tmp29_ = gof_file_is_folder (_tmp30_);
		} else {
			_tmp29_ = FALSE;
		}
		single_folder = _tmp29_;
		can_paste_into = self->is_writable;
	}
	if (!more_than_one_selected) {
		_tmp32_ = TRUE;
	} else {
		_tmp32_ = single_folder;
	}
	if (_tmp32_) {
		gboolean _tmp33_ = FALSE;
		gboolean _tmp34_ = FALSE;
		MarlinViewSlot* _tmp35_;
		GOFDirectoryAsync* _tmp36_;
		GOFDirectoryAsync* _tmp37_;
		gboolean _tmp38_;
		gboolean _tmp39_;
		_tmp35_ = self->slot;
		_tmp36_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = gof_directory_async_get_is_local (_tmp37_);
		_tmp39_ = _tmp38_;
		if (_tmp39_) {
			_tmp34_ = TRUE;
		} else {
			gboolean _tmp40_ = FALSE;
			GOFFile* _tmp41_;
			const gchar* _tmp42_;
			_tmp41_ = file;
			_tmp42_ = gof_file_get_ftype (_tmp41_);
			if (_tmp42_ != NULL) {
				GOFFile* _tmp43_;
				const gchar* _tmp44_;
				_tmp43_ = file;
				_tmp44_ = gof_file_get_ftype (_tmp43_);
				_tmp40_ = g_strcmp0 (_tmp44_, "inode/directory") == 0;
			} else {
				_tmp40_ = FALSE;
			}
			_tmp34_ = _tmp40_;
		}
		if (_tmp34_) {
			_tmp33_ = TRUE;
		} else {
			GOFFile* _tmp45_;
			_tmp45_ = file;
			_tmp33_ = gof_file_is_smb_server (_tmp45_);
		}
		_tmp31_ = _tmp33_;
	} else {
		_tmp31_ = FALSE;
	}
	can_bookmark = _tmp31_;
	_tmp46_ = file;
	can_copy = gof_file_is_readable (_tmp46_);
	_tmp47_ = file;
	can_open = fm_abstract_directory_view_can_open_file (self, _tmp47_, FALSE);
	_tmp49_ = self->priv->_in_recent;
	if (_tmp49_) {
		_tmp48_ = more_than_one_selected;
	} else {
		_tmp48_ = FALSE;
	}
	can_show_properties = !_tmp48_;
	_tmp50_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp50_, "paste-into", can_paste_into);
	_tmp51_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp51_, "open-in", only_folders);
	if (is_selected) {
		_tmp53_ = !more_than_one_selected;
	} else {
		_tmp53_ = FALSE;
	}
	if (_tmp53_) {
		_tmp52_ = can_rename;
	} else {
		_tmp52_ = FALSE;
	}
	_tmp54_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp54_, "rename", _tmp52_);
	_tmp55_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp55_, "view-in-location", is_selected);
	if (is_selected) {
		_tmp57_ = !more_than_one_selected;
	} else {
		_tmp57_ = FALSE;
	}
	if (_tmp57_) {
		_tmp56_ = can_open;
	} else {
		_tmp56_ = FALSE;
	}
	_tmp58_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp58_, "open", _tmp56_);
	_tmp59_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp59_, "open-with-app", can_open);
	_tmp60_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp60_, "open-with-default", can_open);
	_tmp61_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp61_, "open-with-other-app", can_open);
	if (self->is_writable) {
		_tmp62_ = is_selected;
	} else {
		_tmp62_ = FALSE;
	}
	_tmp63_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp63_, "cut", _tmp62_);
	if (self->is_writable) {
		MarlinViewSlot* _tmp65_;
		GOFDirectoryAsync* _tmp66_;
		GOFDirectoryAsync* _tmp67_;
		gboolean _tmp68_;
		gboolean _tmp69_;
		_tmp65_ = self->slot;
		_tmp66_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp65_);
		_tmp67_ = _tmp66_;
		_tmp68_ = gof_directory_async_get_has_trash_dirs (_tmp67_);
		_tmp69_ = _tmp68_;
		_tmp64_ = _tmp69_;
	} else {
		_tmp64_ = FALSE;
	}
	_tmp70_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp70_, "trash", _tmp64_);
	_tmp71_ = self->priv->selection_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp71_, "delete", self->is_writable);
	_tmp72_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp72_, "properties", can_show_properties);
	_tmp73_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp73_, "bookmark", can_bookmark);
	if (!self->priv->in_trash) {
		_tmp74_ = can_copy;
	} else {
		_tmp74_ = FALSE;
	}
	_tmp75_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp75_, "copy", _tmp74_);
	if (!self->priv->in_trash) {
		gboolean _tmp78_;
		_tmp78_ = self->priv->_in_recent;
		_tmp77_ = !_tmp78_;
	} else {
		_tmp77_ = FALSE;
	}
	if (_tmp77_) {
		_tmp76_ = can_copy;
	} else {
		_tmp76_ = FALSE;
	}
	_tmp79_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp79_, "copy-link", _tmp76_);
	_tmp80_ = self->priv->common_actions;
	fm_abstract_directory_view_action_set_enabled (self, _tmp80_, "bookmark", !more_than_one_selected);
	_tmp81_ = selection;
	fm_abstract_directory_view_update_default_app (self, _tmp81_);
	fm_abstract_directory_view_update_menu_actions_sort (self);
	_g_object_unref0 (file);
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
}

static void
fm_abstract_directory_view_update_menu_actions_sort (FMAbstractDirectoryView* self)
{
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	FMListModel* _tmp0_;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->model;
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp0_, &_tmp1_, &_tmp2_);
	sort_column_id = _tmp1_;
	sort_order = _tmp2_;
	if (_tmp3_) {
		GVariant* val = NULL;
		const gchar* _tmp4_;
		GVariant* _tmp5_;
		GSimpleActionGroup* _tmp6_;
		GVariant* _tmp7_;
		GtkSortType _tmp8_;
		GVariant* _tmp9_;
		GSimpleActionGroup* _tmp10_;
		GVariant* _tmp11_;
		GOFPreferences* _tmp12_;
		GOFPreferences* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		GVariant* _tmp16_;
		GSimpleActionGroup* _tmp17_;
		GVariant* _tmp18_;
		_tmp4_ = fm_list_model_column_id_to_string ((FMListModelColumnID) sort_column_id);
		_tmp5_ = g_variant_new_string (_tmp4_);
		g_variant_ref_sink (_tmp5_);
		val = _tmp5_;
		_tmp6_ = self->priv->background_actions;
		_tmp7_ = val;
		fm_abstract_directory_view_action_set_state (self, _tmp6_, "sort-by", _tmp7_);
		_tmp8_ = sort_order;
		_tmp9_ = g_variant_new_boolean (_tmp8_ == GTK_SORT_DESCENDING);
		g_variant_ref_sink (_tmp9_);
		_g_variant_unref0 (val);
		val = _tmp9_;
		_tmp10_ = self->priv->background_actions;
		_tmp11_ = val;
		fm_abstract_directory_view_action_set_state (self, _tmp10_, "reverse", _tmp11_);
		_tmp12_ = gof_preferences_get_default ();
		_tmp13_ = _tmp12_;
		_tmp14_ = gof_preferences_get_sort_directories_first (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_variant_new_boolean (_tmp15_);
		g_variant_ref_sink (_tmp16_);
		_g_variant_unref0 (val);
		val = _tmp16_;
		_g_object_unref0 (_tmp13_);
		_tmp17_ = self->priv->background_actions;
		_tmp18_ = val;
		fm_abstract_directory_view_action_set_state (self, _tmp17_, "folders-first", _tmp18_);
		_g_variant_unref0 (val);
	}
}

static void
fm_abstract_directory_view_update_default_app (FMAbstractDirectoryView* self,
                                               GList* selection)
{
	GAppInfo* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = marlin_mime_actions_get_default_application_for_files (selection);
	_g_object_unref0 (self->priv->default_app);
	self->priv->default_app = _tmp0_;
	return;
}

/** Menu helpers */
static void
fm_abstract_directory_view_action_set_enabled (FMAbstractDirectoryView* self,
                                               GSimpleActionGroup* action_group,
                                               const gchar* name,
                                               gboolean enabled)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	if (action_group != NULL) {
		GSimpleAction* action = NULL;
		GAction* _tmp0_;
		GSimpleAction* _tmp1_;
		GSimpleAction* _tmp2_;
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, name);
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
		action = _tmp1_;
		_tmp2_ = action;
		if (_tmp2_ != NULL) {
			GSimpleAction* _tmp3_;
			_tmp3_ = action;
			g_simple_action_set_enabled (_tmp3_, enabled);
			_g_object_unref0 (action);
			return;
		}
		_g_object_unref0 (action);
	}
	g_critical ("AbstractDirectoryView.vala:2371: Action name not found: %s - cannot en" \
"able", name);
}

static void
fm_abstract_directory_view_action_set_state (FMAbstractDirectoryView* self,
                                             GSimpleActionGroup* action_group,
                                             const gchar* name,
                                             GVariant* val)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (val != NULL);
	if (action_group != NULL) {
		GSimpleAction* action = NULL;
		GAction* _tmp0_;
		GSimpleAction* _tmp1_;
		GSimpleAction* _tmp2_;
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, name);
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
		action = _tmp1_;
		_tmp2_ = action;
		if (_tmp2_ != NULL) {
			GSimpleAction* _tmp3_;
			_tmp3_ = action;
			g_simple_action_set_state (_tmp3_, val);
			_g_object_unref0 (action);
			return;
		}
		_g_object_unref0 (action);
	}
	g_critical ("AbstractDirectoryView.vala:2382: Action name not found: %s - cannot se" \
"t state", name);
}

static gint
___lambda38_ (GFile* a,
              GFile* b)
{
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gint _tmp9_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = ((GCompareFunc) g_strcmp0);
	_tmp1_ = g_file_get_basename (a);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_get_basename (b);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
	_tmp8_ = _tmp7_;
	_tmp9_ = _tmp0_ (_tmp4_, _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp9_;
	return result;
}

static gint
____lambda38__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda38_ ((GFile*) a, (GFile*) b);
	return result;
}

static void
___lambda39_ (GFile* folder)
{
	g_return_if_fail (folder != NULL);
	fm_abstract_directory_view_load_templates_from_folder (folder);
}

static void
____lambda39__gfunc (gconstpointer data,
                     gpointer self)
{
	___lambda39_ ((GFile*) data);
}

static void
fm_abstract_directory_view_load_templates_from_folder (GFile* template_folder)
{
	GList* file_list = NULL;
	GList* folder_list = NULL;
	GFileEnumerator* enumerator = NULL;
	gchar* f_attr = NULL;
	gchar* _tmp0_;
	GFileQueryInfoFlags flags = 0U;
	GList* _tmp24_;
	GList* _tmp30_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (template_folder != NULL);
	file_list = NULL;
	folder_list = NULL;
	_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME G_FILE_ATTRIBUTE_STANDARD_TYPE);
	f_attr = _tmp0_;
	flags = G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS;
	{
		GFileEnumerator* _tmp1_ = NULL;
		const gchar* _tmp2_;
		GFileQueryInfoFlags _tmp3_;
		GFileEnumerator* _tmp4_;
		GFileEnumerator* _tmp5_;
		guint count = 0U;
		GList* _tmp6_;
		GFile* location = NULL;
		GFileInfo* info = NULL;
		GFileEnumerator* _tmp7_;
		GFileInfo* _tmp8_;
		_tmp2_ = f_attr;
		_tmp3_ = flags;
		_tmp4_ = g_file_enumerate_children (template_folder, _tmp2_, _tmp3_, NULL, &_inner_error0_);
		_tmp1_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch31_g_error;
		}
		_tmp5_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (enumerator);
		enumerator = _tmp5_;
		_tmp6_ = fm_abstract_directory_view_templates;
		count = g_list_length (_tmp6_);
		_tmp7_ = enumerator;
		_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error0_);
		info = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (location);
			_g_object_unref0 (_tmp1_);
			goto __catch31_g_error;
		}
		while (TRUE) {
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFileInfo* _tmp14_;
			GFileInfo* _tmp20_ = NULL;
			GFileEnumerator* _tmp21_;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
			if (count < ((guint) FM_ABSTRACT_DIRECTORY_VIEW_MAX_TEMPLATES)) {
				GFileInfo* _tmp10_;
				_tmp10_ = info;
				_tmp9_ = _tmp10_ != NULL;
			} else {
				_tmp9_ = FALSE;
			}
			if (!_tmp9_) {
				break;
			}
			_tmp11_ = info;
			_tmp12_ = g_file_info_get_name (_tmp11_);
			_tmp13_ = g_file_get_child (template_folder, _tmp12_);
			_g_object_unref0 (location);
			location = _tmp13_;
			_tmp14_ = info;
			if (g_file_info_get_file_type (_tmp14_) == G_FILE_TYPE_DIRECTORY) {
				GFile* _tmp15_;
				GFile* _tmp16_;
				_tmp15_ = location;
				_tmp16_ = _g_object_ref0 (_tmp15_);
				folder_list = g_list_prepend (folder_list, _tmp16_);
			} else {
				GFile* _tmp17_;
				GFile* _tmp18_;
				guint _tmp19_;
				_tmp17_ = location;
				_tmp18_ = _g_object_ref0 (_tmp17_);
				file_list = g_list_prepend (file_list, _tmp18_);
				_tmp19_ = count;
				count = _tmp19_ + 1;
			}
			_tmp21_ = enumerator;
			_tmp22_ = g_file_enumerator_next_file (_tmp21_, NULL, &_inner_error0_);
			_tmp20_ = _tmp22_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (location);
				_g_object_unref0 (_tmp1_);
				goto __catch31_g_error;
			}
			_tmp23_ = _tmp20_;
			_tmp20_ = NULL;
			_g_object_unref0 (info);
			info = _tmp23_;
			_g_object_unref0 (_tmp20_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (location);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally31;
	__catch31_g_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (_error_);
		_g_free0 (f_attr);
		_g_object_unref0 (enumerator);
		(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
		return;
	}
	__finally31:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (f_attr);
		_g_object_unref0 (enumerator);
		(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp24_ = file_list;
	if (g_list_length (_tmp24_) > ((guint) 0)) {
		GList* _tmp25_;
		GFile* _tmp29_;
		file_list = g_list_sort (file_list, ____lambda38__gcompare_func);
		_tmp25_ = file_list;
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
			file_collection = _tmp25_;
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
				GFile* _tmp26_;
				GFile* file = NULL;
				_tmp26_ = _g_object_ref0 ((GFile*) file_it->data);
				file = _tmp26_;
				{
					GFile* _tmp27_;
					GFile* _tmp28_;
					_tmp27_ = file;
					_tmp28_ = _g_object_ref0 (_tmp27_);
					fm_abstract_directory_view_templates = g_list_append (fm_abstract_directory_view_templates, _tmp28_);
					_g_object_unref0 (file);
				}
			}
		}
		_tmp29_ = _g_object_ref0 (template_folder);
		fm_abstract_directory_view_templates = g_list_append (fm_abstract_directory_view_templates, _tmp29_);
	}
	_tmp30_ = folder_list;
	if (g_list_length (_tmp30_) > ((guint) 0)) {
		GList* _tmp31_;
		_tmp31_ = folder_list;
		g_list_foreach (_tmp31_, ____lambda39__gfunc, NULL);
	}
	_g_free0 (f_attr);
	_g_object_unref0 (enumerator);
	(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
}

static void
fm_abstract_directory_view_filter_this_app_from_open_with_apps (FMAbstractDirectoryView* self)
{
	GList* l = NULL;
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->open_with_apps;
	l = _tmp0_;
	while (TRUE) {
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		GList* _tmp10_;
		GList* _tmp11_;
		_tmp1_ = l;
		if (!(_tmp1_ != NULL)) {
			break;
		}
		_tmp2_ = l;
		_tmp3_ = _tmp2_->data;
		if (G_TYPE_CHECK_INSTANCE_TYPE ((GAppInfo*) _tmp3_, g_app_info_get_type ())) {
			GList* _tmp4_;
			gconstpointer _tmp5_;
			_tmp4_ = l;
			_tmp5_ = _tmp4_->data;
			if (fm_abstract_directory_view_app_is_this_app (self, (GAppInfo*) _tmp5_)) {
				GList* _tmp6_;
				_tmp6_ = l;
				self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp6_);
				break;
			}
		} else {
			GList* _tmp7_;
			GList* _tmp8_;
			GList* _tmp9_;
			_tmp7_ = l;
			self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp7_);
			_tmp8_ = self->priv->open_with_apps;
			l = _tmp8_;
			_tmp9_ = l;
			if (_tmp9_ == NULL) {
				break;
			}
		}
		_tmp10_ = l;
		_tmp11_ = _tmp10_->next;
		l = _tmp11_;
	}
}

static gboolean
fm_abstract_directory_view_app_is_this_app (FMAbstractDirectoryView* self,
                                            GAppInfo* ai)
{
	gchar* exec_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ai != NULL, FALSE);
	_tmp0_ = g_app_info_get_executable (ai);
	_tmp1_ = g_strdup (_tmp0_);
	exec_name = _tmp1_;
	_tmp3_ = exec_name;
	if (g_strcmp0 (_tmp3_, APP_NAME) == 0) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = exec_name;
		_tmp2_ = g_strcmp0 (_tmp4_, TERMINAL_NAME) == 0;
	}
	result = _tmp2_;
	_g_free0 (exec_name);
	return result;
}

static void
fm_abstract_directory_view_filter_default_app_from_open_with_apps (FMAbstractDirectoryView* self)
{
	GAppInfo* _tmp0_;
	gchar* id1 = NULL;
	gchar* id2 = NULL;
	GAppInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->default_app;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->default_app;
	_tmp2_ = g_app_info_get_id (_tmp1_);
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (id2);
	id2 = _tmp3_;
	_tmp4_ = id2;
	if (_tmp4_ != NULL) {
		GList* l = NULL;
		GList* _tmp5_;
		_tmp5_ = self->priv->open_with_apps;
		l = _tmp5_;
		while (TRUE) {
			gboolean _tmp6_ = FALSE;
			GList* _tmp7_;
			GList* _tmp10_;
			gconstpointer _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			const gchar* _tmp15_;
			GList* _tmp19_;
			GList* _tmp20_;
			_tmp7_ = l;
			if (_tmp7_ != NULL) {
				GList* _tmp8_;
				gconstpointer _tmp9_;
				_tmp8_ = l;
				_tmp9_ = _tmp8_->data;
				_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE ((GAppInfo*) _tmp9_, g_app_info_get_type ());
			} else {
				_tmp6_ = FALSE;
			}
			if (!_tmp6_) {
				break;
			}
			_tmp10_ = l;
			_tmp11_ = _tmp10_->data;
			_tmp12_ = g_app_info_get_id ((GAppInfo*) _tmp11_);
			_tmp13_ = g_strdup (_tmp12_);
			_g_free0 (id1);
			id1 = _tmp13_;
			_tmp15_ = id1;
			if (_tmp15_ != NULL) {
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				_tmp16_ = id1;
				_tmp17_ = id2;
				_tmp14_ = g_strcmp0 (_tmp16_, _tmp17_) == 0;
			} else {
				_tmp14_ = FALSE;
			}
			if (_tmp14_) {
				GList* _tmp18_;
				_tmp18_ = l;
				self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp18_);
				break;
			}
			_tmp19_ = l;
			_tmp20_ = _tmp19_->next;
			l = _tmp20_;
		}
	}
	_g_free0 (id2);
	_g_free0 (id1);
}

/** Menu action functions */
static void
__lambda82_ (FMAbstractDirectoryView* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		_tmp0_ = marlin_file_operations_new_file_from_template_finish (res, &_inner_error0_);
		file = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch32_g_error;
		}
		fm_abstract_directory_view_create_file_done (file, self);
		_g_object_unref0 (file);
	}
	goto __finally32;
	__catch32_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_critical ("AbstractDirectoryView.vala:2502: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally32:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda82__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda82_ ((FMAbstractDirectoryView*) self, source_object, res);
	g_object_unref (self);
}

static void
fm_abstract_directory_view_create_from_template (FMAbstractDirectoryView* self,
                                                 GFile* template)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	gchar* new_name = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	MarlinViewSlot* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (template != NULL);
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	gof_directory_async_block_monitor (_tmp2_);
	_tmp3_ = g_file_get_basename (template);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf (_ ("Untitled %s"), _tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	new_name = _tmp6_;
	_tmp7_ = self->slot;
	_tmp8_ = gof_abstract_slot_get_location ((GOFAbstractSlot*) _tmp7_);
	_tmp9_ = _tmp8_;
	marlin_file_operations_new_file_from_template ((GtkWidget*) self, NULL, _tmp9_, new_name, template, NULL, ___lambda82__gasync_ready_callback, g_object_ref (self));
	_g_free0 (new_name);
}

static void
fm_abstract_directory_view_open_files_with (FMAbstractDirectoryView* self,
                                            GAppInfo* app,
                                            GList* files)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (app != NULL);
	marlin_mime_actions_open_multiple_gof_files_request (files, (GtkWidget*) self, app);
}

/** Thumbnail handling */
static gboolean
__lambda51_ (FMAbstractDirectoryView* self)
{
	gboolean result = FALSE;
	if (self->priv->thumbnail_source_id > ((guint) 0)) {
		result = G_SOURCE_CONTINUE;
		return result;
	}
	fm_abstract_directory_view_thaw_child_notify (self);
	self->priv->freeze_source_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda51__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda51_ ((FMAbstractDirectoryView*) self);
	return result;
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
	return g_boxed_copy (gtk_tree_path_get_type (), self);
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
	return self ? _vala_GtkTreePath_copy (self) : NULL;
}

static gboolean
__lambda52_ (FMAbstractDirectoryView* self)
{
	GtkTreePath* start_path = NULL;
	GtkTreePath* end_path = NULL;
	GtkTreePath* path = NULL;
	GtkTreePath* sp = NULL;
	GtkTreePath* ep = NULL;
	GtkTreeIter iter = {0};
	gboolean valid_iter = FALSE;
	GOFFile* file = NULL;
	GList* visible_files = NULL;
	guint actually_visible = 0U;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp42_ = FALSE;
	gboolean result = FALSE;
	visible_files = NULL;
	actually_visible = (guint) 0;
	_tmp2_ = fm_abstract_directory_view_get_visible_range (self, &_tmp0_, &_tmp1_);
	__vala_GtkTreePath_free0 (start_path);
	start_path = _tmp0_;
	__vala_GtkTreePath_free0 (end_path);
	end_path = _tmp1_;
	if (_tmp2_) {
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreePath* _tmp6_;
		gint count = 0;
		FMListModel* _tmp12_;
		GtkTreePath* _tmp13_;
		GtkTreeIter _tmp14_ = {0};
		gboolean _tmp15_;
		_tmp3_ = start_path;
		_tmp4_ = __vala_GtkTreePath_copy0 (_tmp3_);
		__vala_GtkTreePath_free0 (sp);
		sp = _tmp4_;
		_tmp5_ = end_path;
		_tmp6_ = __vala_GtkTreePath_copy0 (_tmp5_);
		__vala_GtkTreePath_free0 (ep);
		ep = _tmp6_;
		count = 50;
		while (TRUE) {
			gboolean _tmp7_ = FALSE;
			GtkTreePath* _tmp8_;
			gint _tmp9_;
			_tmp8_ = start_path;
			if (gtk_tree_path_prev (_tmp8_)) {
				_tmp7_ = count > 0;
			} else {
				_tmp7_ = FALSE;
			}
			if (!_tmp7_) {
				break;
			}
			_tmp9_ = count;
			count = _tmp9_ - 1;
		}
		count = 50;
		while (TRUE) {
			GtkTreePath* _tmp10_;
			gint _tmp11_;
			if (!(count > 0)) {
				break;
			}
			_tmp10_ = end_path;
			gtk_tree_path_next (_tmp10_);
			_tmp11_ = count;
			count = _tmp11_ - 1;
		}
		_tmp12_ = self->model;
		_tmp13_ = start_path;
		_tmp15_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp12_, &_tmp14_, _tmp13_);
		iter = _tmp14_;
		valid_iter = _tmp15_;
		while (TRUE) {
			gboolean _tmp16_ = FALSE;
			FMListModel* _tmp17_;
			GtkTreeIter _tmp18_;
			GOFFile* _tmp19_;
			FMListModel* _tmp20_;
			GtkTreeIter _tmp21_;
			GtkTreePath* _tmp22_;
			gboolean _tmp23_ = FALSE;
			GOFFile* _tmp24_;
			GtkTreePath* _tmp39_;
			GtkTreePath* _tmp40_;
			if (valid_iter) {
				_tmp16_ = self->priv->thumbnail_source_id > ((guint) 0);
			} else {
				_tmp16_ = FALSE;
			}
			if (!_tmp16_) {
				break;
			}
			_tmp17_ = self->model;
			_tmp18_ = iter;
			_tmp19_ = fm_list_model_file_for_iter (_tmp17_, &_tmp18_);
			_g_object_unref0 (file);
			file = _tmp19_;
			_tmp20_ = self->model;
			_tmp21_ = iter;
			_tmp22_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp20_, &_tmp21_);
			__vala_GtkTreePath_free0 (path);
			path = _tmp22_;
			_tmp24_ = file;
			if (_tmp24_ != NULL) {
				GOFFile* _tmp25_;
				_tmp25_ = file;
				_tmp23_ = !_tmp25_->is_gone;
			} else {
				_tmp23_ = FALSE;
			}
			if (_tmp23_) {
				GOFFile* _tmp26_;
				GOFFile* _tmp27_;
				_tmp26_ = file;
				gof_file_query_thumbnail_update (_tmp26_);
				_tmp27_ = file;
				if (_tmp27_->thumbstate == ((guint) GOF_FILE_THUMB_STATE_UNKNOWN)) {
					GOFFile* _tmp28_;
					GOFFile* _tmp29_;
					MarlinPluginManager* _tmp30_;
					gboolean _tmp33_ = FALSE;
					GtkTreePath* _tmp34_;
					GtkTreePath* _tmp35_;
					_tmp28_ = file;
					_tmp29_ = _g_object_ref0 (_tmp28_);
					visible_files = g_list_prepend (visible_files, _tmp29_);
					_tmp30_ = plugins;
					if (_tmp30_ != NULL) {
						MarlinPluginManager* _tmp31_;
						GOFFile* _tmp32_;
						_tmp31_ = plugins;
						_tmp32_ = file;
						marlin_plugin_manager_update_file_info (_tmp31_, _tmp32_);
					}
					_tmp34_ = path;
					_tmp35_ = sp;
					if (gtk_tree_path_compare (_tmp34_, _tmp35_) >= 0) {
						GtkTreePath* _tmp36_;
						GtkTreePath* _tmp37_;
						_tmp36_ = path;
						_tmp37_ = ep;
						_tmp33_ = gtk_tree_path_compare (_tmp36_, _tmp37_) <= 0;
					} else {
						_tmp33_ = FALSE;
					}
					if (_tmp33_) {
						guint _tmp38_;
						_tmp38_ = actually_visible;
						actually_visible = _tmp38_ + 1;
					}
				}
			}
			_tmp39_ = path;
			_tmp40_ = end_path;
			if (gtk_tree_path_compare (_tmp39_, _tmp40_) != 0) {
				gboolean _tmp41_;
				_tmp41_ = fm_abstract_directory_view_get_next_visible_iter (self, &iter, TRUE);
				valid_iter = _tmp41_;
			} else {
				valid_iter = FALSE;
			}
		}
	}
	if (actually_visible > ((guint) 0)) {
		_tmp42_ = self->priv->thumbnail_source_id > ((guint) 0);
	} else {
		_tmp42_ = FALSE;
	}
	if (_tmp42_) {
		MarlinThumbnailer* _tmp43_;
		GList* _tmp44_;
		gint _tmp45_ = 0;
		_tmp43_ = self->priv->thumbnailer;
		_tmp44_ = visible_files;
		marlin_thumbnailer_queue_files (_tmp43_, _tmp44_, &_tmp45_, self->large_thumbnails);
		self->priv->thumbnail_request = _tmp45_;
	} else {
		fm_abstract_directory_view_draw_when_idle (self);
	}
	self->priv->thumbnail_source_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	(visible_files == NULL) ? NULL : (visible_files = (_g_list_free__g_object_unref0_ (visible_files), NULL));
	_g_object_unref0 (file);
	__vala_GtkTreePath_free0 (ep);
	__vala_GtkTreePath_free0 (sp);
	__vala_GtkTreePath_free0 (path);
	__vala_GtkTreePath_free0 (end_path);
	__vala_GtkTreePath_free0 (start_path);
	return result;
}

static gboolean
___lambda52__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda52_ ((FMAbstractDirectoryView*) self);
	return result;
}

static void
fm_abstract_directory_view_schedule_thumbnail_timeout (FMAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	MarlinViewSlot* _tmp1_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	guint delay = 0U;
	MarlinViewSlot* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->slot;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, GOF_TYPE_ABSTRACT_SLOT)) {
		MarlinViewSlot* _tmp2_;
		GOFDirectoryAsync* _tmp3_;
		GOFDirectoryAsync* _tmp4_;
		_tmp2_ = self->slot;
		_tmp3_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_assert (_tmp0_, "slot is GOF.AbstractSlot && slot.directory != null");
	if (self->priv->thumbnail_source_id != ((guint) 0)) {
		_tmp8_ = TRUE;
	} else {
		gboolean _tmp9_ = FALSE;
		MarlinViewSlot* _tmp10_;
		GOFDirectoryAsync* _tmp11_;
		GOFDirectoryAsync* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp10_ = self->slot;
		_tmp11_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = gof_directory_async_get_is_local (_tmp12_);
		_tmp14_ = _tmp13_;
		if (!_tmp14_) {
			gboolean _tmp15_;
			_tmp15_ = self->priv->_show_remote_thumbnails;
			_tmp9_ = !_tmp15_;
		} else {
			_tmp9_ = FALSE;
		}
		_tmp8_ = _tmp9_;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		gboolean _tmp16_ = FALSE;
		MarlinViewSlot* _tmp17_;
		GOFDirectoryAsync* _tmp18_;
		GOFDirectoryAsync* _tmp19_;
		gboolean _tmp20_;
		gboolean _tmp21_;
		_tmp17_ = self->slot;
		_tmp18_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = gof_directory_async_get_is_local (_tmp19_);
		_tmp21_ = _tmp20_;
		if (_tmp21_) {
			gboolean _tmp22_;
			_tmp22_ = self->priv->_hide_local_thumbnails;
			_tmp16_ = _tmp22_;
		} else {
			_tmp16_ = FALSE;
		}
		_tmp7_ = _tmp16_;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		MarlinViewSlot* _tmp23_;
		GOFDirectoryAsync* _tmp24_;
		GOFDirectoryAsync* _tmp25_;
		gboolean _tmp26_;
		gboolean _tmp27_;
		_tmp23_ = self->slot;
		_tmp24_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = gof_directory_async_get_can_open_files (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp6_ = !_tmp27_;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		MarlinViewSlot* _tmp28_;
		GOFDirectoryAsync* _tmp29_;
		GOFDirectoryAsync* _tmp30_;
		_tmp28_ = self->slot;
		_tmp29_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp28_);
		_tmp30_ = _tmp29_;
		_tmp5_ = gof_directory_async_is_loading (_tmp30_);
	}
	if (_tmp5_) {
		return;
	}
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->thumbnail_source_id);
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->freeze_source_id);
	fm_abstract_directory_view_freeze_child_notify (self);
	self->priv->freeze_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda51__gsource_func, g_object_ref (self), g_object_unref);
	_tmp31_ = self->slot;
	_tmp32_ = marlin_view_slot_get_displayed_files_count (_tmp31_);
	_tmp33_ = _tmp32_;
	delay = MIN ((guint) (50 + (_tmp33_ / 10)), (guint) 500);
	self->priv->thumbnail_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, delay, ___lambda52__gsource_func, g_object_ref (self), g_object_unref);
}

static gboolean
__lambda53_ (FMAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
	gboolean result = FALSE;
	self->priv->draw_timeout_id = (guint) 0;
	_tmp0_ = self->priv->view;
	gtk_widget_queue_draw (_tmp0_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda53__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda53_ ((FMAbstractDirectoryView*) self);
	return result;
}

static void
fm_abstract_directory_view_draw_when_idle (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->draw_timeout_id > ((guint) 0)) {
		return;
	}
	self->priv->draw_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda53__gsource_func, g_object_ref (self), g_object_unref);
}

void
fm_abstract_directory_view_block_model (FMAbstractDirectoryView* self)
{
	FMListModel* _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->model;
	g_signal_parse_name ("row-deleted", gtk_tree_model_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkTreeModel*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self);
}

void
fm_abstract_directory_view_unblock_model (FMAbstractDirectoryView* self)
{
	FMListModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->model;
	g_signal_connect_object ((GtkTreeModel*) _tmp0_, "row-deleted", (GCallback) _fm_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self, 0);
}

static GtkWidget*
fm_abstract_directory_view_get_real_view (FMAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_bin_get_type ()) ? ((GtkBin*) self) : NULL);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
_fm_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                            GdkEventButton* event,
                                                                                            gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_drag_timeout_button_release ((FMAbstractDirectoryView*) self, event);
	return result;
}

static gboolean
_fm_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                          GdkEventMotion* event,
                                                                                          gpointer self)
{
	gboolean result;
	result = fm_abstract_directory_view_on_drag_timeout_motion_notify ((FMAbstractDirectoryView*) self, event);
	return result;
}

static void
fm_abstract_directory_view_connect_drag_timeout_motion_and_release_events (FMAbstractDirectoryView* self)
{
	GtkWidget* real_view = NULL;
	GtkWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_real_view (self);
	real_view = _tmp0_;
	g_signal_connect_object (real_view, "button-release-event", (GCallback) _fm_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event, self, 0);
	g_signal_connect_object (real_view, "motion-notify-event", (GCallback) _fm_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event, self, 0);
	_g_object_unref0 (real_view);
}

static void
fm_abstract_directory_view_disconnect_drag_timeout_motion_and_release_events (FMAbstractDirectoryView* self)
{
	GtkWidget* real_view = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	guint _tmp2_;
	GtkWidget* _tmp3_;
	guint _tmp4_;
	g_return_if_fail (self != NULL);
	if (self->priv->drag_timer_id == ((guint) 0)) {
		return;
	}
	_tmp0_ = fm_abstract_directory_view_get_real_view (self);
	real_view = _tmp0_;
	_tmp1_ = real_view;
	g_signal_parse_name ("button-release-event", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event, self);
	_tmp3_ = real_view;
	g_signal_parse_name ("motion-notify-event", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event, self);
	_g_object_unref0 (real_view);
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
	g_atomic_int_inc (&_data34_->_ref_count_);
	return _data34_;
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data34_->self;
		_g_object_unref0 (_data34_->context);
		_g_object_unref0 (self);
		g_slice_free (Block34Data, _data34_);
	}
}

static gboolean
__lambda90_ (Block34Data* _data34_)
{
	FMAbstractDirectoryView* self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gboolean result = FALSE;
	self = _data34_->self;
	_tmp0_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_bin_get_type ()) ? ((GtkBin*) self) : NULL);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	widget = _tmp1_;
	_tmp2_ = widget;
	if (_tmp2_ != NULL) {
		GdkDevice* pointer = NULL;
		GdkDevice* _tmp3_;
		GdkDevice* _tmp4_;
		GdkWindow* window = NULL;
		GtkWidget* _tmp5_;
		GdkWindow* _tmp6_;
		GdkWindow* _tmp7_;
		gint x = 0;
		gint y = 0;
		gint w = 0;
		gint h = 0;
		GdkWindow* _tmp8_;
		GdkDevice* _tmp9_;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		GdkWindow* _tmp12_;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		GtkAdjustment* _tmp15_;
		GtkAdjustment* _tmp16_;
		_tmp3_ = gdk_drag_context_get_device (_data34_->context);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		pointer = _tmp4_;
		_tmp5_ = widget;
		_tmp6_ = gtk_widget_get_window (_tmp5_);
		_tmp7_ = _g_object_ref0 (_tmp6_);
		window = _tmp7_;
		_tmp8_ = window;
		_tmp9_ = pointer;
		gdk_window_get_device_position (_tmp8_, _tmp9_, &_tmp10_, &_tmp11_, NULL);
		x = _tmp10_;
		y = _tmp11_;
		_tmp12_ = window;
		gdk_window_get_geometry (_tmp12_, NULL, NULL, &_tmp13_, &_tmp14_);
		w = _tmp13_;
		h = _tmp14_;
		_tmp15_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
		fm_abstract_directory_view_scroll_if_near_edge (self, y, h, 20, _tmp15_);
		_tmp16_ = gtk_scrolled_window_get_hadjustment ((GtkScrolledWindow*) self);
		fm_abstract_directory_view_scroll_if_near_edge (self, x, w, 20, _tmp16_);
		result = G_SOURCE_CONTINUE;
		_g_object_unref0 (window);
		_g_object_unref0 (pointer);
		_g_object_unref0 (widget);
		return result;
	} else {
		result = G_SOURCE_REMOVE;
		_g_object_unref0 (widget);
		return result;
	}
	_g_object_unref0 (widget);
}

static gboolean
___lambda90__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda90_ (self);
	return result;
}

static void
fm_abstract_directory_view_start_drag_scroll_timer (FMAbstractDirectoryView* self,
                                                    GdkDragContext* context)
{
	Block34Data* _data34_;
	GdkDragContext* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_data34_ = g_slice_new0 (Block34Data);
	_data34_->_ref_count_ = 1;
	_data34_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (context);
	_g_object_unref0 (_data34_->context);
	_data34_->context = _tmp0_;
	self->priv->drag_scroll_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 50, ___lambda90__gsource_func, block34_data_ref (_data34_), block34_data_unref);
	block34_data_unref (_data34_);
	_data34_ = NULL;
}

static void
fm_abstract_directory_view_scroll_if_near_edge (FMAbstractDirectoryView* self,
                                                gint pos,
                                                gint dim,
                                                gint threshold,
                                                GtkAdjustment* adj)
{
	gint band = 0;
	gint offset = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (adj != NULL);
	band = 2 * threshold;
	offset = pos - band;
	if (offset > 0) {
		offset = MAX (band - (dim - pos), 0);
	}
	if (offset != 0) {
		gdouble val = 0.0;
		gdouble lower = 0.0;
		gdouble upper = 0.0;
		gdouble page = 0.0;
		val = gtk_adjustment_get_value (adj);
		lower = gtk_adjustment_get_lower (adj);
		upper = gtk_adjustment_get_upper (adj);
		page = gtk_adjustment_get_page_size (adj);
		val = CLAMP (val + (2 * offset), lower, upper - page);
		gtk_adjustment_set_value (adj, val);
	}
}

static void
fm_abstract_directory_view_remove_marlin_icon_info_cache (FMAbstractDirectoryView* self,
                                                          GOFFile* file)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = gof_file_get_thumbnail_path (file);
	_tmp1_ = g_strdup (_tmp0_);
	path = _tmp1_;
	_tmp2_ = path;
	if (_tmp2_ != NULL) {
		MarlinIconSize s = 0;
		{
			gint z = 0;
			z = (gint) MARLIN_ZOOM_LEVEL_SMALLEST;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					const gchar* _tmp5_;
					MarlinIconSize _tmp6_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = z;
						z = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					if (!(z <= ((gint) MARLIN_ZOOM_LEVEL_LARGEST))) {
						break;
					}
					s = marlin_zoom_level_to_icon_size ((MarlinZoomLevel) z);
					_tmp5_ = path;
					_tmp6_ = s;
					marlin_icon_info_remove_cache (_tmp5_, (gint) _tmp6_, gtk_widget_get_scale_factor ((GtkWidget*) self));
				}
			}
		}
	}
	_g_free0 (path);
}

static Block35Data*
block35_data_ref (Block35Data* _data35_)
{
	g_atomic_int_inc (&_data35_->_ref_count_);
	return _data35_;
}

static void
block35_data_unref (void * _userdata_)
{
	Block35Data* _data35_;
	_data35_ = (Block35Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data35_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data35_->self;
		(_data35_->action_files == NULL) ? NULL : (_data35_->action_files = (_g_list_free__g_object_unref0_ (_data35_->action_files), NULL));
		_g_object_unref0 (self);
		g_slice_free (Block35Data, _data35_);
	}
}

static void
____lambda35_ (Block35Data* _data35_,
               GOFFile* file)
{
	FMAbstractDirectoryView* self;
	GOFFile* goffile = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GOFFile* _tmp2_;
	GOFFile* _tmp3_;
	GOFFile* _tmp4_;
	self = _data35_->self;
	g_return_if_fail (file != NULL);
	_tmp0_ = gof_file_get_display_target_uri (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = gof_file_get_by_uri (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	goffile = _tmp3_;
	gof_file_query_update (goffile);
	_tmp4_ = _g_object_ref0 (goffile);
	_data35_->action_files = g_list_append (_data35_->action_files, _tmp4_);
	_g_object_unref0 (goffile);
}

static void
_____lambda35__gfunc (gconstpointer data,
                      gpointer self)
{
	____lambda35_ (self, (GOFFile*) data);
}

static GList*
fm_abstract_directory_view_get_files_for_action (FMAbstractDirectoryView* self)
{
	Block35Data* _data35_;
	GList* _tmp0_;
	GList* _tmp11_;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data35_ = g_slice_new0 (Block35Data);
	_data35_->_ref_count_ = 1;
	_data35_->self = g_object_ref (self);
	_data35_->action_files = NULL;
	fm_abstract_directory_view_update_selected_files_and_menu (self);
	_tmp0_ = self->selected_files;
	if (_tmp0_ == NULL) {
		MarlinViewSlot* _tmp1_;
		GOFDirectoryAsync* _tmp2_;
		GOFDirectoryAsync* _tmp3_;
		GOFFile* _tmp4_;
		GOFFile* _tmp5_;
		GOFFile* _tmp6_;
		_tmp1_ = self->slot;
		_tmp2_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = gof_directory_async_get_file (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_data35_->action_files = g_list_prepend (_data35_->action_files, _tmp6_);
	} else {
		gboolean _tmp7_;
		_tmp7_ = self->priv->_in_recent;
		if (_tmp7_) {
			GList* _tmp8_;
			_tmp8_ = self->selected_files;
			g_list_foreach (_tmp8_, _____lambda35__gfunc, _data35_);
		} else {
			GList* _tmp9_;
			GList* _tmp10_;
			_tmp9_ = self->selected_files;
			_tmp10_ = g_list_copy_deep (_tmp9_, (GCopyFunc) g_object_ref, NULL);
			(_data35_->action_files == NULL) ? NULL : (_data35_->action_files = (_g_list_free__g_object_unref0_ (_data35_->action_files), NULL));
			_data35_->action_files = _tmp10_;
		}
	}
	_tmp11_ = _data35_->action_files;
	_data35_->action_files = NULL;
	result = _tmp11_;
	block35_data_unref (_data35_);
	_data35_ = NULL;
	return result;
}

void
fm_abstract_directory_view_on_view_items_activated (FMAbstractDirectoryView* self)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_selected_files (self);
	fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_DEFAULT, _tmp0_);
}

void
fm_abstract_directory_view_on_view_selection_changed (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	self->priv->selected_files_invalid = TRUE;
}

/** Returns true if the code parameter matches the keycode of the keyval parameter for
          * any keyboard group or level (in order to allow for non-QWERTY keyboards) **/
gboolean
fm_abstract_directory_view_match_keycode (FMAbstractDirectoryView* self,
                                          guint keyval,
                                          guint code,
                                          gint level)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkKeymap* keymap = NULL;
	GdkDisplay* _tmp0_;
	GdkKeymap* _tmp1_;
	GdkKeymap* _tmp2_;
	GdkKeymap* _tmp3_;
	GdkKeymapKey* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = gdk_keymap_get_for_display (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	keymap = _tmp2_;
	_tmp3_ = keymap;
	_tmp6_ = gdk_keymap_get_entries_for_keyval (_tmp3_, keyval, &_tmp4_, &_tmp5_);
	keys = (g_free (keys), NULL);
	keys = _tmp4_;
	keys_length1 = _tmp5_;
	_keys_size_ = keys_length1;
	if (_tmp6_) {
		GdkKeymapKey* _tmp7_;
		gint _tmp7__length1;
		_tmp7_ = keys;
		_tmp7__length1 = keys_length1;
		{
			GdkKeymapKey* key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
			key_collection = _tmp7_;
			key_collection_length1 = _tmp7__length1;
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
				GdkKeymapKey key = {0};
				key = key_collection[key_it];
				{
					gboolean _tmp8_ = FALSE;
					GdkKeymapKey _tmp9_;
					_tmp9_ = key;
					if (code == _tmp9_.keycode) {
						GdkKeymapKey _tmp10_;
						_tmp10_ = key;
						_tmp8_ = level == _tmp10_.level;
					} else {
						_tmp8_ = FALSE;
					}
					if (_tmp8_) {
						result = TRUE;
						_g_object_unref0 (keymap);
						keys = (g_free (keys), NULL);
						return result;
					}
				}
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (keymap);
	keys = (g_free (keys), NULL);
	return result;
}

static gboolean
__lambda50_ (FMAbstractDirectoryView* self)
{
	gboolean result = FALSE;
	fm_abstract_directory_view_update_selected_files_and_menu (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda50__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda50_ ((FMAbstractDirectoryView*) self);
	return result;
}

static gboolean
fm_abstract_directory_view_real_on_view_key_press_event (FMAbstractDirectoryView* self,
                                                         GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	guint keyval = 0U;
	GdkModifierType consumed_mods = 0U;
	GdkModifierType mods = 0U;
	GdkModifierType _tmp13_;
	GdkModifierType _tmp14_;
	gboolean no_mods = FALSE;
	GdkModifierType _tmp15_;
	gboolean shift_pressed = FALSE;
	GdkModifierType _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean only_shift_pressed = FALSE;
	gboolean control_pressed = FALSE;
	GdkModifierType _tmp19_;
	gboolean alt_pressed = FALSE;
	GdkModifierType _tmp20_;
	gboolean other_mod_pressed = FALSE;
	GdkModifierType _tmp21_;
	gboolean _tmp22_ = FALSE;
	gboolean only_control_pressed = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean only_alt_pressed = FALSE;
	gboolean in_trash = FALSE;
	MarlinViewSlot* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	gboolean in_recent = FALSE;
	MarlinViewSlot* _tmp28_;
	GFile* _tmp29_;
	GFile* _tmp30_;
	gboolean res = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->is_modifier == ((guint) 1);
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	fm_abstract_directory_view_cancel_hover (self);
	keyval = event->keyval;
	consumed_mods = 0;
	if (keyval > ((guint) 127)) {
		gint eff_grp = 0;
		gint level = 0;
		GdkDisplay* _tmp3_;
		GdkKeymap* _tmp4_;
		GdkModifierType _tmp5_;
		guint _tmp6_ = 0U;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		GdkModifierType _tmp9_ = 0U;
		gboolean _tmp10_;
		_tmp3_ = gtk_widget_get_display ((GtkWidget*) self);
		_tmp4_ = gdk_keymap_get_for_display (_tmp3_);
		_tmp5_ = event->state;
		_tmp10_ = gdk_keymap_translate_keyboard_state (_tmp4_, (guint) event->hardware_keycode, _tmp5_, (gint) event->group, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
		keyval = _tmp6_;
		eff_grp = _tmp7_;
		level = _tmp8_;
		consumed_mods = _tmp9_;
		if (!_tmp10_) {
			g_warning ("AbstractDirectoryView.vala:2797: translate keyboard state failed");
			keyval = event->keyval;
			consumed_mods = 0;
		} else {
			keyval = (guint) 0;
			{
				guint key = 0U;
				key = (guint) 32;
				{
					gboolean _tmp11_ = FALSE;
					_tmp11_ = TRUE;
					while (TRUE) {
						if (!_tmp11_) {
							guint _tmp12_;
							_tmp12_ = key;
							key = _tmp12_ + 1;
						}
						_tmp11_ = FALSE;
						if (!(key < ((guint) 128))) {
							break;
						}
						if (fm_abstract_directory_view_match_keycode (self, key, (guint) event->hardware_keycode, level)) {
							keyval = key;
							break;
						}
					}
				}
			}
			if (keyval == ((guint) 0)) {
				g_debug ("AbstractDirectoryView.vala:2810: Could not match hardware code to ASCI" \
"I hotkey");
				keyval = event->keyval;
				consumed_mods = 0;
			}
		}
	}
	_tmp13_ = event->state;
	_tmp14_ = consumed_mods;
	mods = (_tmp13_ & (~_tmp14_)) & gtk_accelerator_get_default_mod_mask ();
	_tmp15_ = mods;
	no_mods = _tmp15_ == 0;
	_tmp16_ = mods;
	shift_pressed = (_tmp16_ & GDK_SHIFT_MASK) != 0;
	if (shift_pressed) {
		GdkModifierType _tmp18_;
		_tmp18_ = mods;
		_tmp17_ = (_tmp18_ & (~GDK_SHIFT_MASK)) == 0;
	} else {
		_tmp17_ = FALSE;
	}
	only_shift_pressed = _tmp17_;
	_tmp19_ = mods;
	control_pressed = (_tmp19_ & GDK_CONTROL_MASK) != 0;
	_tmp20_ = mods;
	alt_pressed = (_tmp20_ & GDK_MOD1_MASK) != 0;
	_tmp21_ = mods;
	other_mod_pressed = ((_tmp21_ & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
	if (control_pressed) {
		_tmp22_ = !other_mod_pressed;
	} else {
		_tmp22_ = FALSE;
	}
	only_control_pressed = _tmp22_;
	if (alt_pressed) {
		GdkModifierType _tmp24_;
		_tmp24_ = mods;
		_tmp23_ = (_tmp24_ & (~GDK_MOD1_MASK)) == 0;
	} else {
		_tmp23_ = FALSE;
	}
	only_alt_pressed = _tmp23_;
	_tmp25_ = self->slot;
	_tmp26_ = gof_abstract_slot_get_location ((GOFAbstractSlot*) _tmp25_);
	_tmp27_ = _tmp26_;
	in_trash = g_file_has_uri_scheme (_tmp27_, "trash");
	_tmp28_ = self->slot;
	_tmp29_ = gof_abstract_slot_get_location ((GOFAbstractSlot*) _tmp28_);
	_tmp30_ = _tmp29_;
	in_recent = g_file_has_uri_scheme (_tmp30_, "recent");
	res = FALSE;
	switch (keyval) {
		case GDK_KEY_F10:
		{
			if (only_control_pressed) {
				fm_abstract_directory_view_show_context_menu (self, (GdkEvent*) event);
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_F2:
		{
			gboolean _tmp31_ = FALSE;
			if (no_mods) {
				GSimpleActionGroup* _tmp32_;
				_tmp32_ = self->priv->selection_actions;
				_tmp31_ = g_action_group_get_action_enabled ((GActionGroup*) _tmp32_, "rename");
			} else {
				_tmp31_ = FALSE;
			}
			if (_tmp31_) {
				fm_abstract_directory_view_rename_selected_file (self);
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_Delete:
		case GDK_KEY_KP_Delete:
		{
			if (!self->is_writable) {
				MarlinViewWindow* _tmp33_;
				GraniteMessageDialog* _tmp34_;
				GraniteMessageDialog* _tmp35_;
				_tmp33_ = self->window;
				_tmp34_ = pf_dialogs_show_warning_dialog (_ ("Cannot remove files from here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp33_) : NULL);
				_tmp35_ = _tmp34_;
				_g_object_unref0 (_tmp35_);
			} else {
				gboolean _tmp36_;
				_tmp36_ = self->priv->_renaming;
				if (!_tmp36_) {
					gboolean _tmp37_ = FALSE;
					gboolean _tmp38_ = FALSE;
					if (in_trash) {
						_tmp38_ = TRUE;
					} else {
						gboolean _tmp39_;
						gboolean _tmp40_;
						_tmp39_ = fm_abstract_directory_view_get_is_admin (self);
						_tmp40_ = _tmp39_;
						_tmp38_ = _tmp40_;
					}
					if (_tmp38_) {
						_tmp37_ = TRUE;
					} else {
						_tmp37_ = only_shift_pressed;
					}
					fm_abstract_directory_view_trash_or_delete_selected_files (self, _tmp37_);
					res = TRUE;
				}
			}
			break;
		}
		case GDK_KEY_space:
		{
			gboolean _tmp41_ = FALSE;
			if (fm_abstract_directory_view_view_has_focus (self)) {
				_tmp41_ = !in_trash;
			} else {
				_tmp41_ = FALSE;
			}
			if (_tmp41_) {
				GList* _tmp42_;
				_tmp42_ = fm_abstract_directory_view_get_selected_files (self);
				fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_NEW_TAB, _tmp42_);
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_Return:
		case GDK_KEY_KP_Enter:
		{
			if (in_trash) {
				break;
			} else {
				if (in_recent) {
					GList* _tmp43_;
					_tmp43_ = fm_abstract_directory_view_get_selected_files (self);
					fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_DEFAULT, _tmp43_);
				} else {
					if (only_shift_pressed) {
						GList* _tmp44_;
						_tmp44_ = fm_abstract_directory_view_get_selected_files (self);
						fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_NEW_TAB, _tmp44_);
					} else {
						if (only_alt_pressed) {
							GSimpleActionGroup* _tmp45_;
							_tmp45_ = self->priv->common_actions;
							g_action_group_activate_action ((GActionGroup*) _tmp45_, "properties", NULL);
						} else {
							if (no_mods) {
								GList* _tmp46_;
								_tmp46_ = fm_abstract_directory_view_get_selected_files (self);
								fm_abstract_directory_view_activate_selected_items (self, MARLIN_OPEN_FLAG_DEFAULT, _tmp46_);
							} else {
								break;
							}
						}
					}
				}
			}
			res = TRUE;
			break;
		}
		case GDK_KEY_minus:
		{
			gboolean _tmp47_ = FALSE;
			if (alt_pressed) {
				_tmp47_ = control_pressed;
			} else {
				_tmp47_ = FALSE;
			}
			if (_tmp47_) {
				GtkTreePath* path = NULL;
				GtkTreePath* _tmp48_;
				gboolean _tmp49_ = FALSE;
				GtkTreePath* _tmp50_;
				_tmp48_ = fm_abstract_directory_view_get_path_at_cursor (self);
				path = _tmp48_;
				_tmp50_ = path;
				if (_tmp50_ != NULL) {
					GtkTreePath* _tmp51_;
					_tmp51_ = path;
					_tmp49_ = fm_abstract_directory_view_path_is_selected (self, _tmp51_);
				} else {
					_tmp49_ = FALSE;
				}
				if (_tmp49_) {
					GtkTreePath* _tmp52_;
					_tmp52_ = path;
					fm_abstract_directory_view_unselect_path (self, _tmp52_);
				}
				res = TRUE;
				__vala_GtkTreePath_free0 (path);
			}
			break;
		}
		case GDK_KEY_plus:
		case GDK_KEY_equal:
		{
			gboolean _tmp53_ = FALSE;
			if (alt_pressed) {
				_tmp53_ = control_pressed;
			} else {
				_tmp53_ = FALSE;
			}
			if (_tmp53_) {
				GtkTreePath* path = NULL;
				GtkTreePath* _tmp54_;
				gboolean _tmp55_ = FALSE;
				GtkTreePath* _tmp56_;
				_tmp54_ = fm_abstract_directory_view_get_path_at_cursor (self);
				path = _tmp54_;
				_tmp56_ = path;
				if (_tmp56_ != NULL) {
					GtkTreePath* _tmp57_;
					_tmp57_ = path;
					_tmp55_ = !fm_abstract_directory_view_path_is_selected (self, _tmp57_);
				} else {
					_tmp55_ = FALSE;
				}
				if (_tmp55_) {
					GtkTreePath* _tmp58_;
					_tmp58_ = path;
					fm_abstract_directory_view_select_path (self, _tmp58_, FALSE);
				}
				res = TRUE;
				__vala_GtkTreePath_free0 (path);
			}
			break;
		}
		case GDK_KEY_Escape:
		{
			if (no_mods) {
				fm_abstract_directory_view_unselect_all (self);
			}
			break;
		}
		case GDK_KEY_Menu:
		case GDK_KEY_MenuKB:
		{
			if (no_mods) {
				fm_abstract_directory_view_show_context_menu (self, (GdkEvent*) event);
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_N:
		{
			if (control_pressed) {
				fm_abstract_directory_view_new_empty_folder (self);
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_a:
		{
			if (control_pressed) {
				fm_abstract_directory_view_update_selected_files_and_menu (self);
				if (self->priv->all_selected) {
					fm_abstract_directory_view_unselect_all (self);
				} else {
					fm_abstract_directory_view_select_all (self);
				}
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_A:
		{
			if (control_pressed) {
				fm_abstract_directory_view_invert_selection (self);
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_Up:
		case GDK_KEY_Down:
		case GDK_KEY_Left:
		case GDK_KEY_Right:
		{
			GList* selection = NULL;
			GList* _tmp59_;
			gboolean _tmp60_ = FALSE;
			_tmp59_ = fm_abstract_directory_view_get_selected_files (self);
			selection = _tmp59_;
			if (only_alt_pressed) {
				_tmp60_ = keyval == GDK_KEY_Down;
			} else {
				_tmp60_ = FALSE;
			}
			if (_tmp60_) {
				gboolean _tmp61_ = FALSE;
				gboolean _tmp62_ = FALSE;
				GList* _tmp63_;
				_tmp63_ = selection;
				if (_tmp63_ != NULL) {
					GList* _tmp64_;
					GList* _tmp65_;
					GList* _tmp66_;
					_tmp64_ = selection;
					_tmp65_ = g_list_first (_tmp64_);
					_tmp66_ = _tmp65_->next;
					_tmp62_ = _tmp66_ == NULL;
				} else {
					_tmp62_ = FALSE;
				}
				if (_tmp62_) {
					GList* _tmp67_;
					gconstpointer _tmp68_;
					_tmp67_ = selection;
					_tmp68_ = _tmp67_->data;
					_tmp61_ = gof_file_is_folder ((GOFFile*) _tmp68_);
				} else {
					_tmp61_ = FALSE;
				}
				if (_tmp61_) {
					GList* _tmp69_;
					gconstpointer _tmp70_;
					GFile* _tmp71_;
					_tmp69_ = selection;
					_tmp70_ = _tmp69_->data;
					_tmp71_ = ((GOFFile*) _tmp70_)->location;
					fm_abstract_directory_view_load_location (self, _tmp71_);
					res = TRUE;
				}
				break;
			}
			res = fm_abstract_directory_view_move_cursor (self, keyval, only_shift_pressed, control_pressed);
			break;
		}
		case GDK_KEY_Home:
		{
			gboolean _tmp72_ = FALSE;
			if (only_shift_pressed) {
				GtkTreePath* _tmp73_;
				GtkTreePath* _tmp74_;
				_tmp73_ = gtk_tree_path_new_from_indices (0, -1);
				_tmp74_ = _tmp73_;
				_tmp72_ = fm_abstract_directory_view_handle_multi_select (self, _tmp74_);
				__vala_GtkTreePath_free0 (_tmp74_);
			} else {
				_tmp72_ = FALSE;
			}
			res = _tmp72_;
			break;
		}
		case GDK_KEY_End:
		{
			gboolean _tmp75_ = FALSE;
			if (only_shift_pressed) {
				FMListModel* _tmp76_;
				GtkTreePath* _tmp77_;
				GtkTreePath* _tmp78_;
				_tmp76_ = self->model;
				_tmp77_ = gtk_tree_path_new_from_indices (fm_list_model_get_length (_tmp76_), -1);
				_tmp78_ = _tmp77_;
				_tmp75_ = fm_abstract_directory_view_handle_multi_select (self, _tmp78_);
				__vala_GtkTreePath_free0 (_tmp78_);
			} else {
				_tmp75_ = FALSE;
			}
			res = _tmp75_;
			break;
		}
		case GDK_KEY_c:
		case GDK_KEY_C:
		{
			if (only_control_pressed) {
				gboolean caps_on = FALSE;
				GdkDisplay* _tmp79_;
				GdkKeymap* _tmp80_;
				gboolean cap_c = FALSE;
				_tmp79_ = gtk_widget_get_display ((GtkWidget*) self);
				_tmp80_ = gdk_keymap_get_for_display (_tmp79_);
				caps_on = gdk_keymap_get_caps_lock_state (_tmp80_);
				cap_c = keyval == GDK_KEY_C;
				if (caps_on != cap_c) {
					GSimpleActionGroup* _tmp81_;
					_tmp81_ = self->priv->common_actions;
					g_action_group_activate_action ((GActionGroup*) _tmp81_, "copy-link", NULL);
				} else {
					if (in_trash) {
						MarlinViewWindow* _tmp82_;
						GraniteMessageDialog* _tmp83_;
						GraniteMessageDialog* _tmp84_;
						GSimpleActionGroup* _tmp85_;
						_tmp82_ = self->window;
						_tmp83_ = pf_dialogs_show_warning_dialog (_ ("Cannot copy files that are in the trash"), _ ("Cutting the selection instead"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp82_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp82_) : NULL);
						_tmp84_ = _tmp83_;
						_g_object_unref0 (_tmp84_);
						_tmp85_ = self->priv->selection_actions;
						g_action_group_activate_action ((GActionGroup*) _tmp85_, "cut", NULL);
					} else {
						GSimpleActionGroup* _tmp86_;
						_tmp86_ = self->priv->common_actions;
						g_action_group_activate_action ((GActionGroup*) _tmp86_, "copy", NULL);
					}
				}
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_v:
		case GDK_KEY_V:
		{
			if (only_control_pressed) {
				gboolean _tmp87_ = FALSE;
				if (!in_recent) {
					_tmp87_ = self->is_writable;
				} else {
					_tmp87_ = FALSE;
				}
				if (_tmp87_) {
					GSimpleActionGroup* _tmp88_;
					GSimpleActionGroup* _tmp89_;
					_tmp88_ = self->priv->common_actions;
					fm_abstract_directory_view_action_set_enabled (self, _tmp88_, "paste-into", TRUE);
					fm_abstract_directory_view_unselect_all (self);
					_tmp89_ = self->priv->common_actions;
					g_action_group_activate_action ((GActionGroup*) _tmp89_, "paste-into", NULL);
				} else {
					MarlinViewWindow* _tmp90_;
					GraniteMessageDialog* _tmp91_;
					GraniteMessageDialog* _tmp92_;
					_tmp90_ = self->window;
					_tmp91_ = pf_dialogs_show_warning_dialog (_ ("Cannot paste files here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp90_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp90_) : NULL);
					_tmp92_ = _tmp91_;
					_g_object_unref0 (_tmp92_);
				}
				res = TRUE;
			}
			break;
		}
		case GDK_KEY_x:
		case GDK_KEY_X:
		{
			if (only_control_pressed) {
				if (self->is_writable) {
					GSimpleActionGroup* _tmp93_;
					_tmp93_ = self->priv->selection_actions;
					g_action_group_activate_action ((GActionGroup*) _tmp93_, "cut", NULL);
				} else {
					MarlinViewWindow* _tmp94_;
					GraniteMessageDialog* _tmp95_;
					GraniteMessageDialog* _tmp96_;
					_tmp94_ = self->window;
					_tmp95_ = pf_dialogs_show_warning_dialog (_ ("Cannot remove files from here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp94_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp94_) : NULL);
					_tmp96_ = _tmp95_;
					_g_object_unref0 (_tmp96_);
				}
				res = TRUE;
			}
			break;
		}
		default:
		{
			break;
		}
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda50__gsource_func, g_object_ref (self), g_object_unref);
	result = res;
	return result;
}

gboolean
fm_abstract_directory_view_on_view_key_press_event (FMAbstractDirectoryView* self,
                                                    GdkEventKey* event)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->on_view_key_press_event (self, event);
}

gboolean
fm_abstract_directory_view_on_motion_notify_event (FMAbstractDirectoryView* self,
                                                   GdkEventMotion* event)
{
	GtkTreePath* path = NULL;
	gboolean _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	guint _tmp2_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GtkTreePath* _tmp16_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	path = NULL;
	_tmp0_ = self->priv->_renaming;
	if (_tmp0_) {
		result = TRUE;
		__vala_GtkTreePath_free0 (path);
		return result;
	}
	_tmp2_ = fm_abstract_directory_view_get_event_position_info (self, (GdkEventButton*) event, &_tmp1_, FALSE);
	__vala_GtkTreePath_free0 (path);
	path = _tmp1_;
	self->click_zone = _tmp2_;
	if (self->click_zone != self->previous_click_zone) {
		GdkWindow* win = NULL;
		GtkWidget* _tmp3_;
		GdkWindow* _tmp4_;
		GdkWindow* _tmp5_;
		_tmp3_ = self->priv->view;
		_tmp4_ = gtk_widget_get_window (_tmp3_);
		_tmp5_ = _g_object_ref0 (_tmp4_);
		win = _tmp5_;
		switch (self->click_zone) {
			case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
			case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
			{
				gboolean _tmp6_;
				_tmp6_ = self->priv->_single_click_mode;
				if (_tmp6_) {
					GdkWindow* _tmp7_;
					GdkCursor* _tmp8_;
					_tmp7_ = win;
					_tmp8_ = self->priv->activatable_cursor;
					gdk_window_set_cursor (_tmp7_, _tmp8_);
				}
				break;
			}
			default:
			{
				GdkWindow* _tmp9_;
				GdkCursor* _tmp10_;
				_tmp9_ = win;
				_tmp10_ = self->priv->selectable_cursor;
				gdk_window_set_cursor (_tmp9_, _tmp10_);
				break;
			}
		}
		self->previous_click_zone = self->click_zone;
		_g_object_unref0 (win);
	}
	_tmp11_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp12_ = _tmp11_;
	if (_tmp12_) {
		result = FALSE;
		__vala_GtkTreePath_free0 (path);
		return result;
	}
	_tmp16_ = path;
	if (_tmp16_ != NULL) {
		GtkTreePath* _tmp17_;
		_tmp17_ = self->priv->hover_path;
		_tmp15_ = _tmp17_ == NULL;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		_tmp14_ = TRUE;
	} else {
		gboolean _tmp18_ = FALSE;
		GtkTreePath* _tmp19_;
		_tmp19_ = path;
		if (_tmp19_ == NULL) {
			GtkTreePath* _tmp20_;
			_tmp20_ = self->priv->hover_path;
			_tmp18_ = _tmp20_ != NULL;
		} else {
			_tmp18_ = FALSE;
		}
		_tmp14_ = _tmp18_;
	}
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_ = FALSE;
		GtkTreePath* _tmp23_;
		_tmp23_ = path;
		if (_tmp23_ != NULL) {
			GtkTreePath* _tmp24_;
			_tmp24_ = self->priv->hover_path;
			_tmp22_ = _tmp24_ != NULL;
		} else {
			_tmp22_ = FALSE;
		}
		if (_tmp22_) {
			GtkTreePath* _tmp25_;
			GtkTreePath* _tmp26_;
			_tmp25_ = path;
			_tmp26_ = self->priv->hover_path;
			_tmp21_ = gtk_tree_path_compare (_tmp25_, _tmp26_) != 0;
		} else {
			_tmp21_ = FALSE;
		}
		_tmp13_ = _tmp21_;
	}
	if (_tmp13_) {
		gboolean _tmp27_ = FALSE;
		MarlinViewSlot* _tmp28_;
		GOFDirectoryAsync* _tmp29_;
		GOFDirectoryAsync* _tmp30_;
		gboolean _tmp31_;
		gboolean _tmp32_;
		_tmp28_ = self->slot;
		_tmp29_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp28_);
		_tmp30_ = _tmp29_;
		_tmp31_ = gof_directory_async_get_is_local (_tmp30_);
		_tmp32_ = _tmp31_;
		if (_tmp32_) {
			_tmp27_ = TRUE;
		} else {
			GNetworkMonitor* _tmp33_;
			_tmp33_ = g_network_monitor_get_default ();
			_tmp27_ = g_network_monitor_get_network_available (_tmp33_);
		}
		if (_tmp27_) {
			GOFFile* target_file = NULL;
			GOFFile* _tmp34_ = NULL;
			GtkTreePath* _tmp35_;
			GOFFile* file = NULL;
			GOFFile* _tmp39_;
			gboolean _tmp40_ = FALSE;
			GOFFile* _tmp41_;
			GOFFile* _tmp54_;
			GtkTreePath* _tmp55_;
			GtkTreePath* _tmp56_;
			_tmp35_ = path;
			if (_tmp35_ != NULL) {
				FMListModel* _tmp36_;
				GtkTreePath* _tmp37_;
				GOFFile* _tmp38_;
				_tmp36_ = self->model;
				_tmp37_ = path;
				_tmp38_ = fm_list_model_file_for_path (_tmp36_, _tmp37_);
				_g_object_unref0 (_tmp34_);
				_tmp34_ = _tmp38_;
			} else {
				_g_object_unref0 (_tmp34_);
				_tmp34_ = NULL;
			}
			_tmp39_ = _g_object_ref0 (_tmp34_);
			file = _tmp39_;
			_tmp41_ = file;
			if (_tmp41_ != NULL) {
				MarlinViewSlot* _tmp42_;
				GOFDirectoryAsync* _tmp43_;
				GOFDirectoryAsync* _tmp44_;
				gboolean _tmp45_;
				gboolean _tmp46_;
				_tmp42_ = self->slot;
				_tmp43_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp42_);
				_tmp44_ = _tmp43_;
				_tmp45_ = gof_directory_async_get_is_recent (_tmp44_);
				_tmp46_ = _tmp45_;
				_tmp40_ = _tmp46_;
			} else {
				_tmp40_ = FALSE;
			}
			if (_tmp40_) {
				GOFFile* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				GOFFile* _tmp50_;
				GOFFile* _tmp51_;
				_tmp47_ = file;
				_tmp48_ = gof_file_get_display_target_uri (_tmp47_);
				_tmp49_ = _tmp48_;
				_tmp50_ = gof_file_get_by_uri (_tmp49_);
				_g_object_unref0 (target_file);
				target_file = _tmp50_;
				_g_free0 (_tmp49_);
				_tmp51_ = target_file;
				gof_file_ensure_query_info (_tmp51_);
			} else {
				GOFFile* _tmp52_;
				GOFFile* _tmp53_;
				_tmp52_ = file;
				_tmp53_ = _g_object_ref0 (_tmp52_);
				_g_object_unref0 (target_file);
				target_file = _tmp53_;
			}
			_tmp54_ = target_file;
			g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_ITEM_HOVERED_SIGNAL], 0, _tmp54_);
			_tmp55_ = path;
			_tmp56_ = __vala_GtkTreePath_copy0 (_tmp55_);
			__vala_GtkTreePath_free0 (self->priv->hover_path);
			self->priv->hover_path = _tmp56_;
			_g_object_unref0 (file);
			_g_object_unref0 (_tmp34_);
			_g_object_unref0 (target_file);
		}
	}
	result = FALSE;
	__vala_GtkTreePath_free0 (path);
	return result;
}

gboolean
fm_abstract_directory_view_on_leave_notify_event (FMAbstractDirectoryView* self,
                                                  GdkEventCrossing* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_ITEM_HOVERED_SIGNAL], 0, NULL);
	__vala_GtkTreePath_free0 (self->priv->hover_path);
	self->priv->hover_path = NULL;
	result = FALSE;
	return result;
}

static gboolean
fm_abstract_directory_view_real_on_scroll_event (FMAbstractDirectoryView* self,
                                                 GdkEventScroll* event)
{
	GdkModifierType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->state;
	if ((_tmp0_ & GDK_CONTROL_MASK) == 0) {
		gdouble increment = 0.0;
		GdkScrollDirection _tmp1_;
		increment = 0.0;
		_tmp1_ = event->direction;
		switch (_tmp1_) {
			case GDK_SCROLL_LEFT:
			{
				increment = 5.0;
				break;
			}
			case GDK_SCROLL_RIGHT:
			{
				increment = -5.0;
				break;
			}
			case GDK_SCROLL_SMOOTH:
			{
				gdouble delta_x = 0.0;
				gdouble _tmp2_ = 0.0;
				gdk_event_get_scroll_deltas ((GdkEvent*) event, &_tmp2_, NULL);
				delta_x = _tmp2_;
				increment = delta_x * 10.0;
				break;
			}
			default:
			{
				break;
			}
		}
	}
	result = fm_abstract_directory_view_handle_scroll_event (self, event);
	return result;
}

gboolean
fm_abstract_directory_view_on_scroll_event (FMAbstractDirectoryView* self,
                                            GdkEventScroll* event)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->on_scroll_event (self, event);
}

/** name renderer signals */
void
fm_abstract_directory_view_on_name_editing_started (FMAbstractDirectoryView* self,
                                                    GtkCellEditable* editable,
                                                    const gchar* path_string)
{
	gboolean _tmp0_;
	MarlinAbstractEditableLabel* editable_widget = NULL;
	MarlinAbstractEditableLabel* _tmp1_;
	MarlinAbstractEditableLabel* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = self->priv->_renaming;
	if (_tmp0_) {
		return;
	}
	fm_abstract_directory_view_set_renaming (self, TRUE);
	_tmp1_ = _g_object_ref0 (MARLIN_IS_ABSTRACT_EDITABLE_LABEL (editable) ? ((MarlinAbstractEditableLabel*) editable) : NULL);
	editable_widget = _tmp1_;
	_tmp2_ = editable_widget;
	if (_tmp2_ != NULL) {
		MarlinAbstractEditableLabel* _tmp3_;
		gchar* _tmp4_;
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp5_;
		GtkTreeIter* iter = NULL;
		FMListModel* _tmp6_;
		GtkTreePath* _tmp7_;
		GtkTreeIter _tmp8_ = {0};
		GtkTreeIter _tmp9_;
		GtkTreeIter* _tmp10_;
		GOFFile* file = NULL;
		FMListModel* _tmp11_;
		GtkTreeIter* _tmp12_;
		GtkTreeIter _tmp13_;
		GOFFile* _tmp14_ = NULL;
		gint start_offset = 0;
		gint end_offset = 0;
		GOFFile* _tmp15_;
		MarlinAbstractEditableLabel* _tmp19_;
		_tmp3_ = editable_widget;
		_tmp4_ = marlin_abstract_editable_label_get_chars (_tmp3_, 0, -1);
		_g_free0 (self->original_name);
		self->original_name = _tmp4_;
		_tmp5_ = gtk_tree_path_new_from_string (path_string);
		path = _tmp5_;
		iter = NULL;
		_tmp6_ = self->model;
		_tmp7_ = path;
		gtk_tree_model_get_iter ((GtkTreeModel*) _tmp6_, &_tmp8_, _tmp7_);
		__vala_GtkTreeIter_free0 (iter);
		_tmp9_ = _tmp8_;
		_tmp10_ = __vala_GtkTreeIter_copy0 (&_tmp9_);
		iter = _tmp10_;
		file = NULL;
		_tmp11_ = self->model;
		_tmp12_ = iter;
		_tmp13_ = *_tmp12_;
		gtk_tree_model_get ((GtkTreeModel*) _tmp11_, &_tmp13_, FM_LIST_MODEL_FILE_COLUMN, &_tmp14_, -1);
		_g_object_unref0 (file);
		file = _tmp14_;
		start_offset = 0;
		end_offset = -1;
		_tmp15_ = file;
		if (!gof_file_is_folder (_tmp15_)) {
			const gchar* _tmp16_;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			_tmp16_ = self->original_name;
			pf_file_utils_get_rename_region (_tmp16_, &_tmp17_, &_tmp18_, FALSE);
			start_offset = _tmp17_;
			end_offset = _tmp18_;
		}
		_tmp19_ = editable_widget;
		marlin_abstract_editable_label_select_region (_tmp19_, start_offset, end_offset);
		_g_object_unref0 (file);
		__vala_GtkTreeIter_free0 (iter);
		__vala_GtkTreePath_free0 (path);
	} else {
		g_warning ("AbstractDirectoryView.vala:3178: Editable widget is null");
		fm_abstract_directory_view_on_name_editing_canceled (self);
	}
	_g_object_unref0 (editable_widget);
}

void
fm_abstract_directory_view_on_name_editing_canceled (FMAbstractDirectoryView* self)
{
	MarlinTextRenderer* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_set_renaming (self, FALSE);
	_tmp0_ = self->name_renderer;
	g_object_set ((GtkCellRendererText*) _tmp0_, "editable", FALSE, NULL);
	_tmp1_ = g_strdup ("");
	_g_free0 (self->proposed_name);
	self->proposed_name = _tmp1_;
	fm_abstract_directory_view_set_is_frozen (self, FALSE);
	fm_abstract_directory_view_grab_focus (self);
}

static void
____lambda55_ (FMAbstractDirectoryView* self,
               GObject* obj,
               GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
		_tmp0_ = fm_abstract_directory_view_set_file_display_name_finish (self, res, &_inner_error0_);
		_tmp1_ = _tmp0_;
		_g_object_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch33_g_error;
		}
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (e);
	}
	__finally33:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	fm_abstract_directory_view_on_name_editing_canceled (self);
}

static void
_____lambda55__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	____lambda55_ ((FMAbstractDirectoryView*) self, source_object, res);
	g_object_unref (self);
}

void
fm_abstract_directory_view_on_name_edited (FMAbstractDirectoryView* self,
                                           const gchar* path_string,
                                           const gchar* new_name)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	g_return_if_fail (new_name != NULL);
	_tmp1_ = self->priv->_renaming;
	if (!_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->proposed_name;
		_tmp0_ = g_strcmp0 (_tmp2_, new_name) == 0;
	}
	if (_tmp0_) {
		return;
	}
	_tmp3_ = g_strdup ("");
	_g_free0 (self->proposed_name);
	self->proposed_name = _tmp3_;
	if (g_strcmp0 (new_name, "") != 0) {
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp4_;
		GtkTreeIter* iter = NULL;
		FMListModel* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreeIter _tmp7_ = {0};
		GtkTreeIter _tmp8_;
		GtkTreeIter* _tmp9_;
		GOFFile* file = NULL;
		FMListModel* _tmp10_;
		GtkTreeIter* _tmp11_;
		GtkTreeIter _tmp12_;
		GOFFile* _tmp13_ = NULL;
		const gchar* _tmp14_;
		_tmp4_ = gtk_tree_path_new_from_string (path_string);
		path = _tmp4_;
		iter = NULL;
		_tmp5_ = self->model;
		_tmp6_ = path;
		gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
		__vala_GtkTreeIter_free0 (iter);
		_tmp8_ = _tmp7_;
		_tmp9_ = __vala_GtkTreeIter_copy0 (&_tmp8_);
		iter = _tmp9_;
		file = NULL;
		_tmp10_ = self->model;
		_tmp11_ = iter;
		_tmp12_ = *_tmp11_;
		gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp12_, FM_LIST_MODEL_FILE_COLUMN, &_tmp13_, -1);
		_g_object_unref0 (file);
		file = _tmp13_;
		_tmp14_ = self->original_name;
		if (g_strcmp0 (new_name, _tmp14_) != 0) {
			gchar* _tmp15_;
			GOFFile* _tmp16_;
			GFile* _tmp17_;
			_tmp15_ = g_strdup (new_name);
			_g_free0 (self->proposed_name);
			self->proposed_name = _tmp15_;
			_tmp16_ = file;
			_tmp17_ = _tmp16_->location;
			fm_abstract_directory_view_set_file_display_name (self, _tmp17_, new_name, NULL, _____lambda55__gasync_ready_callback, g_object_ref (self));
		} else {
			g_warning ("AbstractDirectoryView.vala:3220: Name unchanged");
			fm_abstract_directory_view_on_name_editing_canceled (self);
		}
		_g_object_unref0 (file);
		__vala_GtkTreeIter_free0 (iter);
		__vala_GtkTreePath_free0 (path);
	} else {
		g_warning ("AbstractDirectoryView.vala:3224: No new name");
		fm_abstract_directory_view_on_name_editing_canceled (self);
	}
}

static void
fm_abstract_directory_view_set_file_display_name_data_free (gpointer _data)
{
	FmAbstractDirectoryViewSetFileDisplayNameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->old_location);
	_g_free0 (_data_->new_name);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (FmAbstractDirectoryViewSetFileDisplayNameData, _data_);
}

void
fm_abstract_directory_view_set_file_display_name (FMAbstractDirectoryView* self,
                                                  GFile* old_location,
                                                  const gchar* new_name,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	FmAbstractDirectoryViewSetFileDisplayNameData* _data_;
	FMAbstractDirectoryView* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
	_data_ = g_slice_new0 (FmAbstractDirectoryViewSetFileDisplayNameData);
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, fm_abstract_directory_view_set_file_display_name_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (old_location);
	_g_object_unref0 (_data_->old_location);
	_data_->old_location = _tmp1_;
	_tmp2_ = g_strdup (new_name);
	_g_free0 (_data_->new_name);
	_data_->new_name = _tmp2_;
	_tmp3_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp3_;
	fm_abstract_directory_view_set_file_display_name_co (_data_);
}

GFile*
fm_abstract_directory_view_set_file_display_name_finish (FMAbstractDirectoryView* self,
                                                         GAsyncResult* _res_,
                                                         GError** error)
{
	GFile* result;
	FmAbstractDirectoryViewSetFileDisplayNameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
_fm_abstract_directory_view_after_renamed_file_added_gof_directory_async_file_added (GOFDirectoryAsync* _sender,
                                                                                     GOFFile* file,
                                                                                     gpointer self)
{
	fm_abstract_directory_view_after_renamed_file_added ((FMAbstractDirectoryView*) self, file);
}

static void
fm_abstract_directory_view_set_file_display_name_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	FmAbstractDirectoryViewSetFileDisplayNameData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	fm_abstract_directory_view_set_file_display_name_co (_data_);
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static gboolean
fm_abstract_directory_view_set_file_display_name_co (FmAbstractDirectoryViewSetFileDisplayNameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->slot;
	_data_->_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	g_signal_connect_object (_data_->_tmp2_, "file-added", (GCallback) _fm_abstract_directory_view_after_renamed_file_added_gof_directory_async_file_added, _data_->self, G_CONNECT_AFTER);
	{
		_data_->_state_ = 1;
		pf_file_utils_set_file_display_name (_data_->old_location, _data_->new_name, _data_->cancellable, fm_abstract_directory_view_set_file_display_name_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp4_ = pf_file_utils_set_file_display_name_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp3_ = _data_->_tmp4_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch34_g_error;
		}
		_data_->_tmp5_ = _data_->_tmp3_;
		_data_->_tmp3_ = NULL;
		_data_->result = _data_->_tmp5_;
		_g_object_unref0 (_data_->_tmp3_);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	goto __finally34;
	__catch34_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp6_ = _data_->e;
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
		_data_->_inner_error0_ = _data_->_tmp7_;
		_g_error_free0 (_data_->e);
		goto __finally34;
	}
	__finally34:
	g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
fm_abstract_directory_view_after_renamed_file_added (FMAbstractDirectoryView* self,
                                                     GOFFile* new_file)
{
	MarlinViewSlot* _tmp0_;
	GOFDirectoryAsync* _tmp1_;
	GOFDirectoryAsync* _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->slot;
	_tmp1_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_parse_name ("file-added", GOF_DIRECTORY_TYPE_ASYNC, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _fm_abstract_directory_view_after_renamed_file_added_gof_directory_async_file_added, self);
	if (new_file != NULL) {
		fm_abstract_directory_view_select_and_scroll_to_gof_file (self, new_file);
	}
}

static PangoRectangle*
_pango_rectangle_dup (PangoRectangle* self)
{
	PangoRectangle* dup;
	dup = g_new0 (PangoRectangle, 1);
	memcpy (dup, self, sizeof (PangoRectangle));
	return dup;
}

static gpointer
__pango_rectangle_dup0 (gpointer self)
{
	return self ? _pango_rectangle_dup (self) : NULL;
}

static gboolean
fm_abstract_directory_view_real_on_view_draw (FMAbstractDirectoryView* self,
                                              cairo_t* cr)
{
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	MarlinViewSlot* _tmp2_;
	GOFDirectoryAsync* _tmp3_;
	GOFDirectoryAsync* _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = self->slot;
	_tmp3_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp2_);
	_tmp4_ = _tmp3_;
	if (gof_directory_async_is_empty (_tmp4_)) {
		PangoLayout* layout = NULL;
		PangoLayout* _tmp5_;
		GtkStyleContext* _tmp6_;
		PangoLayout* _tmp9_;
		MarlinViewSlot* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		PangoRectangle* extents = NULL;
		PangoLayout* _tmp13_;
		PangoRectangle _tmp14_ = {0};
		PangoRectangle _tmp15_;
		PangoRectangle* _tmp16_;
		gdouble width = 0.0;
		PangoRectangle* _tmp17_;
		gdouble height = 0.0;
		PangoRectangle* _tmp18_;
		gdouble x = 0.0;
		gdouble y = 0.0;
		GtkStyleContext* _tmp19_;
		PangoLayout* _tmp20_;
		_tmp5_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
		layout = _tmp5_;
		_tmp6_ = style_context;
		if (!gtk_style_context_has_class (_tmp6_, GRANITE_STYLE_CLASS_H2_LABEL)) {
			GtkStyleContext* _tmp7_;
			GtkStyleContext* _tmp8_;
			_tmp7_ = style_context;
			gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_H2_LABEL);
			_tmp8_ = style_context;
			gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_VIEW);
		}
		_tmp9_ = layout;
		_tmp10_ = self->slot;
		_tmp11_ = marlin_view_slot_get_empty_message (_tmp10_);
		_tmp12_ = _tmp11_;
		pango_layout_set_markup (_tmp9_, _tmp12_, -1);
		_g_free0 (_tmp12_);
		extents = NULL;
		_tmp13_ = layout;
		pango_layout_get_extents (_tmp13_, NULL, &_tmp14_);
		_g_free0 (extents);
		_tmp15_ = _tmp14_;
		_tmp16_ = __pango_rectangle_dup0 (&_tmp15_);
		extents = _tmp16_;
		_tmp17_ = extents;
		width = pango_units_to_double ((*_tmp17_).width);
		_tmp18_ = extents;
		height = pango_units_to_double ((*_tmp18_).height);
		x = (((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / 2) - (width / 2);
		y = (((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / 2) - (height / 2);
		_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp20_ = layout;
		gtk_render_layout (_tmp19_, cr, x, y, _tmp20_);
		result = TRUE;
		_g_free0 (extents);
		_g_object_unref0 (layout);
		_g_object_unref0 (style_context);
		return result;
	} else {
		GtkStyleContext* _tmp21_;
		_tmp21_ = style_context;
		if (gtk_style_context_has_class (_tmp21_, GRANITE_STYLE_CLASS_H2_LABEL)) {
			GtkStyleContext* _tmp22_;
			GtkStyleContext* _tmp23_;
			_tmp22_ = style_context;
			gtk_style_context_remove_class (_tmp22_, GRANITE_STYLE_CLASS_H2_LABEL);
			_tmp23_ = style_context;
			gtk_style_context_remove_class (_tmp23_, GTK_STYLE_CLASS_VIEW);
		}
	}
	result = FALSE;
	_g_object_unref0 (style_context);
	return result;
}

gboolean
fm_abstract_directory_view_on_view_draw (FMAbstractDirectoryView* self,
                                         cairo_t* cr)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->on_view_draw (self, cr);
}

static gboolean
fm_abstract_directory_view_real_handle_primary_button_click (FMAbstractDirectoryView* self,
                                                             GdkEventButton* event,
                                                             GtkTreePath* path)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
fm_abstract_directory_view_handle_primary_button_click (FMAbstractDirectoryView* self,
                                                        GdkEventButton* event,
                                                        GtkTreePath* path)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->handle_primary_button_click (self, event, path);
}

static gboolean
fm_abstract_directory_view_real_handle_secondary_button_click (FMAbstractDirectoryView* self,
                                                               GdkEventButton* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	self->should_scroll = FALSE;
	result = TRUE;
	return result;
}

gboolean
fm_abstract_directory_view_handle_secondary_button_click (FMAbstractDirectoryView* self,
                                                          GdkEventButton* event)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->handle_secondary_button_click (self, event);
}

void
fm_abstract_directory_view_block_drag_and_drop (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	if (!self->dnd_disabled) {
		GtkWidget* _tmp0_;
		gconstpointer _tmp1_;
		GtkWidget* _tmp2_;
		void* _tmp3_;
		_tmp0_ = self->priv->view;
		_tmp1_ = g_object_get_data ((GObject*) _tmp0_, "gtk-site-data");
		self->priv->drag_data = _tmp1_;
		_tmp2_ = self->priv->view;
		_tmp3_ = self->priv->drag_data;
		g_signal_handlers_block_matched (_tmp2_, G_SIGNAL_MATCH_DATA, (guint) 0, (GQuark) 0, NULL, NULL, _tmp3_);
		self->dnd_disabled = TRUE;
	}
}

void
fm_abstract_directory_view_unblock_drag_and_drop (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	if (self->dnd_disabled) {
		GtkWidget* _tmp0_;
		void* _tmp1_;
		_tmp0_ = self->priv->view;
		_tmp1_ = self->priv->drag_data;
		g_signal_handlers_unblock_matched (_tmp0_, G_SIGNAL_MATCH_DATA, (guint) 0, (GQuark) 0, NULL, NULL, _tmp1_);
		self->dnd_disabled = FALSE;
	}
}

static gboolean
fm_abstract_directory_view_real_on_view_button_press_event (FMAbstractDirectoryView* self,
                                                            GdkEventButton* event)
{
	gboolean _tmp0_;
	gboolean _tmp2_ = FALSE;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp4_ = NULL;
	guint _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkTreePath* _tmp9_;
	GtkTreePath* _tmp10_;
	GdkModifierType mods = 0U;
	GdkModifierType _tmp11_;
	gboolean no_mods = FALSE;
	GdkModifierType _tmp12_;
	gboolean control_pressed = FALSE;
	GdkModifierType _tmp13_;
	gboolean shift_pressed = FALSE;
	GdkModifierType _tmp14_;
	gboolean other_mod_pressed = FALSE;
	GdkModifierType _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean only_control_pressed = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean only_shift_pressed = FALSE;
	gboolean _tmp19_ = FALSE;
	GtkTreePath* _tmp20_;
	gboolean path_selected = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean on_blank = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _result_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_renaming;
	if (_tmp0_) {
		MarlinTextRenderer* _tmp1_;
		_tmp1_ = self->name_renderer;
		marlin_text_renderer_end_editing (_tmp1_, FALSE);
	}
	fm_abstract_directory_view_cancel_hover (self);
	if (self->dnd_disabled) {
		GdkEventType _tmp3_;
		_tmp3_ = event->type;
		_tmp2_ = _tmp3_ == GDK_BUTTON_PRESS;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = TRUE;
		return result;
	}
	fm_abstract_directory_view_grab_focus (self);
	path = NULL;
	self->priv->drag_x = (gint) event->x;
	self->priv->drag_y = (gint) event->y;
	_tmp5_ = fm_abstract_directory_view_get_event_position_info (self, event, &_tmp4_, TRUE);
	__vala_GtkTreePath_free0 (path);
	path = _tmp4_;
	self->click_zone = _tmp5_;
	if (self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH)) {
		GtkTreePath* _tmp7_;
		_tmp7_ = path;
		_tmp6_ = _tmp7_ != NULL;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GtkTreePath* _tmp8_;
		_tmp8_ = path;
		fm_abstract_directory_view_unselect_path (self, _tmp8_);
		__vala_GtkTreePath_free0 (path);
		path = NULL;
	}
	_tmp9_ = path;
	_tmp10_ = __vala_GtkTreePath_copy0 (_tmp9_);
	__vala_GtkTreePath_free0 (self->click_path);
	self->click_path = _tmp10_;
	_tmp11_ = event->state;
	mods = _tmp11_ & gtk_accelerator_get_default_mod_mask ();
	_tmp12_ = mods;
	no_mods = _tmp12_ == 0;
	_tmp13_ = mods;
	control_pressed = (_tmp13_ & GDK_CONTROL_MASK) != 0;
	_tmp14_ = mods;
	shift_pressed = (_tmp14_ & GDK_SHIFT_MASK) != 0;
	_tmp15_ = mods;
	other_mod_pressed = ((_tmp15_ & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
	if (control_pressed) {
		_tmp16_ = !other_mod_pressed;
	} else {
		_tmp16_ = FALSE;
	}
	only_control_pressed = _tmp16_;
	if (shift_pressed) {
		_tmp18_ = !control_pressed;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		_tmp17_ = !other_mod_pressed;
	} else {
		_tmp17_ = FALSE;
	}
	only_shift_pressed = _tmp17_;
	_tmp20_ = path;
	if (_tmp20_ != NULL) {
		GtkTreePath* _tmp21_;
		_tmp21_ = path;
		_tmp19_ = fm_abstract_directory_view_path_is_selected (self, _tmp21_);
	} else {
		_tmp19_ = FALSE;
	}
	path_selected = _tmp19_;
	if (self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH)) {
		_tmp22_ = TRUE;
	} else {
		_tmp22_ = self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH);
	}
	on_blank = _tmp22_;
	fm_abstract_directory_view_block_drag_and_drop (self);
	if (self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH)) {
		result = FALSE;
		__vala_GtkTreePath_free0 (path);
		return result;
	}
	if (!fm_abstract_directory_view_will_handle_button_press (self, no_mods, only_control_pressed, only_shift_pressed)) {
		result = FALSE;
		__vala_GtkTreePath_free0 (path);
		return result;
	}
	if (!path_selected) {
		_tmp23_ = self->click_zone != ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER);
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		gboolean _tmp24_ = FALSE;
		if (no_mods) {
			fm_abstract_directory_view_unselect_all (self);
		}
		if (no_mods) {
			_tmp24_ = !on_blank;
		} else {
			_tmp24_ = FALSE;
		}
		if (_tmp24_) {
			GtkTreePath* _tmp25_;
			_tmp25_ = path;
			fm_abstract_directory_view_select_path (self, _tmp25_, TRUE);
		}
	}
	_result_ = FALSE;
	self->should_activate = FALSE;
	self->should_scroll = TRUE;
	switch (event->button) {
		case GDK_BUTTON_PRIMARY:
		{
			gboolean _tmp26_ = FALSE;
			if (only_control_pressed) {
				_tmp26_ = path_selected;
			} else {
				_tmp26_ = FALSE;
			}
			self->should_deselect = _tmp26_;
			switch (self->click_zone) {
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH:
				{
					break;
				}
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH:
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
				{
					gboolean double_click_event = FALSE;
					GdkEventType _tmp27_;
					gboolean _tmp28_ = FALSE;
					GList* _tmp29_;
					gboolean one_or_less = FALSE;
					gboolean _tmp32_ = FALSE;
					gboolean _tmp33_ = FALSE;
					gboolean _tmp38_ = FALSE;
					_tmp27_ = event->type;
					double_click_event = _tmp27_ == GDK_2BUTTON_PRESS;
					fm_abstract_directory_view_update_selected_files_and_menu (self);
					_tmp29_ = self->selected_files;
					if (_tmp29_ == NULL) {
						_tmp28_ = TRUE;
					} else {
						GList* _tmp30_;
						GList* _tmp31_;
						_tmp30_ = self->selected_files;
						_tmp31_ = _tmp30_->next;
						_tmp28_ = _tmp31_ == NULL;
					}
					one_or_less = _tmp28_;
					if (no_mods) {
						gboolean _tmp34_ = FALSE;
						if (!on_blank) {
							_tmp34_ = TRUE;
						} else {
							_tmp34_ = self->activate_on_blank;
						}
						_tmp33_ = _tmp34_;
					} else {
						_tmp33_ = FALSE;
					}
					if (_tmp33_) {
						gboolean _tmp35_ = FALSE;
						gboolean _tmp36_ = FALSE;
						gboolean _tmp37_;
						_tmp37_ = self->priv->_single_click_mode;
						if (_tmp37_) {
							_tmp36_ = one_or_less;
						} else {
							_tmp36_ = FALSE;
						}
						if (_tmp36_) {
							_tmp35_ = TRUE;
						} else {
							_tmp35_ = double_click_event;
						}
						_tmp32_ = _tmp35_;
					} else {
						_tmp32_ = FALSE;
					}
					self->should_activate = _tmp32_;
					if (!no_mods) {
						_tmp38_ = TRUE;
					} else {
						gboolean _tmp39_ = FALSE;
						if (on_blank) {
							gboolean _tmp40_ = FALSE;
							if (!self->activate_on_blank) {
								_tmp40_ = TRUE;
							} else {
								_tmp40_ = !path_selected;
							}
							_tmp39_ = _tmp40_;
						} else {
							_tmp39_ = FALSE;
						}
						_tmp38_ = _tmp39_;
					}
					if (_tmp38_) {
						gboolean _tmp41_ = FALSE;
						fm_abstract_directory_view_update_selected_files_and_menu (self);
						if (only_shift_pressed) {
							GtkTreePath* _tmp42_;
							_tmp42_ = path;
							_tmp41_ = fm_abstract_directory_view_handle_multi_select (self, _tmp42_);
						} else {
							_tmp41_ = FALSE;
						}
						_result_ = _tmp41_;
					} else {
						GtkTreePath* _tmp43_;
						fm_abstract_directory_view_unblock_drag_and_drop (self);
						_tmp43_ = path;
						_result_ = fm_abstract_directory_view_handle_primary_button_click (self, event, _tmp43_);
					}
					break;
				}
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER:
				{
					gboolean _tmp44_ = FALSE;
					gboolean multi_select = FALSE;
					if (only_control_pressed) {
						_tmp44_ = TRUE;
					} else {
						_tmp44_ = only_shift_pressed;
					}
					multi_select = _tmp44_;
					if (multi_select) {
						gboolean _tmp45_ = FALSE;
						if (only_shift_pressed) {
							GtkTreePath* _tmp46_;
							_tmp46_ = path;
							_tmp45_ = fm_abstract_directory_view_handle_multi_select (self, _tmp46_);
						} else {
							_tmp45_ = FALSE;
						}
						_result_ = _tmp45_;
					} else {
						if (path_selected) {
							self->should_deselect = TRUE;
						} else {
							GtkTreePath* _tmp47_;
							self->should_deselect = FALSE;
							_tmp47_ = path;
							fm_abstract_directory_view_select_path (self, _tmp47_, TRUE);
						}
						fm_abstract_directory_view_unblock_drag_and_drop (self);
						_result_ = TRUE;
					}
					break;
				}
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER:
				{
					GtkTreePath* _tmp48_;
					_tmp48_ = path;
					_result_ = fm_abstract_directory_view_expand_collapse (self, _tmp48_);
					break;
				}
				case FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID:
				{
					_result_ = FALSE;
					break;
				}
				default:
				{
					break;
				}
			}
			break;
		}
		case GDK_BUTTON_MIDDLE:
		{
			GtkTreePath* _tmp49_;
			_tmp49_ = path;
			if (!fm_abstract_directory_view_path_is_selected (self, _tmp49_)) {
				GtkTreePath* _tmp50_;
				_tmp50_ = path;
				fm_abstract_directory_view_select_path (self, _tmp50_, TRUE);
			}
			self->should_activate = TRUE;
			fm_abstract_directory_view_unblock_drag_and_drop (self);
			_result_ = TRUE;
			break;
		}
		case GDK_BUTTON_SECONDARY:
		{
			gboolean _tmp51_ = FALSE;
			gboolean _tmp52_ = FALSE;
			gboolean _tmp53_ = FALSE;
			if (self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME)) {
				_tmp53_ = TRUE;
			} else {
				_tmp53_ = self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH);
			}
			if (_tmp53_) {
				_tmp52_ = TRUE;
			} else {
				_tmp52_ = self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON);
			}
			if (_tmp52_) {
				_tmp51_ = TRUE;
			} else {
				_tmp51_ = self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER);
			}
			if (_tmp51_) {
				GtkTreePath* _tmp54_;
				_tmp54_ = path;
				fm_abstract_directory_view_select_path (self, _tmp54_, FALSE);
			} else {
				if (self->click_zone == ((guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID)) {
					fm_abstract_directory_view_unselect_all (self);
				}
			}
			fm_abstract_directory_view_update_selected_files_and_menu (self);
			fm_abstract_directory_view_unblock_drag_and_drop (self);
			fm_abstract_directory_view_start_drag_timer (self, (GdkEvent*) event);
			_result_ = fm_abstract_directory_view_handle_secondary_button_click (self, event);
			break;
		}
		default:
		{
			_result_ = fm_abstract_directory_view_handle_default_button_click (self, event);
			break;
		}
	}
	result = _result_;
	__vala_GtkTreePath_free0 (path);
	return result;
}

gboolean
fm_abstract_directory_view_on_view_button_press_event (FMAbstractDirectoryView* self,
                                                       GdkEventButton* event)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->on_view_button_press_event (self, event);
}

static Block36Data*
block36_data_ref (Block36Data* _data36_)
{
	g_atomic_int_inc (&_data36_->_ref_count_);
	return _data36_;
}

static void
block36_data_unref (void * _userdata_)
{
	Block36Data* _data36_;
	_data36_ = (Block36Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data36_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data36_->self;
		__vala_GdkEventButton_free0 (_data36_->event);
		_g_object_unref0 (self);
		g_slice_free (Block36Data, _data36_);
	}
}

static gboolean
____lambda60_ (Block36Data* _data36_)
{
	FMAbstractDirectoryView* self;
	MarlinOpenFlag _tmp0_ = 0;
	MarlinOpenFlag flag = 0;
	GList* _tmp1_;
	gboolean result = FALSE;
	self = _data36_->self;
	if (_data36_->event->button == ((guint) GDK_BUTTON_MIDDLE)) {
		_tmp0_ = MARLIN_OPEN_FLAG_NEW_TAB;
	} else {
		_tmp0_ = MARLIN_OPEN_FLAG_DEFAULT;
	}
	flag = _tmp0_;
	_tmp1_ = fm_abstract_directory_view_get_selected_files (self);
	fm_abstract_directory_view_activate_selected_items (self, flag, _tmp1_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
_____lambda60__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda60_ (self);
	return result;
}

static gboolean
_____lambda61_ (FMAbstractDirectoryView* self)
{
	gboolean result = FALSE;
	fm_abstract_directory_view_update_selected_files_and_menu (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
______lambda61__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda61_ ((FMAbstractDirectoryView*) self);
	return result;
}

static gboolean
fm_abstract_directory_view_real_on_view_button_release_event (FMAbstractDirectoryView* self,
                                                              GdkEventButton* event)
{
	Block36Data* _data36_;
	GdkEventButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	MarlinViewSlot* _tmp3_;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp4_;
	gint x = 0;
	gint y = 0;
	GtkWidget* _tmp5_;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_data36_ = g_slice_new0 (Block36Data);
	_data36_->_ref_count_ = 1;
	_data36_->self = g_object_ref (self);
	_tmp0_ = __vala_GdkEventButton_copy0 (event);
	__vala_GdkEventButton_free0 (_data36_->event);
	_data36_->event = _tmp0_;
	fm_abstract_directory_view_unblock_drag_and_drop (self);
	_tmp2_ = self->priv->_renaming;
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = !fm_abstract_directory_view_view_has_focus (self);
	}
	if (_tmp1_) {
		result = TRUE;
		block36_data_unref (_data36_);
		_data36_ = NULL;
		return result;
	}
	_tmp3_ = self->slot;
	g_signal_emit_by_name ((GOFAbstractSlot*) _tmp3_, "active", self->should_scroll, TRUE);
	_tmp4_ = fm_abstract_directory_view_get_real_view (self);
	widget = _tmp4_;
	x = (gint) _data36_->event->x;
	y = (gint) _data36_->event->y;
	fm_abstract_directory_view_update_selected_files_and_menu (self);
	_tmp5_ = widget;
	if (!gtk_drag_check_threshold (_tmp5_, self->priv->drag_x, self->priv->drag_y, x, y)) {
		if (self->should_activate) {
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda60__gsource_func, block36_data_ref (_data36_), block36_data_unref);
		} else {
			gboolean _tmp6_ = FALSE;
			if (self->should_deselect) {
				GtkTreePath* _tmp7_;
				_tmp7_ = self->click_path;
				_tmp6_ = _tmp7_ != NULL;
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				GtkTreePath* _tmp8_;
				_tmp8_ = self->click_path;
				fm_abstract_directory_view_unselect_path (self, _tmp8_);
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda61__gsource_func, g_object_ref (self), g_object_unref);
			} else {
				if (_data36_->event->button == ((guint) GDK_BUTTON_SECONDARY)) {
					fm_abstract_directory_view_show_context_menu (self, (GdkEvent*) _data36_->event);
				}
			}
		}
	}
	self->should_activate = FALSE;
	self->should_deselect = FALSE;
	__vala_GtkTreePath_free0 (self->click_path);
	self->click_path = NULL;
	result = FALSE;
	_g_object_unref0 (widget);
	block36_data_unref (_data36_);
	_data36_ = NULL;
	return result;
}

gboolean
fm_abstract_directory_view_on_view_button_release_event (FMAbstractDirectoryView* self,
                                                         GdkEventButton* event)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->on_view_button_release_event (self, event);
}

static void
fm_abstract_directory_view_real_change_zoom_level (FMAbstractDirectoryView* self)
{
	MarlinIconRenderer* _tmp0_;
	MarlinZoomLevel _tmp1_;
	MarlinZoomLevel _tmp2_;
	GValue _tmp3_ = {0};
	MarlinTextRenderer* _tmp4_;
	MarlinZoomLevel _tmp5_;
	MarlinZoomLevel _tmp6_;
	GValue _tmp7_ = {0};
	GtkWidget* _tmp8_;
	_tmp0_ = self->icon_renderer;
	_tmp1_ = fm_abstract_directory_view_get_zoom_level (self);
	_tmp2_ = _tmp1_;
	g_value_init (&_tmp3_, MARLIN_TYPE_ZOOM_LEVEL);
	g_value_set_enum (&_tmp3_, _tmp2_);
	g_object_set_property ((GObject*) _tmp0_, "zoom-level", &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	_tmp4_ = self->name_renderer;
	_tmp5_ = fm_abstract_directory_view_get_zoom_level (self);
	_tmp6_ = _tmp5_;
	g_value_init (&_tmp7_, MARLIN_TYPE_ZOOM_LEVEL);
	g_value_set_enum (&_tmp7_, _tmp6_);
	g_object_set_property ((GObject*) _tmp4_, "zoom-level", &_tmp7_);
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
	_tmp8_ = self->priv->view;
	g_signal_emit_by_name (_tmp8_, "style-updated");
}

void
fm_abstract_directory_view_change_zoom_level (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->change_zoom_level (self);
}

static Block37Data*
block37_data_ref (Block37Data* _data37_)
{
	g_atomic_int_inc (&_data37_->_ref_count_);
	return _data37_;
}

static void
block37_data_unref (void * _userdata_)
{
	Block37Data* _data37_;
	_data37_ = (Block37Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data37_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data37_->self;
		__vala_GtkTreePath_free0 (_data37_->start_path);
		__vala_GtkTreePath_free0 (_data37_->path);
		_g_object_unref0 (self);
		g_slice_free (Block37Data, _data37_);
	}
}

static gboolean
__lambda40_ (Block37Data* _data37_)
{
	FMAbstractDirectoryView* self;
	GtkTreePath* start = NULL;
	GtkTreePath* end = NULL;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* _tmp1_ = NULL;
	guint _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkTreePath* _tmp4_;
	MarlinTextRenderer* _tmp10_;
	GtkTreePath* _tmp11_;
	MarlinTextRenderer* _tmp12_;
	gboolean result = FALSE;
	self = _data37_->self;
	start = NULL;
	end = NULL;
	fm_abstract_directory_view_get_visible_range (self, &_tmp0_, &_tmp1_);
	__vala_GtkTreePath_free0 (start);
	start = _tmp0_;
	__vala_GtkTreePath_free0 (end);
	end = _tmp1_;
	_tmp2_ = _data37_->count;
	_data37_->count = _tmp2_ + 1;
	_tmp4_ = _data37_->start_path;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		if (_data37_->count < ((guint) 20)) {
			GtkTreePath* _tmp6_;
			GtkTreePath* _tmp7_;
			_tmp6_ = start;
			_tmp7_ = _data37_->start_path;
			_tmp5_ = gtk_tree_path_compare (_tmp6_, _tmp7_) != 0;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp3_ = _tmp5_;
	}
	if (_tmp3_) {
		GtkTreePath* _tmp8_;
		GtkTreePath* _tmp9_;
		_tmp8_ = start;
		_tmp9_ = __vala_GtkTreePath_copy0 (_tmp8_);
		__vala_GtkTreePath_free0 (_data37_->start_path);
		_data37_->start_path = _tmp9_;
		_data37_->ok_next_time = FALSE;
		result = G_SOURCE_CONTINUE;
		__vala_GtkTreePath_free0 (end);
		__vala_GtkTreePath_free0 (start);
		return result;
	} else {
		if (!_data37_->ok_next_time) {
			_data37_->ok_next_time = TRUE;
			result = G_SOURCE_CONTINUE;
			__vala_GtkTreePath_free0 (end);
			__vala_GtkTreePath_free0 (start);
			return result;
		}
	}
	_tmp10_ = self->name_renderer;
	g_object_set ((GtkCellRendererText*) _tmp10_, "editable", TRUE, NULL);
	_tmp11_ = _data37_->path;
	_tmp12_ = self->name_renderer;
	fm_abstract_directory_view_set_cursor_on_cell (self, _tmp11_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_cell_renderer_get_type ()) ? ((GtkCellRenderer*) _tmp12_) : NULL, TRUE, FALSE);
	result = G_SOURCE_REMOVE;
	__vala_GtkTreePath_free0 (end);
	__vala_GtkTreePath_free0 (start);
	return result;
}

static gboolean
___lambda40__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda40_ (self);
	return result;
}

static void
fm_abstract_directory_view_start_renaming_file (FMAbstractDirectoryView* self,
                                                GOFFile* file)
{
	Block37Data* _data37_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter* iter = NULL;
	FMListModel* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	GtkTreeIter _tmp5_;
	GtkTreeIter* _tmp6_;
	FMListModel* _tmp7_;
	GtkTreeIter* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkTreePath* _tmp10_;
	GtkTreePath* _tmp11_;
	MarlinTextRenderer* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_data37_ = g_slice_new0 (Block37Data);
	_data37_->_ref_count_ = 1;
	_data37_->self = g_object_ref (self);
	_tmp0_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_warning ("AbstractDirectoryView.vala:3542: Trying to rename when frozen");
		block37_data_unref (_data37_);
		_data37_ = NULL;
		return;
	}
	iter = NULL;
	_tmp2_ = self->model;
	_tmp4_ = fm_list_model_get_first_iter_for_file (_tmp2_, file, &_tmp3_);
	__vala_GtkTreeIter_free0 (iter);
	_tmp5_ = _tmp3_;
	_tmp6_ = __vala_GtkTreeIter_copy0 (&_tmp5_);
	iter = _tmp6_;
	if (!_tmp4_) {
		g_critical ("AbstractDirectoryView.vala:3547: Failed to find rename file in model");
		__vala_GtkTreeIter_free0 (iter);
		block37_data_unref (_data37_);
		_data37_ = NULL;
		return;
	}
	fm_abstract_directory_view_set_is_frozen (self, TRUE);
	_tmp7_ = self->model;
	_tmp8_ = iter;
	_tmp9_ = *_tmp8_;
	_tmp10_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp7_, &_tmp9_);
	_data37_->path = _tmp10_;
	_data37_->count = (guint) 0;
	_data37_->ok_next_time = FALSE;
	_data37_->start_path = NULL;
	_tmp11_ = _data37_->path;
	_tmp12_ = self->name_renderer;
	fm_abstract_directory_view_set_cursor_on_cell (self, _tmp11_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_cell_renderer_get_type ()) ? ((GtkCellRenderer*) _tmp12_) : NULL, FALSE, FALSE);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda40__gsource_func, block37_data_ref (_data37_), block37_data_unref);
	__vala_GtkTreeIter_free0 (iter);
	block37_data_unref (_data37_);
	_data37_ = NULL;
}

gchar*
fm_abstract_directory_view_get_string_from_column_id (FMAbstractDirectoryView* self,
                                                      gint id)
{
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	switch (id) {
		case FM_LIST_MODEL_FILENAME:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("name");
			result = _tmp0_;
			return result;
		}
		case FM_LIST_MODEL_SIZE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("size");
			result = _tmp1_;
			return result;
		}
		case FM_LIST_MODEL_TYPE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("type");
			result = _tmp2_;
			return result;
		}
		case FM_LIST_MODEL_MODIFIED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("modified");
			result = _tmp3_;
			return result;
		}
		default:
		{
			gchar* _tmp4_;
			g_warning ("AbstractDirectoryView.vala:3603: column id not recognised - using 'nam" \
"e'");
			_tmp4_ = g_strdup ("name");
			result = _tmp4_;
			return result;
		}
	}
}

gint
fm_abstract_directory_view_get_column_id_from_string (FMAbstractDirectoryView* self,
                                                      const gchar* col_name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (col_name != NULL, 0);
	_tmp0_ = col_name;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("name")))) {
		switch (0) {
			default:
			{
				result = (gint) FM_LIST_MODEL_FILENAME;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("size")))) {
		switch (0) {
			default:
			{
				result = (gint) FM_LIST_MODEL_SIZE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("type")))) {
		switch (0) {
			default:
			{
				result = (gint) FM_LIST_MODEL_TYPE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("modified")))) {
		switch (0) {
			default:
			{
				result = (gint) FM_LIST_MODEL_MODIFIED;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_warning ("AbstractDirectoryView.vala:3623: column name not recognised - using FI" \
"LENAME");
				result = (gint) FM_LIST_MODEL_FILENAME;
				return result;
			}
		}
	}
}

static Block38Data*
block38_data_ref (Block38Data* _data38_)
{
	g_atomic_int_inc (&_data38_->_ref_count_);
	return _data38_;
}

static void
block38_data_unref (void * _userdata_)
{
	Block38Data* _data38_;
	_data38_ = (Block38Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data38_->_ref_count_)) {
		FMAbstractDirectoryView* self;
		self = _data38_->self;
		_g_object_unref0 (_data38_->dir);
		_g_object_unref0 (self);
		g_slice_free (Block38Data, _data38_);
	}
}

static void
___lambda88_ (Block38Data* _data38_,
              GObject* obj,
              GAsyncResult* res)
{
	FMAbstractDirectoryView* self;
	GError* _inner_error0_ = NULL;
	self = _data38_->self;
	g_return_if_fail (res != NULL);
	{
		GFileInfo* inf = NULL;
		GOFDirectoryAsync* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		_tmp0_ = _data38_->dir;
		_tmp1_ = gof_directory_async_get_location (_tmp0_);
		_tmp2_ = _tmp1_;
		g_file_set_attributes_finish (_tmp2_, res, &_tmp3_, &_inner_error0_);
		_g_object_unref0 (inf);
		inf = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (inf);
			goto __catch35_g_error;
		}
		_g_object_unref0 (inf);
	}
	goto __finally35;
	__catch35_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("AbstractDirectoryView.vala:3668: Could not set file attributes - %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally35:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda88__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda88_ (self, source_object, res);
	block38_data_unref (self);
}

void
fm_abstract_directory_view_on_sort_column_changed (FMAbstractDirectoryView* self)
{
	Block38Data* _data38_;
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	MarlinViewSlot* _tmp7_;
	GOFDirectoryAsync* _tmp8_;
	GOFDirectoryAsync* _tmp9_;
	GOFDirectoryAsync* _tmp10_;
	gchar* sort_col_s = NULL;
	gchar* _tmp11_;
	const gchar* _tmp12_ = NULL;
	GtkSortType _tmp13_;
	gchar* sort_order_s = NULL;
	gchar* _tmp14_;
	GFileInfo* _tmp15_;
	const gchar* _tmp16_;
	GFileInfo* _tmp17_;
	const gchar* _tmp18_;
	GOFDirectoryAsync* _tmp19_;
	GOFFile* _tmp20_;
	GOFFile* _tmp21_;
	GFileInfo* _tmp22_;
	const gchar* _tmp23_;
	GOFDirectoryAsync* _tmp24_;
	GOFFile* _tmp25_;
	GOFFile* _tmp26_;
	GFileInfo* _tmp27_;
	const gchar* _tmp28_;
	GOFDirectoryAsync* _tmp29_;
	GOFFile* _tmp30_;
	GOFFile* _tmp31_;
	GOFDirectoryAsync* _tmp32_;
	GOFFile* _tmp33_;
	GOFFile* _tmp34_;
	GtkSortType _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	g_return_if_fail (self != NULL);
	_data38_ = g_slice_new0 (Block38Data);
	_data38_->_ref_count_ = 1;
	_data38_->self = g_object_ref (self);
	sort_column_id = 0;
	sort_order = 0;
	if (getuid () == ((uid_t) 0)) {
		block38_data_unref (_data38_);
		_data38_ = NULL;
		return;
	}
	_tmp1_ = self->priv->_tree_frozen;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		FMListModel* _tmp2_;
		gint _tmp3_ = 0;
		GtkSortType _tmp4_ = 0;
		gboolean _tmp5_;
		_tmp2_ = self->model;
		_tmp5_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp2_, &_tmp3_, &_tmp4_);
		sort_column_id = _tmp3_;
		sort_order = _tmp4_;
		_tmp0_ = !_tmp5_;
	}
	if (_tmp0_) {
		block38_data_unref (_data38_);
		_data38_ = NULL;
		return;
	}
	_tmp6_ = g_file_info_new ();
	info = _tmp6_;
	_tmp7_ = self->slot;
	_tmp8_ = gof_abstract_slot_get_directory ((GOFAbstractSlot*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	_data38_->dir = _tmp10_;
	_tmp11_ = fm_abstract_directory_view_get_string_from_column_id (self, sort_column_id);
	sort_col_s = _tmp11_;
	_tmp13_ = sort_order;
	if (_tmp13_ == GTK_SORT_DESCENDING) {
		_tmp12_ = "true";
	} else {
		_tmp12_ = "false";
	}
	_tmp14_ = g_strdup (_tmp12_);
	sort_order_s = _tmp14_;
	_tmp15_ = info;
	_tmp16_ = sort_col_s;
	g_file_info_set_attribute_string (_tmp15_, "metadata::marlin-sort-column-id", _tmp16_);
	_tmp17_ = info;
	_tmp18_ = sort_order_s;
	g_file_info_set_attribute_string (_tmp17_, "metadata::marlin-sort-reversed", _tmp18_);
	_tmp19_ = _data38_->dir;
	_tmp20_ = gof_directory_async_get_file (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = _tmp21_->info;
	_tmp23_ = sort_col_s;
	g_file_info_set_attribute_string (_tmp22_, "metadata::marlin-sort-column-id", _tmp23_);
	_tmp24_ = _data38_->dir;
	_tmp25_ = gof_directory_async_get_file (_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = _tmp26_->info;
	_tmp28_ = sort_order_s;
	g_file_info_set_attribute_string (_tmp27_, "metadata::marlin-sort-reversed", _tmp28_);
	_tmp29_ = _data38_->dir;
	_tmp30_ = gof_directory_async_get_file (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp31_->sort_column_id = sort_column_id;
	_tmp32_ = _data38_->dir;
	_tmp33_ = gof_directory_async_get_file (_tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = sort_order;
	_tmp34_->sort_order = _tmp35_;
	_tmp36_ = fm_abstract_directory_view_get_is_admin (self);
	_tmp37_ = _tmp36_;
	if (!_tmp37_) {
		GOFDirectoryAsync* _tmp38_;
		GFile* _tmp39_;
		GFile* _tmp40_;
		GFileInfo* _tmp41_;
		_tmp38_ = _data38_->dir;
		_tmp39_ = gof_directory_async_get_location (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = info;
		g_file_set_attributes_async (_tmp40_, _tmp41_, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, ____lambda88__gasync_ready_callback, block38_data_ref (_data38_));
	}
	_g_free0 (sort_order_s);
	_g_free0 (sort_col_s);
	_g_object_unref0 (info);
	block38_data_unref (_data38_);
	_data38_ = NULL;
}

void
fm_abstract_directory_view_cancel_timeout (FMAbstractDirectoryView* self,
                                           guint* id)
{
	g_return_if_fail (self != NULL);
	if ((*id) > ((guint) 0)) {
		g_source_remove (*id);
		*id = (guint) 0;
	}
}

void
fm_abstract_directory_view_update_selected_files_and_menu (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->selected_files_invalid) {
		guint selected_count = 0U;
		GList* _tmp0_ = NULL;
		guint _tmp1_;
		MarlinViewSlot* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GList* _tmp5_;
		(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
		self->selected_files = NULL;
		_tmp1_ = fm_abstract_directory_view_get_selected_files_from_model (self, &_tmp0_);
		(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
		self->selected_files = _tmp0_;
		selected_count = _tmp1_;
		_tmp2_ = self->slot;
		_tmp3_ = marlin_view_slot_get_displayed_files_count (_tmp2_);
		_tmp4_ = _tmp3_;
		self->priv->all_selected = selected_count == ((guint) _tmp4_);
		self->selected_files = g_list_reverse (self->selected_files);
		self->priv->selected_files_invalid = FALSE;
		fm_abstract_directory_view_update_menu_actions (self);
		_tmp5_ = self->selected_files;
		g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp5_);
	}
}

static gboolean
fm_abstract_directory_view_real_expand_collapse (FMAbstractDirectoryView* self,
                                                 GtkTreePath* path)
{
	gboolean result = FALSE;
	g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_ITEM_HOVERED_SIGNAL], 0, NULL);
	result = TRUE;
	return result;
}

gboolean
fm_abstract_directory_view_expand_collapse (FMAbstractDirectoryView* self,
                                            GtkTreePath* path)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->expand_collapse (self, path);
}

static gboolean
fm_abstract_directory_view_real_handle_default_button_click (FMAbstractDirectoryView* self,
                                                             GdkEventButton* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	result = FALSE;
	return result;
}

gboolean
fm_abstract_directory_view_handle_default_button_click (FMAbstractDirectoryView* self,
                                                        GdkEventButton* event)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->handle_default_button_click (self, event);
}

static gboolean
fm_abstract_directory_view_real_get_next_visible_iter (FMAbstractDirectoryView* self,
                                                       GtkTreeIter* iter,
                                                       gboolean recurse)
{
	FMListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->model;
	_tmp1_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp0_, iter);
	result = _tmp1_;
	return result;
}

gboolean
fm_abstract_directory_view_get_next_visible_iter (FMAbstractDirectoryView* self,
                                                  GtkTreeIter* iter,
                                                  gboolean recurse)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_next_visible_iter (self, iter, recurse);
}

static void
fm_abstract_directory_view_real_cancel (FMAbstractDirectoryView* self)
{
	fm_abstract_directory_view_grab_focus (self);
	fm_abstract_directory_view_cancel_hover (self);
	fm_abstract_directory_view_cancel_thumbnailing (self);
	fm_abstract_directory_view_cancel_drag_timer (self);
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
	fm_abstract_directory_view_cancel_timeout (self, &self->priv->add_remove_file_timeout_id);
}

void
fm_abstract_directory_view_cancel (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->cancel (self);
}

static void
fm_abstract_directory_view_cancel_hover (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_ITEM_HOVERED_SIGNAL], 0, NULL);
	__vala_GtkTreePath_free0 (self->priv->hover_path);
	self->priv->hover_path = NULL;
}

void
fm_abstract_directory_view_close (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_set_is_frozen (self, TRUE);
	fm_abstract_directory_view_cancel (self);
	fm_abstract_directory_view_unselect_all (self);
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
}

static GtkTreeRowReference*
_vala_GtkTreeRowReference_copy (GtkTreeRowReference* self)
{
	return g_boxed_copy (gtk_tree_row_reference_get_type (), self);
}

static gpointer
__vala_GtkTreeRowReference_copy0 (gpointer self)
{
	return self ? _vala_GtkTreeRowReference_copy (self) : NULL;
}

static void
_vala_GtkTreeRowReference_free (GtkTreeRowReference* self)
{
	g_boxed_free (gtk_tree_row_reference_get_type (), self);
}

static void
__vala_GtkTreeRowReference_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL));
}

static inline void
_g_list_free___vala_GtkTreeRowReference_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreeRowReference_free0_);
}

void
fm_abstract_directory_view_invert_selection (FMAbstractDirectoryView* self)
{
	GList* selected_row_refs = NULL;
	GList* _tmp0_;
	GList* _tmp5_;
	g_return_if_fail (self != NULL);
	selected_row_refs = NULL;
	_tmp0_ = fm_abstract_directory_view_get_selected_paths (self);
	{
		GList* p_collection = NULL;
		GList* p_it = NULL;
		p_collection = _tmp0_;
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
			GtkTreePath* _tmp1_;
			GtkTreePath* p = NULL;
			_tmp1_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) p_it->data);
			p = _tmp1_;
			{
				FMListModel* _tmp2_;
				GtkTreePath* _tmp3_;
				GtkTreeRowReference* _tmp4_;
				_tmp2_ = self->model;
				_tmp3_ = p;
				_tmp4_ = gtk_tree_row_reference_new ((GtkTreeModel*) _tmp2_, _tmp3_);
				selected_row_refs = g_list_prepend (selected_row_refs, _tmp4_);
				__vala_GtkTreePath_free0 (p);
			}
		}
		(p_collection == NULL) ? NULL : (p_collection = (_g_list_free___vala_GtkTreePath_free0_ (p_collection), NULL));
	}
	fm_abstract_directory_view_select_all (self);
	_tmp5_ = selected_row_refs;
	if (_tmp5_ != NULL) {
		GList* _tmp6_;
		_tmp6_ = selected_row_refs;
		{
			GList* r_collection = NULL;
			GList* r_it = NULL;
			r_collection = _tmp6_;
			for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
				GtkTreeRowReference* _tmp7_;
				GtkTreeRowReference* r = NULL;
				_tmp7_ = __vala_GtkTreeRowReference_copy0 ((GtkTreeRowReference*) r_it->data);
				r = _tmp7_;
				{
					GtkTreePath* p = NULL;
					GtkTreeRowReference* _tmp8_;
					GtkTreePath* _tmp9_;
					GtkTreePath* _tmp10_;
					_tmp8_ = r;
					_tmp9_ = gtk_tree_row_reference_get_path (_tmp8_);
					p = _tmp9_;
					_tmp10_ = p;
					if (_tmp10_ != NULL) {
						GtkTreePath* _tmp11_;
						_tmp11_ = p;
						fm_abstract_directory_view_unselect_path (self, _tmp11_);
					}
					__vala_GtkTreePath_free0 (p);
					__vala_GtkTreeRowReference_free0 (r);
				}
			}
		}
	}
	(selected_row_refs == NULL) ? NULL : (selected_row_refs = (_g_list_free___vala_GtkTreeRowReference_free0_ (selected_row_refs), NULL));
}

void
fm_abstract_directory_view_select_all (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_tree_select_all (self);
	fm_abstract_directory_view_update_selected_files_and_menu (self);
}

void
fm_abstract_directory_view_unselect_all (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_tree_unselect_all (self);
	fm_abstract_directory_view_update_selected_files_and_menu (self);
}

void
fm_abstract_directory_view_unselect_others (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	fm_abstract_directory_view_tree_unselect_others (self);
	fm_abstract_directory_view_update_selected_files_and_menu (self);
}

static void
fm_abstract_directory_view_real_highlight_path (FMAbstractDirectoryView* self,
                                                GtkTreePath* path)
{
}

void
fm_abstract_directory_view_highlight_path (FMAbstractDirectoryView* self,
                                           GtkTreePath* path)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->highlight_path (self, path);
}

static GtkTreePath*
fm_abstract_directory_view_real_up (FMAbstractDirectoryView* self,
                                    GtkTreePath* path)
{
	GtkTreePath* _tmp0_;
	GtkTreePath* result = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	gtk_tree_path_up (path);
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
	result = _tmp0_;
	return result;
}

GtkTreePath*
fm_abstract_directory_view_up (FMAbstractDirectoryView* self,
                               GtkTreePath* path)
{
	g_return_val_if_fail (self != NULL, NULL);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->up (self, path);
}

static GtkTreePath*
fm_abstract_directory_view_real_down (FMAbstractDirectoryView* self,
                                      GtkTreePath* path)
{
	GtkTreePath* _tmp0_;
	GtkTreePath* result = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	gtk_tree_path_down (path);
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
	result = _tmp0_;
	return result;
}

GtkTreePath*
fm_abstract_directory_view_down (FMAbstractDirectoryView* self,
                                 GtkTreePath* path)
{
	g_return_val_if_fail (self != NULL, NULL);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->down (self, path);
}

/** Abstract methods - must be overridden*/
static GList*
fm_abstract_directory_view_real_get_selected_paths (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_selected_paths'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GList*
fm_abstract_directory_view_get_selected_paths (FMAbstractDirectoryView* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_selected_paths (self);
}

static GtkTreePath*
fm_abstract_directory_view_real_get_path_at_pos (FMAbstractDirectoryView* self,
                                                 gint x,
                                                 gint win)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_path_at_pos'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GtkTreePath*
fm_abstract_directory_view_get_path_at_pos (FMAbstractDirectoryView* self,
                                            gint x,
                                            gint win)
{
	g_return_val_if_fail (self != NULL, NULL);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_path_at_pos (self, x, win);
}

static GtkTreePath*
fm_abstract_directory_view_real_get_path_at_cursor (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_path_at_cursor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GtkTreePath*
fm_abstract_directory_view_get_path_at_cursor (FMAbstractDirectoryView* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_path_at_cursor (self);
}

static void
fm_abstract_directory_view_real_tree_select_all (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_tree_select_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_tree_select_all (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->tree_select_all (self);
}

static void
fm_abstract_directory_view_real_tree_unselect_all (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_tree_unselect_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_tree_unselect_all (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->tree_unselect_all (self);
}

static void
fm_abstract_directory_view_real_tree_unselect_others (FMAbstractDirectoryView* self)
{
}

void
fm_abstract_directory_view_tree_unselect_others (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->tree_unselect_others (self);
}

static void
fm_abstract_directory_view_real_select_path (FMAbstractDirectoryView* self,
                                             GtkTreePath* path,
                                             gboolean cursor_follows)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_select_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_select_path (FMAbstractDirectoryView* self,
                                        GtkTreePath* path,
                                        gboolean cursor_follows)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->select_path (self, path, cursor_follows);
}

static void
fm_abstract_directory_view_real_unselect_path (FMAbstractDirectoryView* self,
                                               GtkTreePath* path)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_unselect_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_unselect_path (FMAbstractDirectoryView* self,
                                          GtkTreePath* path)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->unselect_path (self, path);
}

static gboolean
fm_abstract_directory_view_real_path_is_selected (FMAbstractDirectoryView* self,
                                                  GtkTreePath* path)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_path_is_selected'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
fm_abstract_directory_view_path_is_selected (FMAbstractDirectoryView* self,
                                             GtkTreePath* path)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->path_is_selected (self, path);
}

static gboolean
fm_abstract_directory_view_real_get_visible_range (FMAbstractDirectoryView* self,
                                                   GtkTreePath* * start_path,
                                                   GtkTreePath* * end_path)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_visible_range'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
fm_abstract_directory_view_get_visible_range (FMAbstractDirectoryView* self,
                                              GtkTreePath* * start_path,
                                              GtkTreePath* * end_path)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_visible_range (self, start_path, end_path);
}

static void
fm_abstract_directory_view_real_set_cursor (FMAbstractDirectoryView* self,
                                            GtkTreePath* path,
                                            gboolean start_editing,
                                            gboolean select,
                                            gboolean scroll_to_top)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_set_cursor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_set_cursor (FMAbstractDirectoryView* self,
                                       GtkTreePath* path,
                                       gboolean start_editing,
                                       gboolean select,
                                       gboolean scroll_to_top)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->set_cursor (self, path, start_editing, select, scroll_to_top);
}

static gboolean
fm_abstract_directory_view_real_move_cursor (FMAbstractDirectoryView* self,
                                             guint keyval,
                                             gboolean only_shift_pressed,
                                             gboolean control_pressed)
{
	gboolean result = FALSE;
	result = FALSE;
	return result;
}

gboolean
fm_abstract_directory_view_move_cursor (FMAbstractDirectoryView* self,
                                        guint keyval,
                                        gboolean only_shift_pressed,
                                        gboolean control_pressed)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->move_cursor (self, keyval, only_shift_pressed, control_pressed);
}

static gboolean
fm_abstract_directory_view_real_will_handle_button_press (FMAbstractDirectoryView* self,
                                                          gboolean no_mods,
                                                          gboolean only_control_pressed,
                                                          gboolean only_shift_pressed)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (!no_mods) {
		_tmp0_ = !only_control_pressed;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

gboolean
fm_abstract_directory_view_will_handle_button_press (FMAbstractDirectoryView* self,
                                                     gboolean no_mods,
                                                     gboolean only_control_pressed,
                                                     gboolean only_shift_pressed)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->will_handle_button_press (self, no_mods, only_control_pressed, only_shift_pressed);
}

gboolean
fm_abstract_directory_view_is_on_icon (FMAbstractDirectoryView* self,
                                       gint x,
                                       gint y,
                                       gboolean* on_helper)
{
	GdkRectangle pointer_rect = {0};
	GdkRectangle _tmp0_ = {0};
	gboolean on_icon = FALSE;
	MarlinIconRenderer* _tmp1_;
	GdkRectangle _tmp2_;
	MarlinIconRenderer* _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_.x = x - 2;
	_tmp0_.y = y - 2;
	_tmp0_.width = 4;
	_tmp0_.height = 4;
	pointer_rect = _tmp0_;
	_tmp1_ = self->icon_renderer;
	_tmp2_ = _tmp1_->hover_rect;
	on_icon = gdk_rectangle_intersect (&pointer_rect, &_tmp2_, NULL);
	_tmp3_ = self->icon_renderer;
	_tmp4_ = _tmp3_->hover_helper_rect;
	*on_helper = gdk_rectangle_intersect (&pointer_rect, &_tmp4_, NULL);
	result = on_icon;
	return result;
}

static gboolean
fm_abstract_directory_view_real_handle_multi_select (FMAbstractDirectoryView* self,
                                                     GtkTreePath* path)
{
	gboolean result = FALSE;
	g_return_val_if_fail (path != NULL, FALSE);
	result = FALSE;
	return result;
}

gboolean
fm_abstract_directory_view_handle_multi_select (FMAbstractDirectoryView* self,
                                                GtkTreePath* path)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->handle_multi_select (self, path);
}

static GtkWidget*
fm_abstract_directory_view_real_create_view (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GtkWidget*
fm_abstract_directory_view_create_view (FMAbstractDirectoryView* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->create_view (self);
}

static MarlinZoomLevel
fm_abstract_directory_view_real_get_set_up_zoom_level (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_set_up_zoom_level'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}

MarlinZoomLevel
fm_abstract_directory_view_get_set_up_zoom_level (FMAbstractDirectoryView* self)
{
	g_return_val_if_fail (self != NULL, 0);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_set_up_zoom_level (self);
}

static MarlinZoomLevel
fm_abstract_directory_view_real_get_normal_zoom_level (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_normal_zoom_level'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}

MarlinZoomLevel
fm_abstract_directory_view_get_normal_zoom_level (FMAbstractDirectoryView* self)
{
	g_return_val_if_fail (self != NULL, 0);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_normal_zoom_level (self);
}

static gboolean
fm_abstract_directory_view_real_view_has_focus (FMAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_view_has_focus'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
fm_abstract_directory_view_view_has_focus (FMAbstractDirectoryView* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->view_has_focus (self);
}

static guint
fm_abstract_directory_view_real_get_selected_files_from_model (FMAbstractDirectoryView* self,
                                                               GList* * selected_files)
{
	guint _tmp0_ = 0U;
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_selected_files_from_model'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

guint
fm_abstract_directory_view_get_selected_files_from_model (FMAbstractDirectoryView* self,
                                                          GList* * selected_files)
{
	g_return_val_if_fail (self != NULL, 0U);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_selected_files_from_model (self, selected_files);
}

static guint
fm_abstract_directory_view_real_get_event_position_info (FMAbstractDirectoryView* self,
                                                         GdkEventButton* event,
                                                         GtkTreePath* * path,
                                                         gboolean rubberband)
{
	guint _tmp0_ = 0U;
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_get_event_position_info'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

guint
fm_abstract_directory_view_get_event_position_info (FMAbstractDirectoryView* self,
                                                    GdkEventButton* event,
                                                    GtkTreePath* * path,
                                                    gboolean rubberband)
{
	g_return_val_if_fail (self != NULL, 0U);
	return FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->get_event_position_info (self, event, path, rubberband);
}

static void
fm_abstract_directory_view_real_scroll_to_cell (FMAbstractDirectoryView* self,
                                                GtkTreePath* path,
                                                gboolean scroll_to_top)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_scroll_to_cell'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_scroll_to_cell (FMAbstractDirectoryView* self,
                                           GtkTreePath* path,
                                           gboolean scroll_to_top)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->scroll_to_cell (self, path, scroll_to_top);
}

static void
fm_abstract_directory_view_real_set_cursor_on_cell (FMAbstractDirectoryView* self,
                                                    GtkTreePath* path,
                                                    GtkCellRenderer* renderer,
                                                    gboolean start_editing,
                                                    gboolean scroll_to_top)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_set_cursor_on_cell'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_set_cursor_on_cell (FMAbstractDirectoryView* self,
                                               GtkTreePath* path,
                                               GtkCellRenderer* renderer,
                                               gboolean start_editing,
                                               gboolean scroll_to_top)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->set_cursor_on_cell (self, path, renderer, start_editing, scroll_to_top);
}

static void
fm_abstract_directory_view_real_freeze_tree (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_freeze_tree'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_freeze_tree (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->freeze_tree (self);
}

static void
fm_abstract_directory_view_real_thaw_tree (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_thaw_tree'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_thaw_tree (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->thaw_tree (self);
}

static void
fm_abstract_directory_view_real_freeze_child_notify (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_freeze_child_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_freeze_child_notify (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->freeze_child_notify (self);
}

static void
fm_abstract_directory_view_real_thaw_child_notify (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_thaw_child_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_thaw_child_notify (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->thaw_child_notify (self);
}

static void
fm_abstract_directory_view_real_connect_tree_signals (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_connect_tree_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_connect_tree_signals (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->connect_tree_signals (self);
}

static void
fm_abstract_directory_view_real_disconnect_tree_signals (FMAbstractDirectoryView* self)
{
	g_critical ("Type `%s' does not implement abstract method `fm_abstract_directory_view_disconnect_tree_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
fm_abstract_directory_view_disconnect_tree_signals (FMAbstractDirectoryView* self)
{
	g_return_if_fail (self != NULL);
	FM_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self)->disconnect_tree_signals (self);
}

MarlinZoomLevel
fm_abstract_directory_view_get_zoom_level (FMAbstractDirectoryView* self)
{
	MarlinZoomLevel result;
	MarlinZoomLevel _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_zoom_level;
	result = _tmp0_;
	return result;
}

void
fm_abstract_directory_view_set_zoom_level (FMAbstractDirectoryView* self,
                                           MarlinZoomLevel value)
{
	MarlinZoomLevel _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->maximum_zoom;
	if (value > _tmp0_) {
		MarlinZoomLevel _tmp1_;
		_tmp1_ = self->maximum_zoom;
		self->priv->_zoom_level = _tmp1_;
	} else {
		MarlinZoomLevel _tmp2_;
		_tmp2_ = self->minimum_zoom;
		if (value < _tmp2_) {
			MarlinZoomLevel _tmp3_;
			_tmp3_ = self->minimum_zoom;
			self->priv->_zoom_level = _tmp3_;
		} else {
			self->priv->_zoom_level = value;
		}
	}
	fm_abstract_directory_view_on_zoom_level_changed (self, value);
	g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY]);
}

gint
fm_abstract_directory_view_get_icon_size (FMAbstractDirectoryView* self)
{
	gint result;
	MarlinZoomLevel _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_zoom_level;
	result = (gint) marlin_zoom_level_to_icon_size (_tmp0_);
	return result;
}

static gboolean
fm_abstract_directory_view_get_drop_highlight (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_drop_highlight;
	return result;
}

static void
fm_abstract_directory_view_set_drop_highlight (FMAbstractDirectoryView* self,
                                               gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value != self->priv->_drop_highlight) {
		if (value) {
			gtk_drag_highlight ((GtkWidget*) self);
		} else {
			gtk_drag_unhighlight ((GtkWidget*) self);
		}
	}
	self->priv->_drop_highlight = value;
}

gboolean
fm_abstract_directory_view_get_single_click_mode (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_single_click_mode;
	return result;
}

void
fm_abstract_directory_view_set_single_click_mode (FMAbstractDirectoryView* self,
                                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	if (fm_abstract_directory_view_get_single_click_mode (self) != value) {
		self->priv->_single_click_mode = value;
		g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_SINGLE_CLICK_MODE_PROPERTY]);
	}
}

gboolean
fm_abstract_directory_view_get_renaming (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_renaming;
	return result;
}

void
fm_abstract_directory_view_set_renaming (FMAbstractDirectoryView* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	if (fm_abstract_directory_view_get_renaming (self) != value) {
		self->priv->_renaming = value;
		g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY]);
	}
}

gboolean
fm_abstract_directory_view_get_is_frozen (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_frozen;
	return result;
}

void
fm_abstract_directory_view_set_is_frozen (FMAbstractDirectoryView* self,
                                          gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = fm_abstract_directory_view_get_is_frozen (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != value) {
		self->priv->_is_frozen = value;
		if (value) {
			GSimpleActionGroup* _tmp2_;
			GSimpleActionGroup* _tmp3_;
			GSimpleActionGroup* _tmp4_;
			MarlinClipboardManager* _tmp5_;
			guint _tmp6_;
			GtkWidget* _tmp7_;
			guint _tmp8_;
			_tmp2_ = self->priv->selection_actions;
			fm_abstract_directory_view_action_set_enabled (self, _tmp2_, "cut", FALSE);
			_tmp3_ = self->priv->common_actions;
			fm_abstract_directory_view_action_set_enabled (self, _tmp3_, "copy", FALSE);
			_tmp4_ = self->priv->common_actions;
			fm_abstract_directory_view_action_set_enabled (self, _tmp4_, "paste-into", FALSE);
			fm_abstract_directory_view_disconnect_tree_signals (self);
			_tmp5_ = self->priv->clipboard;
			g_signal_parse_name ("changed", MARLIN_TYPE_CLIPBOARD_MANAGER, &_tmp6_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_clipboard_changed_marlin_clipboard_manager_changed, self);
			_tmp7_ = self->priv->view;
			g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _fm_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event, self);
		} else {
			GtkWidget* _tmp9_;
			MarlinClipboardManager* _tmp10_;
			_tmp9_ = self->priv->view;
			g_signal_connect_object (_tmp9_, "key-press-event", (GCallback) _fm_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event, self, 0);
			_tmp10_ = self->priv->clipboard;
			g_signal_connect_object (_tmp10_, "changed", (GCallback) _fm_abstract_directory_view_on_clipboard_changed_marlin_clipboard_manager_changed, self, 0);
			fm_abstract_directory_view_connect_tree_signals (self);
			fm_abstract_directory_view_update_menu_actions (self);
		}
	}
	g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY]);
}

gboolean
fm_abstract_directory_view_get_in_recent (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_in_recent;
	return result;
}

static void
fm_abstract_directory_view_set_in_recent (FMAbstractDirectoryView* self,
                                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (fm_abstract_directory_view_get_in_recent (self) != value) {
		self->priv->_in_recent = value;
		g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY]);
	}
}

gboolean
fm_abstract_directory_view_get_tree_frozen (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_tree_frozen;
	return result;
}

void
fm_abstract_directory_view_set_tree_frozen (FMAbstractDirectoryView* self,
                                            gboolean value)
{
	g_return_if_fail (self != NULL);
	if (fm_abstract_directory_view_get_tree_frozen (self) != value) {
		self->priv->_tree_frozen = value;
		g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY]);
	}
}

gboolean
fm_abstract_directory_view_get_show_remote_thumbnails (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_remote_thumbnails;
	return result;
}

void
fm_abstract_directory_view_set_show_remote_thumbnails (FMAbstractDirectoryView* self,
                                                       gboolean value)
{
	g_return_if_fail (self != NULL);
	if (fm_abstract_directory_view_get_show_remote_thumbnails (self) != value) {
		self->priv->_show_remote_thumbnails = value;
		g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY]);
	}
}

gboolean
fm_abstract_directory_view_get_hide_local_thumbnails (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_hide_local_thumbnails;
	return result;
}

void
fm_abstract_directory_view_set_hide_local_thumbnails (FMAbstractDirectoryView* self,
                                                      gboolean value)
{
	g_return_if_fail (self != NULL);
	if (fm_abstract_directory_view_get_hide_local_thumbnails (self) != value) {
		self->priv->_hide_local_thumbnails = value;
		g_object_notify_by_pspec ((GObject *) self, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_HIDE_LOCAL_THUMBNAILS_PROPERTY]);
	}
}

gboolean
fm_abstract_directory_view_get_is_admin (FMAbstractDirectoryView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = ((guint) getuid ()) == ((guint) 0);
	return result;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN) (gpointer data1, gpointer arg_1, gint arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), g_value_get_boolean (param_values + 3), data2);
}

static FMAbstractDirectoryViewSortSubMenuItem*
fm_abstract_directory_view_sort_sub_menu_item_construct (GType object_type)
{
	FMAbstractDirectoryViewSortSubMenuItem * self = NULL;
	self = (FMAbstractDirectoryViewSortSubMenuItem*) g_object_new (object_type, NULL);
	return self;
}

static FMAbstractDirectoryViewSortSubMenuItem*
fm_abstract_directory_view_sort_sub_menu_item_new (void)
{
	return fm_abstract_directory_view_sort_sub_menu_item_construct (FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM);
}

static GVariant*
_variant_new11 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new12 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new13 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new14 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GObject *
fm_abstract_directory_view_sort_sub_menu_item_constructor (GType type,
                                                           guint n_construct_properties,
                                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FMAbstractDirectoryViewSortSubMenuItem * self;
	GtkCheckMenuItem* name_radioitem = NULL;
	GtkCheckMenuItem* _tmp0_;
	GtkCheckMenuItem* _tmp1_;
	GtkCheckMenuItem* _tmp2_;
	GVariant* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	GtkCheckMenuItem* size_radioitem = NULL;
	GtkCheckMenuItem* _tmp5_;
	GtkCheckMenuItem* _tmp6_;
	GtkCheckMenuItem* _tmp7_;
	GVariant* _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	GtkCheckMenuItem* type_radioitem = NULL;
	GtkCheckMenuItem* _tmp10_;
	GtkCheckMenuItem* _tmp11_;
	GtkCheckMenuItem* _tmp12_;
	GVariant* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkCheckMenuItem* date_radioitem = NULL;
	GtkCheckMenuItem* _tmp15_;
	GtkCheckMenuItem* _tmp16_;
	GtkCheckMenuItem* _tmp17_;
	GVariant* _tmp18_;
	GtkCheckMenuItem* _tmp19_;
	GtkCheckMenuItem* reversed_checkitem = NULL;
	GtkCheckMenuItem* _tmp20_;
	GtkCheckMenuItem* _tmp21_;
	GtkCheckMenuItem* folders_first_checkitem = NULL;
	GtkCheckMenuItem* _tmp22_;
	GtkCheckMenuItem* _tmp23_;
	GtkMenu* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenu* _tmp27_;
	GtkCheckMenuItem* _tmp28_;
	GtkMenu* _tmp29_;
	GtkMenu* _tmp30_;
	GtkCheckMenuItem* _tmp31_;
	GtkMenu* _tmp32_;
	GtkMenu* _tmp33_;
	GtkCheckMenuItem* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenu* _tmp36_;
	GtkCheckMenuItem* _tmp37_;
	GtkMenu* _tmp38_;
	GtkMenu* _tmp39_;
	GtkSeparatorMenuItem* _tmp40_;
	GtkSeparatorMenuItem* _tmp41_;
	GtkMenu* _tmp42_;
	GtkMenu* _tmp43_;
	GtkCheckMenuItem* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenu* _tmp46_;
	GtkCheckMenuItem* _tmp47_;
	parent_class = G_OBJECT_CLASS (fm_abstract_directory_view_sort_sub_menu_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FM_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FMAbstractDirectoryViewSortSubMenuItem);
	_tmp0_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Name"));
	g_object_ref_sink (_tmp0_);
	name_radioitem = _tmp0_;
	_tmp1_ = name_radioitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp1_, "background.sort-by");
	_tmp2_ = name_radioitem;
	_tmp3_ = _variant_new11 ("name");
	g_object_set ((GtkActionable*) _tmp2_, "action-target", _tmp3_, NULL);
	_g_variant_unref0 (_tmp3_);
	_tmp4_ = name_radioitem;
	gtk_check_menu_item_set_draw_as_radio (_tmp4_, TRUE);
	_tmp5_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Size"));
	g_object_ref_sink (_tmp5_);
	size_radioitem = _tmp5_;
	_tmp6_ = size_radioitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, "background.sort-by");
	_tmp7_ = size_radioitem;
	_tmp8_ = _variant_new12 ("size");
	g_object_set ((GtkActionable*) _tmp7_, "action-target", _tmp8_, NULL);
	_g_variant_unref0 (_tmp8_);
	_tmp9_ = size_radioitem;
	gtk_check_menu_item_set_draw_as_radio (_tmp9_, TRUE);
	_tmp10_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Type"));
	g_object_ref_sink (_tmp10_);
	type_radioitem = _tmp10_;
	_tmp11_ = type_radioitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp11_, "background.sort-by");
	_tmp12_ = type_radioitem;
	_tmp13_ = _variant_new13 ("type");
	g_object_set ((GtkActionable*) _tmp12_, "action-target", _tmp13_, NULL);
	_g_variant_unref0 (_tmp13_);
	_tmp14_ = type_radioitem;
	gtk_check_menu_item_set_draw_as_radio (_tmp14_, TRUE);
	_tmp15_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Date"));
	g_object_ref_sink (_tmp15_);
	date_radioitem = _tmp15_;
	_tmp16_ = date_radioitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp16_, "background.sort-by");
	_tmp17_ = date_radioitem;
	_tmp18_ = _variant_new14 ("modified");
	g_object_set ((GtkActionable*) _tmp17_, "action-target", _tmp18_, NULL);
	_g_variant_unref0 (_tmp18_);
	_tmp19_ = date_radioitem;
	gtk_check_menu_item_set_draw_as_radio (_tmp19_, TRUE);
	_tmp20_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Reversed Order"));
	g_object_ref_sink (_tmp20_);
	reversed_checkitem = _tmp20_;
	_tmp21_ = reversed_checkitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp21_, "background.reverse");
	_tmp22_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Folders Before Files"));
	g_object_ref_sink (_tmp22_);
	folders_first_checkitem = _tmp22_;
	_tmp23_ = folders_first_checkitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp23_, "background.folders-first");
	_tmp24_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp24_);
	_tmp25_ = _tmp24_;
	gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp25_);
	_g_object_unref0 (_tmp25_);
	_tmp26_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp27_ = _tmp26_;
	_tmp28_ = name_radioitem;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp30_ = _tmp29_;
	_tmp31_ = size_radioitem;
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp33_ = _tmp32_;
	_tmp34_ = type_radioitem;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp36_ = _tmp35_;
	_tmp37_ = date_radioitem;
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
	_tmp38_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp39_ = _tmp38_;
	_tmp40_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp40_);
	_tmp41_ = _tmp40_;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp41_);
	_g_object_unref0 (_tmp41_);
	_tmp42_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp43_ = _tmp42_;
	_tmp44_ = reversed_checkitem;
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
	_tmp45_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp46_ = _tmp45_;
	_tmp47_ = folders_first_checkitem;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	gtk_menu_item_set_label ((GtkMenuItem*) self, _ ("Sort by"));
	_g_object_unref0 (folders_first_checkitem);
	_g_object_unref0 (reversed_checkitem);
	_g_object_unref0 (date_radioitem);
	_g_object_unref0 (type_radioitem);
	_g_object_unref0 (size_radioitem);
	_g_object_unref0 (name_radioitem);
	return obj;
}

static void
fm_abstract_directory_view_sort_sub_menu_item_class_init (FMAbstractDirectoryViewSortSubMenuItemClass * klass,
                                                          gpointer klass_data)
{
	fm_abstract_directory_view_sort_sub_menu_item_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = fm_abstract_directory_view_sort_sub_menu_item_constructor;
}

static void
fm_abstract_directory_view_sort_sub_menu_item_instance_init (FMAbstractDirectoryViewSortSubMenuItem * self,
                                                             gpointer klass)
{
}

static GType
fm_abstract_directory_view_sort_sub_menu_item_get_type (void)
{
	static volatile gsize fm_abstract_directory_view_sort_sub_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&fm_abstract_directory_view_sort_sub_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FMAbstractDirectoryViewSortSubMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fm_abstract_directory_view_sort_sub_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FMAbstractDirectoryViewSortSubMenuItem), 0, (GInstanceInitFunc) fm_abstract_directory_view_sort_sub_menu_item_instance_init, NULL };
		GType fm_abstract_directory_view_sort_sub_menu_item_type_id;
		fm_abstract_directory_view_sort_sub_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "FMAbstractDirectoryViewSortSubMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&fm_abstract_directory_view_sort_sub_menu_item_type_id__volatile, fm_abstract_directory_view_sort_sub_menu_item_type_id);
	}
	return fm_abstract_directory_view_sort_sub_menu_item_type_id__volatile;
}

static FMAbstractDirectoryViewNewSubMenuItem*
fm_abstract_directory_view_new_sub_menu_item_construct (GType object_type)
{
	FMAbstractDirectoryViewNewSubMenuItem * self = NULL;
	self = (FMAbstractDirectoryViewNewSubMenuItem*) g_object_new (object_type, NULL);
	return self;
}

static FMAbstractDirectoryViewNewSubMenuItem*
fm_abstract_directory_view_new_sub_menu_item_new (void)
{
	return fm_abstract_directory_view_new_sub_menu_item_construct (FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM);
}

static GVariant*
_variant_new15 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new16 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GObject *
fm_abstract_directory_view_new_sub_menu_item_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FMAbstractDirectoryViewNewSubMenuItem * self;
	GtkMenuItem* folder_menuitem = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GraniteAccelLabel* _tmp2_;
	GraniteAccelLabel* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GVariant* _tmp6_;
	GtkMenuItem* file_menuitem = NULL;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GVariant* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenu* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenuItem* _tmp18_;
	const gchar* template_path = NULL;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	parent_class = G_OBJECT_CLASS (fm_abstract_directory_view_new_sub_menu_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FM_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FMAbstractDirectoryViewNewSubMenuItem);
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp0_);
	folder_menuitem = _tmp0_;
	_tmp1_ = folder_menuitem;
	_tmp2_ = granite_accel_label_new (_ ("Folder"), "<Ctrl><Shift>n");
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = folder_menuitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, "background.new");
	_tmp5_ = folder_menuitem;
	_tmp6_ = _variant_new15 ("FOLDER");
	g_object_set ((GtkActionable*) _tmp5_, "action-target", _tmp6_, NULL);
	_g_variant_unref0 (_tmp6_);
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Empty File"));
	g_object_ref_sink (_tmp7_);
	file_menuitem = _tmp7_;
	_tmp8_ = file_menuitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp8_, "background.new");
	_tmp9_ = file_menuitem;
	_tmp10_ = _variant_new16 ("FILE");
	g_object_set ((GtkActionable*) _tmp9_, "action-target", _tmp10_, NULL);
	_g_variant_unref0 (_tmp10_);
	_tmp11_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp14_ = _tmp13_;
	_tmp15_ = folder_menuitem;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = file_menuitem;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	(fm_abstract_directory_view_templates == NULL) ? NULL : (fm_abstract_directory_view_templates = (_g_list_free__g_object_unref0_ (fm_abstract_directory_view_templates), NULL));
	fm_abstract_directory_view_templates = NULL;
	_tmp19_ = g_get_user_special_dir (G_USER_DIRECTORY_TEMPLATES);
	template_path = _tmp19_;
	_tmp20_ = template_path;
	if (_tmp20_ != NULL) {
		GFile* template_folder = NULL;
		const gchar* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GList* _tmp24_;
		_tmp21_ = template_path;
		_tmp22_ = g_file_new_for_path (_tmp21_);
		template_folder = _tmp22_;
		_tmp23_ = template_folder;
		fm_abstract_directory_view_load_templates_from_folder (_tmp23_);
		_tmp24_ = fm_abstract_directory_view_templates;
		if (g_list_length (_tmp24_) > ((guint) 0)) {
			GtkMenu* _tmp25_;
			GtkMenu* _tmp26_;
			GtkSeparatorMenuItem* _tmp27_;
			GtkSeparatorMenuItem* _tmp28_;
			GtkMenu* active_submenu = NULL;
			GtkMenu* _tmp29_;
			GtkMenu* _tmp30_;
			GtkMenu* _tmp31_;
			gint index = 0;
			GList* _tmp32_;
			_tmp25_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
			_tmp26_ = _tmp25_;
			_tmp27_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp27_);
			_tmp28_ = _tmp27_;
			gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp28_);
			_g_object_unref0 (_tmp28_);
			fm_abstract_directory_view_templates = g_list_reverse (fm_abstract_directory_view_templates);
			_tmp29_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
			_tmp30_ = _tmp29_;
			_tmp31_ = _g_object_ref0 (_tmp30_);
			active_submenu = _tmp31_;
			index = 0;
			_tmp32_ = fm_abstract_directory_view_templates;
			{
				GList* template_collection = NULL;
				GList* template_it = NULL;
				template_collection = _tmp32_;
				for (template_it = template_collection; template_it != NULL; template_it = template_it->next) {
					GFile* template = NULL;
					template = (GFile*) template_it->data;
					{
						gchar* label = NULL;
						GFile* _tmp33_;
						gchar* _tmp34_;
						GFileType ftype = 0;
						GFile* _tmp35_;
						GFileType _tmp36_;
						gint _tmp59_;
						_tmp33_ = template;
						_tmp34_ = g_file_get_basename (_tmp33_);
						label = _tmp34_;
						_tmp35_ = template;
						ftype = g_file_query_file_type (_tmp35_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
						_tmp36_ = ftype;
						if (_tmp36_ == G_FILE_TYPE_DIRECTORY) {
							GFile* _tmp37_;
							GFile* _tmp38_;
							_tmp37_ = template;
							_tmp38_ = template_folder;
							if (_tmp37_ == _tmp38_) {
								GtkMenu* _tmp39_;
								GtkMenu* _tmp40_;
								GtkMenu* _tmp41_;
								_tmp39_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
								_tmp40_ = _tmp39_;
								_tmp41_ = _g_object_ref0 (_tmp40_);
								_g_object_unref0 (active_submenu);
								active_submenu = _tmp41_;
							} else {
								GtkMenu* _tmp42_;
								GtkMenuItem* submenu_item = NULL;
								const gchar* _tmp43_;
								GtkMenuItem* _tmp44_;
								GtkMenuItem* _tmp45_;
								GtkMenu* _tmp46_;
								GtkMenu* _tmp47_;
								GtkMenu* _tmp48_;
								GtkMenuItem* _tmp49_;
								_tmp42_ = (GtkMenu*) gtk_menu_new ();
								g_object_ref_sink (_tmp42_);
								_g_object_unref0 (active_submenu);
								active_submenu = _tmp42_;
								_tmp43_ = label;
								_tmp44_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp43_);
								g_object_ref_sink (_tmp44_);
								submenu_item = _tmp44_;
								_tmp45_ = submenu_item;
								_tmp46_ = active_submenu;
								gtk_menu_item_set_submenu (_tmp45_, _tmp46_);
								_tmp47_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
								_tmp48_ = _tmp47_;
								_tmp49_ = submenu_item;
								gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
								_g_object_unref0 (submenu_item);
							}
						} else {
							GtkMenuItem* template_menuitem = NULL;
							const gchar* _tmp50_;
							GtkMenuItem* _tmp51_;
							GtkMenuItem* _tmp52_;
							gchar* _tmp53_;
							gchar* _tmp54_;
							gchar* _tmp55_;
							gchar* _tmp56_;
							GtkMenu* _tmp57_;
							GtkMenuItem* _tmp58_;
							_tmp50_ = label;
							_tmp51_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp50_);
							g_object_ref_sink (_tmp51_);
							template_menuitem = _tmp51_;
							_tmp52_ = template_menuitem;
							_tmp53_ = g_strdup_printf ("%i", index);
							_tmp54_ = _tmp53_;
							_tmp55_ = g_strconcat ("background.create-from::", _tmp54_, NULL);
							_tmp56_ = _tmp55_;
							gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp52_, _tmp56_);
							_g_free0 (_tmp56_);
							_g_free0 (_tmp54_);
							_tmp57_ = active_submenu;
							_tmp58_ = template_menuitem;
							gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
							_g_object_unref0 (template_menuitem);
						}
						_tmp59_ = index;
						index = _tmp59_ + 1;
						_g_free0 (label);
					}
				}
			}
			_g_object_unref0 (active_submenu);
		}
		_g_object_unref0 (template_folder);
	}
	gtk_menu_item_set_label ((GtkMenuItem*) self, _ ("New"));
	_g_object_unref0 (file_menuitem);
	_g_object_unref0 (folder_menuitem);
	return obj;
}

static void
fm_abstract_directory_view_new_sub_menu_item_class_init (FMAbstractDirectoryViewNewSubMenuItemClass * klass,
                                                         gpointer klass_data)
{
	fm_abstract_directory_view_new_sub_menu_item_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = fm_abstract_directory_view_new_sub_menu_item_constructor;
}

static void
fm_abstract_directory_view_new_sub_menu_item_instance_init (FMAbstractDirectoryViewNewSubMenuItem * self,
                                                            gpointer klass)
{
}

static GType
fm_abstract_directory_view_new_sub_menu_item_get_type (void)
{
	static volatile gsize fm_abstract_directory_view_new_sub_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&fm_abstract_directory_view_new_sub_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FMAbstractDirectoryViewNewSubMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fm_abstract_directory_view_new_sub_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FMAbstractDirectoryViewNewSubMenuItem), 0, (GInstanceInitFunc) fm_abstract_directory_view_new_sub_menu_item_instance_init, NULL };
		GType fm_abstract_directory_view_new_sub_menu_item_type_id;
		fm_abstract_directory_view_new_sub_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "FMAbstractDirectoryViewNewSubMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&fm_abstract_directory_view_new_sub_menu_item_type_id__volatile, fm_abstract_directory_view_new_sub_menu_item_type_id);
	}
	return fm_abstract_directory_view_new_sub_menu_item_type_id__volatile;
}

static void
fm_abstract_directory_view_class_init (FMAbstractDirectoryViewClass * klass,
                                       gpointer klass_data)
{
	MarlinDndHandler* _tmp0_;
	fm_abstract_directory_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FMAbstractDirectoryView_private_offset);
	((FMAbstractDirectoryViewClass *) klass)->set_up_name_renderer = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_set_up_name_renderer;
	((FMAbstractDirectoryViewClass *) klass)->on_row_deleted = (void (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_on_row_deleted;
	((FMAbstractDirectoryViewClass *) klass)->on_view_key_press_event = (gboolean (*) (FMAbstractDirectoryView*, GdkEventKey*)) fm_abstract_directory_view_real_on_view_key_press_event;
	((FMAbstractDirectoryViewClass *) klass)->on_scroll_event = (gboolean (*) (FMAbstractDirectoryView*, GdkEventScroll*)) fm_abstract_directory_view_real_on_scroll_event;
	((FMAbstractDirectoryViewClass *) klass)->on_view_draw = (gboolean (*) (FMAbstractDirectoryView*, cairo_t*)) fm_abstract_directory_view_real_on_view_draw;
	((FMAbstractDirectoryViewClass *) klass)->handle_primary_button_click = (gboolean (*) (FMAbstractDirectoryView*, GdkEventButton*, GtkTreePath*)) fm_abstract_directory_view_real_handle_primary_button_click;
	((FMAbstractDirectoryViewClass *) klass)->handle_secondary_button_click = (gboolean (*) (FMAbstractDirectoryView*, GdkEventButton*)) fm_abstract_directory_view_real_handle_secondary_button_click;
	((FMAbstractDirectoryViewClass *) klass)->on_view_button_press_event = (gboolean (*) (FMAbstractDirectoryView*, GdkEventButton*)) fm_abstract_directory_view_real_on_view_button_press_event;
	((FMAbstractDirectoryViewClass *) klass)->on_view_button_release_event = (gboolean (*) (FMAbstractDirectoryView*, GdkEventButton*)) fm_abstract_directory_view_real_on_view_button_release_event;
	((FMAbstractDirectoryViewClass *) klass)->change_zoom_level = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_change_zoom_level;
	((FMAbstractDirectoryViewClass *) klass)->expand_collapse = (gboolean (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_expand_collapse;
	((FMAbstractDirectoryViewClass *) klass)->handle_default_button_click = (gboolean (*) (FMAbstractDirectoryView*, GdkEventButton*)) fm_abstract_directory_view_real_handle_default_button_click;
	((FMAbstractDirectoryViewClass *) klass)->get_next_visible_iter = (gboolean (*) (FMAbstractDirectoryView*, GtkTreeIter*, gboolean)) fm_abstract_directory_view_real_get_next_visible_iter;
	((FMAbstractDirectoryViewClass *) klass)->cancel = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_cancel;
	((FMAbstractDirectoryViewClass *) klass)->highlight_path = (void (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_highlight_path;
	((FMAbstractDirectoryViewClass *) klass)->up = (GtkTreePath* (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_up;
	((FMAbstractDirectoryViewClass *) klass)->down = (GtkTreePath* (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_down;
	((FMAbstractDirectoryViewClass *) klass)->get_selected_paths = (GList* (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_get_selected_paths;
	((FMAbstractDirectoryViewClass *) klass)->get_path_at_pos = (GtkTreePath* (*) (FMAbstractDirectoryView*, gint, gint)) fm_abstract_directory_view_real_get_path_at_pos;
	((FMAbstractDirectoryViewClass *) klass)->get_path_at_cursor = (GtkTreePath* (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_get_path_at_cursor;
	((FMAbstractDirectoryViewClass *) klass)->tree_select_all = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_tree_select_all;
	((FMAbstractDirectoryViewClass *) klass)->tree_unselect_all = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_tree_unselect_all;
	((FMAbstractDirectoryViewClass *) klass)->tree_unselect_others = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_tree_unselect_others;
	((FMAbstractDirectoryViewClass *) klass)->select_path = (void (*) (FMAbstractDirectoryView*, GtkTreePath*, gboolean)) fm_abstract_directory_view_real_select_path;
	((FMAbstractDirectoryViewClass *) klass)->unselect_path = (void (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_unselect_path;
	((FMAbstractDirectoryViewClass *) klass)->path_is_selected = (gboolean (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_path_is_selected;
	((FMAbstractDirectoryViewClass *) klass)->get_visible_range = (gboolean (*) (FMAbstractDirectoryView*, GtkTreePath* *, GtkTreePath* *)) fm_abstract_directory_view_real_get_visible_range;
	((FMAbstractDirectoryViewClass *) klass)->set_cursor = (void (*) (FMAbstractDirectoryView*, GtkTreePath*, gboolean, gboolean, gboolean)) fm_abstract_directory_view_real_set_cursor;
	((FMAbstractDirectoryViewClass *) klass)->move_cursor = (gboolean (*) (FMAbstractDirectoryView*, guint, gboolean, gboolean)) fm_abstract_directory_view_real_move_cursor;
	((FMAbstractDirectoryViewClass *) klass)->will_handle_button_press = (gboolean (*) (FMAbstractDirectoryView*, gboolean, gboolean, gboolean)) fm_abstract_directory_view_real_will_handle_button_press;
	((FMAbstractDirectoryViewClass *) klass)->handle_multi_select = (gboolean (*) (FMAbstractDirectoryView*, GtkTreePath*)) fm_abstract_directory_view_real_handle_multi_select;
	((FMAbstractDirectoryViewClass *) klass)->create_view = (GtkWidget* (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_create_view;
	((FMAbstractDirectoryViewClass *) klass)->get_set_up_zoom_level = (MarlinZoomLevel (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_get_set_up_zoom_level;
	((FMAbstractDirectoryViewClass *) klass)->get_normal_zoom_level = (MarlinZoomLevel (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_get_normal_zoom_level;
	((FMAbstractDirectoryViewClass *) klass)->view_has_focus = (gboolean (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_view_has_focus;
	((FMAbstractDirectoryViewClass *) klass)->get_selected_files_from_model = (guint (*) (FMAbstractDirectoryView*, GList* *)) fm_abstract_directory_view_real_get_selected_files_from_model;
	((FMAbstractDirectoryViewClass *) klass)->get_event_position_info = (guint (*) (FMAbstractDirectoryView*, GdkEventButton*, GtkTreePath* *, gboolean)) fm_abstract_directory_view_real_get_event_position_info;
	((FMAbstractDirectoryViewClass *) klass)->scroll_to_cell = (void (*) (FMAbstractDirectoryView*, GtkTreePath*, gboolean)) fm_abstract_directory_view_real_scroll_to_cell;
	((FMAbstractDirectoryViewClass *) klass)->set_cursor_on_cell = (void (*) (FMAbstractDirectoryView*, GtkTreePath*, GtkCellRenderer*, gboolean, gboolean)) fm_abstract_directory_view_real_set_cursor_on_cell;
	((FMAbstractDirectoryViewClass *) klass)->freeze_tree = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_freeze_tree;
	((FMAbstractDirectoryViewClass *) klass)->thaw_tree = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_thaw_tree;
	((FMAbstractDirectoryViewClass *) klass)->freeze_child_notify = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_freeze_child_notify;
	((FMAbstractDirectoryViewClass *) klass)->thaw_child_notify = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_thaw_child_notify;
	((FMAbstractDirectoryViewClass *) klass)->connect_tree_signals = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_connect_tree_signals;
	((FMAbstractDirectoryViewClass *) klass)->disconnect_tree_signals = (void (*) (FMAbstractDirectoryView*)) fm_abstract_directory_view_real_disconnect_tree_signals;
	G_OBJECT_CLASS (klass)->get_property = _vala_fm_abstract_directory_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_fm_abstract_directory_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = fm_abstract_directory_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY] = g_param_spec_enum ("zoom-level", "zoom-level", "zoom-level", MARLIN_TYPE_ZOOM_LEVEL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_SINGLE_CLICK_MODE_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_SINGLE_CLICK_MODE_PROPERTY] = g_param_spec_boolean ("single-click-mode", "single-click-mode", "single-click-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY] = g_param_spec_boolean ("renaming", "renaming", "renaming", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY] = g_param_spec_boolean ("is-frozen", "is-frozen", "is-frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY] = g_param_spec_boolean ("in-recent", "in-recent", "in-recent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY] = g_param_spec_boolean ("tree-frozen", "tree-frozen", "tree-frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY] = g_param_spec_boolean ("show-remote-thumbnails", "show-remote-thumbnails", "show-remote-thumbnails", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_HIDE_LOCAL_THUMBNAILS_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_HIDE_LOCAL_THUMBNAILS_PROPERTY] = g_param_spec_boolean ("hide-local-thumbnails", "hide-local-thumbnails", "hide-local-thumbnails", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FM_ABSTRACT_DIRECTORY_VIEW_IS_ADMIN_PROPERTY, fm_abstract_directory_view_properties[FM_ABSTRACT_DIRECTORY_VIEW_IS_ADMIN_PROPERTY] = g_param_spec_boolean ("is-admin", "is-admin", "is-admin", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL] = g_signal_new ("path-change-request", FM_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN, G_TYPE_NONE, 3, g_file_get_type (), MARLIN_TYPE_OPEN_FLAG, G_TYPE_BOOLEAN);
	fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_ITEM_HOVERED_SIGNAL] = g_signal_new ("item-hovered", FM_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GOF_TYPE_FILE);
	fm_abstract_directory_view_signals[FM_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", FM_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
	_tmp0_ = marlin_dnd_handler_new ();
	fm_abstract_directory_view_dnd_handler = _tmp0_;
}

static void
fm_abstract_directory_view_instance_init (FMAbstractDirectoryView * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = fm_abstract_directory_view_get_instance_private (self);
	self->priv->_zoom_level = MARLIN_ZOOM_LEVEL_NORMAL;
	self->minimum_zoom = MARLIN_ZOOM_LEVEL_SMALLEST;
	self->maximum_zoom = MARLIN_ZOOM_LEVEL_LARGEST;
	self->large_thumbnails = FALSE;
	self->priv->drag_x = 0;
	self->priv->drag_y = 0;
	self->priv->drag_timer_id = (guint) 0;
	self->priv->source_drag_file_list = NULL;
	self->priv->current_target_type = GDK_NONE;
	self->priv->drag_scroll_timer_id = (guint) 0;
	self->priv->drag_enter_timer_id = (guint) 0;
	self->priv->destination_data_ready = FALSE;
	self->priv->drop_occurred = FALSE;
	self->priv->drop_target_file = NULL;
	self->priv->destination_drop_file_list = NULL;
	self->priv->current_suggested_action = GDK_ACTION_DEFAULT;
	self->priv->current_actions = GDK_ACTION_DEFAULT;
	self->dnd_disabled = FALSE;
	self->priv->thumbnail_request = -1;
	self->priv->thumbnail_source_id = (guint) 0;
	self->priv->freeze_source_id = (guint) 0;
	self->priv->thumbnailer = NULL;
	self->priv->add_remove_file_timeout_id = (guint) 0;
	self->priv->signal_free_space_change = FALSE;
	self->name_renderer = NULL;
	_tmp0_ = g_strdup ("");
	self->original_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->proposed_name = _tmp1_;
	self->priv->total_delta_y = 0.0;
	self->activate_on_blank = TRUE;
	self->right_margin_unselects_all = FALSE;
	self->should_activate = FALSE;
	self->should_scroll = TRUE;
	self->should_deselect = FALSE;
	self->click_path = NULL;
	self->click_zone = (guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON;
	self->previous_click_zone = (guint) FM_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON;
	self->selected_files = NULL;
	self->priv->selected_files_invalid = TRUE;
	self->priv->hover_path = NULL;
	self->priv->_renaming = FALSE;
	self->priv->_is_frozen = FALSE;
	self->priv->_in_recent = FALSE;
	self->priv->_tree_frozen = FALSE;
	self->priv->in_trash = FALSE;
	self->priv->in_network_root = FALSE;
	self->is_writable = FALSE;
	self->priv->_show_remote_thumbnails = FALSE;
	self->priv->_hide_local_thumbnails = FALSE;
	self->priv->all_selected = FALSE;
	self->priv->select_source_handler = (gulong) 0;
	self->priv->draw_timeout_id = (guint) 0;
}

static void
fm_abstract_directory_view_finalize (GObject * obj)
{
	FMAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FM_TYPE_ABSTRACT_DIRECTORY_VIEW, FMAbstractDirectoryView);
	g_debug ("AbstractDirectoryView.vala:338: ADV destruct");
	_g_object_unref0 (self->priv->common_actions);
	_g_object_unref0 (self->priv->selection_actions);
	_g_object_unref0 (self->priv->background_actions);
	(self->priv->source_drag_file_list == NULL) ? NULL : (self->priv->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->priv->source_drag_file_list), NULL));
	_g_object_unref0 (self->priv->drop_target_file);
	(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
	_g_object_unref0 (self->priv->thumbnailer);
	_g_object_unref0 (self->name_renderer);
	_g_free0 (self->original_name);
	_g_free0 (self->proposed_name);
	__vala_GtkTreePath_free0 (self->priv->deleted_path);
	__vala_GtkTreePath_free0 (self->click_path);
	_g_object_unref0 (self->priv->editable_cursor);
	_g_object_unref0 (self->priv->activatable_cursor);
	_g_object_unref0 (self->priv->selectable_cursor);
	(self->priv->open_with_apps == NULL) ? NULL : (self->priv->open_with_apps = (_g_list_free__g_object_unref0_ (self->priv->open_with_apps), NULL));
	(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
	_g_object_unref0 (self->priv->default_app);
	__vala_GtkTreePath_free0 (self->priv->hover_path);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->model);
	_g_object_unref0 (self->icon_renderer);
	G_OBJECT_CLASS (fm_abstract_directory_view_parent_class)->finalize (obj);
}

GType
fm_abstract_directory_view_get_type (void)
{
	static volatile gsize fm_abstract_directory_view_type_id__volatile = 0;
	if (g_once_init_enter (&fm_abstract_directory_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FMAbstractDirectoryViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fm_abstract_directory_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FMAbstractDirectoryView), 0, (GInstanceInitFunc) fm_abstract_directory_view_instance_init, NULL };
		GType fm_abstract_directory_view_type_id;
		fm_abstract_directory_view_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "FMAbstractDirectoryView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		FMAbstractDirectoryView_private_offset = g_type_add_instance_private (fm_abstract_directory_view_type_id, sizeof (FMAbstractDirectoryViewPrivate));
		g_once_init_leave (&fm_abstract_directory_view_type_id__volatile, fm_abstract_directory_view_type_id);
	}
	return fm_abstract_directory_view_type_id__volatile;
}

static void
_vala_fm_abstract_directory_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	FMAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FM_TYPE_ABSTRACT_DIRECTORY_VIEW, FMAbstractDirectoryView);
	switch (property_id) {
		case FM_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY:
		g_value_set_enum (value, fm_abstract_directory_view_get_zoom_level (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY:
		g_value_set_int (value, fm_abstract_directory_view_get_icon_size (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_SINGLE_CLICK_MODE_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_single_click_mode (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_renaming (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_is_frozen (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_in_recent (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_tree_frozen (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_show_remote_thumbnails (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_HIDE_LOCAL_THUMBNAILS_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_hide_local_thumbnails (self));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_IS_ADMIN_PROPERTY:
		g_value_set_boolean (value, fm_abstract_directory_view_get_is_admin (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_fm_abstract_directory_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	FMAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FM_TYPE_ABSTRACT_DIRECTORY_VIEW, FMAbstractDirectoryView);
	switch (property_id) {
		case FM_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY:
		fm_abstract_directory_view_set_zoom_level (self, g_value_get_enum (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_SINGLE_CLICK_MODE_PROPERTY:
		fm_abstract_directory_view_set_single_click_mode (self, g_value_get_boolean (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY:
		fm_abstract_directory_view_set_renaming (self, g_value_get_boolean (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY:
		fm_abstract_directory_view_set_is_frozen (self, g_value_get_boolean (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY:
		fm_abstract_directory_view_set_in_recent (self, g_value_get_boolean (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY:
		fm_abstract_directory_view_set_tree_frozen (self, g_value_get_boolean (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY:
		fm_abstract_directory_view_set_show_remote_thumbnails (self, g_value_get_boolean (value));
		break;
		case FM_ABSTRACT_DIRECTORY_VIEW_HIDE_LOCAL_THUMBNAILS_PROPERTY:
		fm_abstract_directory_view_set_hide_local_thumbnails (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

